module Data.Char.Properties.BidiCategoryData (getBidiCategory) where
	{
	import Data.Char.Properties.BidiCategoryTypes;
	import Data.Char.Properties.PrivateData;
	import Data.Array;
	import Prelude;

	theList :: [(Char,BidiCategory)];
	theList =
		[
		('\x0000',BidiBN),
		('\x0001',BidiBN),
		('\x0002',BidiBN),
		('\x0003',BidiBN),
		('\x0004',BidiBN),
		('\x0005',BidiBN),
		('\x0006',BidiBN),
		('\x0007',BidiBN),
		('\x0008',BidiBN),
		('\x0009',BidiS),
		('\x000A',BidiB),
		('\x000B',BidiS),
		('\x000C',BidiWS),
		('\x000D',BidiB),
		('\x000E',BidiBN),
		('\x000F',BidiBN),
		('\x0010',BidiBN),
		('\x0011',BidiBN),
		('\x0012',BidiBN),
		('\x0013',BidiBN),
		('\x0014',BidiBN),
		('\x0015',BidiBN),
		('\x0016',BidiBN),
		('\x0017',BidiBN),
		('\x0018',BidiBN),
		('\x0019',BidiBN),
		('\x001A',BidiBN),
		('\x001B',BidiBN),
		('\x001C',BidiB),
		('\x001D',BidiB),
		('\x001E',BidiB),
		('\x001F',BidiS),
		('\x0020',BidiWS),
		('\x0021',BidiON),
		('\x0022',BidiON),
		('\x0023',BidiET),
		('\x0024',BidiET),
		('\x0025',BidiET),
		('\x0026',BidiON),
		('\x0027',BidiON),
		('\x0028',BidiON),
		('\x0029',BidiON),
		('\x002A',BidiON),
		('\x002B',BidiET),
		('\x002C',BidiCS),
		('\x002D',BidiET),
		('\x002E',BidiCS),
		('\x002F',BidiES),
		('\x0030',BidiEN),
		('\x0031',BidiEN),
		('\x0032',BidiEN),
		('\x0033',BidiEN),
		('\x0034',BidiEN),
		('\x0035',BidiEN),
		('\x0036',BidiEN),
		('\x0037',BidiEN),
		('\x0038',BidiEN),
		('\x0039',BidiEN),
		('\x003A',BidiCS),
		('\x003B',BidiON),
		('\x003C',BidiON),
		('\x003D',BidiON),
		('\x003E',BidiON),
		('\x003F',BidiON),
		('\x0040',BidiON),
		('\x005B',BidiON),
		('\x005C',BidiON),
		('\x005D',BidiON),
		('\x005E',BidiON),
		('\x005F',BidiON),
		('\x0060',BidiON),
		('\x007B',BidiON),
		('\x007C',BidiON),
		('\x007D',BidiON),
		('\x007E',BidiON),
		('\x007F',BidiBN),
		('\x0080',BidiBN),
		('\x0081',BidiBN),
		('\x0082',BidiBN),
		('\x0083',BidiBN),
		('\x0084',BidiBN),
		('\x0085',BidiB),
		('\x0086',BidiBN),
		('\x0087',BidiBN),
		('\x0088',BidiBN),
		('\x0089',BidiBN),
		('\x008A',BidiBN),
		('\x008B',BidiBN),
		('\x008C',BidiBN),
		('\x008D',BidiBN),
		('\x008E',BidiBN),
		('\x008F',BidiBN),
		('\x0090',BidiBN),
		('\x0091',BidiBN),
		('\x0092',BidiBN),
		('\x0093',BidiBN),
		('\x0094',BidiBN),
		('\x0095',BidiBN),
		('\x0096',BidiBN),
		('\x0097',BidiBN),
		('\x0098',BidiBN),
		('\x0099',BidiBN),
		('\x009A',BidiBN),
		('\x009B',BidiBN),
		('\x009C',BidiBN),
		('\x009D',BidiBN),
		('\x009E',BidiBN),
		('\x009F',BidiBN),
		('\x00A0',BidiCS),
		('\x00A1',BidiON),
		('\x00A2',BidiET),
		('\x00A3',BidiET),
		('\x00A4',BidiET),
		('\x00A5',BidiET),
		('\x00A6',BidiON),
		('\x00A7',BidiON),
		('\x00A8',BidiON),
		('\x00A9',BidiON),
		('\x00AB',BidiON),
		('\x00AC',BidiON),
		('\x00AD',BidiON),
		('\x00AE',BidiON),
		('\x00AF',BidiON),
		('\x00B0',BidiET),
		('\x00B1',BidiET),
		('\x00B2',BidiEN),
		('\x00B3',BidiEN),
		('\x00B4',BidiON),
		('\x00B6',BidiON),
		('\x00B7',BidiON),
		('\x00B8',BidiON),
		('\x00B9',BidiEN),
		('\x00BB',BidiON),
		('\x00BC',BidiON),
		('\x00BD',BidiON),
		('\x00BE',BidiON),
		('\x00BF',BidiON),
		('\x00D7',BidiON),
		('\x00F7',BidiON),
		('\x02B9',BidiON),
		('\x02BA',BidiON),
		('\x02C2',BidiON),
		('\x02C3',BidiON),
		('\x02C4',BidiON),
		('\x02C5',BidiON),
		('\x02C6',BidiON),
		('\x02C7',BidiON),
		('\x02C8',BidiON),
		('\x02C9',BidiON),
		('\x02CA',BidiON),
		('\x02CB',BidiON),
		('\x02CC',BidiON),
		('\x02CD',BidiON),
		('\x02CE',BidiON),
		('\x02CF',BidiON),
		('\x02D2',BidiON),
		('\x02D3',BidiON),
		('\x02D4',BidiON),
		('\x02D5',BidiON),
		('\x02D6',BidiON),
		('\x02D7',BidiON),
		('\x02D8',BidiON),
		('\x02D9',BidiON),
		('\x02DA',BidiON),
		('\x02DB',BidiON),
		('\x02DC',BidiON),
		('\x02DD',BidiON),
		('\x02DE',BidiON),
		('\x02DF',BidiON),
		('\x02E5',BidiON),
		('\x02E6',BidiON),
		('\x02E7',BidiON),
		('\x02E8',BidiON),
		('\x02E9',BidiON),
		('\x02EA',BidiON),
		('\x02EB',BidiON),
		('\x02EC',BidiON),
		('\x02ED',BidiON),
		('\x0300',BidiNSM),
		('\x0301',BidiNSM),
		('\x0302',BidiNSM),
		('\x0303',BidiNSM),
		('\x0304',BidiNSM),
		('\x0305',BidiNSM),
		('\x0306',BidiNSM),
		('\x0307',BidiNSM),
		('\x0308',BidiNSM),
		('\x0309',BidiNSM),
		('\x030A',BidiNSM),
		('\x030B',BidiNSM),
		('\x030C',BidiNSM),
		('\x030D',BidiNSM),
		('\x030E',BidiNSM),
		('\x030F',BidiNSM),
		('\x0310',BidiNSM),
		('\x0311',BidiNSM),
		('\x0312',BidiNSM),
		('\x0313',BidiNSM),
		('\x0314',BidiNSM),
		('\x0315',BidiNSM),
		('\x0316',BidiNSM),
		('\x0317',BidiNSM),
		('\x0318',BidiNSM),
		('\x0319',BidiNSM),
		('\x031A',BidiNSM),
		('\x031B',BidiNSM),
		('\x031C',BidiNSM),
		('\x031D',BidiNSM),
		('\x031E',BidiNSM),
		('\x031F',BidiNSM),
		('\x0320',BidiNSM),
		('\x0321',BidiNSM),
		('\x0322',BidiNSM),
		('\x0323',BidiNSM),
		('\x0324',BidiNSM),
		('\x0325',BidiNSM),
		('\x0326',BidiNSM),
		('\x0327',BidiNSM),
		('\x0328',BidiNSM),
		('\x0329',BidiNSM),
		('\x032A',BidiNSM),
		('\x032B',BidiNSM),
		('\x032C',BidiNSM),
		('\x032D',BidiNSM),
		('\x032E',BidiNSM),
		('\x032F',BidiNSM),
		('\x0330',BidiNSM),
		('\x0331',BidiNSM),
		('\x0332',BidiNSM),
		('\x0333',BidiNSM),
		('\x0334',BidiNSM),
		('\x0335',BidiNSM),
		('\x0336',BidiNSM),
		('\x0337',BidiNSM),
		('\x0338',BidiNSM),
		('\x0339',BidiNSM),
		('\x033A',BidiNSM),
		('\x033B',BidiNSM),
		('\x033C',BidiNSM),
		('\x033D',BidiNSM),
		('\x033E',BidiNSM),
		('\x033F',BidiNSM),
		('\x0340',BidiNSM),
		('\x0341',BidiNSM),
		('\x0342',BidiNSM),
		('\x0343',BidiNSM),
		('\x0344',BidiNSM),
		('\x0345',BidiNSM),
		('\x0346',BidiNSM),
		('\x0347',BidiNSM),
		('\x0348',BidiNSM),
		('\x0349',BidiNSM),
		('\x034A',BidiNSM),
		('\x034B',BidiNSM),
		('\x034C',BidiNSM),
		('\x034D',BidiNSM),
		('\x034E',BidiNSM),
		('\x034F',BidiNSM),
		('\x0360',BidiNSM),
		('\x0361',BidiNSM),
		('\x0362',BidiNSM),
		('\x0363',BidiNSM),
		('\x0364',BidiNSM),
		('\x0365',BidiNSM),
		('\x0366',BidiNSM),
		('\x0367',BidiNSM),
		('\x0368',BidiNSM),
		('\x0369',BidiNSM),
		('\x036A',BidiNSM),
		('\x036B',BidiNSM),
		('\x036C',BidiNSM),
		('\x036D',BidiNSM),
		('\x036E',BidiNSM),
		('\x036F',BidiNSM),
		('\x0374',BidiON),
		('\x0375',BidiON),
		('\x037E',BidiON),
		('\x0384',BidiON),
		('\x0385',BidiON),
		('\x0387',BidiON),
		('\x03F6',BidiON),
		('\x0483',BidiNSM),
		('\x0484',BidiNSM),
		('\x0485',BidiNSM),
		('\x0486',BidiNSM),
		('\x0488',BidiNSM),
		('\x0489',BidiNSM),
		('\x058A',BidiON),
		('\x0591',BidiNSM),
		('\x0592',BidiNSM),
		('\x0593',BidiNSM),
		('\x0594',BidiNSM),
		('\x0595',BidiNSM),
		('\x0596',BidiNSM),
		('\x0597',BidiNSM),
		('\x0598',BidiNSM),
		('\x0599',BidiNSM),
		('\x059A',BidiNSM),
		('\x059B',BidiNSM),
		('\x059C',BidiNSM),
		('\x059D',BidiNSM),
		('\x059E',BidiNSM),
		('\x059F',BidiNSM),
		('\x05A0',BidiNSM),
		('\x05A1',BidiNSM),
		('\x05A3',BidiNSM),
		('\x05A4',BidiNSM),
		('\x05A5',BidiNSM),
		('\x05A6',BidiNSM),
		('\x05A7',BidiNSM),
		('\x05A8',BidiNSM),
		('\x05A9',BidiNSM),
		('\x05AA',BidiNSM),
		('\x05AB',BidiNSM),
		('\x05AC',BidiNSM),
		('\x05AD',BidiNSM),
		('\x05AE',BidiNSM),
		('\x05AF',BidiNSM),
		('\x05B0',BidiNSM),
		('\x05B1',BidiNSM),
		('\x05B2',BidiNSM),
		('\x05B3',BidiNSM),
		('\x05B4',BidiNSM),
		('\x05B5',BidiNSM),
		('\x05B6',BidiNSM),
		('\x05B7',BidiNSM),
		('\x05B8',BidiNSM),
		('\x05B9',BidiNSM),
		('\x05BB',BidiNSM),
		('\x05BC',BidiNSM),
		('\x05BD',BidiNSM),
		('\x05BE',BidiR),
		('\x05BF',BidiNSM),
		('\x05C0',BidiR),
		('\x05C1',BidiNSM),
		('\x05C2',BidiNSM),
		('\x05C3',BidiR),
		('\x05C4',BidiNSM),
		('\x05D0',BidiR),
		('\x05D1',BidiR),
		('\x05D2',BidiR),
		('\x05D3',BidiR),
		('\x05D4',BidiR),
		('\x05D5',BidiR),
		('\x05D6',BidiR),
		('\x05D7',BidiR),
		('\x05D8',BidiR),
		('\x05D9',BidiR),
		('\x05DA',BidiR),
		('\x05DB',BidiR),
		('\x05DC',BidiR),
		('\x05DD',BidiR),
		('\x05DE',BidiR),
		('\x05DF',BidiR),
		('\x05E0',BidiR),
		('\x05E1',BidiR),
		('\x05E2',BidiR),
		('\x05E3',BidiR),
		('\x05E4',BidiR),
		('\x05E5',BidiR),
		('\x05E6',BidiR),
		('\x05E7',BidiR),
		('\x05E8',BidiR),
		('\x05E9',BidiR),
		('\x05EA',BidiR),
		('\x05F0',BidiR),
		('\x05F1',BidiR),
		('\x05F2',BidiR),
		('\x05F3',BidiR),
		('\x05F4',BidiR),
		('\x060C',BidiCS),
		('\x061B',BidiAL),
		('\x061F',BidiAL),
		('\x0621',BidiAL),
		('\x0622',BidiAL),
		('\x0623',BidiAL),
		('\x0624',BidiAL),
		('\x0625',BidiAL),
		('\x0626',BidiAL),
		('\x0627',BidiAL),
		('\x0628',BidiAL),
		('\x0629',BidiAL),
		('\x062A',BidiAL),
		('\x062B',BidiAL),
		('\x062C',BidiAL),
		('\x062D',BidiAL),
		('\x062E',BidiAL),
		('\x062F',BidiAL),
		('\x0630',BidiAL),
		('\x0631',BidiAL),
		('\x0632',BidiAL),
		('\x0633',BidiAL),
		('\x0634',BidiAL),
		('\x0635',BidiAL),
		('\x0636',BidiAL),
		('\x0637',BidiAL),
		('\x0638',BidiAL),
		('\x0639',BidiAL),
		('\x063A',BidiAL),
		('\x0640',BidiAL),
		('\x0641',BidiAL),
		('\x0642',BidiAL),
		('\x0643',BidiAL),
		('\x0644',BidiAL),
		('\x0645',BidiAL),
		('\x0646',BidiAL),
		('\x0647',BidiAL),
		('\x0648',BidiAL),
		('\x0649',BidiAL),
		('\x064A',BidiAL),
		('\x064B',BidiNSM),
		('\x064C',BidiNSM),
		('\x064D',BidiNSM),
		('\x064E',BidiNSM),
		('\x064F',BidiNSM),
		('\x0650',BidiNSM),
		('\x0651',BidiNSM),
		('\x0652',BidiNSM),
		('\x0653',BidiNSM),
		('\x0654',BidiNSM),
		('\x0655',BidiNSM),
		('\x0660',BidiAN),
		('\x0661',BidiAN),
		('\x0662',BidiAN),
		('\x0663',BidiAN),
		('\x0664',BidiAN),
		('\x0665',BidiAN),
		('\x0666',BidiAN),
		('\x0667',BidiAN),
		('\x0668',BidiAN),
		('\x0669',BidiAN),
		('\x066A',BidiET),
		('\x066B',BidiAN),
		('\x066C',BidiAN),
		('\x066D',BidiAL),
		('\x066E',BidiAL),
		('\x066F',BidiAL),
		('\x0670',BidiNSM),
		('\x0671',BidiAL),
		('\x0672',BidiAL),
		('\x0673',BidiAL),
		('\x0674',BidiAL),
		('\x0675',BidiAL),
		('\x0676',BidiAL),
		('\x0677',BidiAL),
		('\x0678',BidiAL),
		('\x0679',BidiAL),
		('\x067A',BidiAL),
		('\x067B',BidiAL),
		('\x067C',BidiAL),
		('\x067D',BidiAL),
		('\x067E',BidiAL),
		('\x067F',BidiAL),
		('\x0680',BidiAL),
		('\x0681',BidiAL),
		('\x0682',BidiAL),
		('\x0683',BidiAL),
		('\x0684',BidiAL),
		('\x0685',BidiAL),
		('\x0686',BidiAL),
		('\x0687',BidiAL),
		('\x0688',BidiAL),
		('\x0689',BidiAL),
		('\x068A',BidiAL),
		('\x068B',BidiAL),
		('\x068C',BidiAL),
		('\x068D',BidiAL),
		('\x068E',BidiAL),
		('\x068F',BidiAL),
		('\x0690',BidiAL),
		('\x0691',BidiAL),
		('\x0692',BidiAL),
		('\x0693',BidiAL),
		('\x0694',BidiAL),
		('\x0695',BidiAL),
		('\x0696',BidiAL),
		('\x0697',BidiAL),
		('\x0698',BidiAL),
		('\x0699',BidiAL),
		('\x069A',BidiAL),
		('\x069B',BidiAL),
		('\x069C',BidiAL),
		('\x069D',BidiAL),
		('\x069E',BidiAL),
		('\x069F',BidiAL),
		('\x06A0',BidiAL),
		('\x06A1',BidiAL),
		('\x06A2',BidiAL),
		('\x06A3',BidiAL),
		('\x06A4',BidiAL),
		('\x06A5',BidiAL),
		('\x06A6',BidiAL),
		('\x06A7',BidiAL),
		('\x06A8',BidiAL),
		('\x06A9',BidiAL),
		('\x06AA',BidiAL),
		('\x06AB',BidiAL),
		('\x06AC',BidiAL),
		('\x06AD',BidiAL),
		('\x06AE',BidiAL),
		('\x06AF',BidiAL),
		('\x06B0',BidiAL),
		('\x06B1',BidiAL),
		('\x06B2',BidiAL),
		('\x06B3',BidiAL),
		('\x06B4',BidiAL),
		('\x06B5',BidiAL),
		('\x06B6',BidiAL),
		('\x06B7',BidiAL),
		('\x06B8',BidiAL),
		('\x06B9',BidiAL),
		('\x06BA',BidiAL),
		('\x06BB',BidiAL),
		('\x06BC',BidiAL),
		('\x06BD',BidiAL),
		('\x06BE',BidiAL),
		('\x06BF',BidiAL),
		('\x06C0',BidiAL),
		('\x06C1',BidiAL),
		('\x06C2',BidiAL),
		('\x06C3',BidiAL),
		('\x06C4',BidiAL),
		('\x06C5',BidiAL),
		('\x06C6',BidiAL),
		('\x06C7',BidiAL),
		('\x06C8',BidiAL),
		('\x06C9',BidiAL),
		('\x06CA',BidiAL),
		('\x06CB',BidiAL),
		('\x06CC',BidiAL),
		('\x06CD',BidiAL),
		('\x06CE',BidiAL),
		('\x06CF',BidiAL),
		('\x06D0',BidiAL),
		('\x06D1',BidiAL),
		('\x06D2',BidiAL),
		('\x06D3',BidiAL),
		('\x06D4',BidiAL),
		('\x06D5',BidiAL),
		('\x06D6',BidiNSM),
		('\x06D7',BidiNSM),
		('\x06D8',BidiNSM),
		('\x06D9',BidiNSM),
		('\x06DA',BidiNSM),
		('\x06DB',BidiNSM),
		('\x06DC',BidiNSM),
		('\x06DD',BidiAL),
		('\x06DE',BidiNSM),
		('\x06DF',BidiNSM),
		('\x06E0',BidiNSM),
		('\x06E1',BidiNSM),
		('\x06E2',BidiNSM),
		('\x06E3',BidiNSM),
		('\x06E4',BidiNSM),
		('\x06E5',BidiAL),
		('\x06E6',BidiAL),
		('\x06E7',BidiNSM),
		('\x06E8',BidiNSM),
		('\x06E9',BidiON),
		('\x06EA',BidiNSM),
		('\x06EB',BidiNSM),
		('\x06EC',BidiNSM),
		('\x06ED',BidiNSM),
		('\x06F0',BidiEN),
		('\x06F1',BidiEN),
		('\x06F2',BidiEN),
		('\x06F3',BidiEN),
		('\x06F4',BidiEN),
		('\x06F5',BidiEN),
		('\x06F6',BidiEN),
		('\x06F7',BidiEN),
		('\x06F8',BidiEN),
		('\x06F9',BidiEN),
		('\x06FA',BidiAL),
		('\x06FB',BidiAL),
		('\x06FC',BidiAL),
		('\x06FD',BidiAL),
		('\x06FE',BidiAL),
		('\x0700',BidiAL),
		('\x0701',BidiAL),
		('\x0702',BidiAL),
		('\x0703',BidiAL),
		('\x0704',BidiAL),
		('\x0705',BidiAL),
		('\x0706',BidiAL),
		('\x0707',BidiAL),
		('\x0708',BidiAL),
		('\x0709',BidiAL),
		('\x070A',BidiAL),
		('\x070B',BidiAL),
		('\x070C',BidiAL),
		('\x070D',BidiAL),
		('\x070F',BidiBN),
		('\x0710',BidiAL),
		('\x0711',BidiNSM),
		('\x0712',BidiAL),
		('\x0713',BidiAL),
		('\x0714',BidiAL),
		('\x0715',BidiAL),
		('\x0716',BidiAL),
		('\x0717',BidiAL),
		('\x0718',BidiAL),
		('\x0719',BidiAL),
		('\x071A',BidiAL),
		('\x071B',BidiAL),
		('\x071C',BidiAL),
		('\x071D',BidiAL),
		('\x071E',BidiAL),
		('\x071F',BidiAL),
		('\x0720',BidiAL),
		('\x0721',BidiAL),
		('\x0722',BidiAL),
		('\x0723',BidiAL),
		('\x0724',BidiAL),
		('\x0725',BidiAL),
		('\x0726',BidiAL),
		('\x0727',BidiAL),
		('\x0728',BidiAL),
		('\x0729',BidiAL),
		('\x072A',BidiAL),
		('\x072B',BidiAL),
		('\x072C',BidiAL),
		('\x0730',BidiNSM),
		('\x0731',BidiNSM),
		('\x0732',BidiNSM),
		('\x0733',BidiNSM),
		('\x0734',BidiNSM),
		('\x0735',BidiNSM),
		('\x0736',BidiNSM),
		('\x0737',BidiNSM),
		('\x0738',BidiNSM),
		('\x0739',BidiNSM),
		('\x073A',BidiNSM),
		('\x073B',BidiNSM),
		('\x073C',BidiNSM),
		('\x073D',BidiNSM),
		('\x073E',BidiNSM),
		('\x073F',BidiNSM),
		('\x0740',BidiNSM),
		('\x0741',BidiNSM),
		('\x0742',BidiNSM),
		('\x0743',BidiNSM),
		('\x0744',BidiNSM),
		('\x0745',BidiNSM),
		('\x0746',BidiNSM),
		('\x0747',BidiNSM),
		('\x0748',BidiNSM),
		('\x0749',BidiNSM),
		('\x074A',BidiNSM),
		('\x0780',BidiAL),
		('\x0781',BidiAL),
		('\x0782',BidiAL),
		('\x0783',BidiAL),
		('\x0784',BidiAL),
		('\x0785',BidiAL),
		('\x0786',BidiAL),
		('\x0787',BidiAL),
		('\x0788',BidiAL),
		('\x0789',BidiAL),
		('\x078A',BidiAL),
		('\x078B',BidiAL),
		('\x078C',BidiAL),
		('\x078D',BidiAL),
		('\x078E',BidiAL),
		('\x078F',BidiAL),
		('\x0790',BidiAL),
		('\x0791',BidiAL),
		('\x0792',BidiAL),
		('\x0793',BidiAL),
		('\x0794',BidiAL),
		('\x0795',BidiAL),
		('\x0796',BidiAL),
		('\x0797',BidiAL),
		('\x0798',BidiAL),
		('\x0799',BidiAL),
		('\x079A',BidiAL),
		('\x079B',BidiAL),
		('\x079C',BidiAL),
		('\x079D',BidiAL),
		('\x079E',BidiAL),
		('\x079F',BidiAL),
		('\x07A0',BidiAL),
		('\x07A1',BidiAL),
		('\x07A2',BidiAL),
		('\x07A3',BidiAL),
		('\x07A4',BidiAL),
		('\x07A5',BidiAL),
		('\x07A6',BidiNSM),
		('\x07A7',BidiNSM),
		('\x07A8',BidiNSM),
		('\x07A9',BidiNSM),
		('\x07AA',BidiNSM),
		('\x07AB',BidiNSM),
		('\x07AC',BidiNSM),
		('\x07AD',BidiNSM),
		('\x07AE',BidiNSM),
		('\x07AF',BidiNSM),
		('\x07B0',BidiNSM),
		('\x07B1',BidiAL),
		('\x0901',BidiNSM),
		('\x0902',BidiNSM),
		('\x093C',BidiNSM),
		('\x0941',BidiNSM),
		('\x0942',BidiNSM),
		('\x0943',BidiNSM),
		('\x0944',BidiNSM),
		('\x0945',BidiNSM),
		('\x0946',BidiNSM),
		('\x0947',BidiNSM),
		('\x0948',BidiNSM),
		('\x094D',BidiNSM),
		('\x0951',BidiNSM),
		('\x0952',BidiNSM),
		('\x0953',BidiNSM),
		('\x0954',BidiNSM),
		('\x0962',BidiNSM),
		('\x0963',BidiNSM),
		('\x0981',BidiNSM),
		('\x09BC',BidiNSM),
		('\x09C1',BidiNSM),
		('\x09C2',BidiNSM),
		('\x09C3',BidiNSM),
		('\x09C4',BidiNSM),
		('\x09CD',BidiNSM),
		('\x09E2',BidiNSM),
		('\x09E3',BidiNSM),
		('\x09F2',BidiET),
		('\x09F3',BidiET),
		('\x0A02',BidiNSM),
		('\x0A3C',BidiNSM),
		('\x0A41',BidiNSM),
		('\x0A42',BidiNSM),
		('\x0A47',BidiNSM),
		('\x0A48',BidiNSM),
		('\x0A4B',BidiNSM),
		('\x0A4C',BidiNSM),
		('\x0A4D',BidiNSM),
		('\x0A70',BidiNSM),
		('\x0A71',BidiNSM),
		('\x0A81',BidiNSM),
		('\x0A82',BidiNSM),
		('\x0ABC',BidiNSM),
		('\x0AC1',BidiNSM),
		('\x0AC2',BidiNSM),
		('\x0AC3',BidiNSM),
		('\x0AC4',BidiNSM),
		('\x0AC5',BidiNSM),
		('\x0AC7',BidiNSM),
		('\x0AC8',BidiNSM),
		('\x0ACD',BidiNSM),
		('\x0B01',BidiNSM),
		('\x0B3C',BidiNSM),
		('\x0B3F',BidiNSM),
		('\x0B41',BidiNSM),
		('\x0B42',BidiNSM),
		('\x0B43',BidiNSM),
		('\x0B4D',BidiNSM),
		('\x0B56',BidiNSM),
		('\x0B82',BidiNSM),
		('\x0BC0',BidiNSM),
		('\x0BCD',BidiNSM),
		('\x0C3E',BidiNSM),
		('\x0C3F',BidiNSM),
		('\x0C40',BidiNSM),
		('\x0C46',BidiNSM),
		('\x0C47',BidiNSM),
		('\x0C48',BidiNSM),
		('\x0C4A',BidiNSM),
		('\x0C4B',BidiNSM),
		('\x0C4C',BidiNSM),
		('\x0C4D',BidiNSM),
		('\x0C55',BidiNSM),
		('\x0C56',BidiNSM),
		('\x0CBF',BidiNSM),
		('\x0CC6',BidiNSM),
		('\x0CCC',BidiNSM),
		('\x0CCD',BidiNSM),
		('\x0D41',BidiNSM),
		('\x0D42',BidiNSM),
		('\x0D43',BidiNSM),
		('\x0D4D',BidiNSM),
		('\x0DCA',BidiNSM),
		('\x0DD2',BidiNSM),
		('\x0DD3',BidiNSM),
		('\x0DD4',BidiNSM),
		('\x0DD6',BidiNSM),
		('\x0E31',BidiNSM),
		('\x0E34',BidiNSM),
		('\x0E35',BidiNSM),
		('\x0E36',BidiNSM),
		('\x0E37',BidiNSM),
		('\x0E38',BidiNSM),
		('\x0E39',BidiNSM),
		('\x0E3A',BidiNSM),
		('\x0E3F',BidiET),
		('\x0E47',BidiNSM),
		('\x0E48',BidiNSM),
		('\x0E49',BidiNSM),
		('\x0E4A',BidiNSM),
		('\x0E4B',BidiNSM),
		('\x0E4C',BidiNSM),
		('\x0E4D',BidiNSM),
		('\x0E4E',BidiNSM),
		('\x0EB1',BidiNSM),
		('\x0EB4',BidiNSM),
		('\x0EB5',BidiNSM),
		('\x0EB6',BidiNSM),
		('\x0EB7',BidiNSM),
		('\x0EB8',BidiNSM),
		('\x0EB9',BidiNSM),
		('\x0EBB',BidiNSM),
		('\x0EBC',BidiNSM),
		('\x0EC8',BidiNSM),
		('\x0EC9',BidiNSM),
		('\x0ECA',BidiNSM),
		('\x0ECB',BidiNSM),
		('\x0ECC',BidiNSM),
		('\x0ECD',BidiNSM),
		('\x0F18',BidiNSM),
		('\x0F19',BidiNSM),
		('\x0F35',BidiNSM),
		('\x0F37',BidiNSM),
		('\x0F39',BidiNSM),
		('\x0F3A',BidiON),
		('\x0F3B',BidiON),
		('\x0F3C',BidiON),
		('\x0F3D',BidiON),
		('\x0F71',BidiNSM),
		('\x0F72',BidiNSM),
		('\x0F73',BidiNSM),
		('\x0F74',BidiNSM),
		('\x0F75',BidiNSM),
		('\x0F76',BidiNSM),
		('\x0F77',BidiNSM),
		('\x0F78',BidiNSM),
		('\x0F79',BidiNSM),
		('\x0F7A',BidiNSM),
		('\x0F7B',BidiNSM),
		('\x0F7C',BidiNSM),
		('\x0F7D',BidiNSM),
		('\x0F7E',BidiNSM),
		('\x0F80',BidiNSM),
		('\x0F81',BidiNSM),
		('\x0F82',BidiNSM),
		('\x0F83',BidiNSM),
		('\x0F84',BidiNSM),
		('\x0F86',BidiNSM),
		('\x0F87',BidiNSM),
		('\x0F90',BidiNSM),
		('\x0F91',BidiNSM),
		('\x0F92',BidiNSM),
		('\x0F93',BidiNSM),
		('\x0F94',BidiNSM),
		('\x0F95',BidiNSM),
		('\x0F96',BidiNSM),
		('\x0F97',BidiNSM),
		('\x0F99',BidiNSM),
		('\x0F9A',BidiNSM),
		('\x0F9B',BidiNSM),
		('\x0F9C',BidiNSM),
		('\x0F9D',BidiNSM),
		('\x0F9E',BidiNSM),
		('\x0F9F',BidiNSM),
		('\x0FA0',BidiNSM),
		('\x0FA1',BidiNSM),
		('\x0FA2',BidiNSM),
		('\x0FA3',BidiNSM),
		('\x0FA4',BidiNSM),
		('\x0FA5',BidiNSM),
		('\x0FA6',BidiNSM),
		('\x0FA7',BidiNSM),
		('\x0FA8',BidiNSM),
		('\x0FA9',BidiNSM),
		('\x0FAA',BidiNSM),
		('\x0FAB',BidiNSM),
		('\x0FAC',BidiNSM),
		('\x0FAD',BidiNSM),
		('\x0FAE',BidiNSM),
		('\x0FAF',BidiNSM),
		('\x0FB0',BidiNSM),
		('\x0FB1',BidiNSM),
		('\x0FB2',BidiNSM),
		('\x0FB3',BidiNSM),
		('\x0FB4',BidiNSM),
		('\x0FB5',BidiNSM),
		('\x0FB6',BidiNSM),
		('\x0FB7',BidiNSM),
		('\x0FB8',BidiNSM),
		('\x0FB9',BidiNSM),
		('\x0FBA',BidiNSM),
		('\x0FBB',BidiNSM),
		('\x0FBC',BidiNSM),
		('\x0FC6',BidiNSM),
		('\x102D',BidiNSM),
		('\x102E',BidiNSM),
		('\x102F',BidiNSM),
		('\x1030',BidiNSM),
		('\x1032',BidiNSM),
		('\x1036',BidiNSM),
		('\x1037',BidiNSM),
		('\x1039',BidiNSM),
		('\x1058',BidiNSM),
		('\x1059',BidiNSM),
		('\x1680',BidiWS),
		('\x169B',BidiON),
		('\x169C',BidiON),
		('\x1712',BidiNSM),
		('\x1713',BidiNSM),
		('\x1714',BidiNSM),
		('\x1732',BidiNSM),
		('\x1733',BidiNSM),
		('\x1734',BidiNSM),
		('\x1752',BidiNSM),
		('\x1753',BidiNSM),
		('\x1772',BidiNSM),
		('\x1773',BidiNSM),
		('\x17B7',BidiNSM),
		('\x17B8',BidiNSM),
		('\x17B9',BidiNSM),
		('\x17BA',BidiNSM),
		('\x17BB',BidiNSM),
		('\x17BC',BidiNSM),
		('\x17BD',BidiNSM),
		('\x17C6',BidiNSM),
		('\x17C9',BidiNSM),
		('\x17CA',BidiNSM),
		('\x17CB',BidiNSM),
		('\x17CC',BidiNSM),
		('\x17CD',BidiNSM),
		('\x17CE',BidiNSM),
		('\x17CF',BidiNSM),
		('\x17D0',BidiNSM),
		('\x17D1',BidiNSM),
		('\x17D2',BidiNSM),
		('\x17D3',BidiNSM),
		('\x17DB',BidiET),
		('\x1800',BidiON),
		('\x1801',BidiON),
		('\x1802',BidiON),
		('\x1803',BidiON),
		('\x1804',BidiON),
		('\x1805',BidiON),
		('\x1806',BidiON),
		('\x1807',BidiON),
		('\x1808',BidiON),
		('\x1809',BidiON),
		('\x180A',BidiON),
		('\x180B',BidiNSM),
		('\x180C',BidiNSM),
		('\x180D',BidiNSM),
		('\x180E',BidiBN),
		('\x18A9',BidiNSM),
		('\x1FBD',BidiON),
		('\x1FBF',BidiON),
		('\x1FC0',BidiON),
		('\x1FC1',BidiON),
		('\x1FCD',BidiON),
		('\x1FCE',BidiON),
		('\x1FCF',BidiON),
		('\x1FDD',BidiON),
		('\x1FDE',BidiON),
		('\x1FDF',BidiON),
		('\x1FED',BidiON),
		('\x1FEE',BidiON),
		('\x1FEF',BidiON),
		('\x1FFD',BidiON),
		('\x1FFE',BidiON),
		('\x2000',BidiWS),
		('\x2001',BidiWS),
		('\x2002',BidiWS),
		('\x2003',BidiWS),
		('\x2004',BidiWS),
		('\x2005',BidiWS),
		('\x2006',BidiWS),
		('\x2007',BidiWS),
		('\x2008',BidiWS),
		('\x2009',BidiWS),
		('\x200A',BidiWS),
		('\x200B',BidiBN),
		('\x200C',BidiBN),
		('\x200D',BidiBN),
		('\x200F',BidiR),
		('\x2010',BidiON),
		('\x2011',BidiON),
		('\x2012',BidiON),
		('\x2013',BidiON),
		('\x2014',BidiON),
		('\x2015',BidiON),
		('\x2016',BidiON),
		('\x2017',BidiON),
		('\x2018',BidiON),
		('\x2019',BidiON),
		('\x201A',BidiON),
		('\x201B',BidiON),
		('\x201C',BidiON),
		('\x201D',BidiON),
		('\x201E',BidiON),
		('\x201F',BidiON),
		('\x2020',BidiON),
		('\x2021',BidiON),
		('\x2022',BidiON),
		('\x2023',BidiON),
		('\x2024',BidiON),
		('\x2025',BidiON),
		('\x2026',BidiON),
		('\x2027',BidiON),
		('\x2028',BidiWS),
		('\x2029',BidiB),
		('\x202A',BidiLRE),
		('\x202B',BidiRLE),
		('\x202C',BidiPDF),
		('\x202D',BidiLRO),
		('\x202E',BidiRLO),
		('\x202F',BidiWS),
		('\x2030',BidiET),
		('\x2031',BidiET),
		('\x2032',BidiET),
		('\x2033',BidiET),
		('\x2034',BidiET),
		('\x2035',BidiON),
		('\x2036',BidiON),
		('\x2037',BidiON),
		('\x2038',BidiON),
		('\x2039',BidiON),
		('\x203A',BidiON),
		('\x203B',BidiON),
		('\x203C',BidiON),
		('\x203D',BidiON),
		('\x203E',BidiON),
		('\x203F',BidiON),
		('\x2040',BidiON),
		('\x2041',BidiON),
		('\x2042',BidiON),
		('\x2043',BidiON),
		('\x2044',BidiON),
		('\x2045',BidiON),
		('\x2046',BidiON),
		('\x2047',BidiON),
		('\x2048',BidiON),
		('\x2049',BidiON),
		('\x204A',BidiON),
		('\x204B',BidiON),
		('\x204C',BidiON),
		('\x204D',BidiON),
		('\x204E',BidiON),
		('\x204F',BidiON),
		('\x2050',BidiON),
		('\x2051',BidiON),
		('\x2052',BidiON),
		('\x2057',BidiON),
		('\x205F',BidiWS),
		('\x2060',BidiBN),
		('\x2061',BidiBN),
		('\x2062',BidiBN),
		('\x2063',BidiBN),
		('\x206A',BidiBN),
		('\x206B',BidiBN),
		('\x206C',BidiBN),
		('\x206D',BidiBN),
		('\x206E',BidiBN),
		('\x206F',BidiBN),
		('\x2070',BidiEN),
		('\x2074',BidiEN),
		('\x2075',BidiEN),
		('\x2076',BidiEN),
		('\x2077',BidiEN),
		('\x2078',BidiEN),
		('\x2079',BidiEN),
		('\x207A',BidiET),
		('\x207B',BidiET),
		('\x207C',BidiON),
		('\x207D',BidiON),
		('\x207E',BidiON),
		('\x2080',BidiEN),
		('\x2081',BidiEN),
		('\x2082',BidiEN),
		('\x2083',BidiEN),
		('\x2084',BidiEN),
		('\x2085',BidiEN),
		('\x2086',BidiEN),
		('\x2087',BidiEN),
		('\x2088',BidiEN),
		('\x2089',BidiEN),
		('\x208A',BidiET),
		('\x208B',BidiET),
		('\x208C',BidiON),
		('\x208D',BidiON),
		('\x208E',BidiON),
		('\x20A0',BidiET),
		('\x20A1',BidiET),
		('\x20A2',BidiET),
		('\x20A3',BidiET),
		('\x20A4',BidiET),
		('\x20A5',BidiET),
		('\x20A6',BidiET),
		('\x20A7',BidiET),
		('\x20A8',BidiET),
		('\x20A9',BidiET),
		('\x20AA',BidiET),
		('\x20AB',BidiET),
		('\x20AC',BidiET),
		('\x20AD',BidiET),
		('\x20AE',BidiET),
		('\x20AF',BidiET),
		('\x20B0',BidiET),
		('\x20B1',BidiET),
		('\x20D0',BidiNSM),
		('\x20D1',BidiNSM),
		('\x20D2',BidiNSM),
		('\x20D3',BidiNSM),
		('\x20D4',BidiNSM),
		('\x20D5',BidiNSM),
		('\x20D6',BidiNSM),
		('\x20D7',BidiNSM),
		('\x20D8',BidiNSM),
		('\x20D9',BidiNSM),
		('\x20DA',BidiNSM),
		('\x20DB',BidiNSM),
		('\x20DC',BidiNSM),
		('\x20DD',BidiNSM),
		('\x20DE',BidiNSM),
		('\x20DF',BidiNSM),
		('\x20E0',BidiNSM),
		('\x20E1',BidiNSM),
		('\x20E2',BidiNSM),
		('\x20E3',BidiNSM),
		('\x20E4',BidiNSM),
		('\x20E5',BidiNSM),
		('\x20E6',BidiNSM),
		('\x20E7',BidiNSM),
		('\x20E8',BidiNSM),
		('\x20E9',BidiNSM),
		('\x20EA',BidiNSM),
		('\x2100',BidiON),
		('\x2101',BidiON),
		('\x2103',BidiON),
		('\x2104',BidiON),
		('\x2105',BidiON),
		('\x2106',BidiON),
		('\x2108',BidiON),
		('\x2109',BidiON),
		('\x2114',BidiON),
		('\x2116',BidiON),
		('\x2117',BidiON),
		('\x2118',BidiON),
		('\x211E',BidiON),
		('\x211F',BidiON),
		('\x2120',BidiON),
		('\x2121',BidiON),
		('\x2122',BidiON),
		('\x2123',BidiON),
		('\x2125',BidiON),
		('\x2127',BidiON),
		('\x2129',BidiON),
		('\x212E',BidiET),
		('\x2132',BidiON),
		('\x213A',BidiON),
		('\x2140',BidiON),
		('\x2141',BidiON),
		('\x2142',BidiON),
		('\x2143',BidiON),
		('\x2144',BidiON),
		('\x214A',BidiON),
		('\x214B',BidiON),
		('\x2153',BidiON),
		('\x2154',BidiON),
		('\x2155',BidiON),
		('\x2156',BidiON),
		('\x2157',BidiON),
		('\x2158',BidiON),
		('\x2159',BidiON),
		('\x215A',BidiON),
		('\x215B',BidiON),
		('\x215C',BidiON),
		('\x215D',BidiON),
		('\x215E',BidiON),
		('\x215F',BidiON),
		('\x2190',BidiON),
		('\x2191',BidiON),
		('\x2192',BidiON),
		('\x2193',BidiON),
		('\x2194',BidiON),
		('\x2195',BidiON),
		('\x2196',BidiON),
		('\x2197',BidiON),
		('\x2198',BidiON),
		('\x2199',BidiON),
		('\x219A',BidiON),
		('\x219B',BidiON),
		('\x219C',BidiON),
		('\x219D',BidiON),
		('\x219E',BidiON),
		('\x219F',BidiON),
		('\x21A0',BidiON),
		('\x21A1',BidiON),
		('\x21A2',BidiON),
		('\x21A3',BidiON),
		('\x21A4',BidiON),
		('\x21A5',BidiON),
		('\x21A6',BidiON),
		('\x21A7',BidiON),
		('\x21A8',BidiON),
		('\x21A9',BidiON),
		('\x21AA',BidiON),
		('\x21AB',BidiON),
		('\x21AC',BidiON),
		('\x21AD',BidiON),
		('\x21AE',BidiON),
		('\x21AF',BidiON),
		('\x21B0',BidiON),
		('\x21B1',BidiON),
		('\x21B2',BidiON),
		('\x21B3',BidiON),
		('\x21B4',BidiON),
		('\x21B5',BidiON),
		('\x21B6',BidiON),
		('\x21B7',BidiON),
		('\x21B8',BidiON),
		('\x21B9',BidiON),
		('\x21BA',BidiON),
		('\x21BB',BidiON),
		('\x21BC',BidiON),
		('\x21BD',BidiON),
		('\x21BE',BidiON),
		('\x21BF',BidiON),
		('\x21C0',BidiON),
		('\x21C1',BidiON),
		('\x21C2',BidiON),
		('\x21C3',BidiON),
		('\x21C4',BidiON),
		('\x21C5',BidiON),
		('\x21C6',BidiON),
		('\x21C7',BidiON),
		('\x21C8',BidiON),
		('\x21C9',BidiON),
		('\x21CA',BidiON),
		('\x21CB',BidiON),
		('\x21CC',BidiON),
		('\x21CD',BidiON),
		('\x21CE',BidiON),
		('\x21CF',BidiON),
		('\x21D0',BidiON),
		('\x21D1',BidiON),
		('\x21D2',BidiON),
		('\x21D3',BidiON),
		('\x21D4',BidiON),
		('\x21D5',BidiON),
		('\x21D6',BidiON),
		('\x21D7',BidiON),
		('\x21D8',BidiON),
		('\x21D9',BidiON),
		('\x21DA',BidiON),
		('\x21DB',BidiON),
		('\x21DC',BidiON),
		('\x21DD',BidiON),
		('\x21DE',BidiON),
		('\x21DF',BidiON),
		('\x21E0',BidiON),
		('\x21E1',BidiON),
		('\x21E2',BidiON),
		('\x21E3',BidiON),
		('\x21E4',BidiON),
		('\x21E5',BidiON),
		('\x21E6',BidiON),
		('\x21E7',BidiON),
		('\x21E8',BidiON),
		('\x21E9',BidiON),
		('\x21EA',BidiON),
		('\x21EB',BidiON),
		('\x21EC',BidiON),
		('\x21ED',BidiON),
		('\x21EE',BidiON),
		('\x21EF',BidiON),
		('\x21F0',BidiON),
		('\x21F1',BidiON),
		('\x21F2',BidiON),
		('\x21F3',BidiON),
		('\x21F4',BidiON),
		('\x21F5',BidiON),
		('\x21F6',BidiON),
		('\x21F7',BidiON),
		('\x21F8',BidiON),
		('\x21F9',BidiON),
		('\x21FA',BidiON),
		('\x21FB',BidiON),
		('\x21FC',BidiON),
		('\x21FD',BidiON),
		('\x21FE',BidiON),
		('\x21FF',BidiON),
		('\x2200',BidiON),
		('\x2201',BidiON),
		('\x2202',BidiON),
		('\x2203',BidiON),
		('\x2204',BidiON),
		('\x2205',BidiON),
		('\x2206',BidiON),
		('\x2207',BidiON),
		('\x2208',BidiON),
		('\x2209',BidiON),
		('\x220A',BidiON),
		('\x220B',BidiON),
		('\x220C',BidiON),
		('\x220D',BidiON),
		('\x220E',BidiON),
		('\x220F',BidiON),
		('\x2210',BidiON),
		('\x2211',BidiON),
		('\x2212',BidiET),
		('\x2213',BidiET),
		('\x2214',BidiON),
		('\x2215',BidiON),
		('\x2216',BidiON),
		('\x2217',BidiON),
		('\x2218',BidiON),
		('\x2219',BidiON),
		('\x221A',BidiON),
		('\x221B',BidiON),
		('\x221C',BidiON),
		('\x221D',BidiON),
		('\x221E',BidiON),
		('\x221F',BidiON),
		('\x2220',BidiON),
		('\x2221',BidiON),
		('\x2222',BidiON),
		('\x2223',BidiON),
		('\x2224',BidiON),
		('\x2225',BidiON),
		('\x2226',BidiON),
		('\x2227',BidiON),
		('\x2228',BidiON),
		('\x2229',BidiON),
		('\x222A',BidiON),
		('\x222B',BidiON),
		('\x222C',BidiON),
		('\x222D',BidiON),
		('\x222E',BidiON),
		('\x222F',BidiON),
		('\x2230',BidiON),
		('\x2231',BidiON),
		('\x2232',BidiON),
		('\x2233',BidiON),
		('\x2234',BidiON),
		('\x2235',BidiON),
		('\x2236',BidiON),
		('\x2237',BidiON),
		('\x2238',BidiON),
		('\x2239',BidiON),
		('\x223A',BidiON),
		('\x223B',BidiON),
		('\x223C',BidiON),
		('\x223D',BidiON),
		('\x223E',BidiON),
		('\x223F',BidiON),
		('\x2240',BidiON),
		('\x2241',BidiON),
		('\x2242',BidiON),
		('\x2243',BidiON),
		('\x2244',BidiON),
		('\x2245',BidiON),
		('\x2246',BidiON),
		('\x2247',BidiON),
		('\x2248',BidiON),
		('\x2249',BidiON),
		('\x224A',BidiON),
		('\x224B',BidiON),
		('\x224C',BidiON),
		('\x224D',BidiON),
		('\x224E',BidiON),
		('\x224F',BidiON),
		('\x2250',BidiON),
		('\x2251',BidiON),
		('\x2252',BidiON),
		('\x2253',BidiON),
		('\x2254',BidiON),
		('\x2255',BidiON),
		('\x2256',BidiON),
		('\x2257',BidiON),
		('\x2258',BidiON),
		('\x2259',BidiON),
		('\x225A',BidiON),
		('\x225B',BidiON),
		('\x225C',BidiON),
		('\x225D',BidiON),
		('\x225E',BidiON),
		('\x225F',BidiON),
		('\x2260',BidiON),
		('\x2261',BidiON),
		('\x2262',BidiON),
		('\x2263',BidiON),
		('\x2264',BidiON),
		('\x2265',BidiON),
		('\x2266',BidiON),
		('\x2267',BidiON),
		('\x2268',BidiON),
		('\x2269',BidiON),
		('\x226A',BidiON),
		('\x226B',BidiON),
		('\x226C',BidiON),
		('\x226D',BidiON),
		('\x226E',BidiON),
		('\x226F',BidiON),
		('\x2270',BidiON),
		('\x2271',BidiON),
		('\x2272',BidiON),
		('\x2273',BidiON),
		('\x2274',BidiON),
		('\x2275',BidiON),
		('\x2276',BidiON),
		('\x2277',BidiON),
		('\x2278',BidiON),
		('\x2279',BidiON),
		('\x227A',BidiON),
		('\x227B',BidiON),
		('\x227C',BidiON),
		('\x227D',BidiON),
		('\x227E',BidiON),
		('\x227F',BidiON),
		('\x2280',BidiON),
		('\x2281',BidiON),
		('\x2282',BidiON),
		('\x2283',BidiON),
		('\x2284',BidiON),
		('\x2285',BidiON),
		('\x2286',BidiON),
		('\x2287',BidiON),
		('\x2288',BidiON),
		('\x2289',BidiON),
		('\x228A',BidiON),
		('\x228B',BidiON),
		('\x228C',BidiON),
		('\x228D',BidiON),
		('\x228E',BidiON),
		('\x228F',BidiON),
		('\x2290',BidiON),
		('\x2291',BidiON),
		('\x2292',BidiON),
		('\x2293',BidiON),
		('\x2294',BidiON),
		('\x2295',BidiON),
		('\x2296',BidiON),
		('\x2297',BidiON),
		('\x2298',BidiON),
		('\x2299',BidiON),
		('\x229A',BidiON),
		('\x229B',BidiON),
		('\x229C',BidiON),
		('\x229D',BidiON),
		('\x229E',BidiON),
		('\x229F',BidiON),
		('\x22A0',BidiON),
		('\x22A1',BidiON),
		('\x22A2',BidiON),
		('\x22A3',BidiON),
		('\x22A4',BidiON),
		('\x22A5',BidiON),
		('\x22A6',BidiON),
		('\x22A7',BidiON),
		('\x22A8',BidiON),
		('\x22A9',BidiON),
		('\x22AA',BidiON),
		('\x22AB',BidiON),
		('\x22AC',BidiON),
		('\x22AD',BidiON),
		('\x22AE',BidiON),
		('\x22AF',BidiON),
		('\x22B0',BidiON),
		('\x22B1',BidiON),
		('\x22B2',BidiON),
		('\x22B3',BidiON),
		('\x22B4',BidiON),
		('\x22B5',BidiON),
		('\x22B6',BidiON),
		('\x22B7',BidiON),
		('\x22B8',BidiON),
		('\x22B9',BidiON),
		('\x22BA',BidiON),
		('\x22BB',BidiON),
		('\x22BC',BidiON),
		('\x22BD',BidiON),
		('\x22BE',BidiON),
		('\x22BF',BidiON),
		('\x22C0',BidiON),
		('\x22C1',BidiON),
		('\x22C2',BidiON),
		('\x22C3',BidiON),
		('\x22C4',BidiON),
		('\x22C5',BidiON),
		('\x22C6',BidiON),
		('\x22C7',BidiON),
		('\x22C8',BidiON),
		('\x22C9',BidiON),
		('\x22CA',BidiON),
		('\x22CB',BidiON),
		('\x22CC',BidiON),
		('\x22CD',BidiON),
		('\x22CE',BidiON),
		('\x22CF',BidiON),
		('\x22D0',BidiON),
		('\x22D1',BidiON),
		('\x22D2',BidiON),
		('\x22D3',BidiON),
		('\x22D4',BidiON),
		('\x22D5',BidiON),
		('\x22D6',BidiON),
		('\x22D7',BidiON),
		('\x22D8',BidiON),
		('\x22D9',BidiON),
		('\x22DA',BidiON),
		('\x22DB',BidiON),
		('\x22DC',BidiON),
		('\x22DD',BidiON),
		('\x22DE',BidiON),
		('\x22DF',BidiON),
		('\x22E0',BidiON),
		('\x22E1',BidiON),
		('\x22E2',BidiON),
		('\x22E3',BidiON),
		('\x22E4',BidiON),
		('\x22E5',BidiON),
		('\x22E6',BidiON),
		('\x22E7',BidiON),
		('\x22E8',BidiON),
		('\x22E9',BidiON),
		('\x22EA',BidiON),
		('\x22EB',BidiON),
		('\x22EC',BidiON),
		('\x22ED',BidiON),
		('\x22EE',BidiON),
		('\x22EF',BidiON),
		('\x22F0',BidiON),
		('\x22F1',BidiON),
		('\x22F2',BidiON),
		('\x22F3',BidiON),
		('\x22F4',BidiON),
		('\x22F5',BidiON),
		('\x22F6',BidiON),
		('\x22F7',BidiON),
		('\x22F8',BidiON),
		('\x22F9',BidiON),
		('\x22FA',BidiON),
		('\x22FB',BidiON),
		('\x22FC',BidiON),
		('\x22FD',BidiON),
		('\x22FE',BidiON),
		('\x22FF',BidiON),
		('\x2300',BidiON),
		('\x2301',BidiON),
		('\x2302',BidiON),
		('\x2303',BidiON),
		('\x2304',BidiON),
		('\x2305',BidiON),
		('\x2306',BidiON),
		('\x2307',BidiON),
		('\x2308',BidiON),
		('\x2309',BidiON),
		('\x230A',BidiON),
		('\x230B',BidiON),
		('\x230C',BidiON),
		('\x230D',BidiON),
		('\x230E',BidiON),
		('\x230F',BidiON),
		('\x2310',BidiON),
		('\x2311',BidiON),
		('\x2312',BidiON),
		('\x2313',BidiON),
		('\x2314',BidiON),
		('\x2315',BidiON),
		('\x2316',BidiON),
		('\x2317',BidiON),
		('\x2318',BidiON),
		('\x2319',BidiON),
		('\x231A',BidiON),
		('\x231B',BidiON),
		('\x231C',BidiON),
		('\x231D',BidiON),
		('\x231E',BidiON),
		('\x231F',BidiON),
		('\x2320',BidiON),
		('\x2321',BidiON),
		('\x2322',BidiON),
		('\x2323',BidiON),
		('\x2324',BidiON),
		('\x2325',BidiON),
		('\x2326',BidiON),
		('\x2327',BidiON),
		('\x2328',BidiON),
		('\x2329',BidiON),
		('\x232A',BidiON),
		('\x232B',BidiON),
		('\x232C',BidiON),
		('\x232D',BidiON),
		('\x232E',BidiON),
		('\x232F',BidiON),
		('\x2330',BidiON),
		('\x2331',BidiON),
		('\x2332',BidiON),
		('\x2333',BidiON),
		('\x2334',BidiON),
		('\x2335',BidiON),
		('\x237B',BidiON),
		('\x237C',BidiON),
		('\x237D',BidiON),
		('\x237E',BidiON),
		('\x237F',BidiON),
		('\x2380',BidiON),
		('\x2381',BidiON),
		('\x2382',BidiON),
		('\x2383',BidiON),
		('\x2384',BidiON),
		('\x2385',BidiON),
		('\x2386',BidiON),
		('\x2387',BidiON),
		('\x2388',BidiON),
		('\x2389',BidiON),
		('\x238A',BidiON),
		('\x238B',BidiON),
		('\x238C',BidiON),
		('\x238D',BidiON),
		('\x238E',BidiON),
		('\x238F',BidiON),
		('\x2390',BidiON),
		('\x2391',BidiON),
		('\x2392',BidiON),
		('\x2393',BidiON),
		('\x2394',BidiON),
		('\x2396',BidiON),
		('\x2397',BidiON),
		('\x2398',BidiON),
		('\x2399',BidiON),
		('\x239A',BidiON),
		('\x239B',BidiON),
		('\x239C',BidiON),
		('\x239D',BidiON),
		('\x239E',BidiON),
		('\x239F',BidiON),
		('\x23A0',BidiON),
		('\x23A1',BidiON),
		('\x23A2',BidiON),
		('\x23A3',BidiON),
		('\x23A4',BidiON),
		('\x23A5',BidiON),
		('\x23A6',BidiON),
		('\x23A7',BidiON),
		('\x23A8',BidiON),
		('\x23A9',BidiON),
		('\x23AA',BidiON),
		('\x23AB',BidiON),
		('\x23AC',BidiON),
		('\x23AD',BidiON),
		('\x23AE',BidiON),
		('\x23AF',BidiON),
		('\x23B0',BidiON),
		('\x23B1',BidiON),
		('\x23B2',BidiON),
		('\x23B3',BidiON),
		('\x23B4',BidiON),
		('\x23B5',BidiON),
		('\x23B6',BidiON),
		('\x23B7',BidiON),
		('\x23B8',BidiON),
		('\x23B9',BidiON),
		('\x23BA',BidiON),
		('\x23BB',BidiON),
		('\x23BC',BidiON),
		('\x23BD',BidiON),
		('\x23BE',BidiON),
		('\x23BF',BidiON),
		('\x23C0',BidiON),
		('\x23C1',BidiON),
		('\x23C2',BidiON),
		('\x23C3',BidiON),
		('\x23C4',BidiON),
		('\x23C5',BidiON),
		('\x23C6',BidiON),
		('\x23C7',BidiON),
		('\x23C8',BidiON),
		('\x23C9',BidiON),
		('\x23CA',BidiON),
		('\x23CB',BidiON),
		('\x23CC',BidiON),
		('\x23CD',BidiON),
		('\x23CE',BidiON),
		('\x2400',BidiON),
		('\x2401',BidiON),
		('\x2402',BidiON),
		('\x2403',BidiON),
		('\x2404',BidiON),
		('\x2405',BidiON),
		('\x2406',BidiON),
		('\x2407',BidiON),
		('\x2408',BidiON),
		('\x2409',BidiON),
		('\x240A',BidiON),
		('\x240B',BidiON),
		('\x240C',BidiON),
		('\x240D',BidiON),
		('\x240E',BidiON),
		('\x240F',BidiON),
		('\x2410',BidiON),
		('\x2411',BidiON),
		('\x2412',BidiON),
		('\x2413',BidiON),
		('\x2414',BidiON),
		('\x2415',BidiON),
		('\x2416',BidiON),
		('\x2417',BidiON),
		('\x2418',BidiON),
		('\x2419',BidiON),
		('\x241A',BidiON),
		('\x241B',BidiON),
		('\x241C',BidiON),
		('\x241D',BidiON),
		('\x241E',BidiON),
		('\x241F',BidiON),
		('\x2420',BidiON),
		('\x2421',BidiON),
		('\x2422',BidiON),
		('\x2423',BidiON),
		('\x2424',BidiON),
		('\x2425',BidiON),
		('\x2426',BidiON),
		('\x2440',BidiON),
		('\x2441',BidiON),
		('\x2442',BidiON),
		('\x2443',BidiON),
		('\x2444',BidiON),
		('\x2445',BidiON),
		('\x2446',BidiON),
		('\x2447',BidiON),
		('\x2448',BidiON),
		('\x2449',BidiON),
		('\x244A',BidiON),
		('\x2460',BidiEN),
		('\x2461',BidiEN),
		('\x2462',BidiEN),
		('\x2463',BidiEN),
		('\x2464',BidiEN),
		('\x2465',BidiEN),
		('\x2466',BidiEN),
		('\x2467',BidiEN),
		('\x2468',BidiEN),
		('\x2469',BidiEN),
		('\x246A',BidiEN),
		('\x246B',BidiEN),
		('\x246C',BidiEN),
		('\x246D',BidiEN),
		('\x246E',BidiEN),
		('\x246F',BidiEN),
		('\x2470',BidiEN),
		('\x2471',BidiEN),
		('\x2472',BidiEN),
		('\x2473',BidiEN),
		('\x2474',BidiEN),
		('\x2475',BidiEN),
		('\x2476',BidiEN),
		('\x2477',BidiEN),
		('\x2478',BidiEN),
		('\x2479',BidiEN),
		('\x247A',BidiEN),
		('\x247B',BidiEN),
		('\x247C',BidiEN),
		('\x247D',BidiEN),
		('\x247E',BidiEN),
		('\x247F',BidiEN),
		('\x2480',BidiEN),
		('\x2481',BidiEN),
		('\x2482',BidiEN),
		('\x2483',BidiEN),
		('\x2484',BidiEN),
		('\x2485',BidiEN),
		('\x2486',BidiEN),
		('\x2487',BidiEN),
		('\x2488',BidiEN),
		('\x2489',BidiEN),
		('\x248A',BidiEN),
		('\x248B',BidiEN),
		('\x248C',BidiEN),
		('\x248D',BidiEN),
		('\x248E',BidiEN),
		('\x248F',BidiEN),
		('\x2490',BidiEN),
		('\x2491',BidiEN),
		('\x2492',BidiEN),
		('\x2493',BidiEN),
		('\x2494',BidiEN),
		('\x2495',BidiEN),
		('\x2496',BidiEN),
		('\x2497',BidiEN),
		('\x2498',BidiEN),
		('\x2499',BidiEN),
		('\x249A',BidiEN),
		('\x249B',BidiEN),
		('\x24EA',BidiEN),
		('\x24EB',BidiON),
		('\x24EC',BidiON),
		('\x24ED',BidiON),
		('\x24EE',BidiON),
		('\x24EF',BidiON),
		('\x24F0',BidiON),
		('\x24F1',BidiON),
		('\x24F2',BidiON),
		('\x24F3',BidiON),
		('\x24F4',BidiON),
		('\x24F5',BidiON),
		('\x24F6',BidiON),
		('\x24F7',BidiON),
		('\x24F8',BidiON),
		('\x24F9',BidiON),
		('\x24FA',BidiON),
		('\x24FB',BidiON),
		('\x24FC',BidiON),
		('\x24FD',BidiON),
		('\x24FE',BidiON),
		('\x2500',BidiON),
		('\x2501',BidiON),
		('\x2502',BidiON),
		('\x2503',BidiON),
		('\x2504',BidiON),
		('\x2505',BidiON),
		('\x2506',BidiON),
		('\x2507',BidiON),
		('\x2508',BidiON),
		('\x2509',BidiON),
		('\x250A',BidiON),
		('\x250B',BidiON),
		('\x250C',BidiON),
		('\x250D',BidiON),
		('\x250E',BidiON),
		('\x250F',BidiON),
		('\x2510',BidiON),
		('\x2511',BidiON),
		('\x2512',BidiON),
		('\x2513',BidiON),
		('\x2514',BidiON),
		('\x2515',BidiON),
		('\x2516',BidiON),
		('\x2517',BidiON),
		('\x2518',BidiON),
		('\x2519',BidiON),
		('\x251A',BidiON),
		('\x251B',BidiON),
		('\x251C',BidiON),
		('\x251D',BidiON),
		('\x251E',BidiON),
		('\x251F',BidiON),
		('\x2520',BidiON),
		('\x2521',BidiON),
		('\x2522',BidiON),
		('\x2523',BidiON),
		('\x2524',BidiON),
		('\x2525',BidiON),
		('\x2526',BidiON),
		('\x2527',BidiON),
		('\x2528',BidiON),
		('\x2529',BidiON),
		('\x252A',BidiON),
		('\x252B',BidiON),
		('\x252C',BidiON),
		('\x252D',BidiON),
		('\x252E',BidiON),
		('\x252F',BidiON),
		('\x2530',BidiON),
		('\x2531',BidiON),
		('\x2532',BidiON),
		('\x2533',BidiON),
		('\x2534',BidiON),
		('\x2535',BidiON),
		('\x2536',BidiON),
		('\x2537',BidiON),
		('\x2538',BidiON),
		('\x2539',BidiON),
		('\x253A',BidiON),
		('\x253B',BidiON),
		('\x253C',BidiON),
		('\x253D',BidiON),
		('\x253E',BidiON),
		('\x253F',BidiON),
		('\x2540',BidiON),
		('\x2541',BidiON),
		('\x2542',BidiON),
		('\x2543',BidiON),
		('\x2544',BidiON),
		('\x2545',BidiON),
		('\x2546',BidiON),
		('\x2547',BidiON),
		('\x2548',BidiON),
		('\x2549',BidiON),
		('\x254A',BidiON),
		('\x254B',BidiON),
		('\x254C',BidiON),
		('\x254D',BidiON),
		('\x254E',BidiON),
		('\x254F',BidiON),
		('\x2550',BidiON),
		('\x2551',BidiON),
		('\x2552',BidiON),
		('\x2553',BidiON),
		('\x2554',BidiON),
		('\x2555',BidiON),
		('\x2556',BidiON),
		('\x2557',BidiON),
		('\x2558',BidiON),
		('\x2559',BidiON),
		('\x255A',BidiON),
		('\x255B',BidiON),
		('\x255C',BidiON),
		('\x255D',BidiON),
		('\x255E',BidiON),
		('\x255F',BidiON),
		('\x2560',BidiON),
		('\x2561',BidiON),
		('\x2562',BidiON),
		('\x2563',BidiON),
		('\x2564',BidiON),
		('\x2565',BidiON),
		('\x2566',BidiON),
		('\x2567',BidiON),
		('\x2568',BidiON),
		('\x2569',BidiON),
		('\x256A',BidiON),
		('\x256B',BidiON),
		('\x256C',BidiON),
		('\x256D',BidiON),
		('\x256E',BidiON),
		('\x256F',BidiON),
		('\x2570',BidiON),
		('\x2571',BidiON),
		('\x2572',BidiON),
		('\x2573',BidiON),
		('\x2574',BidiON),
		('\x2575',BidiON),
		('\x2576',BidiON),
		('\x2577',BidiON),
		('\x2578',BidiON),
		('\x2579',BidiON),
		('\x257A',BidiON),
		('\x257B',BidiON),
		('\x257C',BidiON),
		('\x257D',BidiON),
		('\x257E',BidiON),
		('\x257F',BidiON),
		('\x2580',BidiON),
		('\x2581',BidiON),
		('\x2582',BidiON),
		('\x2583',BidiON),
		('\x2584',BidiON),
		('\x2585',BidiON),
		('\x2586',BidiON),
		('\x2587',BidiON),
		('\x2588',BidiON),
		('\x2589',BidiON),
		('\x258A',BidiON),
		('\x258B',BidiON),
		('\x258C',BidiON),
		('\x258D',BidiON),
		('\x258E',BidiON),
		('\x258F',BidiON),
		('\x2590',BidiON),
		('\x2591',BidiON),
		('\x2592',BidiON),
		('\x2593',BidiON),
		('\x2594',BidiON),
		('\x2595',BidiON),
		('\x2596',BidiON),
		('\x2597',BidiON),
		('\x2598',BidiON),
		('\x2599',BidiON),
		('\x259A',BidiON),
		('\x259B',BidiON),
		('\x259C',BidiON),
		('\x259D',BidiON),
		('\x259E',BidiON),
		('\x259F',BidiON),
		('\x25A0',BidiON),
		('\x25A1',BidiON),
		('\x25A2',BidiON),
		('\x25A3',BidiON),
		('\x25A4',BidiON),
		('\x25A5',BidiON),
		('\x25A6',BidiON),
		('\x25A7',BidiON),
		('\x25A8',BidiON),
		('\x25A9',BidiON),
		('\x25AA',BidiON),
		('\x25AB',BidiON),
		('\x25AC',BidiON),
		('\x25AD',BidiON),
		('\x25AE',BidiON),
		('\x25AF',BidiON),
		('\x25B0',BidiON),
		('\x25B1',BidiON),
		('\x25B2',BidiON),
		('\x25B3',BidiON),
		('\x25B4',BidiON),
		('\x25B5',BidiON),
		('\x25B6',BidiON),
		('\x25B7',BidiON),
		('\x25B8',BidiON),
		('\x25B9',BidiON),
		('\x25BA',BidiON),
		('\x25BB',BidiON),
		('\x25BC',BidiON),
		('\x25BD',BidiON),
		('\x25BE',BidiON),
		('\x25BF',BidiON),
		('\x25C0',BidiON),
		('\x25C1',BidiON),
		('\x25C2',BidiON),
		('\x25C3',BidiON),
		('\x25C4',BidiON),
		('\x25C5',BidiON),
		('\x25C6',BidiON),
		('\x25C7',BidiON),
		('\x25C8',BidiON),
		('\x25C9',BidiON),
		('\x25CA',BidiON),
		('\x25CB',BidiON),
		('\x25CC',BidiON),
		('\x25CD',BidiON),
		('\x25CE',BidiON),
		('\x25CF',BidiON),
		('\x25D0',BidiON),
		('\x25D1',BidiON),
		('\x25D2',BidiON),
		('\x25D3',BidiON),
		('\x25D4',BidiON),
		('\x25D5',BidiON),
		('\x25D6',BidiON),
		('\x25D7',BidiON),
		('\x25D8',BidiON),
		('\x25D9',BidiON),
		('\x25DA',BidiON),
		('\x25DB',BidiON),
		('\x25DC',BidiON),
		('\x25DD',BidiON),
		('\x25DE',BidiON),
		('\x25DF',BidiON),
		('\x25E0',BidiON),
		('\x25E1',BidiON),
		('\x25E2',BidiON),
		('\x25E3',BidiON),
		('\x25E4',BidiON),
		('\x25E5',BidiON),
		('\x25E6',BidiON),
		('\x25E7',BidiON),
		('\x25E8',BidiON),
		('\x25E9',BidiON),
		('\x25EA',BidiON),
		('\x25EB',BidiON),
		('\x25EC',BidiON),
		('\x25ED',BidiON),
		('\x25EE',BidiON),
		('\x25EF',BidiON),
		('\x25F0',BidiON),
		('\x25F1',BidiON),
		('\x25F2',BidiON),
		('\x25F3',BidiON),
		('\x25F4',BidiON),
		('\x25F5',BidiON),
		('\x25F6',BidiON),
		('\x25F7',BidiON),
		('\x25F8',BidiON),
		('\x25F9',BidiON),
		('\x25FA',BidiON),
		('\x25FB',BidiON),
		('\x25FC',BidiON),
		('\x25FD',BidiON),
		('\x25FE',BidiON),
		('\x25FF',BidiON),
		('\x2600',BidiON),
		('\x2601',BidiON),
		('\x2602',BidiON),
		('\x2603',BidiON),
		('\x2604',BidiON),
		('\x2605',BidiON),
		('\x2606',BidiON),
		('\x2607',BidiON),
		('\x2608',BidiON),
		('\x2609',BidiON),
		('\x260A',BidiON),
		('\x260B',BidiON),
		('\x260C',BidiON),
		('\x260D',BidiON),
		('\x260E',BidiON),
		('\x260F',BidiON),
		('\x2610',BidiON),
		('\x2611',BidiON),
		('\x2612',BidiON),
		('\x2613',BidiON),
		('\x2616',BidiON),
		('\x2617',BidiON),
		('\x2619',BidiON),
		('\x261A',BidiON),
		('\x261B',BidiON),
		('\x261C',BidiON),
		('\x261D',BidiON),
		('\x261E',BidiON),
		('\x261F',BidiON),
		('\x2620',BidiON),
		('\x2621',BidiON),
		('\x2622',BidiON),
		('\x2623',BidiON),
		('\x2624',BidiON),
		('\x2625',BidiON),
		('\x2626',BidiON),
		('\x2627',BidiON),
		('\x2628',BidiON),
		('\x2629',BidiON),
		('\x262A',BidiON),
		('\x262B',BidiON),
		('\x262C',BidiON),
		('\x262D',BidiON),
		('\x262E',BidiON),
		('\x262F',BidiON),
		('\x2630',BidiON),
		('\x2631',BidiON),
		('\x2632',BidiON),
		('\x2633',BidiON),
		('\x2634',BidiON),
		('\x2635',BidiON),
		('\x2636',BidiON),
		('\x2637',BidiON),
		('\x2638',BidiON),
		('\x2639',BidiON),
		('\x263A',BidiON),
		('\x263B',BidiON),
		('\x263C',BidiON),
		('\x263D',BidiON),
		('\x263E',BidiON),
		('\x263F',BidiON),
		('\x2640',BidiON),
		('\x2641',BidiON),
		('\x2642',BidiON),
		('\x2643',BidiON),
		('\x2644',BidiON),
		('\x2645',BidiON),
		('\x2646',BidiON),
		('\x2647',BidiON),
		('\x2648',BidiON),
		('\x2649',BidiON),
		('\x264A',BidiON),
		('\x264B',BidiON),
		('\x264C',BidiON),
		('\x264D',BidiON),
		('\x264E',BidiON),
		('\x264F',BidiON),
		('\x2650',BidiON),
		('\x2651',BidiON),
		('\x2652',BidiON),
		('\x2653',BidiON),
		('\x2654',BidiON),
		('\x2655',BidiON),
		('\x2656',BidiON),
		('\x2657',BidiON),
		('\x2658',BidiON),
		('\x2659',BidiON),
		('\x265A',BidiON),
		('\x265B',BidiON),
		('\x265C',BidiON),
		('\x265D',BidiON),
		('\x265E',BidiON),
		('\x265F',BidiON),
		('\x2660',BidiON),
		('\x2661',BidiON),
		('\x2662',BidiON),
		('\x2663',BidiON),
		('\x2664',BidiON),
		('\x2665',BidiON),
		('\x2666',BidiON),
		('\x2667',BidiON),
		('\x2668',BidiON),
		('\x2669',BidiON),
		('\x266A',BidiON),
		('\x266B',BidiON),
		('\x266C',BidiON),
		('\x266D',BidiON),
		('\x266E',BidiON),
		('\x266F',BidiON),
		('\x2670',BidiON),
		('\x2671',BidiON),
		('\x2672',BidiON),
		('\x2673',BidiON),
		('\x2674',BidiON),
		('\x2675',BidiON),
		('\x2676',BidiON),
		('\x2677',BidiON),
		('\x2678',BidiON),
		('\x2679',BidiON),
		('\x267A',BidiON),
		('\x267B',BidiON),
		('\x267C',BidiON),
		('\x267D',BidiON),
		('\x2680',BidiON),
		('\x2681',BidiON),
		('\x2682',BidiON),
		('\x2683',BidiON),
		('\x2684',BidiON),
		('\x2685',BidiON),
		('\x2686',BidiON),
		('\x2687',BidiON),
		('\x2688',BidiON),
		('\x2689',BidiON),
		('\x2701',BidiON),
		('\x2702',BidiON),
		('\x2703',BidiON),
		('\x2704',BidiON),
		('\x2706',BidiON),
		('\x2707',BidiON),
		('\x2708',BidiON),
		('\x2709',BidiON),
		('\x270C',BidiON),
		('\x270D',BidiON),
		('\x270E',BidiON),
		('\x270F',BidiON),
		('\x2710',BidiON),
		('\x2711',BidiON),
		('\x2712',BidiON),
		('\x2713',BidiON),
		('\x2714',BidiON),
		('\x2715',BidiON),
		('\x2716',BidiON),
		('\x2717',BidiON),
		('\x2718',BidiON),
		('\x2719',BidiON),
		('\x271A',BidiON),
		('\x271B',BidiON),
		('\x271C',BidiON),
		('\x271D',BidiON),
		('\x271E',BidiON),
		('\x271F',BidiON),
		('\x2720',BidiON),
		('\x2721',BidiON),
		('\x2722',BidiON),
		('\x2723',BidiON),
		('\x2724',BidiON),
		('\x2725',BidiON),
		('\x2726',BidiON),
		('\x2727',BidiON),
		('\x2729',BidiON),
		('\x272A',BidiON),
		('\x272B',BidiON),
		('\x272C',BidiON),
		('\x272D',BidiON),
		('\x272E',BidiON),
		('\x272F',BidiON),
		('\x2730',BidiON),
		('\x2731',BidiON),
		('\x2732',BidiON),
		('\x2733',BidiON),
		('\x2734',BidiON),
		('\x2735',BidiON),
		('\x2736',BidiON),
		('\x2737',BidiON),
		('\x2738',BidiON),
		('\x2739',BidiON),
		('\x273A',BidiON),
		('\x273B',BidiON),
		('\x273C',BidiON),
		('\x273D',BidiON),
		('\x273E',BidiON),
		('\x273F',BidiON),
		('\x2740',BidiON),
		('\x2741',BidiON),
		('\x2742',BidiON),
		('\x2743',BidiON),
		('\x2744',BidiON),
		('\x2745',BidiON),
		('\x2746',BidiON),
		('\x2747',BidiON),
		('\x2748',BidiON),
		('\x2749',BidiON),
		('\x274A',BidiON),
		('\x274B',BidiON),
		('\x274D',BidiON),
		('\x274F',BidiON),
		('\x2750',BidiON),
		('\x2751',BidiON),
		('\x2752',BidiON),
		('\x2756',BidiON),
		('\x2758',BidiON),
		('\x2759',BidiON),
		('\x275A',BidiON),
		('\x275B',BidiON),
		('\x275C',BidiON),
		('\x275D',BidiON),
		('\x275E',BidiON),
		('\x2761',BidiON),
		('\x2762',BidiON),
		('\x2763',BidiON),
		('\x2764',BidiON),
		('\x2765',BidiON),
		('\x2766',BidiON),
		('\x2767',BidiON),
		('\x2768',BidiON),
		('\x2769',BidiON),
		('\x276A',BidiON),
		('\x276B',BidiON),
		('\x276C',BidiON),
		('\x276D',BidiON),
		('\x276E',BidiON),
		('\x276F',BidiON),
		('\x2770',BidiON),
		('\x2771',BidiON),
		('\x2772',BidiON),
		('\x2773',BidiON),
		('\x2774',BidiON),
		('\x2775',BidiON),
		('\x2776',BidiON),
		('\x2777',BidiON),
		('\x2778',BidiON),
		('\x2779',BidiON),
		('\x277A',BidiON),
		('\x277B',BidiON),
		('\x277C',BidiON),
		('\x277D',BidiON),
		('\x277E',BidiON),
		('\x277F',BidiON),
		('\x2780',BidiON),
		('\x2781',BidiON),
		('\x2782',BidiON),
		('\x2783',BidiON),
		('\x2784',BidiON),
		('\x2785',BidiON),
		('\x2786',BidiON),
		('\x2787',BidiON),
		('\x2788',BidiON),
		('\x2789',BidiON),
		('\x278A',BidiON),
		('\x278B',BidiON),
		('\x278C',BidiON),
		('\x278D',BidiON),
		('\x278E',BidiON),
		('\x278F',BidiON),
		('\x2790',BidiON),
		('\x2791',BidiON),
		('\x2792',BidiON),
		('\x2793',BidiON),
		('\x2794',BidiON),
		('\x2798',BidiON),
		('\x2799',BidiON),
		('\x279A',BidiON),
		('\x279B',BidiON),
		('\x279C',BidiON),
		('\x279D',BidiON),
		('\x279E',BidiON),
		('\x279F',BidiON),
		('\x27A0',BidiON),
		('\x27A1',BidiON),
		('\x27A2',BidiON),
		('\x27A3',BidiON),
		('\x27A4',BidiON),
		('\x27A5',BidiON),
		('\x27A6',BidiON),
		('\x27A7',BidiON),
		('\x27A8',BidiON),
		('\x27A9',BidiON),
		('\x27AA',BidiON),
		('\x27AB',BidiON),
		('\x27AC',BidiON),
		('\x27AD',BidiON),
		('\x27AE',BidiON),
		('\x27AF',BidiON),
		('\x27B1',BidiON),
		('\x27B2',BidiON),
		('\x27B3',BidiON),
		('\x27B4',BidiON),
		('\x27B5',BidiON),
		('\x27B6',BidiON),
		('\x27B7',BidiON),
		('\x27B8',BidiON),
		('\x27B9',BidiON),
		('\x27BA',BidiON),
		('\x27BB',BidiON),
		('\x27BC',BidiON),
		('\x27BD',BidiON),
		('\x27BE',BidiON),
		('\x27D0',BidiON),
		('\x27D1',BidiON),
		('\x27D2',BidiON),
		('\x27D3',BidiON),
		('\x27D4',BidiON),
		('\x27D5',BidiON),
		('\x27D6',BidiON),
		('\x27D7',BidiON),
		('\x27D8',BidiON),
		('\x27D9',BidiON),
		('\x27DA',BidiON),
		('\x27DB',BidiON),
		('\x27DC',BidiON),
		('\x27DD',BidiON),
		('\x27DE',BidiON),
		('\x27DF',BidiON),
		('\x27E0',BidiON),
		('\x27E1',BidiON),
		('\x27E2',BidiON),
		('\x27E3',BidiON),
		('\x27E4',BidiON),
		('\x27E5',BidiON),
		('\x27E6',BidiON),
		('\x27E7',BidiON),
		('\x27E8',BidiON),
		('\x27E9',BidiON),
		('\x27EA',BidiON),
		('\x27EB',BidiON),
		('\x27F0',BidiON),
		('\x27F1',BidiON),
		('\x27F2',BidiON),
		('\x27F3',BidiON),
		('\x27F4',BidiON),
		('\x27F5',BidiON),
		('\x27F6',BidiON),
		('\x27F7',BidiON),
		('\x27F8',BidiON),
		('\x27F9',BidiON),
		('\x27FA',BidiON),
		('\x27FB',BidiON),
		('\x27FC',BidiON),
		('\x27FD',BidiON),
		('\x27FE',BidiON),
		('\x27FF',BidiON),
		('\x2800',BidiON),
		('\x2801',BidiON),
		('\x2802',BidiON),
		('\x2803',BidiON),
		('\x2804',BidiON),
		('\x2805',BidiON),
		('\x2806',BidiON),
		('\x2807',BidiON),
		('\x2808',BidiON),
		('\x2809',BidiON),
		('\x280A',BidiON),
		('\x280B',BidiON),
		('\x280C',BidiON),
		('\x280D',BidiON),
		('\x280E',BidiON),
		('\x280F',BidiON),
		('\x2810',BidiON),
		('\x2811',BidiON),
		('\x2812',BidiON),
		('\x2813',BidiON),
		('\x2814',BidiON),
		('\x2815',BidiON),
		('\x2816',BidiON),
		('\x2817',BidiON),
		('\x2818',BidiON),
		('\x2819',BidiON),
		('\x281A',BidiON),
		('\x281B',BidiON),
		('\x281C',BidiON),
		('\x281D',BidiON),
		('\x281E',BidiON),
		('\x281F',BidiON),
		('\x2820',BidiON),
		('\x2821',BidiON),
		('\x2822',BidiON),
		('\x2823',BidiON),
		('\x2824',BidiON),
		('\x2825',BidiON),
		('\x2826',BidiON),
		('\x2827',BidiON),
		('\x2828',BidiON),
		('\x2829',BidiON),
		('\x282A',BidiON),
		('\x282B',BidiON),
		('\x282C',BidiON),
		('\x282D',BidiON),
		('\x282E',BidiON),
		('\x282F',BidiON),
		('\x2830',BidiON),
		('\x2831',BidiON),
		('\x2832',BidiON),
		('\x2833',BidiON),
		('\x2834',BidiON),
		('\x2835',BidiON),
		('\x2836',BidiON),
		('\x2837',BidiON),
		('\x2838',BidiON),
		('\x2839',BidiON),
		('\x283A',BidiON),
		('\x283B',BidiON),
		('\x283C',BidiON),
		('\x283D',BidiON),
		('\x283E',BidiON),
		('\x283F',BidiON),
		('\x2840',BidiON),
		('\x2841',BidiON),
		('\x2842',BidiON),
		('\x2843',BidiON),
		('\x2844',BidiON),
		('\x2845',BidiON),
		('\x2846',BidiON),
		('\x2847',BidiON),
		('\x2848',BidiON),
		('\x2849',BidiON),
		('\x284A',BidiON),
		('\x284B',BidiON),
		('\x284C',BidiON),
		('\x284D',BidiON),
		('\x284E',BidiON),
		('\x284F',BidiON),
		('\x2850',BidiON),
		('\x2851',BidiON),
		('\x2852',BidiON),
		('\x2853',BidiON),
		('\x2854',BidiON),
		('\x2855',BidiON),
		('\x2856',BidiON),
		('\x2857',BidiON),
		('\x2858',BidiON),
		('\x2859',BidiON),
		('\x285A',BidiON),
		('\x285B',BidiON),
		('\x285C',BidiON),
		('\x285D',BidiON),
		('\x285E',BidiON),
		('\x285F',BidiON),
		('\x2860',BidiON),
		('\x2861',BidiON),
		('\x2862',BidiON),
		('\x2863',BidiON),
		('\x2864',BidiON),
		('\x2865',BidiON),
		('\x2866',BidiON),
		('\x2867',BidiON),
		('\x2868',BidiON),
		('\x2869',BidiON),
		('\x286A',BidiON),
		('\x286B',BidiON),
		('\x286C',BidiON),
		('\x286D',BidiON),
		('\x286E',BidiON),
		('\x286F',BidiON),
		('\x2870',BidiON),
		('\x2871',BidiON),
		('\x2872',BidiON),
		('\x2873',BidiON),
		('\x2874',BidiON),
		('\x2875',BidiON),
		('\x2876',BidiON),
		('\x2877',BidiON),
		('\x2878',BidiON),
		('\x2879',BidiON),
		('\x287A',BidiON),
		('\x287B',BidiON),
		('\x287C',BidiON),
		('\x287D',BidiON),
		('\x287E',BidiON),
		('\x287F',BidiON),
		('\x2880',BidiON),
		('\x2881',BidiON),
		('\x2882',BidiON),
		('\x2883',BidiON),
		('\x2884',BidiON),
		('\x2885',BidiON),
		('\x2886',BidiON),
		('\x2887',BidiON),
		('\x2888',BidiON),
		('\x2889',BidiON),
		('\x288A',BidiON),
		('\x288B',BidiON),
		('\x288C',BidiON),
		('\x288D',BidiON),
		('\x288E',BidiON),
		('\x288F',BidiON),
		('\x2890',BidiON),
		('\x2891',BidiON),
		('\x2892',BidiON),
		('\x2893',BidiON),
		('\x2894',BidiON),
		('\x2895',BidiON),
		('\x2896',BidiON),
		('\x2897',BidiON),
		('\x2898',BidiON),
		('\x2899',BidiON),
		('\x289A',BidiON),
		('\x289B',BidiON),
		('\x289C',BidiON),
		('\x289D',BidiON),
		('\x289E',BidiON),
		('\x289F',BidiON),
		('\x28A0',BidiON),
		('\x28A1',BidiON),
		('\x28A2',BidiON),
		('\x28A3',BidiON),
		('\x28A4',BidiON),
		('\x28A5',BidiON),
		('\x28A6',BidiON),
		('\x28A7',BidiON),
		('\x28A8',BidiON),
		('\x28A9',BidiON),
		('\x28AA',BidiON),
		('\x28AB',BidiON),
		('\x28AC',BidiON),
		('\x28AD',BidiON),
		('\x28AE',BidiON),
		('\x28AF',BidiON),
		('\x28B0',BidiON),
		('\x28B1',BidiON),
		('\x28B2',BidiON),
		('\x28B3',BidiON),
		('\x28B4',BidiON),
		('\x28B5',BidiON),
		('\x28B6',BidiON),
		('\x28B7',BidiON),
		('\x28B8',BidiON),
		('\x28B9',BidiON),
		('\x28BA',BidiON),
		('\x28BB',BidiON),
		('\x28BC',BidiON),
		('\x28BD',BidiON),
		('\x28BE',BidiON),
		('\x28BF',BidiON),
		('\x28C0',BidiON),
		('\x28C1',BidiON),
		('\x28C2',BidiON),
		('\x28C3',BidiON),
		('\x28C4',BidiON),
		('\x28C5',BidiON),
		('\x28C6',BidiON),
		('\x28C7',BidiON),
		('\x28C8',BidiON),
		('\x28C9',BidiON),
		('\x28CA',BidiON),
		('\x28CB',BidiON),
		('\x28CC',BidiON),
		('\x28CD',BidiON),
		('\x28CE',BidiON),
		('\x28CF',BidiON),
		('\x28D0',BidiON),
		('\x28D1',BidiON),
		('\x28D2',BidiON),
		('\x28D3',BidiON),
		('\x28D4',BidiON),
		('\x28D5',BidiON),
		('\x28D6',BidiON),
		('\x28D7',BidiON),
		('\x28D8',BidiON),
		('\x28D9',BidiON),
		('\x28DA',BidiON),
		('\x28DB',BidiON),
		('\x28DC',BidiON),
		('\x28DD',BidiON),
		('\x28DE',BidiON),
		('\x28DF',BidiON),
		('\x28E0',BidiON),
		('\x28E1',BidiON),
		('\x28E2',BidiON),
		('\x28E3',BidiON),
		('\x28E4',BidiON),
		('\x28E5',BidiON),
		('\x28E6',BidiON),
		('\x28E7',BidiON),
		('\x28E8',BidiON),
		('\x28E9',BidiON),
		('\x28EA',BidiON),
		('\x28EB',BidiON),
		('\x28EC',BidiON),
		('\x28ED',BidiON),
		('\x28EE',BidiON),
		('\x28EF',BidiON),
		('\x28F0',BidiON),
		('\x28F1',BidiON),
		('\x28F2',BidiON),
		('\x28F3',BidiON),
		('\x28F4',BidiON),
		('\x28F5',BidiON),
		('\x28F6',BidiON),
		('\x28F7',BidiON),
		('\x28F8',BidiON),
		('\x28F9',BidiON),
		('\x28FA',BidiON),
		('\x28FB',BidiON),
		('\x28FC',BidiON),
		('\x28FD',BidiON),
		('\x28FE',BidiON),
		('\x28FF',BidiON),
		('\x2900',BidiON),
		('\x2901',BidiON),
		('\x2902',BidiON),
		('\x2903',BidiON),
		('\x2904',BidiON),
		('\x2905',BidiON),
		('\x2906',BidiON),
		('\x2907',BidiON),
		('\x2908',BidiON),
		('\x2909',BidiON),
		('\x290A',BidiON),
		('\x290B',BidiON),
		('\x290C',BidiON),
		('\x290D',BidiON),
		('\x290E',BidiON),
		('\x290F',BidiON),
		('\x2910',BidiON),
		('\x2911',BidiON),
		('\x2912',BidiON),
		('\x2913',BidiON),
		('\x2914',BidiON),
		('\x2915',BidiON),
		('\x2916',BidiON),
		('\x2917',BidiON),
		('\x2918',BidiON),
		('\x2919',BidiON),
		('\x291A',BidiON),
		('\x291B',BidiON),
		('\x291C',BidiON),
		('\x291D',BidiON),
		('\x291E',BidiON),
		('\x291F',BidiON),
		('\x2920',BidiON),
		('\x2921',BidiON),
		('\x2922',BidiON),
		('\x2923',BidiON),
		('\x2924',BidiON),
		('\x2925',BidiON),
		('\x2926',BidiON),
		('\x2927',BidiON),
		('\x2928',BidiON),
		('\x2929',BidiON),
		('\x292A',BidiON),
		('\x292B',BidiON),
		('\x292C',BidiON),
		('\x292D',BidiON),
		('\x292E',BidiON),
		('\x292F',BidiON),
		('\x2930',BidiON),
		('\x2931',BidiON),
		('\x2932',BidiON),
		('\x2933',BidiON),
		('\x2934',BidiON),
		('\x2935',BidiON),
		('\x2936',BidiON),
		('\x2937',BidiON),
		('\x2938',BidiON),
		('\x2939',BidiON),
		('\x293A',BidiON),
		('\x293B',BidiON),
		('\x293C',BidiON),
		('\x293D',BidiON),
		('\x293E',BidiON),
		('\x293F',BidiON),
		('\x2940',BidiON),
		('\x2941',BidiON),
		('\x2942',BidiON),
		('\x2943',BidiON),
		('\x2944',BidiON),
		('\x2945',BidiON),
		('\x2946',BidiON),
		('\x2947',BidiON),
		('\x2948',BidiON),
		('\x2949',BidiON),
		('\x294A',BidiON),
		('\x294B',BidiON),
		('\x294C',BidiON),
		('\x294D',BidiON),
		('\x294E',BidiON),
		('\x294F',BidiON),
		('\x2950',BidiON),
		('\x2951',BidiON),
		('\x2952',BidiON),
		('\x2953',BidiON),
		('\x2954',BidiON),
		('\x2955',BidiON),
		('\x2956',BidiON),
		('\x2957',BidiON),
		('\x2958',BidiON),
		('\x2959',BidiON),
		('\x295A',BidiON),
		('\x295B',BidiON),
		('\x295C',BidiON),
		('\x295D',BidiON),
		('\x295E',BidiON),
		('\x295F',BidiON),
		('\x2960',BidiON),
		('\x2961',BidiON),
		('\x2962',BidiON),
		('\x2963',BidiON),
		('\x2964',BidiON),
		('\x2965',BidiON),
		('\x2966',BidiON),
		('\x2967',BidiON),
		('\x2968',BidiON),
		('\x2969',BidiON),
		('\x296A',BidiON),
		('\x296B',BidiON),
		('\x296C',BidiON),
		('\x296D',BidiON),
		('\x296E',BidiON),
		('\x296F',BidiON),
		('\x2970',BidiON),
		('\x2971',BidiON),
		('\x2972',BidiON),
		('\x2973',BidiON),
		('\x2974',BidiON),
		('\x2975',BidiON),
		('\x2976',BidiON),
		('\x2977',BidiON),
		('\x2978',BidiON),
		('\x2979',BidiON),
		('\x297A',BidiON),
		('\x297B',BidiON),
		('\x297C',BidiON),
		('\x297D',BidiON),
		('\x297E',BidiON),
		('\x297F',BidiON),
		('\x2980',BidiON),
		('\x2981',BidiON),
		('\x2982',BidiON),
		('\x2983',BidiON),
		('\x2984',BidiON),
		('\x2985',BidiON),
		('\x2986',BidiON),
		('\x2987',BidiON),
		('\x2988',BidiON),
		('\x2989',BidiON),
		('\x298A',BidiON),
		('\x298B',BidiON),
		('\x298C',BidiON),
		('\x298D',BidiON),
		('\x298E',BidiON),
		('\x298F',BidiON),
		('\x2990',BidiON),
		('\x2991',BidiON),
		('\x2992',BidiON),
		('\x2993',BidiON),
		('\x2994',BidiON),
		('\x2995',BidiON),
		('\x2996',BidiON),
		('\x2997',BidiON),
		('\x2998',BidiON),
		('\x2999',BidiON),
		('\x299A',BidiON),
		('\x299B',BidiON),
		('\x299C',BidiON),
		('\x299D',BidiON),
		('\x299E',BidiON),
		('\x299F',BidiON),
		('\x29A0',BidiON),
		('\x29A1',BidiON),
		('\x29A2',BidiON),
		('\x29A3',BidiON),
		('\x29A4',BidiON),
		('\x29A5',BidiON),
		('\x29A6',BidiON),
		('\x29A7',BidiON),
		('\x29A8',BidiON),
		('\x29A9',BidiON),
		('\x29AA',BidiON),
		('\x29AB',BidiON),
		('\x29AC',BidiON),
		('\x29AD',BidiON),
		('\x29AE',BidiON),
		('\x29AF',BidiON),
		('\x29B0',BidiON),
		('\x29B1',BidiON),
		('\x29B2',BidiON),
		('\x29B3',BidiON),
		('\x29B4',BidiON),
		('\x29B5',BidiON),
		('\x29B6',BidiON),
		('\x29B7',BidiON),
		('\x29B8',BidiON),
		('\x29B9',BidiON),
		('\x29BA',BidiON),
		('\x29BB',BidiON),
		('\x29BC',BidiON),
		('\x29BD',BidiON),
		('\x29BE',BidiON),
		('\x29BF',BidiON),
		('\x29C0',BidiON),
		('\x29C1',BidiON),
		('\x29C2',BidiON),
		('\x29C3',BidiON),
		('\x29C4',BidiON),
		('\x29C5',BidiON),
		('\x29C6',BidiON),
		('\x29C7',BidiON),
		('\x29C8',BidiON),
		('\x29C9',BidiON),
		('\x29CA',BidiON),
		('\x29CB',BidiON),
		('\x29CC',BidiON),
		('\x29CD',BidiON),
		('\x29CE',BidiON),
		('\x29CF',BidiON),
		('\x29D0',BidiON),
		('\x29D1',BidiON),
		('\x29D2',BidiON),
		('\x29D3',BidiON),
		('\x29D4',BidiON),
		('\x29D5',BidiON),
		('\x29D6',BidiON),
		('\x29D7',BidiON),
		('\x29D8',BidiON),
		('\x29D9',BidiON),
		('\x29DA',BidiON),
		('\x29DB',BidiON),
		('\x29DC',BidiON),
		('\x29DD',BidiON),
		('\x29DE',BidiON),
		('\x29DF',BidiON),
		('\x29E0',BidiON),
		('\x29E1',BidiON),
		('\x29E2',BidiON),
		('\x29E3',BidiON),
		('\x29E4',BidiON),
		('\x29E5',BidiON),
		('\x29E6',BidiON),
		('\x29E7',BidiON),
		('\x29E8',BidiON),
		('\x29E9',BidiON),
		('\x29EA',BidiON),
		('\x29EB',BidiON),
		('\x29EC',BidiON),
		('\x29ED',BidiON),
		('\x29EE',BidiON),
		('\x29EF',BidiON),
		('\x29F0',BidiON),
		('\x29F1',BidiON),
		('\x29F2',BidiON),
		('\x29F3',BidiON),
		('\x29F4',BidiON),
		('\x29F5',BidiON),
		('\x29F6',BidiON),
		('\x29F7',BidiON),
		('\x29F8',BidiON),
		('\x29F9',BidiON),
		('\x29FA',BidiON),
		('\x29FB',BidiON),
		('\x29FC',BidiON),
		('\x29FD',BidiON),
		('\x29FE',BidiON),
		('\x29FF',BidiON),
		('\x2A00',BidiON),
		('\x2A01',BidiON),
		('\x2A02',BidiON),
		('\x2A03',BidiON),
		('\x2A04',BidiON),
		('\x2A05',BidiON),
		('\x2A06',BidiON),
		('\x2A07',BidiON),
		('\x2A08',BidiON),
		('\x2A09',BidiON),
		('\x2A0A',BidiON),
		('\x2A0B',BidiON),
		('\x2A0C',BidiON),
		('\x2A0D',BidiON),
		('\x2A0E',BidiON),
		('\x2A0F',BidiON),
		('\x2A10',BidiON),
		('\x2A11',BidiON),
		('\x2A12',BidiON),
		('\x2A13',BidiON),
		('\x2A14',BidiON),
		('\x2A15',BidiON),
		('\x2A16',BidiON),
		('\x2A17',BidiON),
		('\x2A18',BidiON),
		('\x2A19',BidiON),
		('\x2A1A',BidiON),
		('\x2A1B',BidiON),
		('\x2A1C',BidiON),
		('\x2A1D',BidiON),
		('\x2A1E',BidiON),
		('\x2A1F',BidiON),
		('\x2A20',BidiON),
		('\x2A21',BidiON),
		('\x2A22',BidiON),
		('\x2A23',BidiON),
		('\x2A24',BidiON),
		('\x2A25',BidiON),
		('\x2A26',BidiON),
		('\x2A27',BidiON),
		('\x2A28',BidiON),
		('\x2A29',BidiON),
		('\x2A2A',BidiON),
		('\x2A2B',BidiON),
		('\x2A2C',BidiON),
		('\x2A2D',BidiON),
		('\x2A2E',BidiON),
		('\x2A2F',BidiON),
		('\x2A30',BidiON),
		('\x2A31',BidiON),
		('\x2A32',BidiON),
		('\x2A33',BidiON),
		('\x2A34',BidiON),
		('\x2A35',BidiON),
		('\x2A36',BidiON),
		('\x2A37',BidiON),
		('\x2A38',BidiON),
		('\x2A39',BidiON),
		('\x2A3A',BidiON),
		('\x2A3B',BidiON),
		('\x2A3C',BidiON),
		('\x2A3D',BidiON),
		('\x2A3E',BidiON),
		('\x2A3F',BidiON),
		('\x2A40',BidiON),
		('\x2A41',BidiON),
		('\x2A42',BidiON),
		('\x2A43',BidiON),
		('\x2A44',BidiON),
		('\x2A45',BidiON),
		('\x2A46',BidiON),
		('\x2A47',BidiON),
		('\x2A48',BidiON),
		('\x2A49',BidiON),
		('\x2A4A',BidiON),
		('\x2A4B',BidiON),
		('\x2A4C',BidiON),
		('\x2A4D',BidiON),
		('\x2A4E',BidiON),
		('\x2A4F',BidiON),
		('\x2A50',BidiON),
		('\x2A51',BidiON),
		('\x2A52',BidiON),
		('\x2A53',BidiON),
		('\x2A54',BidiON),
		('\x2A55',BidiON),
		('\x2A56',BidiON),
		('\x2A57',BidiON),
		('\x2A58',BidiON),
		('\x2A59',BidiON),
		('\x2A5A',BidiON),
		('\x2A5B',BidiON),
		('\x2A5C',BidiON),
		('\x2A5D',BidiON),
		('\x2A5E',BidiON),
		('\x2A5F',BidiON),
		('\x2A60',BidiON),
		('\x2A61',BidiON),
		('\x2A62',BidiON),
		('\x2A63',BidiON),
		('\x2A64',BidiON),
		('\x2A65',BidiON),
		('\x2A66',BidiON),
		('\x2A67',BidiON),
		('\x2A68',BidiON),
		('\x2A69',BidiON),
		('\x2A6A',BidiON),
		('\x2A6B',BidiON),
		('\x2A6C',BidiON),
		('\x2A6D',BidiON),
		('\x2A6E',BidiON),
		('\x2A6F',BidiON),
		('\x2A70',BidiON),
		('\x2A71',BidiON),
		('\x2A72',BidiON),
		('\x2A73',BidiON),
		('\x2A74',BidiON),
		('\x2A75',BidiON),
		('\x2A76',BidiON),
		('\x2A77',BidiON),
		('\x2A78',BidiON),
		('\x2A79',BidiON),
		('\x2A7A',BidiON),
		('\x2A7B',BidiON),
		('\x2A7C',BidiON),
		('\x2A7D',BidiON),
		('\x2A7E',BidiON),
		('\x2A7F',BidiON),
		('\x2A80',BidiON),
		('\x2A81',BidiON),
		('\x2A82',BidiON),
		('\x2A83',BidiON),
		('\x2A84',BidiON),
		('\x2A85',BidiON),
		('\x2A86',BidiON),
		('\x2A87',BidiON),
		('\x2A88',BidiON),
		('\x2A89',BidiON),
		('\x2A8A',BidiON),
		('\x2A8B',BidiON),
		('\x2A8C',BidiON),
		('\x2A8D',BidiON),
		('\x2A8E',BidiON),
		('\x2A8F',BidiON),
		('\x2A90',BidiON),
		('\x2A91',BidiON),
		('\x2A92',BidiON),
		('\x2A93',BidiON),
		('\x2A94',BidiON),
		('\x2A95',BidiON),
		('\x2A96',BidiON),
		('\x2A97',BidiON),
		('\x2A98',BidiON),
		('\x2A99',BidiON),
		('\x2A9A',BidiON),
		('\x2A9B',BidiON),
		('\x2A9C',BidiON),
		('\x2A9D',BidiON),
		('\x2A9E',BidiON),
		('\x2A9F',BidiON),
		('\x2AA0',BidiON),
		('\x2AA1',BidiON),
		('\x2AA2',BidiON),
		('\x2AA3',BidiON),
		('\x2AA4',BidiON),
		('\x2AA5',BidiON),
		('\x2AA6',BidiON),
		('\x2AA7',BidiON),
		('\x2AA8',BidiON),
		('\x2AA9',BidiON),
		('\x2AAA',BidiON),
		('\x2AAB',BidiON),
		('\x2AAC',BidiON),
		('\x2AAD',BidiON),
		('\x2AAE',BidiON),
		('\x2AAF',BidiON),
		('\x2AB0',BidiON),
		('\x2AB1',BidiON),
		('\x2AB2',BidiON),
		('\x2AB3',BidiON),
		('\x2AB4',BidiON),
		('\x2AB5',BidiON),
		('\x2AB6',BidiON),
		('\x2AB7',BidiON),
		('\x2AB8',BidiON),
		('\x2AB9',BidiON),
		('\x2ABA',BidiON),
		('\x2ABB',BidiON),
		('\x2ABC',BidiON),
		('\x2ABD',BidiON),
		('\x2ABE',BidiON),
		('\x2ABF',BidiON),
		('\x2AC0',BidiON),
		('\x2AC1',BidiON),
		('\x2AC2',BidiON),
		('\x2AC3',BidiON),
		('\x2AC4',BidiON),
		('\x2AC5',BidiON),
		('\x2AC6',BidiON),
		('\x2AC7',BidiON),
		('\x2AC8',BidiON),
		('\x2AC9',BidiON),
		('\x2ACA',BidiON),
		('\x2ACB',BidiON),
		('\x2ACC',BidiON),
		('\x2ACD',BidiON),
		('\x2ACE',BidiON),
		('\x2ACF',BidiON),
		('\x2AD0',BidiON),
		('\x2AD1',BidiON),
		('\x2AD2',BidiON),
		('\x2AD3',BidiON),
		('\x2AD4',BidiON),
		('\x2AD5',BidiON),
		('\x2AD6',BidiON),
		('\x2AD7',BidiON),
		('\x2AD8',BidiON),
		('\x2AD9',BidiON),
		('\x2ADA',BidiON),
		('\x2ADB',BidiON),
		('\x2ADC',BidiON),
		('\x2ADD',BidiON),
		('\x2ADE',BidiON),
		('\x2ADF',BidiON),
		('\x2AE0',BidiON),
		('\x2AE1',BidiON),
		('\x2AE2',BidiON),
		('\x2AE3',BidiON),
		('\x2AE4',BidiON),
		('\x2AE5',BidiON),
		('\x2AE6',BidiON),
		('\x2AE7',BidiON),
		('\x2AE8',BidiON),
		('\x2AE9',BidiON),
		('\x2AEA',BidiON),
		('\x2AEB',BidiON),
		('\x2AEC',BidiON),
		('\x2AED',BidiON),
		('\x2AEE',BidiON),
		('\x2AEF',BidiON),
		('\x2AF0',BidiON),
		('\x2AF1',BidiON),
		('\x2AF2',BidiON),
		('\x2AF3',BidiON),
		('\x2AF4',BidiON),
		('\x2AF5',BidiON),
		('\x2AF6',BidiON),
		('\x2AF7',BidiON),
		('\x2AF8',BidiON),
		('\x2AF9',BidiON),
		('\x2AFA',BidiON),
		('\x2AFB',BidiON),
		('\x2AFC',BidiON),
		('\x2AFD',BidiON),
		('\x2AFE',BidiON),
		('\x2AFF',BidiON),
		('\x2E80',BidiON),
		('\x2E81',BidiON),
		('\x2E82',BidiON),
		('\x2E83',BidiON),
		('\x2E84',BidiON),
		('\x2E85',BidiON),
		('\x2E86',BidiON),
		('\x2E87',BidiON),
		('\x2E88',BidiON),
		('\x2E89',BidiON),
		('\x2E8A',BidiON),
		('\x2E8B',BidiON),
		('\x2E8C',BidiON),
		('\x2E8D',BidiON),
		('\x2E8E',BidiON),
		('\x2E8F',BidiON),
		('\x2E90',BidiON),
		('\x2E91',BidiON),
		('\x2E92',BidiON),
		('\x2E93',BidiON),
		('\x2E94',BidiON),
		('\x2E95',BidiON),
		('\x2E96',BidiON),
		('\x2E97',BidiON),
		('\x2E98',BidiON),
		('\x2E99',BidiON),
		('\x2E9B',BidiON),
		('\x2E9C',BidiON),
		('\x2E9D',BidiON),
		('\x2E9E',BidiON),
		('\x2E9F',BidiON),
		('\x2EA0',BidiON),
		('\x2EA1',BidiON),
		('\x2EA2',BidiON),
		('\x2EA3',BidiON),
		('\x2EA4',BidiON),
		('\x2EA5',BidiON),
		('\x2EA6',BidiON),
		('\x2EA7',BidiON),
		('\x2EA8',BidiON),
		('\x2EA9',BidiON),
		('\x2EAA',BidiON),
		('\x2EAB',BidiON),
		('\x2EAC',BidiON),
		('\x2EAD',BidiON),
		('\x2EAE',BidiON),
		('\x2EAF',BidiON),
		('\x2EB0',BidiON),
		('\x2EB1',BidiON),
		('\x2EB2',BidiON),
		('\x2EB3',BidiON),
		('\x2EB4',BidiON),
		('\x2EB5',BidiON),
		('\x2EB6',BidiON),
		('\x2EB7',BidiON),
		('\x2EB8',BidiON),
		('\x2EB9',BidiON),
		('\x2EBA',BidiON),
		('\x2EBB',BidiON),
		('\x2EBC',BidiON),
		('\x2EBD',BidiON),
		('\x2EBE',BidiON),
		('\x2EBF',BidiON),
		('\x2EC0',BidiON),
		('\x2EC1',BidiON),
		('\x2EC2',BidiON),
		('\x2EC3',BidiON),
		('\x2EC4',BidiON),
		('\x2EC5',BidiON),
		('\x2EC6',BidiON),
		('\x2EC7',BidiON),
		('\x2EC8',BidiON),
		('\x2EC9',BidiON),
		('\x2ECA',BidiON),
		('\x2ECB',BidiON),
		('\x2ECC',BidiON),
		('\x2ECD',BidiON),
		('\x2ECE',BidiON),
		('\x2ECF',BidiON),
		('\x2ED0',BidiON),
		('\x2ED1',BidiON),
		('\x2ED2',BidiON),
		('\x2ED3',BidiON),
		('\x2ED4',BidiON),
		('\x2ED5',BidiON),
		('\x2ED6',BidiON),
		('\x2ED7',BidiON),
		('\x2ED8',BidiON),
		('\x2ED9',BidiON),
		('\x2EDA',BidiON),
		('\x2EDB',BidiON),
		('\x2EDC',BidiON),
		('\x2EDD',BidiON),
		('\x2EDE',BidiON),
		('\x2EDF',BidiON),
		('\x2EE0',BidiON),
		('\x2EE1',BidiON),
		('\x2EE2',BidiON),
		('\x2EE3',BidiON),
		('\x2EE4',BidiON),
		('\x2EE5',BidiON),
		('\x2EE6',BidiON),
		('\x2EE7',BidiON),
		('\x2EE8',BidiON),
		('\x2EE9',BidiON),
		('\x2EEA',BidiON),
		('\x2EEB',BidiON),
		('\x2EEC',BidiON),
		('\x2EED',BidiON),
		('\x2EEE',BidiON),
		('\x2EEF',BidiON),
		('\x2EF0',BidiON),
		('\x2EF1',BidiON),
		('\x2EF2',BidiON),
		('\x2EF3',BidiON),
		('\x2F00',BidiON),
		('\x2F01',BidiON),
		('\x2F02',BidiON),
		('\x2F03',BidiON),
		('\x2F04',BidiON),
		('\x2F05',BidiON),
		('\x2F06',BidiON),
		('\x2F07',BidiON),
		('\x2F08',BidiON),
		('\x2F09',BidiON),
		('\x2F0A',BidiON),
		('\x2F0B',BidiON),
		('\x2F0C',BidiON),
		('\x2F0D',BidiON),
		('\x2F0E',BidiON),
		('\x2F0F',BidiON),
		('\x2F10',BidiON),
		('\x2F11',BidiON),
		('\x2F12',BidiON),
		('\x2F13',BidiON),
		('\x2F14',BidiON),
		('\x2F15',BidiON),
		('\x2F16',BidiON),
		('\x2F17',BidiON),
		('\x2F18',BidiON),
		('\x2F19',BidiON),
		('\x2F1A',BidiON),
		('\x2F1B',BidiON),
		('\x2F1C',BidiON),
		('\x2F1D',BidiON),
		('\x2F1E',BidiON),
		('\x2F1F',BidiON),
		('\x2F20',BidiON),
		('\x2F21',BidiON),
		('\x2F22',BidiON),
		('\x2F23',BidiON),
		('\x2F24',BidiON),
		('\x2F25',BidiON),
		('\x2F26',BidiON),
		('\x2F27',BidiON),
		('\x2F28',BidiON),
		('\x2F29',BidiON),
		('\x2F2A',BidiON),
		('\x2F2B',BidiON),
		('\x2F2C',BidiON),
		('\x2F2D',BidiON),
		('\x2F2E',BidiON),
		('\x2F2F',BidiON),
		('\x2F30',BidiON),
		('\x2F31',BidiON),
		('\x2F32',BidiON),
		('\x2F33',BidiON),
		('\x2F34',BidiON),
		('\x2F35',BidiON),
		('\x2F36',BidiON),
		('\x2F37',BidiON),
		('\x2F38',BidiON),
		('\x2F39',BidiON),
		('\x2F3A',BidiON),
		('\x2F3B',BidiON),
		('\x2F3C',BidiON),
		('\x2F3D',BidiON),
		('\x2F3E',BidiON),
		('\x2F3F',BidiON),
		('\x2F40',BidiON),
		('\x2F41',BidiON),
		('\x2F42',BidiON),
		('\x2F43',BidiON),
		('\x2F44',BidiON),
		('\x2F45',BidiON),
		('\x2F46',BidiON),
		('\x2F47',BidiON),
		('\x2F48',BidiON),
		('\x2F49',BidiON),
		('\x2F4A',BidiON),
		('\x2F4B',BidiON),
		('\x2F4C',BidiON),
		('\x2F4D',BidiON),
		('\x2F4E',BidiON),
		('\x2F4F',BidiON),
		('\x2F50',BidiON),
		('\x2F51',BidiON),
		('\x2F52',BidiON),
		('\x2F53',BidiON),
		('\x2F54',BidiON),
		('\x2F55',BidiON),
		('\x2F56',BidiON),
		('\x2F57',BidiON),
		('\x2F58',BidiON),
		('\x2F59',BidiON),
		('\x2F5A',BidiON),
		('\x2F5B',BidiON),
		('\x2F5C',BidiON),
		('\x2F5D',BidiON),
		('\x2F5E',BidiON),
		('\x2F5F',BidiON),
		('\x2F60',BidiON),
		('\x2F61',BidiON),
		('\x2F62',BidiON),
		('\x2F63',BidiON),
		('\x2F64',BidiON),
		('\x2F65',BidiON),
		('\x2F66',BidiON),
		('\x2F67',BidiON),
		('\x2F68',BidiON),
		('\x2F69',BidiON),
		('\x2F6A',BidiON),
		('\x2F6B',BidiON),
		('\x2F6C',BidiON),
		('\x2F6D',BidiON),
		('\x2F6E',BidiON),
		('\x2F6F',BidiON),
		('\x2F70',BidiON),
		('\x2F71',BidiON),
		('\x2F72',BidiON),
		('\x2F73',BidiON),
		('\x2F74',BidiON),
		('\x2F75',BidiON),
		('\x2F76',BidiON),
		('\x2F77',BidiON),
		('\x2F78',BidiON),
		('\x2F79',BidiON),
		('\x2F7A',BidiON),
		('\x2F7B',BidiON),
		('\x2F7C',BidiON),
		('\x2F7D',BidiON),
		('\x2F7E',BidiON),
		('\x2F7F',BidiON),
		('\x2F80',BidiON),
		('\x2F81',BidiON),
		('\x2F82',BidiON),
		('\x2F83',BidiON),
		('\x2F84',BidiON),
		('\x2F85',BidiON),
		('\x2F86',BidiON),
		('\x2F87',BidiON),
		('\x2F88',BidiON),
		('\x2F89',BidiON),
		('\x2F8A',BidiON),
		('\x2F8B',BidiON),
		('\x2F8C',BidiON),
		('\x2F8D',BidiON),
		('\x2F8E',BidiON),
		('\x2F8F',BidiON),
		('\x2F90',BidiON),
		('\x2F91',BidiON),
		('\x2F92',BidiON),
		('\x2F93',BidiON),
		('\x2F94',BidiON),
		('\x2F95',BidiON),
		('\x2F96',BidiON),
		('\x2F97',BidiON),
		('\x2F98',BidiON),
		('\x2F99',BidiON),
		('\x2F9A',BidiON),
		('\x2F9B',BidiON),
		('\x2F9C',BidiON),
		('\x2F9D',BidiON),
		('\x2F9E',BidiON),
		('\x2F9F',BidiON),
		('\x2FA0',BidiON),
		('\x2FA1',BidiON),
		('\x2FA2',BidiON),
		('\x2FA3',BidiON),
		('\x2FA4',BidiON),
		('\x2FA5',BidiON),
		('\x2FA6',BidiON),
		('\x2FA7',BidiON),
		('\x2FA8',BidiON),
		('\x2FA9',BidiON),
		('\x2FAA',BidiON),
		('\x2FAB',BidiON),
		('\x2FAC',BidiON),
		('\x2FAD',BidiON),
		('\x2FAE',BidiON),
		('\x2FAF',BidiON),
		('\x2FB0',BidiON),
		('\x2FB1',BidiON),
		('\x2FB2',BidiON),
		('\x2FB3',BidiON),
		('\x2FB4',BidiON),
		('\x2FB5',BidiON),
		('\x2FB6',BidiON),
		('\x2FB7',BidiON),
		('\x2FB8',BidiON),
		('\x2FB9',BidiON),
		('\x2FBA',BidiON),
		('\x2FBB',BidiON),
		('\x2FBC',BidiON),
		('\x2FBD',BidiON),
		('\x2FBE',BidiON),
		('\x2FBF',BidiON),
		('\x2FC0',BidiON),
		('\x2FC1',BidiON),
		('\x2FC2',BidiON),
		('\x2FC3',BidiON),
		('\x2FC4',BidiON),
		('\x2FC5',BidiON),
		('\x2FC6',BidiON),
		('\x2FC7',BidiON),
		('\x2FC8',BidiON),
		('\x2FC9',BidiON),
		('\x2FCA',BidiON),
		('\x2FCB',BidiON),
		('\x2FCC',BidiON),
		('\x2FCD',BidiON),
		('\x2FCE',BidiON),
		('\x2FCF',BidiON),
		('\x2FD0',BidiON),
		('\x2FD1',BidiON),
		('\x2FD2',BidiON),
		('\x2FD3',BidiON),
		('\x2FD4',BidiON),
		('\x2FD5',BidiON),
		('\x2FF0',BidiON),
		('\x2FF1',BidiON),
		('\x2FF2',BidiON),
		('\x2FF3',BidiON),
		('\x2FF4',BidiON),
		('\x2FF5',BidiON),
		('\x2FF6',BidiON),
		('\x2FF7',BidiON),
		('\x2FF8',BidiON),
		('\x2FF9',BidiON),
		('\x2FFA',BidiON),
		('\x2FFB',BidiON),
		('\x3000',BidiWS),
		('\x3001',BidiON),
		('\x3002',BidiON),
		('\x3003',BidiON),
		('\x3004',BidiON),
		('\x3008',BidiON),
		('\x3009',BidiON),
		('\x300A',BidiON),
		('\x300B',BidiON),
		('\x300C',BidiON),
		('\x300D',BidiON),
		('\x300E',BidiON),
		('\x300F',BidiON),
		('\x3010',BidiON),
		('\x3011',BidiON),
		('\x3012',BidiON),
		('\x3013',BidiON),
		('\x3014',BidiON),
		('\x3015',BidiON),
		('\x3016',BidiON),
		('\x3017',BidiON),
		('\x3018',BidiON),
		('\x3019',BidiON),
		('\x301A',BidiON),
		('\x301B',BidiON),
		('\x301C',BidiON),
		('\x301D',BidiON),
		('\x301E',BidiON),
		('\x301F',BidiON),
		('\x3020',BidiON),
		('\x302A',BidiNSM),
		('\x302B',BidiNSM),
		('\x302C',BidiNSM),
		('\x302D',BidiNSM),
		('\x302E',BidiNSM),
		('\x302F',BidiNSM),
		('\x3030',BidiON),
		('\x3036',BidiON),
		('\x3037',BidiON),
		('\x303D',BidiON),
		('\x303E',BidiON),
		('\x303F',BidiON),
		('\x3099',BidiNSM),
		('\x309A',BidiNSM),
		('\x309B',BidiON),
		('\x309C',BidiON),
		('\x30A0',BidiON),
		('\x30FB',BidiON),
		('\x3251',BidiON),
		('\x3252',BidiON),
		('\x3253',BidiON),
		('\x3254',BidiON),
		('\x3255',BidiON),
		('\x3256',BidiON),
		('\x3257',BidiON),
		('\x3258',BidiON),
		('\x3259',BidiON),
		('\x325A',BidiON),
		('\x325B',BidiON),
		('\x325C',BidiON),
		('\x325D',BidiON),
		('\x325E',BidiON),
		('\x325F',BidiON),
		('\x32B1',BidiON),
		('\x32B2',BidiON),
		('\x32B3',BidiON),
		('\x32B4',BidiON),
		('\x32B5',BidiON),
		('\x32B6',BidiON),
		('\x32B7',BidiON),
		('\x32B8',BidiON),
		('\x32B9',BidiON),
		('\x32BA',BidiON),
		('\x32BB',BidiON),
		('\x32BC',BidiON),
		('\x32BD',BidiON),
		('\x32BE',BidiON),
		('\x32BF',BidiON),
		('\xA490',BidiON),
		('\xA491',BidiON),
		('\xA492',BidiON),
		('\xA493',BidiON),
		('\xA494',BidiON),
		('\xA495',BidiON),
		('\xA496',BidiON),
		('\xA497',BidiON),
		('\xA498',BidiON),
		('\xA499',BidiON),
		('\xA49A',BidiON),
		('\xA49B',BidiON),
		('\xA49C',BidiON),
		('\xA49D',BidiON),
		('\xA49E',BidiON),
		('\xA49F',BidiON),
		('\xA4A0',BidiON),
		('\xA4A1',BidiON),
		('\xA4A2',BidiON),
		('\xA4A3',BidiON),
		('\xA4A4',BidiON),
		('\xA4A5',BidiON),
		('\xA4A6',BidiON),
		('\xA4A7',BidiON),
		('\xA4A8',BidiON),
		('\xA4A9',BidiON),
		('\xA4AA',BidiON),
		('\xA4AB',BidiON),
		('\xA4AC',BidiON),
		('\xA4AD',BidiON),
		('\xA4AE',BidiON),
		('\xA4AF',BidiON),
		('\xA4B0',BidiON),
		('\xA4B1',BidiON),
		('\xA4B2',BidiON),
		('\xA4B3',BidiON),
		('\xA4B4',BidiON),
		('\xA4B5',BidiON),
		('\xA4B6',BidiON),
		('\xA4B7',BidiON),
		('\xA4B8',BidiON),
		('\xA4B9',BidiON),
		('\xA4BA',BidiON),
		('\xA4BB',BidiON),
		('\xA4BC',BidiON),
		('\xA4BD',BidiON),
		('\xA4BE',BidiON),
		('\xA4BF',BidiON),
		('\xA4C0',BidiON),
		('\xA4C1',BidiON),
		('\xA4C2',BidiON),
		('\xA4C3',BidiON),
		('\xA4C4',BidiON),
		('\xA4C5',BidiON),
		('\xA4C6',BidiON),
		('\xFB1D',BidiR),
		('\xFB1E',BidiNSM),
		('\xFB1F',BidiR),
		('\xFB20',BidiR),
		('\xFB21',BidiR),
		('\xFB22',BidiR),
		('\xFB23',BidiR),
		('\xFB24',BidiR),
		('\xFB25',BidiR),
		('\xFB26',BidiR),
		('\xFB27',BidiR),
		('\xFB28',BidiR),
		('\xFB29',BidiET),
		('\xFB2A',BidiR),
		('\xFB2B',BidiR),
		('\xFB2C',BidiR),
		('\xFB2D',BidiR),
		('\xFB2E',BidiR),
		('\xFB2F',BidiR),
		('\xFB30',BidiR),
		('\xFB31',BidiR),
		('\xFB32',BidiR),
		('\xFB33',BidiR),
		('\xFB34',BidiR),
		('\xFB35',BidiR),
		('\xFB36',BidiR),
		('\xFB38',BidiR),
		('\xFB39',BidiR),
		('\xFB3A',BidiR),
		('\xFB3B',BidiR),
		('\xFB3C',BidiR),
		('\xFB3E',BidiR),
		('\xFB40',BidiR),
		('\xFB41',BidiR),
		('\xFB43',BidiR),
		('\xFB44',BidiR),
		('\xFB46',BidiR),
		('\xFB47',BidiR),
		('\xFB48',BidiR),
		('\xFB49',BidiR),
		('\xFB4A',BidiR),
		('\xFB4B',BidiR),
		('\xFB4C',BidiR),
		('\xFB4D',BidiR),
		('\xFB4E',BidiR),
		('\xFB4F',BidiR),
		('\xFB50',BidiAL),
		('\xFB51',BidiAL),
		('\xFB52',BidiAL),
		('\xFB53',BidiAL),
		('\xFB54',BidiAL),
		('\xFB55',BidiAL),
		('\xFB56',BidiAL),
		('\xFB57',BidiAL),
		('\xFB58',BidiAL),
		('\xFB59',BidiAL),
		('\xFB5A',BidiAL),
		('\xFB5B',BidiAL),
		('\xFB5C',BidiAL),
		('\xFB5D',BidiAL),
		('\xFB5E',BidiAL),
		('\xFB5F',BidiAL),
		('\xFB60',BidiAL),
		('\xFB61',BidiAL),
		('\xFB62',BidiAL),
		('\xFB63',BidiAL),
		('\xFB64',BidiAL),
		('\xFB65',BidiAL),
		('\xFB66',BidiAL),
		('\xFB67',BidiAL),
		('\xFB68',BidiAL),
		('\xFB69',BidiAL),
		('\xFB6A',BidiAL),
		('\xFB6B',BidiAL),
		('\xFB6C',BidiAL),
		('\xFB6D',BidiAL),
		('\xFB6E',BidiAL),
		('\xFB6F',BidiAL),
		('\xFB70',BidiAL),
		('\xFB71',BidiAL),
		('\xFB72',BidiAL),
		('\xFB73',BidiAL),
		('\xFB74',BidiAL),
		('\xFB75',BidiAL),
		('\xFB76',BidiAL),
		('\xFB77',BidiAL),
		('\xFB78',BidiAL),
		('\xFB79',BidiAL),
		('\xFB7A',BidiAL),
		('\xFB7B',BidiAL),
		('\xFB7C',BidiAL),
		('\xFB7D',BidiAL),
		('\xFB7E',BidiAL),
		('\xFB7F',BidiAL),
		('\xFB80',BidiAL),
		('\xFB81',BidiAL),
		('\xFB82',BidiAL),
		('\xFB83',BidiAL),
		('\xFB84',BidiAL),
		('\xFB85',BidiAL),
		('\xFB86',BidiAL),
		('\xFB87',BidiAL),
		('\xFB88',BidiAL),
		('\xFB89',BidiAL),
		('\xFB8A',BidiAL),
		('\xFB8B',BidiAL),
		('\xFB8C',BidiAL),
		('\xFB8D',BidiAL),
		('\xFB8E',BidiAL),
		('\xFB8F',BidiAL),
		('\xFB90',BidiAL),
		('\xFB91',BidiAL),
		('\xFB92',BidiAL),
		('\xFB93',BidiAL),
		('\xFB94',BidiAL),
		('\xFB95',BidiAL),
		('\xFB96',BidiAL),
		('\xFB97',BidiAL),
		('\xFB98',BidiAL),
		('\xFB99',BidiAL),
		('\xFB9A',BidiAL),
		('\xFB9B',BidiAL),
		('\xFB9C',BidiAL),
		('\xFB9D',BidiAL),
		('\xFB9E',BidiAL),
		('\xFB9F',BidiAL),
		('\xFBA0',BidiAL),
		('\xFBA1',BidiAL),
		('\xFBA2',BidiAL),
		('\xFBA3',BidiAL),
		('\xFBA4',BidiAL),
		('\xFBA5',BidiAL),
		('\xFBA6',BidiAL),
		('\xFBA7',BidiAL),
		('\xFBA8',BidiAL),
		('\xFBA9',BidiAL),
		('\xFBAA',BidiAL),
		('\xFBAB',BidiAL),
		('\xFBAC',BidiAL),
		('\xFBAD',BidiAL),
		('\xFBAE',BidiAL),
		('\xFBAF',BidiAL),
		('\xFBB0',BidiAL),
		('\xFBB1',BidiAL),
		('\xFBD3',BidiAL),
		('\xFBD4',BidiAL),
		('\xFBD5',BidiAL),
		('\xFBD6',BidiAL),
		('\xFBD7',BidiAL),
		('\xFBD8',BidiAL),
		('\xFBD9',BidiAL),
		('\xFBDA',BidiAL),
		('\xFBDB',BidiAL),
		('\xFBDC',BidiAL),
		('\xFBDD',BidiAL),
		('\xFBDE',BidiAL),
		('\xFBDF',BidiAL),
		('\xFBE0',BidiAL),
		('\xFBE1',BidiAL),
		('\xFBE2',BidiAL),
		('\xFBE3',BidiAL),
		('\xFBE4',BidiAL),
		('\xFBE5',BidiAL),
		('\xFBE6',BidiAL),
		('\xFBE7',BidiAL),
		('\xFBE8',BidiAL),
		('\xFBE9',BidiAL),
		('\xFBEA',BidiAL),
		('\xFBEB',BidiAL),
		('\xFBEC',BidiAL),
		('\xFBED',BidiAL),
		('\xFBEE',BidiAL),
		('\xFBEF',BidiAL),
		('\xFBF0',BidiAL),
		('\xFBF1',BidiAL),
		('\xFBF2',BidiAL),
		('\xFBF3',BidiAL),
		('\xFBF4',BidiAL),
		('\xFBF5',BidiAL),
		('\xFBF6',BidiAL),
		('\xFBF7',BidiAL),
		('\xFBF8',BidiAL),
		('\xFBF9',BidiAL),
		('\xFBFA',BidiAL),
		('\xFBFB',BidiAL),
		('\xFBFC',BidiAL),
		('\xFBFD',BidiAL),
		('\xFBFE',BidiAL),
		('\xFBFF',BidiAL),
		('\xFC00',BidiAL),
		('\xFC01',BidiAL),
		('\xFC02',BidiAL),
		('\xFC03',BidiAL),
		('\xFC04',BidiAL),
		('\xFC05',BidiAL),
		('\xFC06',BidiAL),
		('\xFC07',BidiAL),
		('\xFC08',BidiAL),
		('\xFC09',BidiAL),
		('\xFC0A',BidiAL),
		('\xFC0B',BidiAL),
		('\xFC0C',BidiAL),
		('\xFC0D',BidiAL),
		('\xFC0E',BidiAL),
		('\xFC0F',BidiAL),
		('\xFC10',BidiAL),
		('\xFC11',BidiAL),
		('\xFC12',BidiAL),
		('\xFC13',BidiAL),
		('\xFC14',BidiAL),
		('\xFC15',BidiAL),
		('\xFC16',BidiAL),
		('\xFC17',BidiAL),
		('\xFC18',BidiAL),
		('\xFC19',BidiAL),
		('\xFC1A',BidiAL),
		('\xFC1B',BidiAL),
		('\xFC1C',BidiAL),
		('\xFC1D',BidiAL),
		('\xFC1E',BidiAL),
		('\xFC1F',BidiAL),
		('\xFC20',BidiAL),
		('\xFC21',BidiAL),
		('\xFC22',BidiAL),
		('\xFC23',BidiAL),
		('\xFC24',BidiAL),
		('\xFC25',BidiAL),
		('\xFC26',BidiAL),
		('\xFC27',BidiAL),
		('\xFC28',BidiAL),
		('\xFC29',BidiAL),
		('\xFC2A',BidiAL),
		('\xFC2B',BidiAL),
		('\xFC2C',BidiAL),
		('\xFC2D',BidiAL),
		('\xFC2E',BidiAL),
		('\xFC2F',BidiAL),
		('\xFC30',BidiAL),
		('\xFC31',BidiAL),
		('\xFC32',BidiAL),
		('\xFC33',BidiAL),
		('\xFC34',BidiAL),
		('\xFC35',BidiAL),
		('\xFC36',BidiAL),
		('\xFC37',BidiAL),
		('\xFC38',BidiAL),
		('\xFC39',BidiAL),
		('\xFC3A',BidiAL),
		('\xFC3B',BidiAL),
		('\xFC3C',BidiAL),
		('\xFC3D',BidiAL),
		('\xFC3E',BidiAL),
		('\xFC3F',BidiAL),
		('\xFC40',BidiAL),
		('\xFC41',BidiAL),
		('\xFC42',BidiAL),
		('\xFC43',BidiAL),
		('\xFC44',BidiAL),
		('\xFC45',BidiAL),
		('\xFC46',BidiAL),
		('\xFC47',BidiAL),
		('\xFC48',BidiAL),
		('\xFC49',BidiAL),
		('\xFC4A',BidiAL),
		('\xFC4B',BidiAL),
		('\xFC4C',BidiAL),
		('\xFC4D',BidiAL),
		('\xFC4E',BidiAL),
		('\xFC4F',BidiAL),
		('\xFC50',BidiAL),
		('\xFC51',BidiAL),
		('\xFC52',BidiAL),
		('\xFC53',BidiAL),
		('\xFC54',BidiAL),
		('\xFC55',BidiAL),
		('\xFC56',BidiAL),
		('\xFC57',BidiAL),
		('\xFC58',BidiAL),
		('\xFC59',BidiAL),
		('\xFC5A',BidiAL),
		('\xFC5B',BidiAL),
		('\xFC5C',BidiAL),
		('\xFC5D',BidiAL),
		('\xFC5E',BidiAL),
		('\xFC5F',BidiAL),
		('\xFC60',BidiAL),
		('\xFC61',BidiAL),
		('\xFC62',BidiAL),
		('\xFC63',BidiAL),
		('\xFC64',BidiAL),
		('\xFC65',BidiAL),
		('\xFC66',BidiAL),
		('\xFC67',BidiAL),
		('\xFC68',BidiAL),
		('\xFC69',BidiAL),
		('\xFC6A',BidiAL),
		('\xFC6B',BidiAL),
		('\xFC6C',BidiAL),
		('\xFC6D',BidiAL),
		('\xFC6E',BidiAL),
		('\xFC6F',BidiAL),
		('\xFC70',BidiAL),
		('\xFC71',BidiAL),
		('\xFC72',BidiAL),
		('\xFC73',BidiAL),
		('\xFC74',BidiAL),
		('\xFC75',BidiAL),
		('\xFC76',BidiAL),
		('\xFC77',BidiAL),
		('\xFC78',BidiAL),
		('\xFC79',BidiAL),
		('\xFC7A',BidiAL),
		('\xFC7B',BidiAL),
		('\xFC7C',BidiAL),
		('\xFC7D',BidiAL),
		('\xFC7E',BidiAL),
		('\xFC7F',BidiAL),
		('\xFC80',BidiAL),
		('\xFC81',BidiAL),
		('\xFC82',BidiAL),
		('\xFC83',BidiAL),
		('\xFC84',BidiAL),
		('\xFC85',BidiAL),
		('\xFC86',BidiAL),
		('\xFC87',BidiAL),
		('\xFC88',BidiAL),
		('\xFC89',BidiAL),
		('\xFC8A',BidiAL),
		('\xFC8B',BidiAL),
		('\xFC8C',BidiAL),
		('\xFC8D',BidiAL),
		('\xFC8E',BidiAL),
		('\xFC8F',BidiAL),
		('\xFC90',BidiAL),
		('\xFC91',BidiAL),
		('\xFC92',BidiAL),
		('\xFC93',BidiAL),
		('\xFC94',BidiAL),
		('\xFC95',BidiAL),
		('\xFC96',BidiAL),
		('\xFC97',BidiAL),
		('\xFC98',BidiAL),
		('\xFC99',BidiAL),
		('\xFC9A',BidiAL),
		('\xFC9B',BidiAL),
		('\xFC9C',BidiAL),
		('\xFC9D',BidiAL),
		('\xFC9E',BidiAL),
		('\xFC9F',BidiAL),
		('\xFCA0',BidiAL),
		('\xFCA1',BidiAL),
		('\xFCA2',BidiAL),
		('\xFCA3',BidiAL),
		('\xFCA4',BidiAL),
		('\xFCA5',BidiAL),
		('\xFCA6',BidiAL),
		('\xFCA7',BidiAL),
		('\xFCA8',BidiAL),
		('\xFCA9',BidiAL),
		('\xFCAA',BidiAL),
		('\xFCAB',BidiAL),
		('\xFCAC',BidiAL),
		('\xFCAD',BidiAL),
		('\xFCAE',BidiAL),
		('\xFCAF',BidiAL),
		('\xFCB0',BidiAL),
		('\xFCB1',BidiAL),
		('\xFCB2',BidiAL),
		('\xFCB3',BidiAL),
		('\xFCB4',BidiAL),
		('\xFCB5',BidiAL),
		('\xFCB6',BidiAL),
		('\xFCB7',BidiAL),
		('\xFCB8',BidiAL),
		('\xFCB9',BidiAL),
		('\xFCBA',BidiAL),
		('\xFCBB',BidiAL),
		('\xFCBC',BidiAL),
		('\xFCBD',BidiAL),
		('\xFCBE',BidiAL),
		('\xFCBF',BidiAL),
		('\xFCC0',BidiAL),
		('\xFCC1',BidiAL),
		('\xFCC2',BidiAL),
		('\xFCC3',BidiAL),
		('\xFCC4',BidiAL),
		('\xFCC5',BidiAL),
		('\xFCC6',BidiAL),
		('\xFCC7',BidiAL),
		('\xFCC8',BidiAL),
		('\xFCC9',BidiAL),
		('\xFCCA',BidiAL),
		('\xFCCB',BidiAL),
		('\xFCCC',BidiAL),
		('\xFCCD',BidiAL),
		('\xFCCE',BidiAL),
		('\xFCCF',BidiAL),
		('\xFCD0',BidiAL),
		('\xFCD1',BidiAL),
		('\xFCD2',BidiAL),
		('\xFCD3',BidiAL),
		('\xFCD4',BidiAL),
		('\xFCD5',BidiAL),
		('\xFCD6',BidiAL),
		('\xFCD7',BidiAL),
		('\xFCD8',BidiAL),
		('\xFCD9',BidiAL),
		('\xFCDA',BidiAL),
		('\xFCDB',BidiAL),
		('\xFCDC',BidiAL),
		('\xFCDD',BidiAL),
		('\xFCDE',BidiAL),
		('\xFCDF',BidiAL),
		('\xFCE0',BidiAL),
		('\xFCE1',BidiAL),
		('\xFCE2',BidiAL),
		('\xFCE3',BidiAL),
		('\xFCE4',BidiAL),
		('\xFCE5',BidiAL),
		('\xFCE6',BidiAL),
		('\xFCE7',BidiAL),
		('\xFCE8',BidiAL),
		('\xFCE9',BidiAL),
		('\xFCEA',BidiAL),
		('\xFCEB',BidiAL),
		('\xFCEC',BidiAL),
		('\xFCED',BidiAL),
		('\xFCEE',BidiAL),
		('\xFCEF',BidiAL),
		('\xFCF0',BidiAL),
		('\xFCF1',BidiAL),
		('\xFCF2',BidiAL),
		('\xFCF3',BidiAL),
		('\xFCF4',BidiAL),
		('\xFCF5',BidiAL),
		('\xFCF6',BidiAL),
		('\xFCF7',BidiAL),
		('\xFCF8',BidiAL),
		('\xFCF9',BidiAL),
		('\xFCFA',BidiAL),
		('\xFCFB',BidiAL),
		('\xFCFC',BidiAL),
		('\xFCFD',BidiAL),
		('\xFCFE',BidiAL),
		('\xFCFF',BidiAL),
		('\xFD00',BidiAL),
		('\xFD01',BidiAL),
		('\xFD02',BidiAL),
		('\xFD03',BidiAL),
		('\xFD04',BidiAL),
		('\xFD05',BidiAL),
		('\xFD06',BidiAL),
		('\xFD07',BidiAL),
		('\xFD08',BidiAL),
		('\xFD09',BidiAL),
		('\xFD0A',BidiAL),
		('\xFD0B',BidiAL),
		('\xFD0C',BidiAL),
		('\xFD0D',BidiAL),
		('\xFD0E',BidiAL),
		('\xFD0F',BidiAL),
		('\xFD10',BidiAL),
		('\xFD11',BidiAL),
		('\xFD12',BidiAL),
		('\xFD13',BidiAL),
		('\xFD14',BidiAL),
		('\xFD15',BidiAL),
		('\xFD16',BidiAL),
		('\xFD17',BidiAL),
		('\xFD18',BidiAL),
		('\xFD19',BidiAL),
		('\xFD1A',BidiAL),
		('\xFD1B',BidiAL),
		('\xFD1C',BidiAL),
		('\xFD1D',BidiAL),
		('\xFD1E',BidiAL),
		('\xFD1F',BidiAL),
		('\xFD20',BidiAL),
		('\xFD21',BidiAL),
		('\xFD22',BidiAL),
		('\xFD23',BidiAL),
		('\xFD24',BidiAL),
		('\xFD25',BidiAL),
		('\xFD26',BidiAL),
		('\xFD27',BidiAL),
		('\xFD28',BidiAL),
		('\xFD29',BidiAL),
		('\xFD2A',BidiAL),
		('\xFD2B',BidiAL),
		('\xFD2C',BidiAL),
		('\xFD2D',BidiAL),
		('\xFD2E',BidiAL),
		('\xFD2F',BidiAL),
		('\xFD30',BidiAL),
		('\xFD31',BidiAL),
		('\xFD32',BidiAL),
		('\xFD33',BidiAL),
		('\xFD34',BidiAL),
		('\xFD35',BidiAL),
		('\xFD36',BidiAL),
		('\xFD37',BidiAL),
		('\xFD38',BidiAL),
		('\xFD39',BidiAL),
		('\xFD3A',BidiAL),
		('\xFD3B',BidiAL),
		('\xFD3C',BidiAL),
		('\xFD3D',BidiAL),
		('\xFD3E',BidiON),
		('\xFD3F',BidiON),
		('\xFD50',BidiAL),
		('\xFD51',BidiAL),
		('\xFD52',BidiAL),
		('\xFD53',BidiAL),
		('\xFD54',BidiAL),
		('\xFD55',BidiAL),
		('\xFD56',BidiAL),
		('\xFD57',BidiAL),
		('\xFD58',BidiAL),
		('\xFD59',BidiAL),
		('\xFD5A',BidiAL),
		('\xFD5B',BidiAL),
		('\xFD5C',BidiAL),
		('\xFD5D',BidiAL),
		('\xFD5E',BidiAL),
		('\xFD5F',BidiAL),
		('\xFD60',BidiAL),
		('\xFD61',BidiAL),
		('\xFD62',BidiAL),
		('\xFD63',BidiAL),
		('\xFD64',BidiAL),
		('\xFD65',BidiAL),
		('\xFD66',BidiAL),
		('\xFD67',BidiAL),
		('\xFD68',BidiAL),
		('\xFD69',BidiAL),
		('\xFD6A',BidiAL),
		('\xFD6B',BidiAL),
		('\xFD6C',BidiAL),
		('\xFD6D',BidiAL),
		('\xFD6E',BidiAL),
		('\xFD6F',BidiAL),
		('\xFD70',BidiAL),
		('\xFD71',BidiAL),
		('\xFD72',BidiAL),
		('\xFD73',BidiAL),
		('\xFD74',BidiAL),
		('\xFD75',BidiAL),
		('\xFD76',BidiAL),
		('\xFD77',BidiAL),
		('\xFD78',BidiAL),
		('\xFD79',BidiAL),
		('\xFD7A',BidiAL),
		('\xFD7B',BidiAL),
		('\xFD7C',BidiAL),
		('\xFD7D',BidiAL),
		('\xFD7E',BidiAL),
		('\xFD7F',BidiAL),
		('\xFD80',BidiAL),
		('\xFD81',BidiAL),
		('\xFD82',BidiAL),
		('\xFD83',BidiAL),
		('\xFD84',BidiAL),
		('\xFD85',BidiAL),
		('\xFD86',BidiAL),
		('\xFD87',BidiAL),
		('\xFD88',BidiAL),
		('\xFD89',BidiAL),
		('\xFD8A',BidiAL),
		('\xFD8B',BidiAL),
		('\xFD8C',BidiAL),
		('\xFD8D',BidiAL),
		('\xFD8E',BidiAL),
		('\xFD8F',BidiAL),
		('\xFD92',BidiAL),
		('\xFD93',BidiAL),
		('\xFD94',BidiAL),
		('\xFD95',BidiAL),
		('\xFD96',BidiAL),
		('\xFD97',BidiAL),
		('\xFD98',BidiAL),
		('\xFD99',BidiAL),
		('\xFD9A',BidiAL),
		('\xFD9B',BidiAL),
		('\xFD9C',BidiAL),
		('\xFD9D',BidiAL),
		('\xFD9E',BidiAL),
		('\xFD9F',BidiAL),
		('\xFDA0',BidiAL),
		('\xFDA1',BidiAL),
		('\xFDA2',BidiAL),
		('\xFDA3',BidiAL),
		('\xFDA4',BidiAL),
		('\xFDA5',BidiAL),
		('\xFDA6',BidiAL),
		('\xFDA7',BidiAL),
		('\xFDA8',BidiAL),
		('\xFDA9',BidiAL),
		('\xFDAA',BidiAL),
		('\xFDAB',BidiAL),
		('\xFDAC',BidiAL),
		('\xFDAD',BidiAL),
		('\xFDAE',BidiAL),
		('\xFDAF',BidiAL),
		('\xFDB0',BidiAL),
		('\xFDB1',BidiAL),
		('\xFDB2',BidiAL),
		('\xFDB3',BidiAL),
		('\xFDB4',BidiAL),
		('\xFDB5',BidiAL),
		('\xFDB6',BidiAL),
		('\xFDB7',BidiAL),
		('\xFDB8',BidiAL),
		('\xFDB9',BidiAL),
		('\xFDBA',BidiAL),
		('\xFDBB',BidiAL),
		('\xFDBC',BidiAL),
		('\xFDBD',BidiAL),
		('\xFDBE',BidiAL),
		('\xFDBF',BidiAL),
		('\xFDC0',BidiAL),
		('\xFDC1',BidiAL),
		('\xFDC2',BidiAL),
		('\xFDC3',BidiAL),
		('\xFDC4',BidiAL),
		('\xFDC5',BidiAL),
		('\xFDC6',BidiAL),
		('\xFDC7',BidiAL),
		('\xFDF0',BidiAL),
		('\xFDF1',BidiAL),
		('\xFDF2',BidiAL),
		('\xFDF3',BidiAL),
		('\xFDF4',BidiAL),
		('\xFDF5',BidiAL),
		('\xFDF6',BidiAL),
		('\xFDF7',BidiAL),
		('\xFDF8',BidiAL),
		('\xFDF9',BidiAL),
		('\xFDFA',BidiAL),
		('\xFDFB',BidiAL),
		('\xFDFC',BidiAL),
		('\xFE00',BidiNSM),
		('\xFE01',BidiNSM),
		('\xFE02',BidiNSM),
		('\xFE03',BidiNSM),
		('\xFE04',BidiNSM),
		('\xFE05',BidiNSM),
		('\xFE06',BidiNSM),
		('\xFE07',BidiNSM),
		('\xFE08',BidiNSM),
		('\xFE09',BidiNSM),
		('\xFE0A',BidiNSM),
		('\xFE0B',BidiNSM),
		('\xFE0C',BidiNSM),
		('\xFE0D',BidiNSM),
		('\xFE0E',BidiNSM),
		('\xFE0F',BidiNSM),
		('\xFE20',BidiNSM),
		('\xFE21',BidiNSM),
		('\xFE22',BidiNSM),
		('\xFE23',BidiNSM),
		('\xFE30',BidiON),
		('\xFE31',BidiON),
		('\xFE32',BidiON),
		('\xFE33',BidiON),
		('\xFE34',BidiON),
		('\xFE35',BidiON),
		('\xFE36',BidiON),
		('\xFE37',BidiON),
		('\xFE38',BidiON),
		('\xFE39',BidiON),
		('\xFE3A',BidiON),
		('\xFE3B',BidiON),
		('\xFE3C',BidiON),
		('\xFE3D',BidiON),
		('\xFE3E',BidiON),
		('\xFE3F',BidiON),
		('\xFE40',BidiON),
		('\xFE41',BidiON),
		('\xFE42',BidiON),
		('\xFE43',BidiON),
		('\xFE44',BidiON),
		('\xFE45',BidiON),
		('\xFE46',BidiON),
		('\xFE49',BidiON),
		('\xFE4A',BidiON),
		('\xFE4B',BidiON),
		('\xFE4C',BidiON),
		('\xFE4D',BidiON),
		('\xFE4E',BidiON),
		('\xFE4F',BidiON),
		('\xFE50',BidiCS),
		('\xFE51',BidiON),
		('\xFE52',BidiCS),
		('\xFE54',BidiON),
		('\xFE55',BidiCS),
		('\xFE56',BidiON),
		('\xFE57',BidiON),
		('\xFE58',BidiON),
		('\xFE59',BidiON),
		('\xFE5A',BidiON),
		('\xFE5B',BidiON),
		('\xFE5C',BidiON),
		('\xFE5D',BidiON),
		('\xFE5E',BidiON),
		('\xFE5F',BidiET),
		('\xFE60',BidiON),
		('\xFE61',BidiON),
		('\xFE62',BidiET),
		('\xFE63',BidiET),
		('\xFE64',BidiON),
		('\xFE65',BidiON),
		('\xFE66',BidiON),
		('\xFE68',BidiON),
		('\xFE69',BidiET),
		('\xFE6A',BidiET),
		('\xFE6B',BidiON),
		('\xFE70',BidiAL),
		('\xFE71',BidiAL),
		('\xFE72',BidiAL),
		('\xFE73',BidiAL),
		('\xFE74',BidiAL),
		('\xFE76',BidiAL),
		('\xFE77',BidiAL),
		('\xFE78',BidiAL),
		('\xFE79',BidiAL),
		('\xFE7A',BidiAL),
		('\xFE7B',BidiAL),
		('\xFE7C',BidiAL),
		('\xFE7D',BidiAL),
		('\xFE7E',BidiAL),
		('\xFE7F',BidiAL),
		('\xFE80',BidiAL),
		('\xFE81',BidiAL),
		('\xFE82',BidiAL),
		('\xFE83',BidiAL),
		('\xFE84',BidiAL),
		('\xFE85',BidiAL),
		('\xFE86',BidiAL),
		('\xFE87',BidiAL),
		('\xFE88',BidiAL),
		('\xFE89',BidiAL),
		('\xFE8A',BidiAL),
		('\xFE8B',BidiAL),
		('\xFE8C',BidiAL),
		('\xFE8D',BidiAL),
		('\xFE8E',BidiAL),
		('\xFE8F',BidiAL),
		('\xFE90',BidiAL),
		('\xFE91',BidiAL),
		('\xFE92',BidiAL),
		('\xFE93',BidiAL),
		('\xFE94',BidiAL),
		('\xFE95',BidiAL),
		('\xFE96',BidiAL),
		('\xFE97',BidiAL),
		('\xFE98',BidiAL),
		('\xFE99',BidiAL),
		('\xFE9A',BidiAL),
		('\xFE9B',BidiAL),
		('\xFE9C',BidiAL),
		('\xFE9D',BidiAL),
		('\xFE9E',BidiAL),
		('\xFE9F',BidiAL),
		('\xFEA0',BidiAL),
		('\xFEA1',BidiAL),
		('\xFEA2',BidiAL),
		('\xFEA3',BidiAL),
		('\xFEA4',BidiAL),
		('\xFEA5',BidiAL),
		('\xFEA6',BidiAL),
		('\xFEA7',BidiAL),
		('\xFEA8',BidiAL),
		('\xFEA9',BidiAL),
		('\xFEAA',BidiAL),
		('\xFEAB',BidiAL),
		('\xFEAC',BidiAL),
		('\xFEAD',BidiAL),
		('\xFEAE',BidiAL),
		('\xFEAF',BidiAL),
		('\xFEB0',BidiAL),
		('\xFEB1',BidiAL),
		('\xFEB2',BidiAL),
		('\xFEB3',BidiAL),
		('\xFEB4',BidiAL),
		('\xFEB5',BidiAL),
		('\xFEB6',BidiAL),
		('\xFEB7',BidiAL),
		('\xFEB8',BidiAL),
		('\xFEB9',BidiAL),
		('\xFEBA',BidiAL),
		('\xFEBB',BidiAL),
		('\xFEBC',BidiAL),
		('\xFEBD',BidiAL),
		('\xFEBE',BidiAL),
		('\xFEBF',BidiAL),
		('\xFEC0',BidiAL),
		('\xFEC1',BidiAL),
		('\xFEC2',BidiAL),
		('\xFEC3',BidiAL),
		('\xFEC4',BidiAL),
		('\xFEC5',BidiAL),
		('\xFEC6',BidiAL),
		('\xFEC7',BidiAL),
		('\xFEC8',BidiAL),
		('\xFEC9',BidiAL),
		('\xFECA',BidiAL),
		('\xFECB',BidiAL),
		('\xFECC',BidiAL),
		('\xFECD',BidiAL),
		('\xFECE',BidiAL),
		('\xFECF',BidiAL),
		('\xFED0',BidiAL),
		('\xFED1',BidiAL),
		('\xFED2',BidiAL),
		('\xFED3',BidiAL),
		('\xFED4',BidiAL),
		('\xFED5',BidiAL),
		('\xFED6',BidiAL),
		('\xFED7',BidiAL),
		('\xFED8',BidiAL),
		('\xFED9',BidiAL),
		('\xFEDA',BidiAL),
		('\xFEDB',BidiAL),
		('\xFEDC',BidiAL),
		('\xFEDD',BidiAL),
		('\xFEDE',BidiAL),
		('\xFEDF',BidiAL),
		('\xFEE0',BidiAL),
		('\xFEE1',BidiAL),
		('\xFEE2',BidiAL),
		('\xFEE3',BidiAL),
		('\xFEE4',BidiAL),
		('\xFEE5',BidiAL),
		('\xFEE6',BidiAL),
		('\xFEE7',BidiAL),
		('\xFEE8',BidiAL),
		('\xFEE9',BidiAL),
		('\xFEEA',BidiAL),
		('\xFEEB',BidiAL),
		('\xFEEC',BidiAL),
		('\xFEED',BidiAL),
		('\xFEEE',BidiAL),
		('\xFEEF',BidiAL),
		('\xFEF0',BidiAL),
		('\xFEF1',BidiAL),
		('\xFEF2',BidiAL),
		('\xFEF3',BidiAL),
		('\xFEF4',BidiAL),
		('\xFEF5',BidiAL),
		('\xFEF6',BidiAL),
		('\xFEF7',BidiAL),
		('\xFEF8',BidiAL),
		('\xFEF9',BidiAL),
		('\xFEFA',BidiAL),
		('\xFEFB',BidiAL),
		('\xFEFC',BidiAL),
		('\xFEFF',BidiBN),
		('\xFF01',BidiON),
		('\xFF02',BidiON),
		('\xFF03',BidiET),
		('\xFF04',BidiET),
		('\xFF05',BidiET),
		('\xFF06',BidiON),
		('\xFF07',BidiON),
		('\xFF08',BidiON),
		('\xFF09',BidiON),
		('\xFF0A',BidiON),
		('\xFF0B',BidiET),
		('\xFF0C',BidiCS),
		('\xFF0D',BidiET),
		('\xFF0E',BidiCS),
		('\xFF0F',BidiES),
		('\xFF10',BidiEN),
		('\xFF11',BidiEN),
		('\xFF12',BidiEN),
		('\xFF13',BidiEN),
		('\xFF14',BidiEN),
		('\xFF15',BidiEN),
		('\xFF16',BidiEN),
		('\xFF17',BidiEN),
		('\xFF18',BidiEN),
		('\xFF19',BidiEN),
		('\xFF1A',BidiCS),
		('\xFF1B',BidiON),
		('\xFF1C',BidiON),
		('\xFF1D',BidiON),
		('\xFF1E',BidiON),
		('\xFF1F',BidiON),
		('\xFF20',BidiON),
		('\xFF3B',BidiON),
		('\xFF3C',BidiON),
		('\xFF3D',BidiON),
		('\xFF3E',BidiON),
		('\xFF3F',BidiON),
		('\xFF40',BidiON),
		('\xFF5B',BidiON),
		('\xFF5C',BidiON),
		('\xFF5D',BidiON),
		('\xFF5E',BidiON),
		('\xFF5F',BidiON),
		('\xFF60',BidiON),
		('\xFF61',BidiON),
		('\xFF62',BidiON),
		('\xFF63',BidiON),
		('\xFF64',BidiON),
		('\xFF65',BidiON),
		('\xFFE0',BidiET),
		('\xFFE1',BidiET),
		('\xFFE2',BidiON),
		('\xFFE3',BidiON),
		('\xFFE4',BidiON),
		('\xFFE5',BidiET),
		('\xFFE6',BidiET),
		('\xFFE8',BidiON),
		('\xFFE9',BidiON),
		('\xFFEA',BidiON),
		('\xFFEB',BidiON),
		('\xFFEC',BidiON),
		('\xFFED',BidiON),
		('\xFFEE',BidiON),
		('\xFFF9',BidiBN),
		('\xFFFA',BidiBN),
		('\xFFFB',BidiBN),
		('\xFFFC',BidiON),
		('\xFFFD',BidiON),
		('\x1D167',BidiNSM),
		('\x1D168',BidiNSM),
		('\x1D169',BidiNSM),
		('\x1D173',BidiBN),
		('\x1D174',BidiBN),
		('\x1D175',BidiBN),
		('\x1D176',BidiBN),
		('\x1D177',BidiBN),
		('\x1D178',BidiBN),
		('\x1D179',BidiBN),
		('\x1D17A',BidiBN),
		('\x1D17B',BidiNSM),
		('\x1D17C',BidiNSM),
		('\x1D17D',BidiNSM),
		('\x1D17E',BidiNSM),
		('\x1D17F',BidiNSM),
		('\x1D180',BidiNSM),
		('\x1D181',BidiNSM),
		('\x1D182',BidiNSM),
		('\x1D185',BidiNSM),
		('\x1D186',BidiNSM),
		('\x1D187',BidiNSM),
		('\x1D188',BidiNSM),
		('\x1D189',BidiNSM),
		('\x1D18A',BidiNSM),
		('\x1D18B',BidiNSM),
		('\x1D1AA',BidiNSM),
		('\x1D1AB',BidiNSM),
		('\x1D1AC',BidiNSM),
		('\x1D1AD',BidiNSM),
		('\x1D7CE',BidiEN),
		('\x1D7CF',BidiEN),
		('\x1D7D0',BidiEN),
		('\x1D7D1',BidiEN),
		('\x1D7D2',BidiEN),
		('\x1D7D3',BidiEN),
		('\x1D7D4',BidiEN),
		('\x1D7D5',BidiEN),
		('\x1D7D6',BidiEN),
		('\x1D7D7',BidiEN),
		('\x1D7D8',BidiEN),
		('\x1D7D9',BidiEN),
		('\x1D7DA',BidiEN),
		('\x1D7DB',BidiEN),
		('\x1D7DC',BidiEN),
		('\x1D7DD',BidiEN),
		('\x1D7DE',BidiEN),
		('\x1D7DF',BidiEN),
		('\x1D7E0',BidiEN),
		('\x1D7E1',BidiEN),
		('\x1D7E2',BidiEN),
		('\x1D7E3',BidiEN),
		('\x1D7E4',BidiEN),
		('\x1D7E5',BidiEN),
		('\x1D7E6',BidiEN),
		('\x1D7E7',BidiEN),
		('\x1D7E8',BidiEN),
		('\x1D7E9',BidiEN),
		('\x1D7EA',BidiEN),
		('\x1D7EB',BidiEN),
		('\x1D7EC',BidiEN),
		('\x1D7ED',BidiEN),
		('\x1D7EE',BidiEN),
		('\x1D7EF',BidiEN),
		('\x1D7F0',BidiEN),
		('\x1D7F1',BidiEN),
		('\x1D7F2',BidiEN),
		('\x1D7F3',BidiEN),
		('\x1D7F4',BidiEN),
		('\x1D7F5',BidiEN),
		('\x1D7F6',BidiEN),
		('\x1D7F7',BidiEN),
		('\x1D7F8',BidiEN),
		('\x1D7F9',BidiEN),
		('\x1D7FA',BidiEN),
		('\x1D7FB',BidiEN),
		('\x1D7FC',BidiEN),
		('\x1D7FD',BidiEN),
		('\x1D7FE',BidiEN),
		('\x1D7FF',BidiEN),
		('\xE0001',BidiBN),
		('\xE0020',BidiBN),
		('\xE0021',BidiBN),
		('\xE0022',BidiBN),
		('\xE0023',BidiBN),
		('\xE0024',BidiBN),
		('\xE0025',BidiBN),
		('\xE0026',BidiBN),
		('\xE0027',BidiBN),
		('\xE0028',BidiBN),
		('\xE0029',BidiBN),
		('\xE002A',BidiBN),
		('\xE002B',BidiBN),
		('\xE002C',BidiBN),
		('\xE002D',BidiBN),
		('\xE002E',BidiBN),
		('\xE002F',BidiBN),
		('\xE0030',BidiBN),
		('\xE0031',BidiBN),
		('\xE0032',BidiBN),
		('\xE0033',BidiBN),
		('\xE0034',BidiBN),
		('\xE0035',BidiBN),
		('\xE0036',BidiBN),
		('\xE0037',BidiBN),
		('\xE0038',BidiBN),
		('\xE0039',BidiBN),
		('\xE003A',BidiBN),
		('\xE003B',BidiBN),
		('\xE003C',BidiBN),
		('\xE003D',BidiBN),
		('\xE003E',BidiBN),
		('\xE003F',BidiBN),
		('\xE0040',BidiBN),
		('\xE0041',BidiBN),
		('\xE0042',BidiBN),
		('\xE0043',BidiBN),
		('\xE0044',BidiBN),
		('\xE0045',BidiBN),
		('\xE0046',BidiBN),
		('\xE0047',BidiBN),
		('\xE0048',BidiBN),
		('\xE0049',BidiBN),
		('\xE004A',BidiBN),
		('\xE004B',BidiBN),
		('\xE004C',BidiBN),
		('\xE004D',BidiBN),
		('\xE004E',BidiBN),
		('\xE004F',BidiBN),
		('\xE0050',BidiBN),
		('\xE0051',BidiBN),
		('\xE0052',BidiBN),
		('\xE0053',BidiBN),
		('\xE0054',BidiBN),
		('\xE0055',BidiBN),
		('\xE0056',BidiBN),
		('\xE0057',BidiBN),
		('\xE0058',BidiBN),
		('\xE0059',BidiBN),
		('\xE005A',BidiBN),
		('\xE005B',BidiBN),
		('\xE005C',BidiBN),
		('\xE005D',BidiBN),
		('\xE005E',BidiBN),
		('\xE005F',BidiBN),
		('\xE0060',BidiBN),
		('\xE0061',BidiBN),
		('\xE0062',BidiBN),
		('\xE0063',BidiBN),
		('\xE0064',BidiBN),
		('\xE0065',BidiBN),
		('\xE0066',BidiBN),
		('\xE0067',BidiBN),
		('\xE0068',BidiBN),
		('\xE0069',BidiBN),
		('\xE006A',BidiBN),
		('\xE006B',BidiBN),
		('\xE006C',BidiBN),
		('\xE006D',BidiBN),
		('\xE006E',BidiBN),
		('\xE006F',BidiBN),
		('\xE0070',BidiBN),
		('\xE0071',BidiBN),
		('\xE0072',BidiBN),
		('\xE0073',BidiBN),
		('\xE0074',BidiBN),
		('\xE0075',BidiBN),
		('\xE0076',BidiBN),
		('\xE0077',BidiBN),
		('\xE0078',BidiBN),
		('\xE0079',BidiBN),
		('\xE007A',BidiBN),
		('\xE007B',BidiBN),
		('\xE007C',BidiBN),
		('\xE007D',BidiBN),
		('\xE007E',BidiBN),
		('\xE007F',BidiBN),
		('\x10FFFF',BidiL)
		];

	theArray :: Array Char BidiCategory;
	theArray = accumArray (\_ a -> a) BidiL ('\0','\x10FFFF') theList;

	getFromArray :: Char -> BidiCategory;
	getFromArray c = if (inRange ('\0','\x10FFFF') c)
	 then theArray ! c
	 else BidiL;

	getBidiCategory :: Char -> BidiCategory;
	getBidiCategory c = handleOmittedRange (getFromArray c) getFromArray c;
	}
