module Data.Char.Properties.DecompositionData (getDecomposition) where
{
	import Data.Char.Properties.DecompositionTypes;
	import Data.Char.Properties.PrivateData;
	import Data.Array;
	import Prelude;

	theList :: [(Char,Decomposition)];
	theList =
		[
		('\x00A0',MkDecomposition DCNoBreak ['\x0020']),
		('\x00A8',MkDecomposition DCCompat ['\x0020','\x0308']),
		('\x00AA',MkDecomposition DCSuper ['\x0061']),
		('\x00AF',MkDecomposition DCCompat ['\x0020','\x0304']),
		('\x00B2',MkDecomposition DCSuper ['\x0032']),
		('\x00B3',MkDecomposition DCSuper ['\x0033']),
		('\x00B4',MkDecomposition DCCompat ['\x0020','\x0301']),
		('\x00B5',MkDecomposition DCCompat ['\x03BC']),
		('\x00B8',MkDecomposition DCCompat ['\x0020','\x0327']),
		('\x00B9',MkDecomposition DCSuper ['\x0031']),
		('\x00BA',MkDecomposition DCSuper ['\x006F']),
		('\x00BC',MkDecomposition DCFraction ['\x0031','\x2044','\x0034']),
		('\x00BD',MkDecomposition DCFraction ['\x0031','\x2044','\x0032']),
		('\x00BE',MkDecomposition DCFraction ['\x0033','\x2044','\x0034']),
		('\x00C0',MkDecomposition DCCanonical ['\x0041','\x0300']),
		('\x00C1',MkDecomposition DCCanonical ['\x0041','\x0301']),
		('\x00C2',MkDecomposition DCCanonical ['\x0041','\x0302']),
		('\x00C3',MkDecomposition DCCanonical ['\x0041','\x0303']),
		('\x00C4',MkDecomposition DCCanonical ['\x0041','\x0308']),
		('\x00C5',MkDecomposition DCCanonical ['\x0041','\x030A']),
		('\x00C7',MkDecomposition DCCanonical ['\x0043','\x0327']),
		('\x00C8',MkDecomposition DCCanonical ['\x0045','\x0300']),
		('\x00C9',MkDecomposition DCCanonical ['\x0045','\x0301']),
		('\x00CA',MkDecomposition DCCanonical ['\x0045','\x0302']),
		('\x00CB',MkDecomposition DCCanonical ['\x0045','\x0308']),
		('\x00CC',MkDecomposition DCCanonical ['\x0049','\x0300']),
		('\x00CD',MkDecomposition DCCanonical ['\x0049','\x0301']),
		('\x00CE',MkDecomposition DCCanonical ['\x0049','\x0302']),
		('\x00CF',MkDecomposition DCCanonical ['\x0049','\x0308']),
		('\x00D1',MkDecomposition DCCanonical ['\x004E','\x0303']),
		('\x00D2',MkDecomposition DCCanonical ['\x004F','\x0300']),
		('\x00D3',MkDecomposition DCCanonical ['\x004F','\x0301']),
		('\x00D4',MkDecomposition DCCanonical ['\x004F','\x0302']),
		('\x00D5',MkDecomposition DCCanonical ['\x004F','\x0303']),
		('\x00D6',MkDecomposition DCCanonical ['\x004F','\x0308']),
		('\x00D9',MkDecomposition DCCanonical ['\x0055','\x0300']),
		('\x00DA',MkDecomposition DCCanonical ['\x0055','\x0301']),
		('\x00DB',MkDecomposition DCCanonical ['\x0055','\x0302']),
		('\x00DC',MkDecomposition DCCanonical ['\x0055','\x0308']),
		('\x00DD',MkDecomposition DCCanonical ['\x0059','\x0301']),
		('\x00E0',MkDecomposition DCCanonical ['\x0061','\x0300']),
		('\x00E1',MkDecomposition DCCanonical ['\x0061','\x0301']),
		('\x00E2',MkDecomposition DCCanonical ['\x0061','\x0302']),
		('\x00E3',MkDecomposition DCCanonical ['\x0061','\x0303']),
		('\x00E4',MkDecomposition DCCanonical ['\x0061','\x0308']),
		('\x00E5',MkDecomposition DCCanonical ['\x0061','\x030A']),
		('\x00E7',MkDecomposition DCCanonical ['\x0063','\x0327']),
		('\x00E8',MkDecomposition DCCanonical ['\x0065','\x0300']),
		('\x00E9',MkDecomposition DCCanonical ['\x0065','\x0301']),
		('\x00EA',MkDecomposition DCCanonical ['\x0065','\x0302']),
		('\x00EB',MkDecomposition DCCanonical ['\x0065','\x0308']),
		('\x00EC',MkDecomposition DCCanonical ['\x0069','\x0300']),
		('\x00ED',MkDecomposition DCCanonical ['\x0069','\x0301']),
		('\x00EE',MkDecomposition DCCanonical ['\x0069','\x0302']),
		('\x00EF',MkDecomposition DCCanonical ['\x0069','\x0308']),
		('\x00F1',MkDecomposition DCCanonical ['\x006E','\x0303']),
		('\x00F2',MkDecomposition DCCanonical ['\x006F','\x0300']),
		('\x00F3',MkDecomposition DCCanonical ['\x006F','\x0301']),
		('\x00F4',MkDecomposition DCCanonical ['\x006F','\x0302']),
		('\x00F5',MkDecomposition DCCanonical ['\x006F','\x0303']),
		('\x00F6',MkDecomposition DCCanonical ['\x006F','\x0308']),
		('\x00F9',MkDecomposition DCCanonical ['\x0075','\x0300']),
		('\x00FA',MkDecomposition DCCanonical ['\x0075','\x0301']),
		('\x00FB',MkDecomposition DCCanonical ['\x0075','\x0302']),
		('\x00FC',MkDecomposition DCCanonical ['\x0075','\x0308']),
		('\x00FD',MkDecomposition DCCanonical ['\x0079','\x0301']),
		('\x00FF',MkDecomposition DCCanonical ['\x0079','\x0308']),
		('\x0100',MkDecomposition DCCanonical ['\x0041','\x0304']),
		('\x0101',MkDecomposition DCCanonical ['\x0061','\x0304']),
		('\x0102',MkDecomposition DCCanonical ['\x0041','\x0306']),
		('\x0103',MkDecomposition DCCanonical ['\x0061','\x0306']),
		('\x0104',MkDecomposition DCCanonical ['\x0041','\x0328']),
		('\x0105',MkDecomposition DCCanonical ['\x0061','\x0328']),
		('\x0106',MkDecomposition DCCanonical ['\x0043','\x0301']),
		('\x0107',MkDecomposition DCCanonical ['\x0063','\x0301']),
		('\x0108',MkDecomposition DCCanonical ['\x0043','\x0302']),
		('\x0109',MkDecomposition DCCanonical ['\x0063','\x0302']),
		('\x010A',MkDecomposition DCCanonical ['\x0043','\x0307']),
		('\x010B',MkDecomposition DCCanonical ['\x0063','\x0307']),
		('\x010C',MkDecomposition DCCanonical ['\x0043','\x030C']),
		('\x010D',MkDecomposition DCCanonical ['\x0063','\x030C']),
		('\x010E',MkDecomposition DCCanonical ['\x0044','\x030C']),
		('\x010F',MkDecomposition DCCanonical ['\x0064','\x030C']),
		('\x0112',MkDecomposition DCCanonical ['\x0045','\x0304']),
		('\x0113',MkDecomposition DCCanonical ['\x0065','\x0304']),
		('\x0114',MkDecomposition DCCanonical ['\x0045','\x0306']),
		('\x0115',MkDecomposition DCCanonical ['\x0065','\x0306']),
		('\x0116',MkDecomposition DCCanonical ['\x0045','\x0307']),
		('\x0117',MkDecomposition DCCanonical ['\x0065','\x0307']),
		('\x0118',MkDecomposition DCCanonical ['\x0045','\x0328']),
		('\x0119',MkDecomposition DCCanonical ['\x0065','\x0328']),
		('\x011A',MkDecomposition DCCanonical ['\x0045','\x030C']),
		('\x011B',MkDecomposition DCCanonical ['\x0065','\x030C']),
		('\x011C',MkDecomposition DCCanonical ['\x0047','\x0302']),
		('\x011D',MkDecomposition DCCanonical ['\x0067','\x0302']),
		('\x011E',MkDecomposition DCCanonical ['\x0047','\x0306']),
		('\x011F',MkDecomposition DCCanonical ['\x0067','\x0306']),
		('\x0120',MkDecomposition DCCanonical ['\x0047','\x0307']),
		('\x0121',MkDecomposition DCCanonical ['\x0067','\x0307']),
		('\x0122',MkDecomposition DCCanonical ['\x0047','\x0327']),
		('\x0123',MkDecomposition DCCanonical ['\x0067','\x0327']),
		('\x0124',MkDecomposition DCCanonical ['\x0048','\x0302']),
		('\x0125',MkDecomposition DCCanonical ['\x0068','\x0302']),
		('\x0128',MkDecomposition DCCanonical ['\x0049','\x0303']),
		('\x0129',MkDecomposition DCCanonical ['\x0069','\x0303']),
		('\x012A',MkDecomposition DCCanonical ['\x0049','\x0304']),
		('\x012B',MkDecomposition DCCanonical ['\x0069','\x0304']),
		('\x012C',MkDecomposition DCCanonical ['\x0049','\x0306']),
		('\x012D',MkDecomposition DCCanonical ['\x0069','\x0306']),
		('\x012E',MkDecomposition DCCanonical ['\x0049','\x0328']),
		('\x012F',MkDecomposition DCCanonical ['\x0069','\x0328']),
		('\x0130',MkDecomposition DCCanonical ['\x0049','\x0307']),
		('\x0132',MkDecomposition DCCompat ['\x0049','\x004A']),
		('\x0133',MkDecomposition DCCompat ['\x0069','\x006A']),
		('\x0134',MkDecomposition DCCanonical ['\x004A','\x0302']),
		('\x0135',MkDecomposition DCCanonical ['\x006A','\x0302']),
		('\x0136',MkDecomposition DCCanonical ['\x004B','\x0327']),
		('\x0137',MkDecomposition DCCanonical ['\x006B','\x0327']),
		('\x0139',MkDecomposition DCCanonical ['\x004C','\x0301']),
		('\x013A',MkDecomposition DCCanonical ['\x006C','\x0301']),
		('\x013B',MkDecomposition DCCanonical ['\x004C','\x0327']),
		('\x013C',MkDecomposition DCCanonical ['\x006C','\x0327']),
		('\x013D',MkDecomposition DCCanonical ['\x004C','\x030C']),
		('\x013E',MkDecomposition DCCanonical ['\x006C','\x030C']),
		('\x013F',MkDecomposition DCCompat ['\x004C','\x00B7']),
		('\x0140',MkDecomposition DCCompat ['\x006C','\x00B7']),
		('\x0143',MkDecomposition DCCanonical ['\x004E','\x0301']),
		('\x0144',MkDecomposition DCCanonical ['\x006E','\x0301']),
		('\x0145',MkDecomposition DCCanonical ['\x004E','\x0327']),
		('\x0146',MkDecomposition DCCanonical ['\x006E','\x0327']),
		('\x0147',MkDecomposition DCCanonical ['\x004E','\x030C']),
		('\x0148',MkDecomposition DCCanonical ['\x006E','\x030C']),
		('\x0149',MkDecomposition DCCompat ['\x02BC','\x006E']),
		('\x014C',MkDecomposition DCCanonical ['\x004F','\x0304']),
		('\x014D',MkDecomposition DCCanonical ['\x006F','\x0304']),
		('\x014E',MkDecomposition DCCanonical ['\x004F','\x0306']),
		('\x014F',MkDecomposition DCCanonical ['\x006F','\x0306']),
		('\x0150',MkDecomposition DCCanonical ['\x004F','\x030B']),
		('\x0151',MkDecomposition DCCanonical ['\x006F','\x030B']),
		('\x0154',MkDecomposition DCCanonical ['\x0052','\x0301']),
		('\x0155',MkDecomposition DCCanonical ['\x0072','\x0301']),
		('\x0156',MkDecomposition DCCanonical ['\x0052','\x0327']),
		('\x0157',MkDecomposition DCCanonical ['\x0072','\x0327']),
		('\x0158',MkDecomposition DCCanonical ['\x0052','\x030C']),
		('\x0159',MkDecomposition DCCanonical ['\x0072','\x030C']),
		('\x015A',MkDecomposition DCCanonical ['\x0053','\x0301']),
		('\x015B',MkDecomposition DCCanonical ['\x0073','\x0301']),
		('\x015C',MkDecomposition DCCanonical ['\x0053','\x0302']),
		('\x015D',MkDecomposition DCCanonical ['\x0073','\x0302']),
		('\x015E',MkDecomposition DCCanonical ['\x0053','\x0327']),
		('\x015F',MkDecomposition DCCanonical ['\x0073','\x0327']),
		('\x0160',MkDecomposition DCCanonical ['\x0053','\x030C']),
		('\x0161',MkDecomposition DCCanonical ['\x0073','\x030C']),
		('\x0162',MkDecomposition DCCanonical ['\x0054','\x0327']),
		('\x0163',MkDecomposition DCCanonical ['\x0074','\x0327']),
		('\x0164',MkDecomposition DCCanonical ['\x0054','\x030C']),
		('\x0165',MkDecomposition DCCanonical ['\x0074','\x030C']),
		('\x0168',MkDecomposition DCCanonical ['\x0055','\x0303']),
		('\x0169',MkDecomposition DCCanonical ['\x0075','\x0303']),
		('\x016A',MkDecomposition DCCanonical ['\x0055','\x0304']),
		('\x016B',MkDecomposition DCCanonical ['\x0075','\x0304']),
		('\x016C',MkDecomposition DCCanonical ['\x0055','\x0306']),
		('\x016D',MkDecomposition DCCanonical ['\x0075','\x0306']),
		('\x016E',MkDecomposition DCCanonical ['\x0055','\x030A']),
		('\x016F',MkDecomposition DCCanonical ['\x0075','\x030A']),
		('\x0170',MkDecomposition DCCanonical ['\x0055','\x030B']),
		('\x0171',MkDecomposition DCCanonical ['\x0075','\x030B']),
		('\x0172',MkDecomposition DCCanonical ['\x0055','\x0328']),
		('\x0173',MkDecomposition DCCanonical ['\x0075','\x0328']),
		('\x0174',MkDecomposition DCCanonical ['\x0057','\x0302']),
		('\x0175',MkDecomposition DCCanonical ['\x0077','\x0302']),
		('\x0176',MkDecomposition DCCanonical ['\x0059','\x0302']),
		('\x0177',MkDecomposition DCCanonical ['\x0079','\x0302']),
		('\x0178',MkDecomposition DCCanonical ['\x0059','\x0308']),
		('\x0179',MkDecomposition DCCanonical ['\x005A','\x0301']),
		('\x017A',MkDecomposition DCCanonical ['\x007A','\x0301']),
		('\x017B',MkDecomposition DCCanonical ['\x005A','\x0307']),
		('\x017C',MkDecomposition DCCanonical ['\x007A','\x0307']),
		('\x017D',MkDecomposition DCCanonical ['\x005A','\x030C']),
		('\x017E',MkDecomposition DCCanonical ['\x007A','\x030C']),
		('\x017F',MkDecomposition DCCompat ['\x0073']),
		('\x01A0',MkDecomposition DCCanonical ['\x004F','\x031B']),
		('\x01A1',MkDecomposition DCCanonical ['\x006F','\x031B']),
		('\x01AF',MkDecomposition DCCanonical ['\x0055','\x031B']),
		('\x01B0',MkDecomposition DCCanonical ['\x0075','\x031B']),
		('\x01C4',MkDecomposition DCCompat ['\x0044','\x017D']),
		('\x01C5',MkDecomposition DCCompat ['\x0044','\x017E']),
		('\x01C6',MkDecomposition DCCompat ['\x0064','\x017E']),
		('\x01C7',MkDecomposition DCCompat ['\x004C','\x004A']),
		('\x01C8',MkDecomposition DCCompat ['\x004C','\x006A']),
		('\x01C9',MkDecomposition DCCompat ['\x006C','\x006A']),
		('\x01CA',MkDecomposition DCCompat ['\x004E','\x004A']),
		('\x01CB',MkDecomposition DCCompat ['\x004E','\x006A']),
		('\x01CC',MkDecomposition DCCompat ['\x006E','\x006A']),
		('\x01CD',MkDecomposition DCCanonical ['\x0041','\x030C']),
		('\x01CE',MkDecomposition DCCanonical ['\x0061','\x030C']),
		('\x01CF',MkDecomposition DCCanonical ['\x0049','\x030C']),
		('\x01D0',MkDecomposition DCCanonical ['\x0069','\x030C']),
		('\x01D1',MkDecomposition DCCanonical ['\x004F','\x030C']),
		('\x01D2',MkDecomposition DCCanonical ['\x006F','\x030C']),
		('\x01D3',MkDecomposition DCCanonical ['\x0055','\x030C']),
		('\x01D4',MkDecomposition DCCanonical ['\x0075','\x030C']),
		('\x01D5',MkDecomposition DCCanonical ['\x00DC','\x0304']),
		('\x01D6',MkDecomposition DCCanonical ['\x00FC','\x0304']),
		('\x01D7',MkDecomposition DCCanonical ['\x00DC','\x0301']),
		('\x01D8',MkDecomposition DCCanonical ['\x00FC','\x0301']),
		('\x01D9',MkDecomposition DCCanonical ['\x00DC','\x030C']),
		('\x01DA',MkDecomposition DCCanonical ['\x00FC','\x030C']),
		('\x01DB',MkDecomposition DCCanonical ['\x00DC','\x0300']),
		('\x01DC',MkDecomposition DCCanonical ['\x00FC','\x0300']),
		('\x01DE',MkDecomposition DCCanonical ['\x00C4','\x0304']),
		('\x01DF',MkDecomposition DCCanonical ['\x00E4','\x0304']),
		('\x01E0',MkDecomposition DCCanonical ['\x0226','\x0304']),
		('\x01E1',MkDecomposition DCCanonical ['\x0227','\x0304']),
		('\x01E2',MkDecomposition DCCanonical ['\x00C6','\x0304']),
		('\x01E3',MkDecomposition DCCanonical ['\x00E6','\x0304']),
		('\x01E6',MkDecomposition DCCanonical ['\x0047','\x030C']),
		('\x01E7',MkDecomposition DCCanonical ['\x0067','\x030C']),
		('\x01E8',MkDecomposition DCCanonical ['\x004B','\x030C']),
		('\x01E9',MkDecomposition DCCanonical ['\x006B','\x030C']),
		('\x01EA',MkDecomposition DCCanonical ['\x004F','\x0328']),
		('\x01EB',MkDecomposition DCCanonical ['\x006F','\x0328']),
		('\x01EC',MkDecomposition DCCanonical ['\x01EA','\x0304']),
		('\x01ED',MkDecomposition DCCanonical ['\x01EB','\x0304']),
		('\x01EE',MkDecomposition DCCanonical ['\x01B7','\x030C']),
		('\x01EF',MkDecomposition DCCanonical ['\x0292','\x030C']),
		('\x01F0',MkDecomposition DCCanonical ['\x006A','\x030C']),
		('\x01F1',MkDecomposition DCCompat ['\x0044','\x005A']),
		('\x01F2',MkDecomposition DCCompat ['\x0044','\x007A']),
		('\x01F3',MkDecomposition DCCompat ['\x0064','\x007A']),
		('\x01F4',MkDecomposition DCCanonical ['\x0047','\x0301']),
		('\x01F5',MkDecomposition DCCanonical ['\x0067','\x0301']),
		('\x01F8',MkDecomposition DCCanonical ['\x004E','\x0300']),
		('\x01F9',MkDecomposition DCCanonical ['\x006E','\x0300']),
		('\x01FA',MkDecomposition DCCanonical ['\x00C5','\x0301']),
		('\x01FB',MkDecomposition DCCanonical ['\x00E5','\x0301']),
		('\x01FC',MkDecomposition DCCanonical ['\x00C6','\x0301']),
		('\x01FD',MkDecomposition DCCanonical ['\x00E6','\x0301']),
		('\x01FE',MkDecomposition DCCanonical ['\x00D8','\x0301']),
		('\x01FF',MkDecomposition DCCanonical ['\x00F8','\x0301']),
		('\x0200',MkDecomposition DCCanonical ['\x0041','\x030F']),
		('\x0201',MkDecomposition DCCanonical ['\x0061','\x030F']),
		('\x0202',MkDecomposition DCCanonical ['\x0041','\x0311']),
		('\x0203',MkDecomposition DCCanonical ['\x0061','\x0311']),
		('\x0204',MkDecomposition DCCanonical ['\x0045','\x030F']),
		('\x0205',MkDecomposition DCCanonical ['\x0065','\x030F']),
		('\x0206',MkDecomposition DCCanonical ['\x0045','\x0311']),
		('\x0207',MkDecomposition DCCanonical ['\x0065','\x0311']),
		('\x0208',MkDecomposition DCCanonical ['\x0049','\x030F']),
		('\x0209',MkDecomposition DCCanonical ['\x0069','\x030F']),
		('\x020A',MkDecomposition DCCanonical ['\x0049','\x0311']),
		('\x020B',MkDecomposition DCCanonical ['\x0069','\x0311']),
		('\x020C',MkDecomposition DCCanonical ['\x004F','\x030F']),
		('\x020D',MkDecomposition DCCanonical ['\x006F','\x030F']),
		('\x020E',MkDecomposition DCCanonical ['\x004F','\x0311']),
		('\x020F',MkDecomposition DCCanonical ['\x006F','\x0311']),
		('\x0210',MkDecomposition DCCanonical ['\x0052','\x030F']),
		('\x0211',MkDecomposition DCCanonical ['\x0072','\x030F']),
		('\x0212',MkDecomposition DCCanonical ['\x0052','\x0311']),
		('\x0213',MkDecomposition DCCanonical ['\x0072','\x0311']),
		('\x0214',MkDecomposition DCCanonical ['\x0055','\x030F']),
		('\x0215',MkDecomposition DCCanonical ['\x0075','\x030F']),
		('\x0216',MkDecomposition DCCanonical ['\x0055','\x0311']),
		('\x0217',MkDecomposition DCCanonical ['\x0075','\x0311']),
		('\x0218',MkDecomposition DCCanonical ['\x0053','\x0326']),
		('\x0219',MkDecomposition DCCanonical ['\x0073','\x0326']),
		('\x021A',MkDecomposition DCCanonical ['\x0054','\x0326']),
		('\x021B',MkDecomposition DCCanonical ['\x0074','\x0326']),
		('\x021E',MkDecomposition DCCanonical ['\x0048','\x030C']),
		('\x021F',MkDecomposition DCCanonical ['\x0068','\x030C']),
		('\x0226',MkDecomposition DCCanonical ['\x0041','\x0307']),
		('\x0227',MkDecomposition DCCanonical ['\x0061','\x0307']),
		('\x0228',MkDecomposition DCCanonical ['\x0045','\x0327']),
		('\x0229',MkDecomposition DCCanonical ['\x0065','\x0327']),
		('\x022A',MkDecomposition DCCanonical ['\x00D6','\x0304']),
		('\x022B',MkDecomposition DCCanonical ['\x00F6','\x0304']),
		('\x022C',MkDecomposition DCCanonical ['\x00D5','\x0304']),
		('\x022D',MkDecomposition DCCanonical ['\x00F5','\x0304']),
		('\x022E',MkDecomposition DCCanonical ['\x004F','\x0307']),
		('\x022F',MkDecomposition DCCanonical ['\x006F','\x0307']),
		('\x0230',MkDecomposition DCCanonical ['\x022E','\x0304']),
		('\x0231',MkDecomposition DCCanonical ['\x022F','\x0304']),
		('\x0232',MkDecomposition DCCanonical ['\x0059','\x0304']),
		('\x0233',MkDecomposition DCCanonical ['\x0079','\x0304']),
		('\x02B0',MkDecomposition DCSuper ['\x0068']),
		('\x02B1',MkDecomposition DCSuper ['\x0266']),
		('\x02B2',MkDecomposition DCSuper ['\x006A']),
		('\x02B3',MkDecomposition DCSuper ['\x0072']),
		('\x02B4',MkDecomposition DCSuper ['\x0279']),
		('\x02B5',MkDecomposition DCSuper ['\x027B']),
		('\x02B6',MkDecomposition DCSuper ['\x0281']),
		('\x02B7',MkDecomposition DCSuper ['\x0077']),
		('\x02B8',MkDecomposition DCSuper ['\x0079']),
		('\x02D8',MkDecomposition DCCompat ['\x0020','\x0306']),
		('\x02D9',MkDecomposition DCCompat ['\x0020','\x0307']),
		('\x02DA',MkDecomposition DCCompat ['\x0020','\x030A']),
		('\x02DB',MkDecomposition DCCompat ['\x0020','\x0328']),
		('\x02DC',MkDecomposition DCCompat ['\x0020','\x0303']),
		('\x02DD',MkDecomposition DCCompat ['\x0020','\x030B']),
		('\x02E0',MkDecomposition DCSuper ['\x0263']),
		('\x02E1',MkDecomposition DCSuper ['\x006C']),
		('\x02E2',MkDecomposition DCSuper ['\x0073']),
		('\x02E3',MkDecomposition DCSuper ['\x0078']),
		('\x02E4',MkDecomposition DCSuper ['\x0295']),
		('\x0340',MkDecomposition DCCanonical ['\x0300']),
		('\x0341',MkDecomposition DCCanonical ['\x0301']),
		('\x0343',MkDecomposition DCCanonical ['\x0313']),
		('\x0344',MkDecomposition DCCanonical ['\x0308','\x0301']),
		('\x0374',MkDecomposition DCCanonical ['\x02B9']),
		('\x037A',MkDecomposition DCCompat ['\x0020','\x0345']),
		('\x037E',MkDecomposition DCCanonical ['\x003B']),
		('\x0384',MkDecomposition DCCompat ['\x0020','\x0301']),
		('\x0385',MkDecomposition DCCanonical ['\x00A8','\x0301']),
		('\x0386',MkDecomposition DCCanonical ['\x0391','\x0301']),
		('\x0387',MkDecomposition DCCanonical ['\x00B7']),
		('\x0388',MkDecomposition DCCanonical ['\x0395','\x0301']),
		('\x0389',MkDecomposition DCCanonical ['\x0397','\x0301']),
		('\x038A',MkDecomposition DCCanonical ['\x0399','\x0301']),
		('\x038C',MkDecomposition DCCanonical ['\x039F','\x0301']),
		('\x038E',MkDecomposition DCCanonical ['\x03A5','\x0301']),
		('\x038F',MkDecomposition DCCanonical ['\x03A9','\x0301']),
		('\x0390',MkDecomposition DCCanonical ['\x03CA','\x0301']),
		('\x03AA',MkDecomposition DCCanonical ['\x0399','\x0308']),
		('\x03AB',MkDecomposition DCCanonical ['\x03A5','\x0308']),
		('\x03AC',MkDecomposition DCCanonical ['\x03B1','\x0301']),
		('\x03AD',MkDecomposition DCCanonical ['\x03B5','\x0301']),
		('\x03AE',MkDecomposition DCCanonical ['\x03B7','\x0301']),
		('\x03AF',MkDecomposition DCCanonical ['\x03B9','\x0301']),
		('\x03B0',MkDecomposition DCCanonical ['\x03CB','\x0301']),
		('\x03CA',MkDecomposition DCCanonical ['\x03B9','\x0308']),
		('\x03CB',MkDecomposition DCCanonical ['\x03C5','\x0308']),
		('\x03CC',MkDecomposition DCCanonical ['\x03BF','\x0301']),
		('\x03CD',MkDecomposition DCCanonical ['\x03C5','\x0301']),
		('\x03CE',MkDecomposition DCCanonical ['\x03C9','\x0301']),
		('\x03D0',MkDecomposition DCCompat ['\x03B2']),
		('\x03D1',MkDecomposition DCCompat ['\x03B8']),
		('\x03D2',MkDecomposition DCCompat ['\x03A5']),
		('\x03D3',MkDecomposition DCCanonical ['\x03D2','\x0301']),
		('\x03D4',MkDecomposition DCCanonical ['\x03D2','\x0308']),
		('\x03D5',MkDecomposition DCCompat ['\x03C6']),
		('\x03D6',MkDecomposition DCCompat ['\x03C0']),
		('\x03F0',MkDecomposition DCCompat ['\x03BA']),
		('\x03F1',MkDecomposition DCCompat ['\x03C1']),
		('\x03F2',MkDecomposition DCCompat ['\x03C2']),
		('\x03F4',MkDecomposition DCCompat ['\x0398']),
		('\x03F5',MkDecomposition DCCompat ['\x03B5']),
		('\x0400',MkDecomposition DCCanonical ['\x0415','\x0300']),
		('\x0401',MkDecomposition DCCanonical ['\x0415','\x0308']),
		('\x0403',MkDecomposition DCCanonical ['\x0413','\x0301']),
		('\x0407',MkDecomposition DCCanonical ['\x0406','\x0308']),
		('\x040C',MkDecomposition DCCanonical ['\x041A','\x0301']),
		('\x040D',MkDecomposition DCCanonical ['\x0418','\x0300']),
		('\x040E',MkDecomposition DCCanonical ['\x0423','\x0306']),
		('\x0419',MkDecomposition DCCanonical ['\x0418','\x0306']),
		('\x0439',MkDecomposition DCCanonical ['\x0438','\x0306']),
		('\x0450',MkDecomposition DCCanonical ['\x0435','\x0300']),
		('\x0451',MkDecomposition DCCanonical ['\x0435','\x0308']),
		('\x0453',MkDecomposition DCCanonical ['\x0433','\x0301']),
		('\x0457',MkDecomposition DCCanonical ['\x0456','\x0308']),
		('\x045C',MkDecomposition DCCanonical ['\x043A','\x0301']),
		('\x045D',MkDecomposition DCCanonical ['\x0438','\x0300']),
		('\x045E',MkDecomposition DCCanonical ['\x0443','\x0306']),
		('\x0476',MkDecomposition DCCanonical ['\x0474','\x030F']),
		('\x0477',MkDecomposition DCCanonical ['\x0475','\x030F']),
		('\x04C1',MkDecomposition DCCanonical ['\x0416','\x0306']),
		('\x04C2',MkDecomposition DCCanonical ['\x0436','\x0306']),
		('\x04D0',MkDecomposition DCCanonical ['\x0410','\x0306']),
		('\x04D1',MkDecomposition DCCanonical ['\x0430','\x0306']),
		('\x04D2',MkDecomposition DCCanonical ['\x0410','\x0308']),
		('\x04D3',MkDecomposition DCCanonical ['\x0430','\x0308']),
		('\x04D6',MkDecomposition DCCanonical ['\x0415','\x0306']),
		('\x04D7',MkDecomposition DCCanonical ['\x0435','\x0306']),
		('\x04DA',MkDecomposition DCCanonical ['\x04D8','\x0308']),
		('\x04DB',MkDecomposition DCCanonical ['\x04D9','\x0308']),
		('\x04DC',MkDecomposition DCCanonical ['\x0416','\x0308']),
		('\x04DD',MkDecomposition DCCanonical ['\x0436','\x0308']),
		('\x04DE',MkDecomposition DCCanonical ['\x0417','\x0308']),
		('\x04DF',MkDecomposition DCCanonical ['\x0437','\x0308']),
		('\x04E2',MkDecomposition DCCanonical ['\x0418','\x0304']),
		('\x04E3',MkDecomposition DCCanonical ['\x0438','\x0304']),
		('\x04E4',MkDecomposition DCCanonical ['\x0418','\x0308']),
		('\x04E5',MkDecomposition DCCanonical ['\x0438','\x0308']),
		('\x04E6',MkDecomposition DCCanonical ['\x041E','\x0308']),
		('\x04E7',MkDecomposition DCCanonical ['\x043E','\x0308']),
		('\x04EA',MkDecomposition DCCanonical ['\x04E8','\x0308']),
		('\x04EB',MkDecomposition DCCanonical ['\x04E9','\x0308']),
		('\x04EC',MkDecomposition DCCanonical ['\x042D','\x0308']),
		('\x04ED',MkDecomposition DCCanonical ['\x044D','\x0308']),
		('\x04EE',MkDecomposition DCCanonical ['\x0423','\x0304']),
		('\x04EF',MkDecomposition DCCanonical ['\x0443','\x0304']),
		('\x04F0',MkDecomposition DCCanonical ['\x0423','\x0308']),
		('\x04F1',MkDecomposition DCCanonical ['\x0443','\x0308']),
		('\x04F2',MkDecomposition DCCanonical ['\x0423','\x030B']),
		('\x04F3',MkDecomposition DCCanonical ['\x0443','\x030B']),
		('\x04F4',MkDecomposition DCCanonical ['\x0427','\x0308']),
		('\x04F5',MkDecomposition DCCanonical ['\x0447','\x0308']),
		('\x04F8',MkDecomposition DCCanonical ['\x042B','\x0308']),
		('\x04F9',MkDecomposition DCCanonical ['\x044B','\x0308']),
		('\x0587',MkDecomposition DCCompat ['\x0565','\x0582']),
		('\x0622',MkDecomposition DCCanonical ['\x0627','\x0653']),
		('\x0623',MkDecomposition DCCanonical ['\x0627','\x0654']),
		('\x0624',MkDecomposition DCCanonical ['\x0648','\x0654']),
		('\x0625',MkDecomposition DCCanonical ['\x0627','\x0655']),
		('\x0626',MkDecomposition DCCanonical ['\x064A','\x0654']),
		('\x0675',MkDecomposition DCCompat ['\x0627','\x0674']),
		('\x0676',MkDecomposition DCCompat ['\x0648','\x0674']),
		('\x0677',MkDecomposition DCCompat ['\x06C7','\x0674']),
		('\x0678',MkDecomposition DCCompat ['\x064A','\x0674']),
		('\x06C0',MkDecomposition DCCanonical ['\x06D5','\x0654']),
		('\x06C2',MkDecomposition DCCanonical ['\x06C1','\x0654']),
		('\x06D3',MkDecomposition DCCanonical ['\x06D2','\x0654']),
		('\x0929',MkDecomposition DCCanonical ['\x0928','\x093C']),
		('\x0931',MkDecomposition DCCanonical ['\x0930','\x093C']),
		('\x0934',MkDecomposition DCCanonical ['\x0933','\x093C']),
		('\x0958',MkDecomposition DCCanonical ['\x0915','\x093C']),
		('\x0959',MkDecomposition DCCanonical ['\x0916','\x093C']),
		('\x095A',MkDecomposition DCCanonical ['\x0917','\x093C']),
		('\x095B',MkDecomposition DCCanonical ['\x091C','\x093C']),
		('\x095C',MkDecomposition DCCanonical ['\x0921','\x093C']),
		('\x095D',MkDecomposition DCCanonical ['\x0922','\x093C']),
		('\x095E',MkDecomposition DCCanonical ['\x092B','\x093C']),
		('\x095F',MkDecomposition DCCanonical ['\x092F','\x093C']),
		('\x09CB',MkDecomposition DCCanonical ['\x09C7','\x09BE']),
		('\x09CC',MkDecomposition DCCanonical ['\x09C7','\x09D7']),
		('\x09DC',MkDecomposition DCCanonical ['\x09A1','\x09BC']),
		('\x09DD',MkDecomposition DCCanonical ['\x09A2','\x09BC']),
		('\x09DF',MkDecomposition DCCanonical ['\x09AF','\x09BC']),
		('\x0A33',MkDecomposition DCCanonical ['\x0A32','\x0A3C']),
		('\x0A36',MkDecomposition DCCanonical ['\x0A38','\x0A3C']),
		('\x0A59',MkDecomposition DCCanonical ['\x0A16','\x0A3C']),
		('\x0A5A',MkDecomposition DCCanonical ['\x0A17','\x0A3C']),
		('\x0A5B',MkDecomposition DCCanonical ['\x0A1C','\x0A3C']),
		('\x0A5E',MkDecomposition DCCanonical ['\x0A2B','\x0A3C']),
		('\x0B48',MkDecomposition DCCanonical ['\x0B47','\x0B56']),
		('\x0B4B',MkDecomposition DCCanonical ['\x0B47','\x0B3E']),
		('\x0B4C',MkDecomposition DCCanonical ['\x0B47','\x0B57']),
		('\x0B5C',MkDecomposition DCCanonical ['\x0B21','\x0B3C']),
		('\x0B5D',MkDecomposition DCCanonical ['\x0B22','\x0B3C']),
		('\x0B94',MkDecomposition DCCanonical ['\x0B92','\x0BD7']),
		('\x0BCA',MkDecomposition DCCanonical ['\x0BC6','\x0BBE']),
		('\x0BCB',MkDecomposition DCCanonical ['\x0BC7','\x0BBE']),
		('\x0BCC',MkDecomposition DCCanonical ['\x0BC6','\x0BD7']),
		('\x0C48',MkDecomposition DCCanonical ['\x0C46','\x0C56']),
		('\x0CC0',MkDecomposition DCCanonical ['\x0CBF','\x0CD5']),
		('\x0CC7',MkDecomposition DCCanonical ['\x0CC6','\x0CD5']),
		('\x0CC8',MkDecomposition DCCanonical ['\x0CC6','\x0CD6']),
		('\x0CCA',MkDecomposition DCCanonical ['\x0CC6','\x0CC2']),
		('\x0CCB',MkDecomposition DCCanonical ['\x0CCA','\x0CD5']),
		('\x0D4A',MkDecomposition DCCanonical ['\x0D46','\x0D3E']),
		('\x0D4B',MkDecomposition DCCanonical ['\x0D47','\x0D3E']),
		('\x0D4C',MkDecomposition DCCanonical ['\x0D46','\x0D57']),
		('\x0DDA',MkDecomposition DCCanonical ['\x0DD9','\x0DCA']),
		('\x0DDC',MkDecomposition DCCanonical ['\x0DD9','\x0DCF']),
		('\x0DDD',MkDecomposition DCCanonical ['\x0DDC','\x0DCA']),
		('\x0DDE',MkDecomposition DCCanonical ['\x0DD9','\x0DDF']),
		('\x0E33',MkDecomposition DCCompat ['\x0E4D','\x0E32']),
		('\x0EB3',MkDecomposition DCCompat ['\x0ECD','\x0EB2']),
		('\x0EDC',MkDecomposition DCCompat ['\x0EAB','\x0E99']),
		('\x0EDD',MkDecomposition DCCompat ['\x0EAB','\x0EA1']),
		('\x0F0C',MkDecomposition DCNoBreak ['\x0F0B']),
		('\x0F43',MkDecomposition DCCanonical ['\x0F42','\x0FB7']),
		('\x0F4D',MkDecomposition DCCanonical ['\x0F4C','\x0FB7']),
		('\x0F52',MkDecomposition DCCanonical ['\x0F51','\x0FB7']),
		('\x0F57',MkDecomposition DCCanonical ['\x0F56','\x0FB7']),
		('\x0F5C',MkDecomposition DCCanonical ['\x0F5B','\x0FB7']),
		('\x0F69',MkDecomposition DCCanonical ['\x0F40','\x0FB5']),
		('\x0F73',MkDecomposition DCCanonical ['\x0F71','\x0F72']),
		('\x0F75',MkDecomposition DCCanonical ['\x0F71','\x0F74']),
		('\x0F76',MkDecomposition DCCanonical ['\x0FB2','\x0F80']),
		('\x0F77',MkDecomposition DCCompat ['\x0FB2','\x0F81']),
		('\x0F78',MkDecomposition DCCanonical ['\x0FB3','\x0F80']),
		('\x0F79',MkDecomposition DCCompat ['\x0FB3','\x0F81']),
		('\x0F81',MkDecomposition DCCanonical ['\x0F71','\x0F80']),
		('\x0F93',MkDecomposition DCCanonical ['\x0F92','\x0FB7']),
		('\x0F9D',MkDecomposition DCCanonical ['\x0F9C','\x0FB7']),
		('\x0FA2',MkDecomposition DCCanonical ['\x0FA1','\x0FB7']),
		('\x0FA7',MkDecomposition DCCanonical ['\x0FA6','\x0FB7']),
		('\x0FAC',MkDecomposition DCCanonical ['\x0FAB','\x0FB7']),
		('\x0FB9',MkDecomposition DCCanonical ['\x0F90','\x0FB5']),
		('\x1026',MkDecomposition DCCanonical ['\x1025','\x102E']),
		('\x1E00',MkDecomposition DCCanonical ['\x0041','\x0325']),
		('\x1E01',MkDecomposition DCCanonical ['\x0061','\x0325']),
		('\x1E02',MkDecomposition DCCanonical ['\x0042','\x0307']),
		('\x1E03',MkDecomposition DCCanonical ['\x0062','\x0307']),
		('\x1E04',MkDecomposition DCCanonical ['\x0042','\x0323']),
		('\x1E05',MkDecomposition DCCanonical ['\x0062','\x0323']),
		('\x1E06',MkDecomposition DCCanonical ['\x0042','\x0331']),
		('\x1E07',MkDecomposition DCCanonical ['\x0062','\x0331']),
		('\x1E08',MkDecomposition DCCanonical ['\x00C7','\x0301']),
		('\x1E09',MkDecomposition DCCanonical ['\x00E7','\x0301']),
		('\x1E0A',MkDecomposition DCCanonical ['\x0044','\x0307']),
		('\x1E0B',MkDecomposition DCCanonical ['\x0064','\x0307']),
		('\x1E0C',MkDecomposition DCCanonical ['\x0044','\x0323']),
		('\x1E0D',MkDecomposition DCCanonical ['\x0064','\x0323']),
		('\x1E0E',MkDecomposition DCCanonical ['\x0044','\x0331']),
		('\x1E0F',MkDecomposition DCCanonical ['\x0064','\x0331']),
		('\x1E10',MkDecomposition DCCanonical ['\x0044','\x0327']),
		('\x1E11',MkDecomposition DCCanonical ['\x0064','\x0327']),
		('\x1E12',MkDecomposition DCCanonical ['\x0044','\x032D']),
		('\x1E13',MkDecomposition DCCanonical ['\x0064','\x032D']),
		('\x1E14',MkDecomposition DCCanonical ['\x0112','\x0300']),
		('\x1E15',MkDecomposition DCCanonical ['\x0113','\x0300']),
		('\x1E16',MkDecomposition DCCanonical ['\x0112','\x0301']),
		('\x1E17',MkDecomposition DCCanonical ['\x0113','\x0301']),
		('\x1E18',MkDecomposition DCCanonical ['\x0045','\x032D']),
		('\x1E19',MkDecomposition DCCanonical ['\x0065','\x032D']),
		('\x1E1A',MkDecomposition DCCanonical ['\x0045','\x0330']),
		('\x1E1B',MkDecomposition DCCanonical ['\x0065','\x0330']),
		('\x1E1C',MkDecomposition DCCanonical ['\x0228','\x0306']),
		('\x1E1D',MkDecomposition DCCanonical ['\x0229','\x0306']),
		('\x1E1E',MkDecomposition DCCanonical ['\x0046','\x0307']),
		('\x1E1F',MkDecomposition DCCanonical ['\x0066','\x0307']),
		('\x1E20',MkDecomposition DCCanonical ['\x0047','\x0304']),
		('\x1E21',MkDecomposition DCCanonical ['\x0067','\x0304']),
		('\x1E22',MkDecomposition DCCanonical ['\x0048','\x0307']),
		('\x1E23',MkDecomposition DCCanonical ['\x0068','\x0307']),
		('\x1E24',MkDecomposition DCCanonical ['\x0048','\x0323']),
		('\x1E25',MkDecomposition DCCanonical ['\x0068','\x0323']),
		('\x1E26',MkDecomposition DCCanonical ['\x0048','\x0308']),
		('\x1E27',MkDecomposition DCCanonical ['\x0068','\x0308']),
		('\x1E28',MkDecomposition DCCanonical ['\x0048','\x0327']),
		('\x1E29',MkDecomposition DCCanonical ['\x0068','\x0327']),
		('\x1E2A',MkDecomposition DCCanonical ['\x0048','\x032E']),
		('\x1E2B',MkDecomposition DCCanonical ['\x0068','\x032E']),
		('\x1E2C',MkDecomposition DCCanonical ['\x0049','\x0330']),
		('\x1E2D',MkDecomposition DCCanonical ['\x0069','\x0330']),
		('\x1E2E',MkDecomposition DCCanonical ['\x00CF','\x0301']),
		('\x1E2F',MkDecomposition DCCanonical ['\x00EF','\x0301']),
		('\x1E30',MkDecomposition DCCanonical ['\x004B','\x0301']),
		('\x1E31',MkDecomposition DCCanonical ['\x006B','\x0301']),
		('\x1E32',MkDecomposition DCCanonical ['\x004B','\x0323']),
		('\x1E33',MkDecomposition DCCanonical ['\x006B','\x0323']),
		('\x1E34',MkDecomposition DCCanonical ['\x004B','\x0331']),
		('\x1E35',MkDecomposition DCCanonical ['\x006B','\x0331']),
		('\x1E36',MkDecomposition DCCanonical ['\x004C','\x0323']),
		('\x1E37',MkDecomposition DCCanonical ['\x006C','\x0323']),
		('\x1E38',MkDecomposition DCCanonical ['\x1E36','\x0304']),
		('\x1E39',MkDecomposition DCCanonical ['\x1E37','\x0304']),
		('\x1E3A',MkDecomposition DCCanonical ['\x004C','\x0331']),
		('\x1E3B',MkDecomposition DCCanonical ['\x006C','\x0331']),
		('\x1E3C',MkDecomposition DCCanonical ['\x004C','\x032D']),
		('\x1E3D',MkDecomposition DCCanonical ['\x006C','\x032D']),
		('\x1E3E',MkDecomposition DCCanonical ['\x004D','\x0301']),
		('\x1E3F',MkDecomposition DCCanonical ['\x006D','\x0301']),
		('\x1E40',MkDecomposition DCCanonical ['\x004D','\x0307']),
		('\x1E41',MkDecomposition DCCanonical ['\x006D','\x0307']),
		('\x1E42',MkDecomposition DCCanonical ['\x004D','\x0323']),
		('\x1E43',MkDecomposition DCCanonical ['\x006D','\x0323']),
		('\x1E44',MkDecomposition DCCanonical ['\x004E','\x0307']),
		('\x1E45',MkDecomposition DCCanonical ['\x006E','\x0307']),
		('\x1E46',MkDecomposition DCCanonical ['\x004E','\x0323']),
		('\x1E47',MkDecomposition DCCanonical ['\x006E','\x0323']),
		('\x1E48',MkDecomposition DCCanonical ['\x004E','\x0331']),
		('\x1E49',MkDecomposition DCCanonical ['\x006E','\x0331']),
		('\x1E4A',MkDecomposition DCCanonical ['\x004E','\x032D']),
		('\x1E4B',MkDecomposition DCCanonical ['\x006E','\x032D']),
		('\x1E4C',MkDecomposition DCCanonical ['\x00D5','\x0301']),
		('\x1E4D',MkDecomposition DCCanonical ['\x00F5','\x0301']),
		('\x1E4E',MkDecomposition DCCanonical ['\x00D5','\x0308']),
		('\x1E4F',MkDecomposition DCCanonical ['\x00F5','\x0308']),
		('\x1E50',MkDecomposition DCCanonical ['\x014C','\x0300']),
		('\x1E51',MkDecomposition DCCanonical ['\x014D','\x0300']),
		('\x1E52',MkDecomposition DCCanonical ['\x014C','\x0301']),
		('\x1E53',MkDecomposition DCCanonical ['\x014D','\x0301']),
		('\x1E54',MkDecomposition DCCanonical ['\x0050','\x0301']),
		('\x1E55',MkDecomposition DCCanonical ['\x0070','\x0301']),
		('\x1E56',MkDecomposition DCCanonical ['\x0050','\x0307']),
		('\x1E57',MkDecomposition DCCanonical ['\x0070','\x0307']),
		('\x1E58',MkDecomposition DCCanonical ['\x0052','\x0307']),
		('\x1E59',MkDecomposition DCCanonical ['\x0072','\x0307']),
		('\x1E5A',MkDecomposition DCCanonical ['\x0052','\x0323']),
		('\x1E5B',MkDecomposition DCCanonical ['\x0072','\x0323']),
		('\x1E5C',MkDecomposition DCCanonical ['\x1E5A','\x0304']),
		('\x1E5D',MkDecomposition DCCanonical ['\x1E5B','\x0304']),
		('\x1E5E',MkDecomposition DCCanonical ['\x0052','\x0331']),
		('\x1E5F',MkDecomposition DCCanonical ['\x0072','\x0331']),
		('\x1E60',MkDecomposition DCCanonical ['\x0053','\x0307']),
		('\x1E61',MkDecomposition DCCanonical ['\x0073','\x0307']),
		('\x1E62',MkDecomposition DCCanonical ['\x0053','\x0323']),
		('\x1E63',MkDecomposition DCCanonical ['\x0073','\x0323']),
		('\x1E64',MkDecomposition DCCanonical ['\x015A','\x0307']),
		('\x1E65',MkDecomposition DCCanonical ['\x015B','\x0307']),
		('\x1E66',MkDecomposition DCCanonical ['\x0160','\x0307']),
		('\x1E67',MkDecomposition DCCanonical ['\x0161','\x0307']),
		('\x1E68',MkDecomposition DCCanonical ['\x1E62','\x0307']),
		('\x1E69',MkDecomposition DCCanonical ['\x1E63','\x0307']),
		('\x1E6A',MkDecomposition DCCanonical ['\x0054','\x0307']),
		('\x1E6B',MkDecomposition DCCanonical ['\x0074','\x0307']),
		('\x1E6C',MkDecomposition DCCanonical ['\x0054','\x0323']),
		('\x1E6D',MkDecomposition DCCanonical ['\x0074','\x0323']),
		('\x1E6E',MkDecomposition DCCanonical ['\x0054','\x0331']),
		('\x1E6F',MkDecomposition DCCanonical ['\x0074','\x0331']),
		('\x1E70',MkDecomposition DCCanonical ['\x0054','\x032D']),
		('\x1E71',MkDecomposition DCCanonical ['\x0074','\x032D']),
		('\x1E72',MkDecomposition DCCanonical ['\x0055','\x0324']),
		('\x1E73',MkDecomposition DCCanonical ['\x0075','\x0324']),
		('\x1E74',MkDecomposition DCCanonical ['\x0055','\x0330']),
		('\x1E75',MkDecomposition DCCanonical ['\x0075','\x0330']),
		('\x1E76',MkDecomposition DCCanonical ['\x0055','\x032D']),
		('\x1E77',MkDecomposition DCCanonical ['\x0075','\x032D']),
		('\x1E78',MkDecomposition DCCanonical ['\x0168','\x0301']),
		('\x1E79',MkDecomposition DCCanonical ['\x0169','\x0301']),
		('\x1E7A',MkDecomposition DCCanonical ['\x016A','\x0308']),
		('\x1E7B',MkDecomposition DCCanonical ['\x016B','\x0308']),
		('\x1E7C',MkDecomposition DCCanonical ['\x0056','\x0303']),
		('\x1E7D',MkDecomposition DCCanonical ['\x0076','\x0303']),
		('\x1E7E',MkDecomposition DCCanonical ['\x0056','\x0323']),
		('\x1E7F',MkDecomposition DCCanonical ['\x0076','\x0323']),
		('\x1E80',MkDecomposition DCCanonical ['\x0057','\x0300']),
		('\x1E81',MkDecomposition DCCanonical ['\x0077','\x0300']),
		('\x1E82',MkDecomposition DCCanonical ['\x0057','\x0301']),
		('\x1E83',MkDecomposition DCCanonical ['\x0077','\x0301']),
		('\x1E84',MkDecomposition DCCanonical ['\x0057','\x0308']),
		('\x1E85',MkDecomposition DCCanonical ['\x0077','\x0308']),
		('\x1E86',MkDecomposition DCCanonical ['\x0057','\x0307']),
		('\x1E87',MkDecomposition DCCanonical ['\x0077','\x0307']),
		('\x1E88',MkDecomposition DCCanonical ['\x0057','\x0323']),
		('\x1E89',MkDecomposition DCCanonical ['\x0077','\x0323']),
		('\x1E8A',MkDecomposition DCCanonical ['\x0058','\x0307']),
		('\x1E8B',MkDecomposition DCCanonical ['\x0078','\x0307']),
		('\x1E8C',MkDecomposition DCCanonical ['\x0058','\x0308']),
		('\x1E8D',MkDecomposition DCCanonical ['\x0078','\x0308']),
		('\x1E8E',MkDecomposition DCCanonical ['\x0059','\x0307']),
		('\x1E8F',MkDecomposition DCCanonical ['\x0079','\x0307']),
		('\x1E90',MkDecomposition DCCanonical ['\x005A','\x0302']),
		('\x1E91',MkDecomposition DCCanonical ['\x007A','\x0302']),
		('\x1E92',MkDecomposition DCCanonical ['\x005A','\x0323']),
		('\x1E93',MkDecomposition DCCanonical ['\x007A','\x0323']),
		('\x1E94',MkDecomposition DCCanonical ['\x005A','\x0331']),
		('\x1E95',MkDecomposition DCCanonical ['\x007A','\x0331']),
		('\x1E96',MkDecomposition DCCanonical ['\x0068','\x0331']),
		('\x1E97',MkDecomposition DCCanonical ['\x0074','\x0308']),
		('\x1E98',MkDecomposition DCCanonical ['\x0077','\x030A']),
		('\x1E99',MkDecomposition DCCanonical ['\x0079','\x030A']),
		('\x1E9A',MkDecomposition DCCompat ['\x0061','\x02BE']),
		('\x1E9B',MkDecomposition DCCanonical ['\x017F','\x0307']),
		('\x1EA0',MkDecomposition DCCanonical ['\x0041','\x0323']),
		('\x1EA1',MkDecomposition DCCanonical ['\x0061','\x0323']),
		('\x1EA2',MkDecomposition DCCanonical ['\x0041','\x0309']),
		('\x1EA3',MkDecomposition DCCanonical ['\x0061','\x0309']),
		('\x1EA4',MkDecomposition DCCanonical ['\x00C2','\x0301']),
		('\x1EA5',MkDecomposition DCCanonical ['\x00E2','\x0301']),
		('\x1EA6',MkDecomposition DCCanonical ['\x00C2','\x0300']),
		('\x1EA7',MkDecomposition DCCanonical ['\x00E2','\x0300']),
		('\x1EA8',MkDecomposition DCCanonical ['\x00C2','\x0309']),
		('\x1EA9',MkDecomposition DCCanonical ['\x00E2','\x0309']),
		('\x1EAA',MkDecomposition DCCanonical ['\x00C2','\x0303']),
		('\x1EAB',MkDecomposition DCCanonical ['\x00E2','\x0303']),
		('\x1EAC',MkDecomposition DCCanonical ['\x1EA0','\x0302']),
		('\x1EAD',MkDecomposition DCCanonical ['\x1EA1','\x0302']),
		('\x1EAE',MkDecomposition DCCanonical ['\x0102','\x0301']),
		('\x1EAF',MkDecomposition DCCanonical ['\x0103','\x0301']),
		('\x1EB0',MkDecomposition DCCanonical ['\x0102','\x0300']),
		('\x1EB1',MkDecomposition DCCanonical ['\x0103','\x0300']),
		('\x1EB2',MkDecomposition DCCanonical ['\x0102','\x0309']),
		('\x1EB3',MkDecomposition DCCanonical ['\x0103','\x0309']),
		('\x1EB4',MkDecomposition DCCanonical ['\x0102','\x0303']),
		('\x1EB5',MkDecomposition DCCanonical ['\x0103','\x0303']),
		('\x1EB6',MkDecomposition DCCanonical ['\x1EA0','\x0306']),
		('\x1EB7',MkDecomposition DCCanonical ['\x1EA1','\x0306']),
		('\x1EB8',MkDecomposition DCCanonical ['\x0045','\x0323']),
		('\x1EB9',MkDecomposition DCCanonical ['\x0065','\x0323']),
		('\x1EBA',MkDecomposition DCCanonical ['\x0045','\x0309']),
		('\x1EBB',MkDecomposition DCCanonical ['\x0065','\x0309']),
		('\x1EBC',MkDecomposition DCCanonical ['\x0045','\x0303']),
		('\x1EBD',MkDecomposition DCCanonical ['\x0065','\x0303']),
		('\x1EBE',MkDecomposition DCCanonical ['\x00CA','\x0301']),
		('\x1EBF',MkDecomposition DCCanonical ['\x00EA','\x0301']),
		('\x1EC0',MkDecomposition DCCanonical ['\x00CA','\x0300']),
		('\x1EC1',MkDecomposition DCCanonical ['\x00EA','\x0300']),
		('\x1EC2',MkDecomposition DCCanonical ['\x00CA','\x0309']),
		('\x1EC3',MkDecomposition DCCanonical ['\x00EA','\x0309']),
		('\x1EC4',MkDecomposition DCCanonical ['\x00CA','\x0303']),
		('\x1EC5',MkDecomposition DCCanonical ['\x00EA','\x0303']),
		('\x1EC6',MkDecomposition DCCanonical ['\x1EB8','\x0302']),
		('\x1EC7',MkDecomposition DCCanonical ['\x1EB9','\x0302']),
		('\x1EC8',MkDecomposition DCCanonical ['\x0049','\x0309']),
		('\x1EC9',MkDecomposition DCCanonical ['\x0069','\x0309']),
		('\x1ECA',MkDecomposition DCCanonical ['\x0049','\x0323']),
		('\x1ECB',MkDecomposition DCCanonical ['\x0069','\x0323']),
		('\x1ECC',MkDecomposition DCCanonical ['\x004F','\x0323']),
		('\x1ECD',MkDecomposition DCCanonical ['\x006F','\x0323']),
		('\x1ECE',MkDecomposition DCCanonical ['\x004F','\x0309']),
		('\x1ECF',MkDecomposition DCCanonical ['\x006F','\x0309']),
		('\x1ED0',MkDecomposition DCCanonical ['\x00D4','\x0301']),
		('\x1ED1',MkDecomposition DCCanonical ['\x00F4','\x0301']),
		('\x1ED2',MkDecomposition DCCanonical ['\x00D4','\x0300']),
		('\x1ED3',MkDecomposition DCCanonical ['\x00F4','\x0300']),
		('\x1ED4',MkDecomposition DCCanonical ['\x00D4','\x0309']),
		('\x1ED5',MkDecomposition DCCanonical ['\x00F4','\x0309']),
		('\x1ED6',MkDecomposition DCCanonical ['\x00D4','\x0303']),
		('\x1ED7',MkDecomposition DCCanonical ['\x00F4','\x0303']),
		('\x1ED8',MkDecomposition DCCanonical ['\x1ECC','\x0302']),
		('\x1ED9',MkDecomposition DCCanonical ['\x1ECD','\x0302']),
		('\x1EDA',MkDecomposition DCCanonical ['\x01A0','\x0301']),
		('\x1EDB',MkDecomposition DCCanonical ['\x01A1','\x0301']),
		('\x1EDC',MkDecomposition DCCanonical ['\x01A0','\x0300']),
		('\x1EDD',MkDecomposition DCCanonical ['\x01A1','\x0300']),
		('\x1EDE',MkDecomposition DCCanonical ['\x01A0','\x0309']),
		('\x1EDF',MkDecomposition DCCanonical ['\x01A1','\x0309']),
		('\x1EE0',MkDecomposition DCCanonical ['\x01A0','\x0303']),
		('\x1EE1',MkDecomposition DCCanonical ['\x01A1','\x0303']),
		('\x1EE2',MkDecomposition DCCanonical ['\x01A0','\x0323']),
		('\x1EE3',MkDecomposition DCCanonical ['\x01A1','\x0323']),
		('\x1EE4',MkDecomposition DCCanonical ['\x0055','\x0323']),
		('\x1EE5',MkDecomposition DCCanonical ['\x0075','\x0323']),
		('\x1EE6',MkDecomposition DCCanonical ['\x0055','\x0309']),
		('\x1EE7',MkDecomposition DCCanonical ['\x0075','\x0309']),
		('\x1EE8',MkDecomposition DCCanonical ['\x01AF','\x0301']),
		('\x1EE9',MkDecomposition DCCanonical ['\x01B0','\x0301']),
		('\x1EEA',MkDecomposition DCCanonical ['\x01AF','\x0300']),
		('\x1EEB',MkDecomposition DCCanonical ['\x01B0','\x0300']),
		('\x1EEC',MkDecomposition DCCanonical ['\x01AF','\x0309']),
		('\x1EED',MkDecomposition DCCanonical ['\x01B0','\x0309']),
		('\x1EEE',MkDecomposition DCCanonical ['\x01AF','\x0303']),
		('\x1EEF',MkDecomposition DCCanonical ['\x01B0','\x0303']),
		('\x1EF0',MkDecomposition DCCanonical ['\x01AF','\x0323']),
		('\x1EF1',MkDecomposition DCCanonical ['\x01B0','\x0323']),
		('\x1EF2',MkDecomposition DCCanonical ['\x0059','\x0300']),
		('\x1EF3',MkDecomposition DCCanonical ['\x0079','\x0300']),
		('\x1EF4',MkDecomposition DCCanonical ['\x0059','\x0323']),
		('\x1EF5',MkDecomposition DCCanonical ['\x0079','\x0323']),
		('\x1EF6',MkDecomposition DCCanonical ['\x0059','\x0309']),
		('\x1EF7',MkDecomposition DCCanonical ['\x0079','\x0309']),
		('\x1EF8',MkDecomposition DCCanonical ['\x0059','\x0303']),
		('\x1EF9',MkDecomposition DCCanonical ['\x0079','\x0303']),
		('\x1F00',MkDecomposition DCCanonical ['\x03B1','\x0313']),
		('\x1F01',MkDecomposition DCCanonical ['\x03B1','\x0314']),
		('\x1F02',MkDecomposition DCCanonical ['\x1F00','\x0300']),
		('\x1F03',MkDecomposition DCCanonical ['\x1F01','\x0300']),
		('\x1F04',MkDecomposition DCCanonical ['\x1F00','\x0301']),
		('\x1F05',MkDecomposition DCCanonical ['\x1F01','\x0301']),
		('\x1F06',MkDecomposition DCCanonical ['\x1F00','\x0342']),
		('\x1F07',MkDecomposition DCCanonical ['\x1F01','\x0342']),
		('\x1F08',MkDecomposition DCCanonical ['\x0391','\x0313']),
		('\x1F09',MkDecomposition DCCanonical ['\x0391','\x0314']),
		('\x1F0A',MkDecomposition DCCanonical ['\x1F08','\x0300']),
		('\x1F0B',MkDecomposition DCCanonical ['\x1F09','\x0300']),
		('\x1F0C',MkDecomposition DCCanonical ['\x1F08','\x0301']),
		('\x1F0D',MkDecomposition DCCanonical ['\x1F09','\x0301']),
		('\x1F0E',MkDecomposition DCCanonical ['\x1F08','\x0342']),
		('\x1F0F',MkDecomposition DCCanonical ['\x1F09','\x0342']),
		('\x1F10',MkDecomposition DCCanonical ['\x03B5','\x0313']),
		('\x1F11',MkDecomposition DCCanonical ['\x03B5','\x0314']),
		('\x1F12',MkDecomposition DCCanonical ['\x1F10','\x0300']),
		('\x1F13',MkDecomposition DCCanonical ['\x1F11','\x0300']),
		('\x1F14',MkDecomposition DCCanonical ['\x1F10','\x0301']),
		('\x1F15',MkDecomposition DCCanonical ['\x1F11','\x0301']),
		('\x1F18',MkDecomposition DCCanonical ['\x0395','\x0313']),
		('\x1F19',MkDecomposition DCCanonical ['\x0395','\x0314']),
		('\x1F1A',MkDecomposition DCCanonical ['\x1F18','\x0300']),
		('\x1F1B',MkDecomposition DCCanonical ['\x1F19','\x0300']),
		('\x1F1C',MkDecomposition DCCanonical ['\x1F18','\x0301']),
		('\x1F1D',MkDecomposition DCCanonical ['\x1F19','\x0301']),
		('\x1F20',MkDecomposition DCCanonical ['\x03B7','\x0313']),
		('\x1F21',MkDecomposition DCCanonical ['\x03B7','\x0314']),
		('\x1F22',MkDecomposition DCCanonical ['\x1F20','\x0300']),
		('\x1F23',MkDecomposition DCCanonical ['\x1F21','\x0300']),
		('\x1F24',MkDecomposition DCCanonical ['\x1F20','\x0301']),
		('\x1F25',MkDecomposition DCCanonical ['\x1F21','\x0301']),
		('\x1F26',MkDecomposition DCCanonical ['\x1F20','\x0342']),
		('\x1F27',MkDecomposition DCCanonical ['\x1F21','\x0342']),
		('\x1F28',MkDecomposition DCCanonical ['\x0397','\x0313']),
		('\x1F29',MkDecomposition DCCanonical ['\x0397','\x0314']),
		('\x1F2A',MkDecomposition DCCanonical ['\x1F28','\x0300']),
		('\x1F2B',MkDecomposition DCCanonical ['\x1F29','\x0300']),
		('\x1F2C',MkDecomposition DCCanonical ['\x1F28','\x0301']),
		('\x1F2D',MkDecomposition DCCanonical ['\x1F29','\x0301']),
		('\x1F2E',MkDecomposition DCCanonical ['\x1F28','\x0342']),
		('\x1F2F',MkDecomposition DCCanonical ['\x1F29','\x0342']),
		('\x1F30',MkDecomposition DCCanonical ['\x03B9','\x0313']),
		('\x1F31',MkDecomposition DCCanonical ['\x03B9','\x0314']),
		('\x1F32',MkDecomposition DCCanonical ['\x1F30','\x0300']),
		('\x1F33',MkDecomposition DCCanonical ['\x1F31','\x0300']),
		('\x1F34',MkDecomposition DCCanonical ['\x1F30','\x0301']),
		('\x1F35',MkDecomposition DCCanonical ['\x1F31','\x0301']),
		('\x1F36',MkDecomposition DCCanonical ['\x1F30','\x0342']),
		('\x1F37',MkDecomposition DCCanonical ['\x1F31','\x0342']),
		('\x1F38',MkDecomposition DCCanonical ['\x0399','\x0313']),
		('\x1F39',MkDecomposition DCCanonical ['\x0399','\x0314']),
		('\x1F3A',MkDecomposition DCCanonical ['\x1F38','\x0300']),
		('\x1F3B',MkDecomposition DCCanonical ['\x1F39','\x0300']),
		('\x1F3C',MkDecomposition DCCanonical ['\x1F38','\x0301']),
		('\x1F3D',MkDecomposition DCCanonical ['\x1F39','\x0301']),
		('\x1F3E',MkDecomposition DCCanonical ['\x1F38','\x0342']),
		('\x1F3F',MkDecomposition DCCanonical ['\x1F39','\x0342']),
		('\x1F40',MkDecomposition DCCanonical ['\x03BF','\x0313']),
		('\x1F41',MkDecomposition DCCanonical ['\x03BF','\x0314']),
		('\x1F42',MkDecomposition DCCanonical ['\x1F40','\x0300']),
		('\x1F43',MkDecomposition DCCanonical ['\x1F41','\x0300']),
		('\x1F44',MkDecomposition DCCanonical ['\x1F40','\x0301']),
		('\x1F45',MkDecomposition DCCanonical ['\x1F41','\x0301']),
		('\x1F48',MkDecomposition DCCanonical ['\x039F','\x0313']),
		('\x1F49',MkDecomposition DCCanonical ['\x039F','\x0314']),
		('\x1F4A',MkDecomposition DCCanonical ['\x1F48','\x0300']),
		('\x1F4B',MkDecomposition DCCanonical ['\x1F49','\x0300']),
		('\x1F4C',MkDecomposition DCCanonical ['\x1F48','\x0301']),
		('\x1F4D',MkDecomposition DCCanonical ['\x1F49','\x0301']),
		('\x1F50',MkDecomposition DCCanonical ['\x03C5','\x0313']),
		('\x1F51',MkDecomposition DCCanonical ['\x03C5','\x0314']),
		('\x1F52',MkDecomposition DCCanonical ['\x1F50','\x0300']),
		('\x1F53',MkDecomposition DCCanonical ['\x1F51','\x0300']),
		('\x1F54',MkDecomposition DCCanonical ['\x1F50','\x0301']),
		('\x1F55',MkDecomposition DCCanonical ['\x1F51','\x0301']),
		('\x1F56',MkDecomposition DCCanonical ['\x1F50','\x0342']),
		('\x1F57',MkDecomposition DCCanonical ['\x1F51','\x0342']),
		('\x1F59',MkDecomposition DCCanonical ['\x03A5','\x0314']),
		('\x1F5B',MkDecomposition DCCanonical ['\x1F59','\x0300']),
		('\x1F5D',MkDecomposition DCCanonical ['\x1F59','\x0301']),
		('\x1F5F',MkDecomposition DCCanonical ['\x1F59','\x0342']),
		('\x1F60',MkDecomposition DCCanonical ['\x03C9','\x0313']),
		('\x1F61',MkDecomposition DCCanonical ['\x03C9','\x0314']),
		('\x1F62',MkDecomposition DCCanonical ['\x1F60','\x0300']),
		('\x1F63',MkDecomposition DCCanonical ['\x1F61','\x0300']),
		('\x1F64',MkDecomposition DCCanonical ['\x1F60','\x0301']),
		('\x1F65',MkDecomposition DCCanonical ['\x1F61','\x0301']),
		('\x1F66',MkDecomposition DCCanonical ['\x1F60','\x0342']),
		('\x1F67',MkDecomposition DCCanonical ['\x1F61','\x0342']),
		('\x1F68',MkDecomposition DCCanonical ['\x03A9','\x0313']),
		('\x1F69',MkDecomposition DCCanonical ['\x03A9','\x0314']),
		('\x1F6A',MkDecomposition DCCanonical ['\x1F68','\x0300']),
		('\x1F6B',MkDecomposition DCCanonical ['\x1F69','\x0300']),
		('\x1F6C',MkDecomposition DCCanonical ['\x1F68','\x0301']),
		('\x1F6D',MkDecomposition DCCanonical ['\x1F69','\x0301']),
		('\x1F6E',MkDecomposition DCCanonical ['\x1F68','\x0342']),
		('\x1F6F',MkDecomposition DCCanonical ['\x1F69','\x0342']),
		('\x1F70',MkDecomposition DCCanonical ['\x03B1','\x0300']),
		('\x1F71',MkDecomposition DCCanonical ['\x03AC']),
		('\x1F72',MkDecomposition DCCanonical ['\x03B5','\x0300']),
		('\x1F73',MkDecomposition DCCanonical ['\x03AD']),
		('\x1F74',MkDecomposition DCCanonical ['\x03B7','\x0300']),
		('\x1F75',MkDecomposition DCCanonical ['\x03AE']),
		('\x1F76',MkDecomposition DCCanonical ['\x03B9','\x0300']),
		('\x1F77',MkDecomposition DCCanonical ['\x03AF']),
		('\x1F78',MkDecomposition DCCanonical ['\x03BF','\x0300']),
		('\x1F79',MkDecomposition DCCanonical ['\x03CC']),
		('\x1F7A',MkDecomposition DCCanonical ['\x03C5','\x0300']),
		('\x1F7B',MkDecomposition DCCanonical ['\x03CD']),
		('\x1F7C',MkDecomposition DCCanonical ['\x03C9','\x0300']),
		('\x1F7D',MkDecomposition DCCanonical ['\x03CE']),
		('\x1F80',MkDecomposition DCCanonical ['\x1F00','\x0345']),
		('\x1F81',MkDecomposition DCCanonical ['\x1F01','\x0345']),
		('\x1F82',MkDecomposition DCCanonical ['\x1F02','\x0345']),
		('\x1F83',MkDecomposition DCCanonical ['\x1F03','\x0345']),
		('\x1F84',MkDecomposition DCCanonical ['\x1F04','\x0345']),
		('\x1F85',MkDecomposition DCCanonical ['\x1F05','\x0345']),
		('\x1F86',MkDecomposition DCCanonical ['\x1F06','\x0345']),
		('\x1F87',MkDecomposition DCCanonical ['\x1F07','\x0345']),
		('\x1F88',MkDecomposition DCCanonical ['\x1F08','\x0345']),
		('\x1F89',MkDecomposition DCCanonical ['\x1F09','\x0345']),
		('\x1F8A',MkDecomposition DCCanonical ['\x1F0A','\x0345']),
		('\x1F8B',MkDecomposition DCCanonical ['\x1F0B','\x0345']),
		('\x1F8C',MkDecomposition DCCanonical ['\x1F0C','\x0345']),
		('\x1F8D',MkDecomposition DCCanonical ['\x1F0D','\x0345']),
		('\x1F8E',MkDecomposition DCCanonical ['\x1F0E','\x0345']),
		('\x1F8F',MkDecomposition DCCanonical ['\x1F0F','\x0345']),
		('\x1F90',MkDecomposition DCCanonical ['\x1F20','\x0345']),
		('\x1F91',MkDecomposition DCCanonical ['\x1F21','\x0345']),
		('\x1F92',MkDecomposition DCCanonical ['\x1F22','\x0345']),
		('\x1F93',MkDecomposition DCCanonical ['\x1F23','\x0345']),
		('\x1F94',MkDecomposition DCCanonical ['\x1F24','\x0345']),
		('\x1F95',MkDecomposition DCCanonical ['\x1F25','\x0345']),
		('\x1F96',MkDecomposition DCCanonical ['\x1F26','\x0345']),
		('\x1F97',MkDecomposition DCCanonical ['\x1F27','\x0345']),
		('\x1F98',MkDecomposition DCCanonical ['\x1F28','\x0345']),
		('\x1F99',MkDecomposition DCCanonical ['\x1F29','\x0345']),
		('\x1F9A',MkDecomposition DCCanonical ['\x1F2A','\x0345']),
		('\x1F9B',MkDecomposition DCCanonical ['\x1F2B','\x0345']),
		('\x1F9C',MkDecomposition DCCanonical ['\x1F2C','\x0345']),
		('\x1F9D',MkDecomposition DCCanonical ['\x1F2D','\x0345']),
		('\x1F9E',MkDecomposition DCCanonical ['\x1F2E','\x0345']),
		('\x1F9F',MkDecomposition DCCanonical ['\x1F2F','\x0345']),
		('\x1FA0',MkDecomposition DCCanonical ['\x1F60','\x0345']),
		('\x1FA1',MkDecomposition DCCanonical ['\x1F61','\x0345']),
		('\x1FA2',MkDecomposition DCCanonical ['\x1F62','\x0345']),
		('\x1FA3',MkDecomposition DCCanonical ['\x1F63','\x0345']),
		('\x1FA4',MkDecomposition DCCanonical ['\x1F64','\x0345']),
		('\x1FA5',MkDecomposition DCCanonical ['\x1F65','\x0345']),
		('\x1FA6',MkDecomposition DCCanonical ['\x1F66','\x0345']),
		('\x1FA7',MkDecomposition DCCanonical ['\x1F67','\x0345']),
		('\x1FA8',MkDecomposition DCCanonical ['\x1F68','\x0345']),
		('\x1FA9',MkDecomposition DCCanonical ['\x1F69','\x0345']),
		('\x1FAA',MkDecomposition DCCanonical ['\x1F6A','\x0345']),
		('\x1FAB',MkDecomposition DCCanonical ['\x1F6B','\x0345']),
		('\x1FAC',MkDecomposition DCCanonical ['\x1F6C','\x0345']),
		('\x1FAD',MkDecomposition DCCanonical ['\x1F6D','\x0345']),
		('\x1FAE',MkDecomposition DCCanonical ['\x1F6E','\x0345']),
		('\x1FAF',MkDecomposition DCCanonical ['\x1F6F','\x0345']),
		('\x1FB0',MkDecomposition DCCanonical ['\x03B1','\x0306']),
		('\x1FB1',MkDecomposition DCCanonical ['\x03B1','\x0304']),
		('\x1FB2',MkDecomposition DCCanonical ['\x1F70','\x0345']),
		('\x1FB3',MkDecomposition DCCanonical ['\x03B1','\x0345']),
		('\x1FB4',MkDecomposition DCCanonical ['\x03AC','\x0345']),
		('\x1FB6',MkDecomposition DCCanonical ['\x03B1','\x0342']),
		('\x1FB7',MkDecomposition DCCanonical ['\x1FB6','\x0345']),
		('\x1FB8',MkDecomposition DCCanonical ['\x0391','\x0306']),
		('\x1FB9',MkDecomposition DCCanonical ['\x0391','\x0304']),
		('\x1FBA',MkDecomposition DCCanonical ['\x0391','\x0300']),
		('\x1FBB',MkDecomposition DCCanonical ['\x0386']),
		('\x1FBC',MkDecomposition DCCanonical ['\x0391','\x0345']),
		('\x1FBD',MkDecomposition DCCompat ['\x0020','\x0313']),
		('\x1FBE',MkDecomposition DCCanonical ['\x03B9']),
		('\x1FBF',MkDecomposition DCCompat ['\x0020','\x0313']),
		('\x1FC0',MkDecomposition DCCompat ['\x0020','\x0342']),
		('\x1FC1',MkDecomposition DCCanonical ['\x00A8','\x0342']),
		('\x1FC2',MkDecomposition DCCanonical ['\x1F74','\x0345']),
		('\x1FC3',MkDecomposition DCCanonical ['\x03B7','\x0345']),
		('\x1FC4',MkDecomposition DCCanonical ['\x03AE','\x0345']),
		('\x1FC6',MkDecomposition DCCanonical ['\x03B7','\x0342']),
		('\x1FC7',MkDecomposition DCCanonical ['\x1FC6','\x0345']),
		('\x1FC8',MkDecomposition DCCanonical ['\x0395','\x0300']),
		('\x1FC9',MkDecomposition DCCanonical ['\x0388']),
		('\x1FCA',MkDecomposition DCCanonical ['\x0397','\x0300']),
		('\x1FCB',MkDecomposition DCCanonical ['\x0389']),
		('\x1FCC',MkDecomposition DCCanonical ['\x0397','\x0345']),
		('\x1FCD',MkDecomposition DCCanonical ['\x1FBF','\x0300']),
		('\x1FCE',MkDecomposition DCCanonical ['\x1FBF','\x0301']),
		('\x1FCF',MkDecomposition DCCanonical ['\x1FBF','\x0342']),
		('\x1FD0',MkDecomposition DCCanonical ['\x03B9','\x0306']),
		('\x1FD1',MkDecomposition DCCanonical ['\x03B9','\x0304']),
		('\x1FD2',MkDecomposition DCCanonical ['\x03CA','\x0300']),
		('\x1FD3',MkDecomposition DCCanonical ['\x0390']),
		('\x1FD6',MkDecomposition DCCanonical ['\x03B9','\x0342']),
		('\x1FD7',MkDecomposition DCCanonical ['\x03CA','\x0342']),
		('\x1FD8',MkDecomposition DCCanonical ['\x0399','\x0306']),
		('\x1FD9',MkDecomposition DCCanonical ['\x0399','\x0304']),
		('\x1FDA',MkDecomposition DCCanonical ['\x0399','\x0300']),
		('\x1FDB',MkDecomposition DCCanonical ['\x038A']),
		('\x1FDD',MkDecomposition DCCanonical ['\x1FFE','\x0300']),
		('\x1FDE',MkDecomposition DCCanonical ['\x1FFE','\x0301']),
		('\x1FDF',MkDecomposition DCCanonical ['\x1FFE','\x0342']),
		('\x1FE0',MkDecomposition DCCanonical ['\x03C5','\x0306']),
		('\x1FE1',MkDecomposition DCCanonical ['\x03C5','\x0304']),
		('\x1FE2',MkDecomposition DCCanonical ['\x03CB','\x0300']),
		('\x1FE3',MkDecomposition DCCanonical ['\x03B0']),
		('\x1FE4',MkDecomposition DCCanonical ['\x03C1','\x0313']),
		('\x1FE5',MkDecomposition DCCanonical ['\x03C1','\x0314']),
		('\x1FE6',MkDecomposition DCCanonical ['\x03C5','\x0342']),
		('\x1FE7',MkDecomposition DCCanonical ['\x03CB','\x0342']),
		('\x1FE8',MkDecomposition DCCanonical ['\x03A5','\x0306']),
		('\x1FE9',MkDecomposition DCCanonical ['\x03A5','\x0304']),
		('\x1FEA',MkDecomposition DCCanonical ['\x03A5','\x0300']),
		('\x1FEB',MkDecomposition DCCanonical ['\x038E']),
		('\x1FEC',MkDecomposition DCCanonical ['\x03A1','\x0314']),
		('\x1FED',MkDecomposition DCCanonical ['\x00A8','\x0300']),
		('\x1FEE',MkDecomposition DCCanonical ['\x0385']),
		('\x1FEF',MkDecomposition DCCanonical ['\x0060']),
		('\x1FF2',MkDecomposition DCCanonical ['\x1F7C','\x0345']),
		('\x1FF3',MkDecomposition DCCanonical ['\x03C9','\x0345']),
		('\x1FF4',MkDecomposition DCCanonical ['\x03CE','\x0345']),
		('\x1FF6',MkDecomposition DCCanonical ['\x03C9','\x0342']),
		('\x1FF7',MkDecomposition DCCanonical ['\x1FF6','\x0345']),
		('\x1FF8',MkDecomposition DCCanonical ['\x039F','\x0300']),
		('\x1FF9',MkDecomposition DCCanonical ['\x038C']),
		('\x1FFA',MkDecomposition DCCanonical ['\x03A9','\x0300']),
		('\x1FFB',MkDecomposition DCCanonical ['\x038F']),
		('\x1FFC',MkDecomposition DCCanonical ['\x03A9','\x0345']),
		('\x1FFD',MkDecomposition DCCanonical ['\x00B4']),
		('\x1FFE',MkDecomposition DCCompat ['\x0020','\x0314']),
		('\x2000',MkDecomposition DCCanonical ['\x2002']),
		('\x2001',MkDecomposition DCCanonical ['\x2003']),
		('\x2002',MkDecomposition DCCompat ['\x0020']),
		('\x2003',MkDecomposition DCCompat ['\x0020']),
		('\x2004',MkDecomposition DCCompat ['\x0020']),
		('\x2005',MkDecomposition DCCompat ['\x0020']),
		('\x2006',MkDecomposition DCCompat ['\x0020']),
		('\x2007',MkDecomposition DCNoBreak ['\x0020']),
		('\x2008',MkDecomposition DCCompat ['\x0020']),
		('\x2009',MkDecomposition DCCompat ['\x0020']),
		('\x200A',MkDecomposition DCCompat ['\x0020']),
		('\x2011',MkDecomposition DCNoBreak ['\x2010']),
		('\x2017',MkDecomposition DCCompat ['\x0020','\x0333']),
		('\x2024',MkDecomposition DCCompat ['\x002E']),
		('\x2025',MkDecomposition DCCompat ['\x002E','\x002E']),
		('\x2026',MkDecomposition DCCompat ['\x002E','\x002E','\x002E']),
		('\x202F',MkDecomposition DCNoBreak ['\x0020']),
		('\x2033',MkDecomposition DCCompat ['\x2032','\x2032']),
		('\x2034',MkDecomposition DCCompat ['\x2032','\x2032','\x2032']),
		('\x2036',MkDecomposition DCCompat ['\x2035','\x2035']),
		('\x2037',MkDecomposition DCCompat ['\x2035','\x2035','\x2035']),
		('\x203C',MkDecomposition DCCompat ['\x0021','\x0021']),
		('\x203E',MkDecomposition DCCompat ['\x0020','\x0305']),
		('\x2047',MkDecomposition DCCompat ['\x003F','\x003F']),
		('\x2048',MkDecomposition DCCompat ['\x003F','\x0021']),
		('\x2049',MkDecomposition DCCompat ['\x0021','\x003F']),
		('\x2057',MkDecomposition DCCompat ['\x2032','\x2032','\x2032','\x2032']),
		('\x205F',MkDecomposition DCCompat ['\x0020']),
		('\x2070',MkDecomposition DCSuper ['\x0030']),
		('\x2071',MkDecomposition DCSuper ['\x0069']),
		('\x2074',MkDecomposition DCSuper ['\x0034']),
		('\x2075',MkDecomposition DCSuper ['\x0035']),
		('\x2076',MkDecomposition DCSuper ['\x0036']),
		('\x2077',MkDecomposition DCSuper ['\x0037']),
		('\x2078',MkDecomposition DCSuper ['\x0038']),
		('\x2079',MkDecomposition DCSuper ['\x0039']),
		('\x207A',MkDecomposition DCSuper ['\x002B']),
		('\x207B',MkDecomposition DCSuper ['\x2212']),
		('\x207C',MkDecomposition DCSuper ['\x003D']),
		('\x207D',MkDecomposition DCSuper ['\x0028']),
		('\x207E',MkDecomposition DCSuper ['\x0029']),
		('\x207F',MkDecomposition DCSuper ['\x006E']),
		('\x2080',MkDecomposition DCSub ['\x0030']),
		('\x2081',MkDecomposition DCSub ['\x0031']),
		('\x2082',MkDecomposition DCSub ['\x0032']),
		('\x2083',MkDecomposition DCSub ['\x0033']),
		('\x2084',MkDecomposition DCSub ['\x0034']),
		('\x2085',MkDecomposition DCSub ['\x0035']),
		('\x2086',MkDecomposition DCSub ['\x0036']),
		('\x2087',MkDecomposition DCSub ['\x0037']),
		('\x2088',MkDecomposition DCSub ['\x0038']),
		('\x2089',MkDecomposition DCSub ['\x0039']),
		('\x208A',MkDecomposition DCSub ['\x002B']),
		('\x208B',MkDecomposition DCSub ['\x2212']),
		('\x208C',MkDecomposition DCSub ['\x003D']),
		('\x208D',MkDecomposition DCSub ['\x0028']),
		('\x208E',MkDecomposition DCSub ['\x0029']),
		('\x20A8',MkDecomposition DCCompat ['\x0052','\x0073']),
		('\x2100',MkDecomposition DCCompat ['\x0061','\x002F','\x0063']),
		('\x2101',MkDecomposition DCCompat ['\x0061','\x002F','\x0073']),
		('\x2102',MkDecomposition DCFont ['\x0043']),
		('\x2103',MkDecomposition DCCompat ['\x00B0','\x0043']),
		('\x2105',MkDecomposition DCCompat ['\x0063','\x002F','\x006F']),
		('\x2106',MkDecomposition DCCompat ['\x0063','\x002F','\x0075']),
		('\x2107',MkDecomposition DCCompat ['\x0190']),
		('\x2109',MkDecomposition DCCompat ['\x00B0','\x0046']),
		('\x210A',MkDecomposition DCFont ['\x0067']),
		('\x210B',MkDecomposition DCFont ['\x0048']),
		('\x210C',MkDecomposition DCFont ['\x0048']),
		('\x210D',MkDecomposition DCFont ['\x0048']),
		('\x210E',MkDecomposition DCFont ['\x0068']),
		('\x210F',MkDecomposition DCFont ['\x0127']),
		('\x2110',MkDecomposition DCFont ['\x0049']),
		('\x2111',MkDecomposition DCFont ['\x0049']),
		('\x2112',MkDecomposition DCFont ['\x004C']),
		('\x2113',MkDecomposition DCFont ['\x006C']),
		('\x2115',MkDecomposition DCFont ['\x004E']),
		('\x2116',MkDecomposition DCCompat ['\x004E','\x006F']),
		('\x2119',MkDecomposition DCFont ['\x0050']),
		('\x211A',MkDecomposition DCFont ['\x0051']),
		('\x211B',MkDecomposition DCFont ['\x0052']),
		('\x211C',MkDecomposition DCFont ['\x0052']),
		('\x211D',MkDecomposition DCFont ['\x0052']),
		('\x2120',MkDecomposition DCSuper ['\x0053','\x004D']),
		('\x2121',MkDecomposition DCCompat ['\x0054','\x0045','\x004C']),
		('\x2122',MkDecomposition DCSuper ['\x0054','\x004D']),
		('\x2124',MkDecomposition DCFont ['\x005A']),
		('\x2126',MkDecomposition DCCanonical ['\x03A9']),
		('\x2128',MkDecomposition DCFont ['\x005A']),
		('\x212A',MkDecomposition DCCanonical ['\x004B']),
		('\x212B',MkDecomposition DCCanonical ['\x00C5']),
		('\x212C',MkDecomposition DCFont ['\x0042']),
		('\x212D',MkDecomposition DCFont ['\x0043']),
		('\x212F',MkDecomposition DCFont ['\x0065']),
		('\x2130',MkDecomposition DCFont ['\x0045']),
		('\x2131',MkDecomposition DCFont ['\x0046']),
		('\x2133',MkDecomposition DCFont ['\x004D']),
		('\x2134',MkDecomposition DCFont ['\x006F']),
		('\x2135',MkDecomposition DCCompat ['\x05D0']),
		('\x2136',MkDecomposition DCCompat ['\x05D1']),
		('\x2137',MkDecomposition DCCompat ['\x05D2']),
		('\x2138',MkDecomposition DCCompat ['\x05D3']),
		('\x2139',MkDecomposition DCFont ['\x0069']),
		('\x213D',MkDecomposition DCFont ['\x03B3']),
		('\x213E',MkDecomposition DCFont ['\x0393']),
		('\x213F',MkDecomposition DCFont ['\x03A0']),
		('\x2140',MkDecomposition DCFont ['\x2211']),
		('\x2145',MkDecomposition DCFont ['\x0044']),
		('\x2146',MkDecomposition DCFont ['\x0064']),
		('\x2147',MkDecomposition DCFont ['\x0065']),
		('\x2148',MkDecomposition DCFont ['\x0069']),
		('\x2149',MkDecomposition DCFont ['\x006A']),
		('\x2153',MkDecomposition DCFraction ['\x0031','\x2044','\x0033']),
		('\x2154',MkDecomposition DCFraction ['\x0032','\x2044','\x0033']),
		('\x2155',MkDecomposition DCFraction ['\x0031','\x2044','\x0035']),
		('\x2156',MkDecomposition DCFraction ['\x0032','\x2044','\x0035']),
		('\x2157',MkDecomposition DCFraction ['\x0033','\x2044','\x0035']),
		('\x2158',MkDecomposition DCFraction ['\x0034','\x2044','\x0035']),
		('\x2159',MkDecomposition DCFraction ['\x0031','\x2044','\x0036']),
		('\x215A',MkDecomposition DCFraction ['\x0035','\x2044','\x0036']),
		('\x215B',MkDecomposition DCFraction ['\x0031','\x2044','\x0038']),
		('\x215C',MkDecomposition DCFraction ['\x0033','\x2044','\x0038']),
		('\x215D',MkDecomposition DCFraction ['\x0035','\x2044','\x0038']),
		('\x215E',MkDecomposition DCFraction ['\x0037','\x2044','\x0038']),
		('\x215F',MkDecomposition DCFraction ['\x0031','\x2044']),
		('\x2160',MkDecomposition DCCompat ['\x0049']),
		('\x2161',MkDecomposition DCCompat ['\x0049','\x0049']),
		('\x2162',MkDecomposition DCCompat ['\x0049','\x0049','\x0049']),
		('\x2163',MkDecomposition DCCompat ['\x0049','\x0056']),
		('\x2164',MkDecomposition DCCompat ['\x0056']),
		('\x2165',MkDecomposition DCCompat ['\x0056','\x0049']),
		('\x2166',MkDecomposition DCCompat ['\x0056','\x0049','\x0049']),
		('\x2167',MkDecomposition DCCompat ['\x0056','\x0049','\x0049','\x0049']),
		('\x2168',MkDecomposition DCCompat ['\x0049','\x0058']),
		('\x2169',MkDecomposition DCCompat ['\x0058']),
		('\x216A',MkDecomposition DCCompat ['\x0058','\x0049']),
		('\x216B',MkDecomposition DCCompat ['\x0058','\x0049','\x0049']),
		('\x216C',MkDecomposition DCCompat ['\x004C']),
		('\x216D',MkDecomposition DCCompat ['\x0043']),
		('\x216E',MkDecomposition DCCompat ['\x0044']),
		('\x216F',MkDecomposition DCCompat ['\x004D']),
		('\x2170',MkDecomposition DCCompat ['\x0069']),
		('\x2171',MkDecomposition DCCompat ['\x0069','\x0069']),
		('\x2172',MkDecomposition DCCompat ['\x0069','\x0069','\x0069']),
		('\x2173',MkDecomposition DCCompat ['\x0069','\x0076']),
		('\x2174',MkDecomposition DCCompat ['\x0076']),
		('\x2175',MkDecomposition DCCompat ['\x0076','\x0069']),
		('\x2176',MkDecomposition DCCompat ['\x0076','\x0069','\x0069']),
		('\x2177',MkDecomposition DCCompat ['\x0076','\x0069','\x0069','\x0069']),
		('\x2178',MkDecomposition DCCompat ['\x0069','\x0078']),
		('\x2179',MkDecomposition DCCompat ['\x0078']),
		('\x217A',MkDecomposition DCCompat ['\x0078','\x0069']),
		('\x217B',MkDecomposition DCCompat ['\x0078','\x0069','\x0069']),
		('\x217C',MkDecomposition DCCompat ['\x006C']),
		('\x217D',MkDecomposition DCCompat ['\x0063']),
		('\x217E',MkDecomposition DCCompat ['\x0064']),
		('\x217F',MkDecomposition DCCompat ['\x006D']),
		('\x219A',MkDecomposition DCCanonical ['\x2190','\x0338']),
		('\x219B',MkDecomposition DCCanonical ['\x2192','\x0338']),
		('\x21AE',MkDecomposition DCCanonical ['\x2194','\x0338']),
		('\x21CD',MkDecomposition DCCanonical ['\x21D0','\x0338']),
		('\x21CE',MkDecomposition DCCanonical ['\x21D4','\x0338']),
		('\x21CF',MkDecomposition DCCanonical ['\x21D2','\x0338']),
		('\x2204',MkDecomposition DCCanonical ['\x2203','\x0338']),
		('\x2209',MkDecomposition DCCanonical ['\x2208','\x0338']),
		('\x220C',MkDecomposition DCCanonical ['\x220B','\x0338']),
		('\x2224',MkDecomposition DCCanonical ['\x2223','\x0338']),
		('\x2226',MkDecomposition DCCanonical ['\x2225','\x0338']),
		('\x222C',MkDecomposition DCCompat ['\x222B','\x222B']),
		('\x222D',MkDecomposition DCCompat ['\x222B','\x222B','\x222B']),
		('\x222F',MkDecomposition DCCompat ['\x222E','\x222E']),
		('\x2230',MkDecomposition DCCompat ['\x222E','\x222E','\x222E']),
		('\x2241',MkDecomposition DCCanonical ['\x223C','\x0338']),
		('\x2244',MkDecomposition DCCanonical ['\x2243','\x0338']),
		('\x2247',MkDecomposition DCCanonical ['\x2245','\x0338']),
		('\x2249',MkDecomposition DCCanonical ['\x2248','\x0338']),
		('\x2260',MkDecomposition DCCanonical ['\x003D','\x0338']),
		('\x2262',MkDecomposition DCCanonical ['\x2261','\x0338']),
		('\x226D',MkDecomposition DCCanonical ['\x224D','\x0338']),
		('\x226E',MkDecomposition DCCanonical ['\x003C','\x0338']),
		('\x226F',MkDecomposition DCCanonical ['\x003E','\x0338']),
		('\x2270',MkDecomposition DCCanonical ['\x2264','\x0338']),
		('\x2271',MkDecomposition DCCanonical ['\x2265','\x0338']),
		('\x2274',MkDecomposition DCCanonical ['\x2272','\x0338']),
		('\x2275',MkDecomposition DCCanonical ['\x2273','\x0338']),
		('\x2278',MkDecomposition DCCanonical ['\x2276','\x0338']),
		('\x2279',MkDecomposition DCCanonical ['\x2277','\x0338']),
		('\x2280',MkDecomposition DCCanonical ['\x227A','\x0338']),
		('\x2281',MkDecomposition DCCanonical ['\x227B','\x0338']),
		('\x2284',MkDecomposition DCCanonical ['\x2282','\x0338']),
		('\x2285',MkDecomposition DCCanonical ['\x2283','\x0338']),
		('\x2288',MkDecomposition DCCanonical ['\x2286','\x0338']),
		('\x2289',MkDecomposition DCCanonical ['\x2287','\x0338']),
		('\x22AC',MkDecomposition DCCanonical ['\x22A2','\x0338']),
		('\x22AD',MkDecomposition DCCanonical ['\x22A8','\x0338']),
		('\x22AE',MkDecomposition DCCanonical ['\x22A9','\x0338']),
		('\x22AF',MkDecomposition DCCanonical ['\x22AB','\x0338']),
		('\x22E0',MkDecomposition DCCanonical ['\x227C','\x0338']),
		('\x22E1',MkDecomposition DCCanonical ['\x227D','\x0338']),
		('\x22E2',MkDecomposition DCCanonical ['\x2291','\x0338']),
		('\x22E3',MkDecomposition DCCanonical ['\x2292','\x0338']),
		('\x22EA',MkDecomposition DCCanonical ['\x22B2','\x0338']),
		('\x22EB',MkDecomposition DCCanonical ['\x22B3','\x0338']),
		('\x22EC',MkDecomposition DCCanonical ['\x22B4','\x0338']),
		('\x22ED',MkDecomposition DCCanonical ['\x22B5','\x0338']),
		('\x2329',MkDecomposition DCCanonical ['\x3008']),
		('\x232A',MkDecomposition DCCanonical ['\x3009']),
		('\x2460',MkDecomposition DCCircle ['\x0031']),
		('\x2461',MkDecomposition DCCircle ['\x0032']),
		('\x2462',MkDecomposition DCCircle ['\x0033']),
		('\x2463',MkDecomposition DCCircle ['\x0034']),
		('\x2464',MkDecomposition DCCircle ['\x0035']),
		('\x2465',MkDecomposition DCCircle ['\x0036']),
		('\x2466',MkDecomposition DCCircle ['\x0037']),
		('\x2467',MkDecomposition DCCircle ['\x0038']),
		('\x2468',MkDecomposition DCCircle ['\x0039']),
		('\x2469',MkDecomposition DCCircle ['\x0031','\x0030']),
		('\x246A',MkDecomposition DCCircle ['\x0031','\x0031']),
		('\x246B',MkDecomposition DCCircle ['\x0031','\x0032']),
		('\x246C',MkDecomposition DCCircle ['\x0031','\x0033']),
		('\x246D',MkDecomposition DCCircle ['\x0031','\x0034']),
		('\x246E',MkDecomposition DCCircle ['\x0031','\x0035']),
		('\x246F',MkDecomposition DCCircle ['\x0031','\x0036']),
		('\x2470',MkDecomposition DCCircle ['\x0031','\x0037']),
		('\x2471',MkDecomposition DCCircle ['\x0031','\x0038']),
		('\x2472',MkDecomposition DCCircle ['\x0031','\x0039']),
		('\x2473',MkDecomposition DCCircle ['\x0032','\x0030']),
		('\x2474',MkDecomposition DCCompat ['\x0028','\x0031','\x0029']),
		('\x2475',MkDecomposition DCCompat ['\x0028','\x0032','\x0029']),
		('\x2476',MkDecomposition DCCompat ['\x0028','\x0033','\x0029']),
		('\x2477',MkDecomposition DCCompat ['\x0028','\x0034','\x0029']),
		('\x2478',MkDecomposition DCCompat ['\x0028','\x0035','\x0029']),
		('\x2479',MkDecomposition DCCompat ['\x0028','\x0036','\x0029']),
		('\x247A',MkDecomposition DCCompat ['\x0028','\x0037','\x0029']),
		('\x247B',MkDecomposition DCCompat ['\x0028','\x0038','\x0029']),
		('\x247C',MkDecomposition DCCompat ['\x0028','\x0039','\x0029']),
		('\x247D',MkDecomposition DCCompat ['\x0028','\x0031','\x0030','\x0029']),
		('\x247E',MkDecomposition DCCompat ['\x0028','\x0031','\x0031','\x0029']),
		('\x247F',MkDecomposition DCCompat ['\x0028','\x0031','\x0032','\x0029']),
		('\x2480',MkDecomposition DCCompat ['\x0028','\x0031','\x0033','\x0029']),
		('\x2481',MkDecomposition DCCompat ['\x0028','\x0031','\x0034','\x0029']),
		('\x2482',MkDecomposition DCCompat ['\x0028','\x0031','\x0035','\x0029']),
		('\x2483',MkDecomposition DCCompat ['\x0028','\x0031','\x0036','\x0029']),
		('\x2484',MkDecomposition DCCompat ['\x0028','\x0031','\x0037','\x0029']),
		('\x2485',MkDecomposition DCCompat ['\x0028','\x0031','\x0038','\x0029']),
		('\x2486',MkDecomposition DCCompat ['\x0028','\x0031','\x0039','\x0029']),
		('\x2487',MkDecomposition DCCompat ['\x0028','\x0032','\x0030','\x0029']),
		('\x2488',MkDecomposition DCCompat ['\x0031','\x002E']),
		('\x2489',MkDecomposition DCCompat ['\x0032','\x002E']),
		('\x248A',MkDecomposition DCCompat ['\x0033','\x002E']),
		('\x248B',MkDecomposition DCCompat ['\x0034','\x002E']),
		('\x248C',MkDecomposition DCCompat ['\x0035','\x002E']),
		('\x248D',MkDecomposition DCCompat ['\x0036','\x002E']),
		('\x248E',MkDecomposition DCCompat ['\x0037','\x002E']),
		('\x248F',MkDecomposition DCCompat ['\x0038','\x002E']),
		('\x2490',MkDecomposition DCCompat ['\x0039','\x002E']),
		('\x2491',MkDecomposition DCCompat ['\x0031','\x0030','\x002E']),
		('\x2492',MkDecomposition DCCompat ['\x0031','\x0031','\x002E']),
		('\x2493',MkDecomposition DCCompat ['\x0031','\x0032','\x002E']),
		('\x2494',MkDecomposition DCCompat ['\x0031','\x0033','\x002E']),
		('\x2495',MkDecomposition DCCompat ['\x0031','\x0034','\x002E']),
		('\x2496',MkDecomposition DCCompat ['\x0031','\x0035','\x002E']),
		('\x2497',MkDecomposition DCCompat ['\x0031','\x0036','\x002E']),
		('\x2498',MkDecomposition DCCompat ['\x0031','\x0037','\x002E']),
		('\x2499',MkDecomposition DCCompat ['\x0031','\x0038','\x002E']),
		('\x249A',MkDecomposition DCCompat ['\x0031','\x0039','\x002E']),
		('\x249B',MkDecomposition DCCompat ['\x0032','\x0030','\x002E']),
		('\x249C',MkDecomposition DCCompat ['\x0028','\x0061','\x0029']),
		('\x249D',MkDecomposition DCCompat ['\x0028','\x0062','\x0029']),
		('\x249E',MkDecomposition DCCompat ['\x0028','\x0063','\x0029']),
		('\x249F',MkDecomposition DCCompat ['\x0028','\x0064','\x0029']),
		('\x24A0',MkDecomposition DCCompat ['\x0028','\x0065','\x0029']),
		('\x24A1',MkDecomposition DCCompat ['\x0028','\x0066','\x0029']),
		('\x24A2',MkDecomposition DCCompat ['\x0028','\x0067','\x0029']),
		('\x24A3',MkDecomposition DCCompat ['\x0028','\x0068','\x0029']),
		('\x24A4',MkDecomposition DCCompat ['\x0028','\x0069','\x0029']),
		('\x24A5',MkDecomposition DCCompat ['\x0028','\x006A','\x0029']),
		('\x24A6',MkDecomposition DCCompat ['\x0028','\x006B','\x0029']),
		('\x24A7',MkDecomposition DCCompat ['\x0028','\x006C','\x0029']),
		('\x24A8',MkDecomposition DCCompat ['\x0028','\x006D','\x0029']),
		('\x24A9',MkDecomposition DCCompat ['\x0028','\x006E','\x0029']),
		('\x24AA',MkDecomposition DCCompat ['\x0028','\x006F','\x0029']),
		('\x24AB',MkDecomposition DCCompat ['\x0028','\x0070','\x0029']),
		('\x24AC',MkDecomposition DCCompat ['\x0028','\x0071','\x0029']),
		('\x24AD',MkDecomposition DCCompat ['\x0028','\x0072','\x0029']),
		('\x24AE',MkDecomposition DCCompat ['\x0028','\x0073','\x0029']),
		('\x24AF',MkDecomposition DCCompat ['\x0028','\x0074','\x0029']),
		('\x24B0',MkDecomposition DCCompat ['\x0028','\x0075','\x0029']),
		('\x24B1',MkDecomposition DCCompat ['\x0028','\x0076','\x0029']),
		('\x24B2',MkDecomposition DCCompat ['\x0028','\x0077','\x0029']),
		('\x24B3',MkDecomposition DCCompat ['\x0028','\x0078','\x0029']),
		('\x24B4',MkDecomposition DCCompat ['\x0028','\x0079','\x0029']),
		('\x24B5',MkDecomposition DCCompat ['\x0028','\x007A','\x0029']),
		('\x24B6',MkDecomposition DCCircle ['\x0041']),
		('\x24B7',MkDecomposition DCCircle ['\x0042']),
		('\x24B8',MkDecomposition DCCircle ['\x0043']),
		('\x24B9',MkDecomposition DCCircle ['\x0044']),
		('\x24BA',MkDecomposition DCCircle ['\x0045']),
		('\x24BB',MkDecomposition DCCircle ['\x0046']),
		('\x24BC',MkDecomposition DCCircle ['\x0047']),
		('\x24BD',MkDecomposition DCCircle ['\x0048']),
		('\x24BE',MkDecomposition DCCircle ['\x0049']),
		('\x24BF',MkDecomposition DCCircle ['\x004A']),
		('\x24C0',MkDecomposition DCCircle ['\x004B']),
		('\x24C1',MkDecomposition DCCircle ['\x004C']),
		('\x24C2',MkDecomposition DCCircle ['\x004D']),
		('\x24C3',MkDecomposition DCCircle ['\x004E']),
		('\x24C4',MkDecomposition DCCircle ['\x004F']),
		('\x24C5',MkDecomposition DCCircle ['\x0050']),
		('\x24C6',MkDecomposition DCCircle ['\x0051']),
		('\x24C7',MkDecomposition DCCircle ['\x0052']),
		('\x24C8',MkDecomposition DCCircle ['\x0053']),
		('\x24C9',MkDecomposition DCCircle ['\x0054']),
		('\x24CA',MkDecomposition DCCircle ['\x0055']),
		('\x24CB',MkDecomposition DCCircle ['\x0056']),
		('\x24CC',MkDecomposition DCCircle ['\x0057']),
		('\x24CD',MkDecomposition DCCircle ['\x0058']),
		('\x24CE',MkDecomposition DCCircle ['\x0059']),
		('\x24CF',MkDecomposition DCCircle ['\x005A']),
		('\x24D0',MkDecomposition DCCircle ['\x0061']),
		('\x24D1',MkDecomposition DCCircle ['\x0062']),
		('\x24D2',MkDecomposition DCCircle ['\x0063']),
		('\x24D3',MkDecomposition DCCircle ['\x0064']),
		('\x24D4',MkDecomposition DCCircle ['\x0065']),
		('\x24D5',MkDecomposition DCCircle ['\x0066']),
		('\x24D6',MkDecomposition DCCircle ['\x0067']),
		('\x24D7',MkDecomposition DCCircle ['\x0068']),
		('\x24D8',MkDecomposition DCCircle ['\x0069']),
		('\x24D9',MkDecomposition DCCircle ['\x006A']),
		('\x24DA',MkDecomposition DCCircle ['\x006B']),
		('\x24DB',MkDecomposition DCCircle ['\x006C']),
		('\x24DC',MkDecomposition DCCircle ['\x006D']),
		('\x24DD',MkDecomposition DCCircle ['\x006E']),
		('\x24DE',MkDecomposition DCCircle ['\x006F']),
		('\x24DF',MkDecomposition DCCircle ['\x0070']),
		('\x24E0',MkDecomposition DCCircle ['\x0071']),
		('\x24E1',MkDecomposition DCCircle ['\x0072']),
		('\x24E2',MkDecomposition DCCircle ['\x0073']),
		('\x24E3',MkDecomposition DCCircle ['\x0074']),
		('\x24E4',MkDecomposition DCCircle ['\x0075']),
		('\x24E5',MkDecomposition DCCircle ['\x0076']),
		('\x24E6',MkDecomposition DCCircle ['\x0077']),
		('\x24E7',MkDecomposition DCCircle ['\x0078']),
		('\x24E8',MkDecomposition DCCircle ['\x0079']),
		('\x24E9',MkDecomposition DCCircle ['\x007A']),
		('\x24EA',MkDecomposition DCCircle ['\x0030']),
		('\x2A0C',MkDecomposition DCCompat ['\x222B','\x222B','\x222B','\x222B']),
		('\x2A74',MkDecomposition DCCompat ['\x003A','\x003A','\x003D']),
		('\x2A75',MkDecomposition DCCompat ['\x003D','\x003D']),
		('\x2A76',MkDecomposition DCCompat ['\x003D','\x003D','\x003D']),
		('\x2ADC',MkDecomposition DCCanonical ['\x2ADD','\x0338']),
		('\x2E9F',MkDecomposition DCCompat ['\x6BCD']),
		('\x2EF3',MkDecomposition DCCompat ['\x9F9F']),
		('\x2F00',MkDecomposition DCCompat ['\x4E00']),
		('\x2F01',MkDecomposition DCCompat ['\x4E28']),
		('\x2F02',MkDecomposition DCCompat ['\x4E36']),
		('\x2F03',MkDecomposition DCCompat ['\x4E3F']),
		('\x2F04',MkDecomposition DCCompat ['\x4E59']),
		('\x2F05',MkDecomposition DCCompat ['\x4E85']),
		('\x2F06',MkDecomposition DCCompat ['\x4E8C']),
		('\x2F07',MkDecomposition DCCompat ['\x4EA0']),
		('\x2F08',MkDecomposition DCCompat ['\x4EBA']),
		('\x2F09',MkDecomposition DCCompat ['\x513F']),
		('\x2F0A',MkDecomposition DCCompat ['\x5165']),
		('\x2F0B',MkDecomposition DCCompat ['\x516B']),
		('\x2F0C',MkDecomposition DCCompat ['\x5182']),
		('\x2F0D',MkDecomposition DCCompat ['\x5196']),
		('\x2F0E',MkDecomposition DCCompat ['\x51AB']),
		('\x2F0F',MkDecomposition DCCompat ['\x51E0']),
		('\x2F10',MkDecomposition DCCompat ['\x51F5']),
		('\x2F11',MkDecomposition DCCompat ['\x5200']),
		('\x2F12',MkDecomposition DCCompat ['\x529B']),
		('\x2F13',MkDecomposition DCCompat ['\x52F9']),
		('\x2F14',MkDecomposition DCCompat ['\x5315']),
		('\x2F15',MkDecomposition DCCompat ['\x531A']),
		('\x2F16',MkDecomposition DCCompat ['\x5338']),
		('\x2F17',MkDecomposition DCCompat ['\x5341']),
		('\x2F18',MkDecomposition DCCompat ['\x535C']),
		('\x2F19',MkDecomposition DCCompat ['\x5369']),
		('\x2F1A',MkDecomposition DCCompat ['\x5382']),
		('\x2F1B',MkDecomposition DCCompat ['\x53B6']),
		('\x2F1C',MkDecomposition DCCompat ['\x53C8']),
		('\x2F1D',MkDecomposition DCCompat ['\x53E3']),
		('\x2F1E',MkDecomposition DCCompat ['\x56D7']),
		('\x2F1F',MkDecomposition DCCompat ['\x571F']),
		('\x2F20',MkDecomposition DCCompat ['\x58EB']),
		('\x2F21',MkDecomposition DCCompat ['\x5902']),
		('\x2F22',MkDecomposition DCCompat ['\x590A']),
		('\x2F23',MkDecomposition DCCompat ['\x5915']),
		('\x2F24',MkDecomposition DCCompat ['\x5927']),
		('\x2F25',MkDecomposition DCCompat ['\x5973']),
		('\x2F26',MkDecomposition DCCompat ['\x5B50']),
		('\x2F27',MkDecomposition DCCompat ['\x5B80']),
		('\x2F28',MkDecomposition DCCompat ['\x5BF8']),
		('\x2F29',MkDecomposition DCCompat ['\x5C0F']),
		('\x2F2A',MkDecomposition DCCompat ['\x5C22']),
		('\x2F2B',MkDecomposition DCCompat ['\x5C38']),
		('\x2F2C',MkDecomposition DCCompat ['\x5C6E']),
		('\x2F2D',MkDecomposition DCCompat ['\x5C71']),
		('\x2F2E',MkDecomposition DCCompat ['\x5DDB']),
		('\x2F2F',MkDecomposition DCCompat ['\x5DE5']),
		('\x2F30',MkDecomposition DCCompat ['\x5DF1']),
		('\x2F31',MkDecomposition DCCompat ['\x5DFE']),
		('\x2F32',MkDecomposition DCCompat ['\x5E72']),
		('\x2F33',MkDecomposition DCCompat ['\x5E7A']),
		('\x2F34',MkDecomposition DCCompat ['\x5E7F']),
		('\x2F35',MkDecomposition DCCompat ['\x5EF4']),
		('\x2F36',MkDecomposition DCCompat ['\x5EFE']),
		('\x2F37',MkDecomposition DCCompat ['\x5F0B']),
		('\x2F38',MkDecomposition DCCompat ['\x5F13']),
		('\x2F39',MkDecomposition DCCompat ['\x5F50']),
		('\x2F3A',MkDecomposition DCCompat ['\x5F61']),
		('\x2F3B',MkDecomposition DCCompat ['\x5F73']),
		('\x2F3C',MkDecomposition DCCompat ['\x5FC3']),
		('\x2F3D',MkDecomposition DCCompat ['\x6208']),
		('\x2F3E',MkDecomposition DCCompat ['\x6236']),
		('\x2F3F',MkDecomposition DCCompat ['\x624B']),
		('\x2F40',MkDecomposition DCCompat ['\x652F']),
		('\x2F41',MkDecomposition DCCompat ['\x6534']),
		('\x2F42',MkDecomposition DCCompat ['\x6587']),
		('\x2F43',MkDecomposition DCCompat ['\x6597']),
		('\x2F44',MkDecomposition DCCompat ['\x65A4']),
		('\x2F45',MkDecomposition DCCompat ['\x65B9']),
		('\x2F46',MkDecomposition DCCompat ['\x65E0']),
		('\x2F47',MkDecomposition DCCompat ['\x65E5']),
		('\x2F48',MkDecomposition DCCompat ['\x66F0']),
		('\x2F49',MkDecomposition DCCompat ['\x6708']),
		('\x2F4A',MkDecomposition DCCompat ['\x6728']),
		('\x2F4B',MkDecomposition DCCompat ['\x6B20']),
		('\x2F4C',MkDecomposition DCCompat ['\x6B62']),
		('\x2F4D',MkDecomposition DCCompat ['\x6B79']),
		('\x2F4E',MkDecomposition DCCompat ['\x6BB3']),
		('\x2F4F',MkDecomposition DCCompat ['\x6BCB']),
		('\x2F50',MkDecomposition DCCompat ['\x6BD4']),
		('\x2F51',MkDecomposition DCCompat ['\x6BDB']),
		('\x2F52',MkDecomposition DCCompat ['\x6C0F']),
		('\x2F53',MkDecomposition DCCompat ['\x6C14']),
		('\x2F54',MkDecomposition DCCompat ['\x6C34']),
		('\x2F55',MkDecomposition DCCompat ['\x706B']),
		('\x2F56',MkDecomposition DCCompat ['\x722A']),
		('\x2F57',MkDecomposition DCCompat ['\x7236']),
		('\x2F58',MkDecomposition DCCompat ['\x723B']),
		('\x2F59',MkDecomposition DCCompat ['\x723F']),
		('\x2F5A',MkDecomposition DCCompat ['\x7247']),
		('\x2F5B',MkDecomposition DCCompat ['\x7259']),
		('\x2F5C',MkDecomposition DCCompat ['\x725B']),
		('\x2F5D',MkDecomposition DCCompat ['\x72AC']),
		('\x2F5E',MkDecomposition DCCompat ['\x7384']),
		('\x2F5F',MkDecomposition DCCompat ['\x7389']),
		('\x2F60',MkDecomposition DCCompat ['\x74DC']),
		('\x2F61',MkDecomposition DCCompat ['\x74E6']),
		('\x2F62',MkDecomposition DCCompat ['\x7518']),
		('\x2F63',MkDecomposition DCCompat ['\x751F']),
		('\x2F64',MkDecomposition DCCompat ['\x7528']),
		('\x2F65',MkDecomposition DCCompat ['\x7530']),
		('\x2F66',MkDecomposition DCCompat ['\x758B']),
		('\x2F67',MkDecomposition DCCompat ['\x7592']),
		('\x2F68',MkDecomposition DCCompat ['\x7676']),
		('\x2F69',MkDecomposition DCCompat ['\x767D']),
		('\x2F6A',MkDecomposition DCCompat ['\x76AE']),
		('\x2F6B',MkDecomposition DCCompat ['\x76BF']),
		('\x2F6C',MkDecomposition DCCompat ['\x76EE']),
		('\x2F6D',MkDecomposition DCCompat ['\x77DB']),
		('\x2F6E',MkDecomposition DCCompat ['\x77E2']),
		('\x2F6F',MkDecomposition DCCompat ['\x77F3']),
		('\x2F70',MkDecomposition DCCompat ['\x793A']),
		('\x2F71',MkDecomposition DCCompat ['\x79B8']),
		('\x2F72',MkDecomposition DCCompat ['\x79BE']),
		('\x2F73',MkDecomposition DCCompat ['\x7A74']),
		('\x2F74',MkDecomposition DCCompat ['\x7ACB']),
		('\x2F75',MkDecomposition DCCompat ['\x7AF9']),
		('\x2F76',MkDecomposition DCCompat ['\x7C73']),
		('\x2F77',MkDecomposition DCCompat ['\x7CF8']),
		('\x2F78',MkDecomposition DCCompat ['\x7F36']),
		('\x2F79',MkDecomposition DCCompat ['\x7F51']),
		('\x2F7A',MkDecomposition DCCompat ['\x7F8A']),
		('\x2F7B',MkDecomposition DCCompat ['\x7FBD']),
		('\x2F7C',MkDecomposition DCCompat ['\x8001']),
		('\x2F7D',MkDecomposition DCCompat ['\x800C']),
		('\x2F7E',MkDecomposition DCCompat ['\x8012']),
		('\x2F7F',MkDecomposition DCCompat ['\x8033']),
		('\x2F80',MkDecomposition DCCompat ['\x807F']),
		('\x2F81',MkDecomposition DCCompat ['\x8089']),
		('\x2F82',MkDecomposition DCCompat ['\x81E3']),
		('\x2F83',MkDecomposition DCCompat ['\x81EA']),
		('\x2F84',MkDecomposition DCCompat ['\x81F3']),
		('\x2F85',MkDecomposition DCCompat ['\x81FC']),
		('\x2F86',MkDecomposition DCCompat ['\x820C']),
		('\x2F87',MkDecomposition DCCompat ['\x821B']),
		('\x2F88',MkDecomposition DCCompat ['\x821F']),
		('\x2F89',MkDecomposition DCCompat ['\x826E']),
		('\x2F8A',MkDecomposition DCCompat ['\x8272']),
		('\x2F8B',MkDecomposition DCCompat ['\x8278']),
		('\x2F8C',MkDecomposition DCCompat ['\x864D']),
		('\x2F8D',MkDecomposition DCCompat ['\x866B']),
		('\x2F8E',MkDecomposition DCCompat ['\x8840']),
		('\x2F8F',MkDecomposition DCCompat ['\x884C']),
		('\x2F90',MkDecomposition DCCompat ['\x8863']),
		('\x2F91',MkDecomposition DCCompat ['\x897E']),
		('\x2F92',MkDecomposition DCCompat ['\x898B']),
		('\x2F93',MkDecomposition DCCompat ['\x89D2']),
		('\x2F94',MkDecomposition DCCompat ['\x8A00']),
		('\x2F95',MkDecomposition DCCompat ['\x8C37']),
		('\x2F96',MkDecomposition DCCompat ['\x8C46']),
		('\x2F97',MkDecomposition DCCompat ['\x8C55']),
		('\x2F98',MkDecomposition DCCompat ['\x8C78']),
		('\x2F99',MkDecomposition DCCompat ['\x8C9D']),
		('\x2F9A',MkDecomposition DCCompat ['\x8D64']),
		('\x2F9B',MkDecomposition DCCompat ['\x8D70']),
		('\x2F9C',MkDecomposition DCCompat ['\x8DB3']),
		('\x2F9D',MkDecomposition DCCompat ['\x8EAB']),
		('\x2F9E',MkDecomposition DCCompat ['\x8ECA']),
		('\x2F9F',MkDecomposition DCCompat ['\x8F9B']),
		('\x2FA0',MkDecomposition DCCompat ['\x8FB0']),
		('\x2FA1',MkDecomposition DCCompat ['\x8FB5']),
		('\x2FA2',MkDecomposition DCCompat ['\x9091']),
		('\x2FA3',MkDecomposition DCCompat ['\x9149']),
		('\x2FA4',MkDecomposition DCCompat ['\x91C6']),
		('\x2FA5',MkDecomposition DCCompat ['\x91CC']),
		('\x2FA6',MkDecomposition DCCompat ['\x91D1']),
		('\x2FA7',MkDecomposition DCCompat ['\x9577']),
		('\x2FA8',MkDecomposition DCCompat ['\x9580']),
		('\x2FA9',MkDecomposition DCCompat ['\x961C']),
		('\x2FAA',MkDecomposition DCCompat ['\x96B6']),
		('\x2FAB',MkDecomposition DCCompat ['\x96B9']),
		('\x2FAC',MkDecomposition DCCompat ['\x96E8']),
		('\x2FAD',MkDecomposition DCCompat ['\x9751']),
		('\x2FAE',MkDecomposition DCCompat ['\x975E']),
		('\x2FAF',MkDecomposition DCCompat ['\x9762']),
		('\x2FB0',MkDecomposition DCCompat ['\x9769']),
		('\x2FB1',MkDecomposition DCCompat ['\x97CB']),
		('\x2FB2',MkDecomposition DCCompat ['\x97ED']),
		('\x2FB3',MkDecomposition DCCompat ['\x97F3']),
		('\x2FB4',MkDecomposition DCCompat ['\x9801']),
		('\x2FB5',MkDecomposition DCCompat ['\x98A8']),
		('\x2FB6',MkDecomposition DCCompat ['\x98DB']),
		('\x2FB7',MkDecomposition DCCompat ['\x98DF']),
		('\x2FB8',MkDecomposition DCCompat ['\x9996']),
		('\x2FB9',MkDecomposition DCCompat ['\x9999']),
		('\x2FBA',MkDecomposition DCCompat ['\x99AC']),
		('\x2FBB',MkDecomposition DCCompat ['\x9AA8']),
		('\x2FBC',MkDecomposition DCCompat ['\x9AD8']),
		('\x2FBD',MkDecomposition DCCompat ['\x9ADF']),
		('\x2FBE',MkDecomposition DCCompat ['\x9B25']),
		('\x2FBF',MkDecomposition DCCompat ['\x9B2F']),
		('\x2FC0',MkDecomposition DCCompat ['\x9B32']),
		('\x2FC1',MkDecomposition DCCompat ['\x9B3C']),
		('\x2FC2',MkDecomposition DCCompat ['\x9B5A']),
		('\x2FC3',MkDecomposition DCCompat ['\x9CE5']),
		('\x2FC4',MkDecomposition DCCompat ['\x9E75']),
		('\x2FC5',MkDecomposition DCCompat ['\x9E7F']),
		('\x2FC6',MkDecomposition DCCompat ['\x9EA5']),
		('\x2FC7',MkDecomposition DCCompat ['\x9EBB']),
		('\x2FC8',MkDecomposition DCCompat ['\x9EC3']),
		('\x2FC9',MkDecomposition DCCompat ['\x9ECD']),
		('\x2FCA',MkDecomposition DCCompat ['\x9ED1']),
		('\x2FCB',MkDecomposition DCCompat ['\x9EF9']),
		('\x2FCC',MkDecomposition DCCompat ['\x9EFD']),
		('\x2FCD',MkDecomposition DCCompat ['\x9F0E']),
		('\x2FCE',MkDecomposition DCCompat ['\x9F13']),
		('\x2FCF',MkDecomposition DCCompat ['\x9F20']),
		('\x2FD0',MkDecomposition DCCompat ['\x9F3B']),
		('\x2FD1',MkDecomposition DCCompat ['\x9F4A']),
		('\x2FD2',MkDecomposition DCCompat ['\x9F52']),
		('\x2FD3',MkDecomposition DCCompat ['\x9F8D']),
		('\x2FD4',MkDecomposition DCCompat ['\x9F9C']),
		('\x2FD5',MkDecomposition DCCompat ['\x9FA0']),
		('\x3000',MkDecomposition DCWide ['\x0020']),
		('\x3036',MkDecomposition DCCompat ['\x3012']),
		('\x3038',MkDecomposition DCCompat ['\x5341']),
		('\x3039',MkDecomposition DCCompat ['\x5344']),
		('\x303A',MkDecomposition DCCompat ['\x5345']),
		('\x304C',MkDecomposition DCCanonical ['\x304B','\x3099']),
		('\x304E',MkDecomposition DCCanonical ['\x304D','\x3099']),
		('\x3050',MkDecomposition DCCanonical ['\x304F','\x3099']),
		('\x3052',MkDecomposition DCCanonical ['\x3051','\x3099']),
		('\x3054',MkDecomposition DCCanonical ['\x3053','\x3099']),
		('\x3056',MkDecomposition DCCanonical ['\x3055','\x3099']),
		('\x3058',MkDecomposition DCCanonical ['\x3057','\x3099']),
		('\x305A',MkDecomposition DCCanonical ['\x3059','\x3099']),
		('\x305C',MkDecomposition DCCanonical ['\x305B','\x3099']),
		('\x305E',MkDecomposition DCCanonical ['\x305D','\x3099']),
		('\x3060',MkDecomposition DCCanonical ['\x305F','\x3099']),
		('\x3062',MkDecomposition DCCanonical ['\x3061','\x3099']),
		('\x3065',MkDecomposition DCCanonical ['\x3064','\x3099']),
		('\x3067',MkDecomposition DCCanonical ['\x3066','\x3099']),
		('\x3069',MkDecomposition DCCanonical ['\x3068','\x3099']),
		('\x3070',MkDecomposition DCCanonical ['\x306F','\x3099']),
		('\x3071',MkDecomposition DCCanonical ['\x306F','\x309A']),
		('\x3073',MkDecomposition DCCanonical ['\x3072','\x3099']),
		('\x3074',MkDecomposition DCCanonical ['\x3072','\x309A']),
		('\x3076',MkDecomposition DCCanonical ['\x3075','\x3099']),
		('\x3077',MkDecomposition DCCanonical ['\x3075','\x309A']),
		('\x3079',MkDecomposition DCCanonical ['\x3078','\x3099']),
		('\x307A',MkDecomposition DCCanonical ['\x3078','\x309A']),
		('\x307C',MkDecomposition DCCanonical ['\x307B','\x3099']),
		('\x307D',MkDecomposition DCCanonical ['\x307B','\x309A']),
		('\x3094',MkDecomposition DCCanonical ['\x3046','\x3099']),
		('\x309B',MkDecomposition DCCompat ['\x0020','\x3099']),
		('\x309C',MkDecomposition DCCompat ['\x0020','\x309A']),
		('\x309E',MkDecomposition DCCanonical ['\x309D','\x3099']),
		('\x309F',MkDecomposition DCVertical ['\x3088','\x308A']),
		('\x30AC',MkDecomposition DCCanonical ['\x30AB','\x3099']),
		('\x30AE',MkDecomposition DCCanonical ['\x30AD','\x3099']),
		('\x30B0',MkDecomposition DCCanonical ['\x30AF','\x3099']),
		('\x30B2',MkDecomposition DCCanonical ['\x30B1','\x3099']),
		('\x30B4',MkDecomposition DCCanonical ['\x30B3','\x3099']),
		('\x30B6',MkDecomposition DCCanonical ['\x30B5','\x3099']),
		('\x30B8',MkDecomposition DCCanonical ['\x30B7','\x3099']),
		('\x30BA',MkDecomposition DCCanonical ['\x30B9','\x3099']),
		('\x30BC',MkDecomposition DCCanonical ['\x30BB','\x3099']),
		('\x30BE',MkDecomposition DCCanonical ['\x30BD','\x3099']),
		('\x30C0',MkDecomposition DCCanonical ['\x30BF','\x3099']),
		('\x30C2',MkDecomposition DCCanonical ['\x30C1','\x3099']),
		('\x30C5',MkDecomposition DCCanonical ['\x30C4','\x3099']),
		('\x30C7',MkDecomposition DCCanonical ['\x30C6','\x3099']),
		('\x30C9',MkDecomposition DCCanonical ['\x30C8','\x3099']),
		('\x30D0',MkDecomposition DCCanonical ['\x30CF','\x3099']),
		('\x30D1',MkDecomposition DCCanonical ['\x30CF','\x309A']),
		('\x30D3',MkDecomposition DCCanonical ['\x30D2','\x3099']),
		('\x30D4',MkDecomposition DCCanonical ['\x30D2','\x309A']),
		('\x30D6',MkDecomposition DCCanonical ['\x30D5','\x3099']),
		('\x30D7',MkDecomposition DCCanonical ['\x30D5','\x309A']),
		('\x30D9',MkDecomposition DCCanonical ['\x30D8','\x3099']),
		('\x30DA',MkDecomposition DCCanonical ['\x30D8','\x309A']),
		('\x30DC',MkDecomposition DCCanonical ['\x30DB','\x3099']),
		('\x30DD',MkDecomposition DCCanonical ['\x30DB','\x309A']),
		('\x30F4',MkDecomposition DCCanonical ['\x30A6','\x3099']),
		('\x30F7',MkDecomposition DCCanonical ['\x30EF','\x3099']),
		('\x30F8',MkDecomposition DCCanonical ['\x30F0','\x3099']),
		('\x30F9',MkDecomposition DCCanonical ['\x30F1','\x3099']),
		('\x30FA',MkDecomposition DCCanonical ['\x30F2','\x3099']),
		('\x30FE',MkDecomposition DCCanonical ['\x30FD','\x3099']),
		('\x30FF',MkDecomposition DCVertical ['\x30B3','\x30C8']),
		('\x3131',MkDecomposition DCCompat ['\x1100']),
		('\x3132',MkDecomposition DCCompat ['\x1101']),
		('\x3133',MkDecomposition DCCompat ['\x11AA']),
		('\x3134',MkDecomposition DCCompat ['\x1102']),
		('\x3135',MkDecomposition DCCompat ['\x11AC']),
		('\x3136',MkDecomposition DCCompat ['\x11AD']),
		('\x3137',MkDecomposition DCCompat ['\x1103']),
		('\x3138',MkDecomposition DCCompat ['\x1104']),
		('\x3139',MkDecomposition DCCompat ['\x1105']),
		('\x313A',MkDecomposition DCCompat ['\x11B0']),
		('\x313B',MkDecomposition DCCompat ['\x11B1']),
		('\x313C',MkDecomposition DCCompat ['\x11B2']),
		('\x313D',MkDecomposition DCCompat ['\x11B3']),
		('\x313E',MkDecomposition DCCompat ['\x11B4']),
		('\x313F',MkDecomposition DCCompat ['\x11B5']),
		('\x3140',MkDecomposition DCCompat ['\x111A']),
		('\x3141',MkDecomposition DCCompat ['\x1106']),
		('\x3142',MkDecomposition DCCompat ['\x1107']),
		('\x3143',MkDecomposition DCCompat ['\x1108']),
		('\x3144',MkDecomposition DCCompat ['\x1121']),
		('\x3145',MkDecomposition DCCompat ['\x1109']),
		('\x3146',MkDecomposition DCCompat ['\x110A']),
		('\x3147',MkDecomposition DCCompat ['\x110B']),
		('\x3148',MkDecomposition DCCompat ['\x110C']),
		('\x3149',MkDecomposition DCCompat ['\x110D']),
		('\x314A',MkDecomposition DCCompat ['\x110E']),
		('\x314B',MkDecomposition DCCompat ['\x110F']),
		('\x314C',MkDecomposition DCCompat ['\x1110']),
		('\x314D',MkDecomposition DCCompat ['\x1111']),
		('\x314E',MkDecomposition DCCompat ['\x1112']),
		('\x314F',MkDecomposition DCCompat ['\x1161']),
		('\x3150',MkDecomposition DCCompat ['\x1162']),
		('\x3151',MkDecomposition DCCompat ['\x1163']),
		('\x3152',MkDecomposition DCCompat ['\x1164']),
		('\x3153',MkDecomposition DCCompat ['\x1165']),
		('\x3154',MkDecomposition DCCompat ['\x1166']),
		('\x3155',MkDecomposition DCCompat ['\x1167']),
		('\x3156',MkDecomposition DCCompat ['\x1168']),
		('\x3157',MkDecomposition DCCompat ['\x1169']),
		('\x3158',MkDecomposition DCCompat ['\x116A']),
		('\x3159',MkDecomposition DCCompat ['\x116B']),
		('\x315A',MkDecomposition DCCompat ['\x116C']),
		('\x315B',MkDecomposition DCCompat ['\x116D']),
		('\x315C',MkDecomposition DCCompat ['\x116E']),
		('\x315D',MkDecomposition DCCompat ['\x116F']),
		('\x315E',MkDecomposition DCCompat ['\x1170']),
		('\x315F',MkDecomposition DCCompat ['\x1171']),
		('\x3160',MkDecomposition DCCompat ['\x1172']),
		('\x3161',MkDecomposition DCCompat ['\x1173']),
		('\x3162',MkDecomposition DCCompat ['\x1174']),
		('\x3163',MkDecomposition DCCompat ['\x1175']),
		('\x3164',MkDecomposition DCCompat ['\x1160']),
		('\x3165',MkDecomposition DCCompat ['\x1114']),
		('\x3166',MkDecomposition DCCompat ['\x1115']),
		('\x3167',MkDecomposition DCCompat ['\x11C7']),
		('\x3168',MkDecomposition DCCompat ['\x11C8']),
		('\x3169',MkDecomposition DCCompat ['\x11CC']),
		('\x316A',MkDecomposition DCCompat ['\x11CE']),
		('\x316B',MkDecomposition DCCompat ['\x11D3']),
		('\x316C',MkDecomposition DCCompat ['\x11D7']),
		('\x316D',MkDecomposition DCCompat ['\x11D9']),
		('\x316E',MkDecomposition DCCompat ['\x111C']),
		('\x316F',MkDecomposition DCCompat ['\x11DD']),
		('\x3170',MkDecomposition DCCompat ['\x11DF']),
		('\x3171',MkDecomposition DCCompat ['\x111D']),
		('\x3172',MkDecomposition DCCompat ['\x111E']),
		('\x3173',MkDecomposition DCCompat ['\x1120']),
		('\x3174',MkDecomposition DCCompat ['\x1122']),
		('\x3175',MkDecomposition DCCompat ['\x1123']),
		('\x3176',MkDecomposition DCCompat ['\x1127']),
		('\x3177',MkDecomposition DCCompat ['\x1129']),
		('\x3178',MkDecomposition DCCompat ['\x112B']),
		('\x3179',MkDecomposition DCCompat ['\x112C']),
		('\x317A',MkDecomposition DCCompat ['\x112D']),
		('\x317B',MkDecomposition DCCompat ['\x112E']),
		('\x317C',MkDecomposition DCCompat ['\x112F']),
		('\x317D',MkDecomposition DCCompat ['\x1132']),
		('\x317E',MkDecomposition DCCompat ['\x1136']),
		('\x317F',MkDecomposition DCCompat ['\x1140']),
		('\x3180',MkDecomposition DCCompat ['\x1147']),
		('\x3181',MkDecomposition DCCompat ['\x114C']),
		('\x3182',MkDecomposition DCCompat ['\x11F1']),
		('\x3183',MkDecomposition DCCompat ['\x11F2']),
		('\x3184',MkDecomposition DCCompat ['\x1157']),
		('\x3185',MkDecomposition DCCompat ['\x1158']),
		('\x3186',MkDecomposition DCCompat ['\x1159']),
		('\x3187',MkDecomposition DCCompat ['\x1184']),
		('\x3188',MkDecomposition DCCompat ['\x1185']),
		('\x3189',MkDecomposition DCCompat ['\x1188']),
		('\x318A',MkDecomposition DCCompat ['\x1191']),
		('\x318B',MkDecomposition DCCompat ['\x1192']),
		('\x318C',MkDecomposition DCCompat ['\x1194']),
		('\x318D',MkDecomposition DCCompat ['\x119E']),
		('\x318E',MkDecomposition DCCompat ['\x11A1']),
		('\x3192',MkDecomposition DCSuper ['\x4E00']),
		('\x3193',MkDecomposition DCSuper ['\x4E8C']),
		('\x3194',MkDecomposition DCSuper ['\x4E09']),
		('\x3195',MkDecomposition DCSuper ['\x56DB']),
		('\x3196',MkDecomposition DCSuper ['\x4E0A']),
		('\x3197',MkDecomposition DCSuper ['\x4E2D']),
		('\x3198',MkDecomposition DCSuper ['\x4E0B']),
		('\x3199',MkDecomposition DCSuper ['\x7532']),
		('\x319A',MkDecomposition DCSuper ['\x4E59']),
		('\x319B',MkDecomposition DCSuper ['\x4E19']),
		('\x319C',MkDecomposition DCSuper ['\x4E01']),
		('\x319D',MkDecomposition DCSuper ['\x5929']),
		('\x319E',MkDecomposition DCSuper ['\x5730']),
		('\x319F',MkDecomposition DCSuper ['\x4EBA']),
		('\x3200',MkDecomposition DCCompat ['\x0028','\x1100','\x0029']),
		('\x3201',MkDecomposition DCCompat ['\x0028','\x1102','\x0029']),
		('\x3202',MkDecomposition DCCompat ['\x0028','\x1103','\x0029']),
		('\x3203',MkDecomposition DCCompat ['\x0028','\x1105','\x0029']),
		('\x3204',MkDecomposition DCCompat ['\x0028','\x1106','\x0029']),
		('\x3205',MkDecomposition DCCompat ['\x0028','\x1107','\x0029']),
		('\x3206',MkDecomposition DCCompat ['\x0028','\x1109','\x0029']),
		('\x3207',MkDecomposition DCCompat ['\x0028','\x110B','\x0029']),
		('\x3208',MkDecomposition DCCompat ['\x0028','\x110C','\x0029']),
		('\x3209',MkDecomposition DCCompat ['\x0028','\x110E','\x0029']),
		('\x320A',MkDecomposition DCCompat ['\x0028','\x110F','\x0029']),
		('\x320B',MkDecomposition DCCompat ['\x0028','\x1110','\x0029']),
		('\x320C',MkDecomposition DCCompat ['\x0028','\x1111','\x0029']),
		('\x320D',MkDecomposition DCCompat ['\x0028','\x1112','\x0029']),
		('\x320E',MkDecomposition DCCompat ['\x0028','\x1100','\x1161','\x0029']),
		('\x320F',MkDecomposition DCCompat ['\x0028','\x1102','\x1161','\x0029']),
		('\x3210',MkDecomposition DCCompat ['\x0028','\x1103','\x1161','\x0029']),
		('\x3211',MkDecomposition DCCompat ['\x0028','\x1105','\x1161','\x0029']),
		('\x3212',MkDecomposition DCCompat ['\x0028','\x1106','\x1161','\x0029']),
		('\x3213',MkDecomposition DCCompat ['\x0028','\x1107','\x1161','\x0029']),
		('\x3214',MkDecomposition DCCompat ['\x0028','\x1109','\x1161','\x0029']),
		('\x3215',MkDecomposition DCCompat ['\x0028','\x110B','\x1161','\x0029']),
		('\x3216',MkDecomposition DCCompat ['\x0028','\x110C','\x1161','\x0029']),
		('\x3217',MkDecomposition DCCompat ['\x0028','\x110E','\x1161','\x0029']),
		('\x3218',MkDecomposition DCCompat ['\x0028','\x110F','\x1161','\x0029']),
		('\x3219',MkDecomposition DCCompat ['\x0028','\x1110','\x1161','\x0029']),
		('\x321A',MkDecomposition DCCompat ['\x0028','\x1111','\x1161','\x0029']),
		('\x321B',MkDecomposition DCCompat ['\x0028','\x1112','\x1161','\x0029']),
		('\x321C',MkDecomposition DCCompat ['\x0028','\x110C','\x116E','\x0029']),
		('\x3220',MkDecomposition DCCompat ['\x0028','\x4E00','\x0029']),
		('\x3221',MkDecomposition DCCompat ['\x0028','\x4E8C','\x0029']),
		('\x3222',MkDecomposition DCCompat ['\x0028','\x4E09','\x0029']),
		('\x3223',MkDecomposition DCCompat ['\x0028','\x56DB','\x0029']),
		('\x3224',MkDecomposition DCCompat ['\x0028','\x4E94','\x0029']),
		('\x3225',MkDecomposition DCCompat ['\x0028','\x516D','\x0029']),
		('\x3226',MkDecomposition DCCompat ['\x0028','\x4E03','\x0029']),
		('\x3227',MkDecomposition DCCompat ['\x0028','\x516B','\x0029']),
		('\x3228',MkDecomposition DCCompat ['\x0028','\x4E5D','\x0029']),
		('\x3229',MkDecomposition DCCompat ['\x0028','\x5341','\x0029']),
		('\x322A',MkDecomposition DCCompat ['\x0028','\x6708','\x0029']),
		('\x322B',MkDecomposition DCCompat ['\x0028','\x706B','\x0029']),
		('\x322C',MkDecomposition DCCompat ['\x0028','\x6C34','\x0029']),
		('\x322D',MkDecomposition DCCompat ['\x0028','\x6728','\x0029']),
		('\x322E',MkDecomposition DCCompat ['\x0028','\x91D1','\x0029']),
		('\x322F',MkDecomposition DCCompat ['\x0028','\x571F','\x0029']),
		('\x3230',MkDecomposition DCCompat ['\x0028','\x65E5','\x0029']),
		('\x3231',MkDecomposition DCCompat ['\x0028','\x682A','\x0029']),
		('\x3232',MkDecomposition DCCompat ['\x0028','\x6709','\x0029']),
		('\x3233',MkDecomposition DCCompat ['\x0028','\x793E','\x0029']),
		('\x3234',MkDecomposition DCCompat ['\x0028','\x540D','\x0029']),
		('\x3235',MkDecomposition DCCompat ['\x0028','\x7279','\x0029']),
		('\x3236',MkDecomposition DCCompat ['\x0028','\x8CA1','\x0029']),
		('\x3237',MkDecomposition DCCompat ['\x0028','\x795D','\x0029']),
		('\x3238',MkDecomposition DCCompat ['\x0028','\x52B4','\x0029']),
		('\x3239',MkDecomposition DCCompat ['\x0028','\x4EE3','\x0029']),
		('\x323A',MkDecomposition DCCompat ['\x0028','\x547C','\x0029']),
		('\x323B',MkDecomposition DCCompat ['\x0028','\x5B66','\x0029']),
		('\x323C',MkDecomposition DCCompat ['\x0028','\x76E3','\x0029']),
		('\x323D',MkDecomposition DCCompat ['\x0028','\x4F01','\x0029']),
		('\x323E',MkDecomposition DCCompat ['\x0028','\x8CC7','\x0029']),
		('\x323F',MkDecomposition DCCompat ['\x0028','\x5354','\x0029']),
		('\x3240',MkDecomposition DCCompat ['\x0028','\x796D','\x0029']),
		('\x3241',MkDecomposition DCCompat ['\x0028','\x4F11','\x0029']),
		('\x3242',MkDecomposition DCCompat ['\x0028','\x81EA','\x0029']),
		('\x3243',MkDecomposition DCCompat ['\x0028','\x81F3','\x0029']),
		('\x3251',MkDecomposition DCCircle ['\x0032','\x0031']),
		('\x3252',MkDecomposition DCCircle ['\x0032','\x0032']),
		('\x3253',MkDecomposition DCCircle ['\x0032','\x0033']),
		('\x3254',MkDecomposition DCCircle ['\x0032','\x0034']),
		('\x3255',MkDecomposition DCCircle ['\x0032','\x0035']),
		('\x3256',MkDecomposition DCCircle ['\x0032','\x0036']),
		('\x3257',MkDecomposition DCCircle ['\x0032','\x0037']),
		('\x3258',MkDecomposition DCCircle ['\x0032','\x0038']),
		('\x3259',MkDecomposition DCCircle ['\x0032','\x0039']),
		('\x325A',MkDecomposition DCCircle ['\x0033','\x0030']),
		('\x325B',MkDecomposition DCCircle ['\x0033','\x0031']),
		('\x325C',MkDecomposition DCCircle ['\x0033','\x0032']),
		('\x325D',MkDecomposition DCCircle ['\x0033','\x0033']),
		('\x325E',MkDecomposition DCCircle ['\x0033','\x0034']),
		('\x325F',MkDecomposition DCCircle ['\x0033','\x0035']),
		('\x3260',MkDecomposition DCCircle ['\x1100']),
		('\x3261',MkDecomposition DCCircle ['\x1102']),
		('\x3262',MkDecomposition DCCircle ['\x1103']),
		('\x3263',MkDecomposition DCCircle ['\x1105']),
		('\x3264',MkDecomposition DCCircle ['\x1106']),
		('\x3265',MkDecomposition DCCircle ['\x1107']),
		('\x3266',MkDecomposition DCCircle ['\x1109']),
		('\x3267',MkDecomposition DCCircle ['\x110B']),
		('\x3268',MkDecomposition DCCircle ['\x110C']),
		('\x3269',MkDecomposition DCCircle ['\x110E']),
		('\x326A',MkDecomposition DCCircle ['\x110F']),
		('\x326B',MkDecomposition DCCircle ['\x1110']),
		('\x326C',MkDecomposition DCCircle ['\x1111']),
		('\x326D',MkDecomposition DCCircle ['\x1112']),
		('\x326E',MkDecomposition DCCircle ['\x1100','\x1161']),
		('\x326F',MkDecomposition DCCircle ['\x1102','\x1161']),
		('\x3270',MkDecomposition DCCircle ['\x1103','\x1161']),
		('\x3271',MkDecomposition DCCircle ['\x1105','\x1161']),
		('\x3272',MkDecomposition DCCircle ['\x1106','\x1161']),
		('\x3273',MkDecomposition DCCircle ['\x1107','\x1161']),
		('\x3274',MkDecomposition DCCircle ['\x1109','\x1161']),
		('\x3275',MkDecomposition DCCircle ['\x110B','\x1161']),
		('\x3276',MkDecomposition DCCircle ['\x110C','\x1161']),
		('\x3277',MkDecomposition DCCircle ['\x110E','\x1161']),
		('\x3278',MkDecomposition DCCircle ['\x110F','\x1161']),
		('\x3279',MkDecomposition DCCircle ['\x1110','\x1161']),
		('\x327A',MkDecomposition DCCircle ['\x1111','\x1161']),
		('\x327B',MkDecomposition DCCircle ['\x1112','\x1161']),
		('\x3280',MkDecomposition DCCircle ['\x4E00']),
		('\x3281',MkDecomposition DCCircle ['\x4E8C']),
		('\x3282',MkDecomposition DCCircle ['\x4E09']),
		('\x3283',MkDecomposition DCCircle ['\x56DB']),
		('\x3284',MkDecomposition DCCircle ['\x4E94']),
		('\x3285',MkDecomposition DCCircle ['\x516D']),
		('\x3286',MkDecomposition DCCircle ['\x4E03']),
		('\x3287',MkDecomposition DCCircle ['\x516B']),
		('\x3288',MkDecomposition DCCircle ['\x4E5D']),
		('\x3289',MkDecomposition DCCircle ['\x5341']),
		('\x328A',MkDecomposition DCCircle ['\x6708']),
		('\x328B',MkDecomposition DCCircle ['\x706B']),
		('\x328C',MkDecomposition DCCircle ['\x6C34']),
		('\x328D',MkDecomposition DCCircle ['\x6728']),
		('\x328E',MkDecomposition DCCircle ['\x91D1']),
		('\x328F',MkDecomposition DCCircle ['\x571F']),
		('\x3290',MkDecomposition DCCircle ['\x65E5']),
		('\x3291',MkDecomposition DCCircle ['\x682A']),
		('\x3292',MkDecomposition DCCircle ['\x6709']),
		('\x3293',MkDecomposition DCCircle ['\x793E']),
		('\x3294',MkDecomposition DCCircle ['\x540D']),
		('\x3295',MkDecomposition DCCircle ['\x7279']),
		('\x3296',MkDecomposition DCCircle ['\x8CA1']),
		('\x3297',MkDecomposition DCCircle ['\x795D']),
		('\x3298',MkDecomposition DCCircle ['\x52B4']),
		('\x3299',MkDecomposition DCCircle ['\x79D8']),
		('\x329A',MkDecomposition DCCircle ['\x7537']),
		('\x329B',MkDecomposition DCCircle ['\x5973']),
		('\x329C',MkDecomposition DCCircle ['\x9069']),
		('\x329D',MkDecomposition DCCircle ['\x512A']),
		('\x329E',MkDecomposition DCCircle ['\x5370']),
		('\x329F',MkDecomposition DCCircle ['\x6CE8']),
		('\x32A0',MkDecomposition DCCircle ['\x9805']),
		('\x32A1',MkDecomposition DCCircle ['\x4F11']),
		('\x32A2',MkDecomposition DCCircle ['\x5199']),
		('\x32A3',MkDecomposition DCCircle ['\x6B63']),
		('\x32A4',MkDecomposition DCCircle ['\x4E0A']),
		('\x32A5',MkDecomposition DCCircle ['\x4E2D']),
		('\x32A6',MkDecomposition DCCircle ['\x4E0B']),
		('\x32A7',MkDecomposition DCCircle ['\x5DE6']),
		('\x32A8',MkDecomposition DCCircle ['\x53F3']),
		('\x32A9',MkDecomposition DCCircle ['\x533B']),
		('\x32AA',MkDecomposition DCCircle ['\x5B97']),
		('\x32AB',MkDecomposition DCCircle ['\x5B66']),
		('\x32AC',MkDecomposition DCCircle ['\x76E3']),
		('\x32AD',MkDecomposition DCCircle ['\x4F01']),
		('\x32AE',MkDecomposition DCCircle ['\x8CC7']),
		('\x32AF',MkDecomposition DCCircle ['\x5354']),
		('\x32B0',MkDecomposition DCCircle ['\x591C']),
		('\x32B1',MkDecomposition DCCircle ['\x0033','\x0036']),
		('\x32B2',MkDecomposition DCCircle ['\x0033','\x0037']),
		('\x32B3',MkDecomposition DCCircle ['\x0033','\x0038']),
		('\x32B4',MkDecomposition DCCircle ['\x0033','\x0039']),
		('\x32B5',MkDecomposition DCCircle ['\x0034','\x0030']),
		('\x32B6',MkDecomposition DCCircle ['\x0034','\x0031']),
		('\x32B7',MkDecomposition DCCircle ['\x0034','\x0032']),
		('\x32B8',MkDecomposition DCCircle ['\x0034','\x0033']),
		('\x32B9',MkDecomposition DCCircle ['\x0034','\x0034']),
		('\x32BA',MkDecomposition DCCircle ['\x0034','\x0035']),
		('\x32BB',MkDecomposition DCCircle ['\x0034','\x0036']),
		('\x32BC',MkDecomposition DCCircle ['\x0034','\x0037']),
		('\x32BD',MkDecomposition DCCircle ['\x0034','\x0038']),
		('\x32BE',MkDecomposition DCCircle ['\x0034','\x0039']),
		('\x32BF',MkDecomposition DCCircle ['\x0035','\x0030']),
		('\x32C0',MkDecomposition DCCompat ['\x0031','\x6708']),
		('\x32C1',MkDecomposition DCCompat ['\x0032','\x6708']),
		('\x32C2',MkDecomposition DCCompat ['\x0033','\x6708']),
		('\x32C3',MkDecomposition DCCompat ['\x0034','\x6708']),
		('\x32C4',MkDecomposition DCCompat ['\x0035','\x6708']),
		('\x32C5',MkDecomposition DCCompat ['\x0036','\x6708']),
		('\x32C6',MkDecomposition DCCompat ['\x0037','\x6708']),
		('\x32C7',MkDecomposition DCCompat ['\x0038','\x6708']),
		('\x32C8',MkDecomposition DCCompat ['\x0039','\x6708']),
		('\x32C9',MkDecomposition DCCompat ['\x0031','\x0030','\x6708']),
		('\x32CA',MkDecomposition DCCompat ['\x0031','\x0031','\x6708']),
		('\x32CB',MkDecomposition DCCompat ['\x0031','\x0032','\x6708']),
		('\x32D0',MkDecomposition DCCircle ['\x30A2']),
		('\x32D1',MkDecomposition DCCircle ['\x30A4']),
		('\x32D2',MkDecomposition DCCircle ['\x30A6']),
		('\x32D3',MkDecomposition DCCircle ['\x30A8']),
		('\x32D4',MkDecomposition DCCircle ['\x30AA']),
		('\x32D5',MkDecomposition DCCircle ['\x30AB']),
		('\x32D6',MkDecomposition DCCircle ['\x30AD']),
		('\x32D7',MkDecomposition DCCircle ['\x30AF']),
		('\x32D8',MkDecomposition DCCircle ['\x30B1']),
		('\x32D9',MkDecomposition DCCircle ['\x30B3']),
		('\x32DA',MkDecomposition DCCircle ['\x30B5']),
		('\x32DB',MkDecomposition DCCircle ['\x30B7']),
		('\x32DC',MkDecomposition DCCircle ['\x30B9']),
		('\x32DD',MkDecomposition DCCircle ['\x30BB']),
		('\x32DE',MkDecomposition DCCircle ['\x30BD']),
		('\x32DF',MkDecomposition DCCircle ['\x30BF']),
		('\x32E0',MkDecomposition DCCircle ['\x30C1']),
		('\x32E1',MkDecomposition DCCircle ['\x30C4']),
		('\x32E2',MkDecomposition DCCircle ['\x30C6']),
		('\x32E3',MkDecomposition DCCircle ['\x30C8']),
		('\x32E4',MkDecomposition DCCircle ['\x30CA']),
		('\x32E5',MkDecomposition DCCircle ['\x30CB']),
		('\x32E6',MkDecomposition DCCircle ['\x30CC']),
		('\x32E7',MkDecomposition DCCircle ['\x30CD']),
		('\x32E8',MkDecomposition DCCircle ['\x30CE']),
		('\x32E9',MkDecomposition DCCircle ['\x30CF']),
		('\x32EA',MkDecomposition DCCircle ['\x30D2']),
		('\x32EB',MkDecomposition DCCircle ['\x30D5']),
		('\x32EC',MkDecomposition DCCircle ['\x30D8']),
		('\x32ED',MkDecomposition DCCircle ['\x30DB']),
		('\x32EE',MkDecomposition DCCircle ['\x30DE']),
		('\x32EF',MkDecomposition DCCircle ['\x30DF']),
		('\x32F0',MkDecomposition DCCircle ['\x30E0']),
		('\x32F1',MkDecomposition DCCircle ['\x30E1']),
		('\x32F2',MkDecomposition DCCircle ['\x30E2']),
		('\x32F3',MkDecomposition DCCircle ['\x30E4']),
		('\x32F4',MkDecomposition DCCircle ['\x30E6']),
		('\x32F5',MkDecomposition DCCircle ['\x30E8']),
		('\x32F6',MkDecomposition DCCircle ['\x30E9']),
		('\x32F7',MkDecomposition DCCircle ['\x30EA']),
		('\x32F8',MkDecomposition DCCircle ['\x30EB']),
		('\x32F9',MkDecomposition DCCircle ['\x30EC']),
		('\x32FA',MkDecomposition DCCircle ['\x30ED']),
		('\x32FB',MkDecomposition DCCircle ['\x30EF']),
		('\x32FC',MkDecomposition DCCircle ['\x30F0']),
		('\x32FD',MkDecomposition DCCircle ['\x30F1']),
		('\x32FE',MkDecomposition DCCircle ['\x30F2']),
		('\x3300',MkDecomposition DCSquare ['\x30A2','\x30D1','\x30FC','\x30C8']),
		('\x3301',MkDecomposition DCSquare ['\x30A2','\x30EB','\x30D5','\x30A1']),
		('\x3302',MkDecomposition DCSquare ['\x30A2','\x30F3','\x30DA','\x30A2']),
		('\x3303',MkDecomposition DCSquare ['\x30A2','\x30FC','\x30EB']),
		('\x3304',MkDecomposition DCSquare ['\x30A4','\x30CB','\x30F3','\x30B0']),
		('\x3305',MkDecomposition DCSquare ['\x30A4','\x30F3','\x30C1']),
		('\x3306',MkDecomposition DCSquare ['\x30A6','\x30A9','\x30F3']),
		('\x3307',MkDecomposition DCSquare ['\x30A8','\x30B9','\x30AF','\x30FC','\x30C9']),
		('\x3308',MkDecomposition DCSquare ['\x30A8','\x30FC','\x30AB','\x30FC']),
		('\x3309',MkDecomposition DCSquare ['\x30AA','\x30F3','\x30B9']),
		('\x330A',MkDecomposition DCSquare ['\x30AA','\x30FC','\x30E0']),
		('\x330B',MkDecomposition DCSquare ['\x30AB','\x30A4','\x30EA']),
		('\x330C',MkDecomposition DCSquare ['\x30AB','\x30E9','\x30C3','\x30C8']),
		('\x330D',MkDecomposition DCSquare ['\x30AB','\x30ED','\x30EA','\x30FC']),
		('\x330E',MkDecomposition DCSquare ['\x30AC','\x30ED','\x30F3']),
		('\x330F',MkDecomposition DCSquare ['\x30AC','\x30F3','\x30DE']),
		('\x3310',MkDecomposition DCSquare ['\x30AE','\x30AC']),
		('\x3311',MkDecomposition DCSquare ['\x30AE','\x30CB','\x30FC']),
		('\x3312',MkDecomposition DCSquare ['\x30AD','\x30E5','\x30EA','\x30FC']),
		('\x3313',MkDecomposition DCSquare ['\x30AE','\x30EB','\x30C0','\x30FC']),
		('\x3314',MkDecomposition DCSquare ['\x30AD','\x30ED']),
		('\x3315',MkDecomposition DCSquare ['\x30AD','\x30ED','\x30B0','\x30E9','\x30E0']),
		('\x3316',MkDecomposition DCSquare ['\x30AD','\x30ED','\x30E1','\x30FC','\x30C8','\x30EB']),
		('\x3317',MkDecomposition DCSquare ['\x30AD','\x30ED','\x30EF','\x30C3','\x30C8']),
		('\x3318',MkDecomposition DCSquare ['\x30B0','\x30E9','\x30E0']),
		('\x3319',MkDecomposition DCSquare ['\x30B0','\x30E9','\x30E0','\x30C8','\x30F3']),
		('\x331A',MkDecomposition DCSquare ['\x30AF','\x30EB','\x30BC','\x30A4','\x30ED']),
		('\x331B',MkDecomposition DCSquare ['\x30AF','\x30ED','\x30FC','\x30CD']),
		('\x331C',MkDecomposition DCSquare ['\x30B1','\x30FC','\x30B9']),
		('\x331D',MkDecomposition DCSquare ['\x30B3','\x30EB','\x30CA']),
		('\x331E',MkDecomposition DCSquare ['\x30B3','\x30FC','\x30DD']),
		('\x331F',MkDecomposition DCSquare ['\x30B5','\x30A4','\x30AF','\x30EB']),
		('\x3320',MkDecomposition DCSquare ['\x30B5','\x30F3','\x30C1','\x30FC','\x30E0']),
		('\x3321',MkDecomposition DCSquare ['\x30B7','\x30EA','\x30F3','\x30B0']),
		('\x3322',MkDecomposition DCSquare ['\x30BB','\x30F3','\x30C1']),
		('\x3323',MkDecomposition DCSquare ['\x30BB','\x30F3','\x30C8']),
		('\x3324',MkDecomposition DCSquare ['\x30C0','\x30FC','\x30B9']),
		('\x3325',MkDecomposition DCSquare ['\x30C7','\x30B7']),
		('\x3326',MkDecomposition DCSquare ['\x30C9','\x30EB']),
		('\x3327',MkDecomposition DCSquare ['\x30C8','\x30F3']),
		('\x3328',MkDecomposition DCSquare ['\x30CA','\x30CE']),
		('\x3329',MkDecomposition DCSquare ['\x30CE','\x30C3','\x30C8']),
		('\x332A',MkDecomposition DCSquare ['\x30CF','\x30A4','\x30C4']),
		('\x332B',MkDecomposition DCSquare ['\x30D1','\x30FC','\x30BB','\x30F3','\x30C8']),
		('\x332C',MkDecomposition DCSquare ['\x30D1','\x30FC','\x30C4']),
		('\x332D',MkDecomposition DCSquare ['\x30D0','\x30FC','\x30EC','\x30EB']),
		('\x332E',MkDecomposition DCSquare ['\x30D4','\x30A2','\x30B9','\x30C8','\x30EB']),
		('\x332F',MkDecomposition DCSquare ['\x30D4','\x30AF','\x30EB']),
		('\x3330',MkDecomposition DCSquare ['\x30D4','\x30B3']),
		('\x3331',MkDecomposition DCSquare ['\x30D3','\x30EB']),
		('\x3332',MkDecomposition DCSquare ['\x30D5','\x30A1','\x30E9','\x30C3','\x30C9']),
		('\x3333',MkDecomposition DCSquare ['\x30D5','\x30A3','\x30FC','\x30C8']),
		('\x3334',MkDecomposition DCSquare ['\x30D6','\x30C3','\x30B7','\x30A7','\x30EB']),
		('\x3335',MkDecomposition DCSquare ['\x30D5','\x30E9','\x30F3']),
		('\x3336',MkDecomposition DCSquare ['\x30D8','\x30AF','\x30BF','\x30FC','\x30EB']),
		('\x3337',MkDecomposition DCSquare ['\x30DA','\x30BD']),
		('\x3338',MkDecomposition DCSquare ['\x30DA','\x30CB','\x30D2']),
		('\x3339',MkDecomposition DCSquare ['\x30D8','\x30EB','\x30C4']),
		('\x333A',MkDecomposition DCSquare ['\x30DA','\x30F3','\x30B9']),
		('\x333B',MkDecomposition DCSquare ['\x30DA','\x30FC','\x30B8']),
		('\x333C',MkDecomposition DCSquare ['\x30D9','\x30FC','\x30BF']),
		('\x333D',MkDecomposition DCSquare ['\x30DD','\x30A4','\x30F3','\x30C8']),
		('\x333E',MkDecomposition DCSquare ['\x30DC','\x30EB','\x30C8']),
		('\x333F',MkDecomposition DCSquare ['\x30DB','\x30F3']),
		('\x3340',MkDecomposition DCSquare ['\x30DD','\x30F3','\x30C9']),
		('\x3341',MkDecomposition DCSquare ['\x30DB','\x30FC','\x30EB']),
		('\x3342',MkDecomposition DCSquare ['\x30DB','\x30FC','\x30F3']),
		('\x3343',MkDecomposition DCSquare ['\x30DE','\x30A4','\x30AF','\x30ED']),
		('\x3344',MkDecomposition DCSquare ['\x30DE','\x30A4','\x30EB']),
		('\x3345',MkDecomposition DCSquare ['\x30DE','\x30C3','\x30CF']),
		('\x3346',MkDecomposition DCSquare ['\x30DE','\x30EB','\x30AF']),
		('\x3347',MkDecomposition DCSquare ['\x30DE','\x30F3','\x30B7','\x30E7','\x30F3']),
		('\x3348',MkDecomposition DCSquare ['\x30DF','\x30AF','\x30ED','\x30F3']),
		('\x3349',MkDecomposition DCSquare ['\x30DF','\x30EA']),
		('\x334A',MkDecomposition DCSquare ['\x30DF','\x30EA','\x30D0','\x30FC','\x30EB']),
		('\x334B',MkDecomposition DCSquare ['\x30E1','\x30AC']),
		('\x334C',MkDecomposition DCSquare ['\x30E1','\x30AC','\x30C8','\x30F3']),
		('\x334D',MkDecomposition DCSquare ['\x30E1','\x30FC','\x30C8','\x30EB']),
		('\x334E',MkDecomposition DCSquare ['\x30E4','\x30FC','\x30C9']),
		('\x334F',MkDecomposition DCSquare ['\x30E4','\x30FC','\x30EB']),
		('\x3350',MkDecomposition DCSquare ['\x30E6','\x30A2','\x30F3']),
		('\x3351',MkDecomposition DCSquare ['\x30EA','\x30C3','\x30C8','\x30EB']),
		('\x3352',MkDecomposition DCSquare ['\x30EA','\x30E9']),
		('\x3353',MkDecomposition DCSquare ['\x30EB','\x30D4','\x30FC']),
		('\x3354',MkDecomposition DCSquare ['\x30EB','\x30FC','\x30D6','\x30EB']),
		('\x3355',MkDecomposition DCSquare ['\x30EC','\x30E0']),
		('\x3356',MkDecomposition DCSquare ['\x30EC','\x30F3','\x30C8','\x30B2','\x30F3']),
		('\x3357',MkDecomposition DCSquare ['\x30EF','\x30C3','\x30C8']),
		('\x3358',MkDecomposition DCCompat ['\x0030','\x70B9']),
		('\x3359',MkDecomposition DCCompat ['\x0031','\x70B9']),
		('\x335A',MkDecomposition DCCompat ['\x0032','\x70B9']),
		('\x335B',MkDecomposition DCCompat ['\x0033','\x70B9']),
		('\x335C',MkDecomposition DCCompat ['\x0034','\x70B9']),
		('\x335D',MkDecomposition DCCompat ['\x0035','\x70B9']),
		('\x335E',MkDecomposition DCCompat ['\x0036','\x70B9']),
		('\x335F',MkDecomposition DCCompat ['\x0037','\x70B9']),
		('\x3360',MkDecomposition DCCompat ['\x0038','\x70B9']),
		('\x3361',MkDecomposition DCCompat ['\x0039','\x70B9']),
		('\x3362',MkDecomposition DCCompat ['\x0031','\x0030','\x70B9']),
		('\x3363',MkDecomposition DCCompat ['\x0031','\x0031','\x70B9']),
		('\x3364',MkDecomposition DCCompat ['\x0031','\x0032','\x70B9']),
		('\x3365',MkDecomposition DCCompat ['\x0031','\x0033','\x70B9']),
		('\x3366',MkDecomposition DCCompat ['\x0031','\x0034','\x70B9']),
		('\x3367',MkDecomposition DCCompat ['\x0031','\x0035','\x70B9']),
		('\x3368',MkDecomposition DCCompat ['\x0031','\x0036','\x70B9']),
		('\x3369',MkDecomposition DCCompat ['\x0031','\x0037','\x70B9']),
		('\x336A',MkDecomposition DCCompat ['\x0031','\x0038','\x70B9']),
		('\x336B',MkDecomposition DCCompat ['\x0031','\x0039','\x70B9']),
		('\x336C',MkDecomposition DCCompat ['\x0032','\x0030','\x70B9']),
		('\x336D',MkDecomposition DCCompat ['\x0032','\x0031','\x70B9']),
		('\x336E',MkDecomposition DCCompat ['\x0032','\x0032','\x70B9']),
		('\x336F',MkDecomposition DCCompat ['\x0032','\x0033','\x70B9']),
		('\x3370',MkDecomposition DCCompat ['\x0032','\x0034','\x70B9']),
		('\x3371',MkDecomposition DCSquare ['\x0068','\x0050','\x0061']),
		('\x3372',MkDecomposition DCSquare ['\x0064','\x0061']),
		('\x3373',MkDecomposition DCSquare ['\x0041','\x0055']),
		('\x3374',MkDecomposition DCSquare ['\x0062','\x0061','\x0072']),
		('\x3375',MkDecomposition DCSquare ['\x006F','\x0056']),
		('\x3376',MkDecomposition DCSquare ['\x0070','\x0063']),
		('\x337B',MkDecomposition DCSquare ['\x5E73','\x6210']),
		('\x337C',MkDecomposition DCSquare ['\x662D','\x548C']),
		('\x337D',MkDecomposition DCSquare ['\x5927','\x6B63']),
		('\x337E',MkDecomposition DCSquare ['\x660E','\x6CBB']),
		('\x337F',MkDecomposition DCSquare ['\x682A','\x5F0F','\x4F1A','\x793E']),
		('\x3380',MkDecomposition DCSquare ['\x0070','\x0041']),
		('\x3381',MkDecomposition DCSquare ['\x006E','\x0041']),
		('\x3382',MkDecomposition DCSquare ['\x03BC','\x0041']),
		('\x3383',MkDecomposition DCSquare ['\x006D','\x0041']),
		('\x3384',MkDecomposition DCSquare ['\x006B','\x0041']),
		('\x3385',MkDecomposition DCSquare ['\x004B','\x0042']),
		('\x3386',MkDecomposition DCSquare ['\x004D','\x0042']),
		('\x3387',MkDecomposition DCSquare ['\x0047','\x0042']),
		('\x3388',MkDecomposition DCSquare ['\x0063','\x0061','\x006C']),
		('\x3389',MkDecomposition DCSquare ['\x006B','\x0063','\x0061','\x006C']),
		('\x338A',MkDecomposition DCSquare ['\x0070','\x0046']),
		('\x338B',MkDecomposition DCSquare ['\x006E','\x0046']),
		('\x338C',MkDecomposition DCSquare ['\x03BC','\x0046']),
		('\x338D',MkDecomposition DCSquare ['\x03BC','\x0067']),
		('\x338E',MkDecomposition DCSquare ['\x006D','\x0067']),
		('\x338F',MkDecomposition DCSquare ['\x006B','\x0067']),
		('\x3390',MkDecomposition DCSquare ['\x0048','\x007A']),
		('\x3391',MkDecomposition DCSquare ['\x006B','\x0048','\x007A']),
		('\x3392',MkDecomposition DCSquare ['\x004D','\x0048','\x007A']),
		('\x3393',MkDecomposition DCSquare ['\x0047','\x0048','\x007A']),
		('\x3394',MkDecomposition DCSquare ['\x0054','\x0048','\x007A']),
		('\x3395',MkDecomposition DCSquare ['\x03BC','\x2113']),
		('\x3396',MkDecomposition DCSquare ['\x006D','\x2113']),
		('\x3397',MkDecomposition DCSquare ['\x0064','\x2113']),
		('\x3398',MkDecomposition DCSquare ['\x006B','\x2113']),
		('\x3399',MkDecomposition DCSquare ['\x0066','\x006D']),
		('\x339A',MkDecomposition DCSquare ['\x006E','\x006D']),
		('\x339B',MkDecomposition DCSquare ['\x03BC','\x006D']),
		('\x339C',MkDecomposition DCSquare ['\x006D','\x006D']),
		('\x339D',MkDecomposition DCSquare ['\x0063','\x006D']),
		('\x339E',MkDecomposition DCSquare ['\x006B','\x006D']),
		('\x339F',MkDecomposition DCSquare ['\x006D','\x006D','\x00B2']),
		('\x33A0',MkDecomposition DCSquare ['\x0063','\x006D','\x00B2']),
		('\x33A1',MkDecomposition DCSquare ['\x006D','\x00B2']),
		('\x33A2',MkDecomposition DCSquare ['\x006B','\x006D','\x00B2']),
		('\x33A3',MkDecomposition DCSquare ['\x006D','\x006D','\x00B3']),
		('\x33A4',MkDecomposition DCSquare ['\x0063','\x006D','\x00B3']),
		('\x33A5',MkDecomposition DCSquare ['\x006D','\x00B3']),
		('\x33A6',MkDecomposition DCSquare ['\x006B','\x006D','\x00B3']),
		('\x33A7',MkDecomposition DCSquare ['\x006D','\x2215','\x0073']),
		('\x33A8',MkDecomposition DCSquare ['\x006D','\x2215','\x0073','\x00B2']),
		('\x33A9',MkDecomposition DCSquare ['\x0050','\x0061']),
		('\x33AA',MkDecomposition DCSquare ['\x006B','\x0050','\x0061']),
		('\x33AB',MkDecomposition DCSquare ['\x004D','\x0050','\x0061']),
		('\x33AC',MkDecomposition DCSquare ['\x0047','\x0050','\x0061']),
		('\x33AD',MkDecomposition DCSquare ['\x0072','\x0061','\x0064']),
		('\x33AE',MkDecomposition DCSquare ['\x0072','\x0061','\x0064','\x2215','\x0073']),
		('\x33AF',MkDecomposition DCSquare ['\x0072','\x0061','\x0064','\x2215','\x0073','\x00B2']),
		('\x33B0',MkDecomposition DCSquare ['\x0070','\x0073']),
		('\x33B1',MkDecomposition DCSquare ['\x006E','\x0073']),
		('\x33B2',MkDecomposition DCSquare ['\x03BC','\x0073']),
		('\x33B3',MkDecomposition DCSquare ['\x006D','\x0073']),
		('\x33B4',MkDecomposition DCSquare ['\x0070','\x0056']),
		('\x33B5',MkDecomposition DCSquare ['\x006E','\x0056']),
		('\x33B6',MkDecomposition DCSquare ['\x03BC','\x0056']),
		('\x33B7',MkDecomposition DCSquare ['\x006D','\x0056']),
		('\x33B8',MkDecomposition DCSquare ['\x006B','\x0056']),
		('\x33B9',MkDecomposition DCSquare ['\x004D','\x0056']),
		('\x33BA',MkDecomposition DCSquare ['\x0070','\x0057']),
		('\x33BB',MkDecomposition DCSquare ['\x006E','\x0057']),
		('\x33BC',MkDecomposition DCSquare ['\x03BC','\x0057']),
		('\x33BD',MkDecomposition DCSquare ['\x006D','\x0057']),
		('\x33BE',MkDecomposition DCSquare ['\x006B','\x0057']),
		('\x33BF',MkDecomposition DCSquare ['\x004D','\x0057']),
		('\x33C0',MkDecomposition DCSquare ['\x006B','\x03A9']),
		('\x33C1',MkDecomposition DCSquare ['\x004D','\x03A9']),
		('\x33C2',MkDecomposition DCSquare ['\x0061','\x002E','\x006D','\x002E']),
		('\x33C3',MkDecomposition DCSquare ['\x0042','\x0071']),
		('\x33C4',MkDecomposition DCSquare ['\x0063','\x0063']),
		('\x33C5',MkDecomposition DCSquare ['\x0063','\x0064']),
		('\x33C6',MkDecomposition DCSquare ['\x0043','\x2215','\x006B','\x0067']),
		('\x33C7',MkDecomposition DCSquare ['\x0043','\x006F','\x002E']),
		('\x33C8',MkDecomposition DCSquare ['\x0064','\x0042']),
		('\x33C9',MkDecomposition DCSquare ['\x0047','\x0079']),
		('\x33CA',MkDecomposition DCSquare ['\x0068','\x0061']),
		('\x33CB',MkDecomposition DCSquare ['\x0048','\x0050']),
		('\x33CC',MkDecomposition DCSquare ['\x0069','\x006E']),
		('\x33CD',MkDecomposition DCSquare ['\x004B','\x004B']),
		('\x33CE',MkDecomposition DCSquare ['\x004B','\x004D']),
		('\x33CF',MkDecomposition DCSquare ['\x006B','\x0074']),
		('\x33D0',MkDecomposition DCSquare ['\x006C','\x006D']),
		('\x33D1',MkDecomposition DCSquare ['\x006C','\x006E']),
		('\x33D2',MkDecomposition DCSquare ['\x006C','\x006F','\x0067']),
		('\x33D3',MkDecomposition DCSquare ['\x006C','\x0078']),
		('\x33D4',MkDecomposition DCSquare ['\x006D','\x0062']),
		('\x33D5',MkDecomposition DCSquare ['\x006D','\x0069','\x006C']),
		('\x33D6',MkDecomposition DCSquare ['\x006D','\x006F','\x006C']),
		('\x33D7',MkDecomposition DCSquare ['\x0050','\x0048']),
		('\x33D8',MkDecomposition DCSquare ['\x0070','\x002E','\x006D','\x002E']),
		('\x33D9',MkDecomposition DCSquare ['\x0050','\x0050','\x004D']),
		('\x33DA',MkDecomposition DCSquare ['\x0050','\x0052']),
		('\x33DB',MkDecomposition DCSquare ['\x0073','\x0072']),
		('\x33DC',MkDecomposition DCSquare ['\x0053','\x0076']),
		('\x33DD',MkDecomposition DCSquare ['\x0057','\x0062']),
		('\x33E0',MkDecomposition DCCompat ['\x0031','\x65E5']),
		('\x33E1',MkDecomposition DCCompat ['\x0032','\x65E5']),
		('\x33E2',MkDecomposition DCCompat ['\x0033','\x65E5']),
		('\x33E3',MkDecomposition DCCompat ['\x0034','\x65E5']),
		('\x33E4',MkDecomposition DCCompat ['\x0035','\x65E5']),
		('\x33E5',MkDecomposition DCCompat ['\x0036','\x65E5']),
		('\x33E6',MkDecomposition DCCompat ['\x0037','\x65E5']),
		('\x33E7',MkDecomposition DCCompat ['\x0038','\x65E5']),
		('\x33E8',MkDecomposition DCCompat ['\x0039','\x65E5']),
		('\x33E9',MkDecomposition DCCompat ['\x0031','\x0030','\x65E5']),
		('\x33EA',MkDecomposition DCCompat ['\x0031','\x0031','\x65E5']),
		('\x33EB',MkDecomposition DCCompat ['\x0031','\x0032','\x65E5']),
		('\x33EC',MkDecomposition DCCompat ['\x0031','\x0033','\x65E5']),
		('\x33ED',MkDecomposition DCCompat ['\x0031','\x0034','\x65E5']),
		('\x33EE',MkDecomposition DCCompat ['\x0031','\x0035','\x65E5']),
		('\x33EF',MkDecomposition DCCompat ['\x0031','\x0036','\x65E5']),
		('\x33F0',MkDecomposition DCCompat ['\x0031','\x0037','\x65E5']),
		('\x33F1',MkDecomposition DCCompat ['\x0031','\x0038','\x65E5']),
		('\x33F2',MkDecomposition DCCompat ['\x0031','\x0039','\x65E5']),
		('\x33F3',MkDecomposition DCCompat ['\x0032','\x0030','\x65E5']),
		('\x33F4',MkDecomposition DCCompat ['\x0032','\x0031','\x65E5']),
		('\x33F5',MkDecomposition DCCompat ['\x0032','\x0032','\x65E5']),
		('\x33F6',MkDecomposition DCCompat ['\x0032','\x0033','\x65E5']),
		('\x33F7',MkDecomposition DCCompat ['\x0032','\x0034','\x65E5']),
		('\x33F8',MkDecomposition DCCompat ['\x0032','\x0035','\x65E5']),
		('\x33F9',MkDecomposition DCCompat ['\x0032','\x0036','\x65E5']),
		('\x33FA',MkDecomposition DCCompat ['\x0032','\x0037','\x65E5']),
		('\x33FB',MkDecomposition DCCompat ['\x0032','\x0038','\x65E5']),
		('\x33FC',MkDecomposition DCCompat ['\x0032','\x0039','\x65E5']),
		('\x33FD',MkDecomposition DCCompat ['\x0033','\x0030','\x65E5']),
		('\x33FE',MkDecomposition DCCompat ['\x0033','\x0031','\x65E5']),
		('\xF900',MkDecomposition DCCanonical ['\x8C48']),
		('\xF901',MkDecomposition DCCanonical ['\x66F4']),
		('\xF902',MkDecomposition DCCanonical ['\x8ECA']),
		('\xF903',MkDecomposition DCCanonical ['\x8CC8']),
		('\xF904',MkDecomposition DCCanonical ['\x6ED1']),
		('\xF905',MkDecomposition DCCanonical ['\x4E32']),
		('\xF906',MkDecomposition DCCanonical ['\x53E5']),
		('\xF907',MkDecomposition DCCanonical ['\x9F9C']),
		('\xF908',MkDecomposition DCCanonical ['\x9F9C']),
		('\xF909',MkDecomposition DCCanonical ['\x5951']),
		('\xF90A',MkDecomposition DCCanonical ['\x91D1']),
		('\xF90B',MkDecomposition DCCanonical ['\x5587']),
		('\xF90C',MkDecomposition DCCanonical ['\x5948']),
		('\xF90D',MkDecomposition DCCanonical ['\x61F6']),
		('\xF90E',MkDecomposition DCCanonical ['\x7669']),
		('\xF90F',MkDecomposition DCCanonical ['\x7F85']),
		('\xF910',MkDecomposition DCCanonical ['\x863F']),
		('\xF911',MkDecomposition DCCanonical ['\x87BA']),
		('\xF912',MkDecomposition DCCanonical ['\x88F8']),
		('\xF913',MkDecomposition DCCanonical ['\x908F']),
		('\xF914',MkDecomposition DCCanonical ['\x6A02']),
		('\xF915',MkDecomposition DCCanonical ['\x6D1B']),
		('\xF916',MkDecomposition DCCanonical ['\x70D9']),
		('\xF917',MkDecomposition DCCanonical ['\x73DE']),
		('\xF918',MkDecomposition DCCanonical ['\x843D']),
		('\xF919',MkDecomposition DCCanonical ['\x916A']),
		('\xF91A',MkDecomposition DCCanonical ['\x99F1']),
		('\xF91B',MkDecomposition DCCanonical ['\x4E82']),
		('\xF91C',MkDecomposition DCCanonical ['\x5375']),
		('\xF91D',MkDecomposition DCCanonical ['\x6B04']),
		('\xF91E',MkDecomposition DCCanonical ['\x721B']),
		('\xF91F',MkDecomposition DCCanonical ['\x862D']),
		('\xF920',MkDecomposition DCCanonical ['\x9E1E']),
		('\xF921',MkDecomposition DCCanonical ['\x5D50']),
		('\xF922',MkDecomposition DCCanonical ['\x6FEB']),
		('\xF923',MkDecomposition DCCanonical ['\x85CD']),
		('\xF924',MkDecomposition DCCanonical ['\x8964']),
		('\xF925',MkDecomposition DCCanonical ['\x62C9']),
		('\xF926',MkDecomposition DCCanonical ['\x81D8']),
		('\xF927',MkDecomposition DCCanonical ['\x881F']),
		('\xF928',MkDecomposition DCCanonical ['\x5ECA']),
		('\xF929',MkDecomposition DCCanonical ['\x6717']),
		('\xF92A',MkDecomposition DCCanonical ['\x6D6A']),
		('\xF92B',MkDecomposition DCCanonical ['\x72FC']),
		('\xF92C',MkDecomposition DCCanonical ['\x90CE']),
		('\xF92D',MkDecomposition DCCanonical ['\x4F86']),
		('\xF92E',MkDecomposition DCCanonical ['\x51B7']),
		('\xF92F',MkDecomposition DCCanonical ['\x52DE']),
		('\xF930',MkDecomposition DCCanonical ['\x64C4']),
		('\xF931',MkDecomposition DCCanonical ['\x6AD3']),
		('\xF932',MkDecomposition DCCanonical ['\x7210']),
		('\xF933',MkDecomposition DCCanonical ['\x76E7']),
		('\xF934',MkDecomposition DCCanonical ['\x8001']),
		('\xF935',MkDecomposition DCCanonical ['\x8606']),
		('\xF936',MkDecomposition DCCanonical ['\x865C']),
		('\xF937',MkDecomposition DCCanonical ['\x8DEF']),
		('\xF938',MkDecomposition DCCanonical ['\x9732']),
		('\xF939',MkDecomposition DCCanonical ['\x9B6F']),
		('\xF93A',MkDecomposition DCCanonical ['\x9DFA']),
		('\xF93B',MkDecomposition DCCanonical ['\x788C']),
		('\xF93C',MkDecomposition DCCanonical ['\x797F']),
		('\xF93D',MkDecomposition DCCanonical ['\x7DA0']),
		('\xF93E',MkDecomposition DCCanonical ['\x83C9']),
		('\xF93F',MkDecomposition DCCanonical ['\x9304']),
		('\xF940',MkDecomposition DCCanonical ['\x9E7F']),
		('\xF941',MkDecomposition DCCanonical ['\x8AD6']),
		('\xF942',MkDecomposition DCCanonical ['\x58DF']),
		('\xF943',MkDecomposition DCCanonical ['\x5F04']),
		('\xF944',MkDecomposition DCCanonical ['\x7C60']),
		('\xF945',MkDecomposition DCCanonical ['\x807E']),
		('\xF946',MkDecomposition DCCanonical ['\x7262']),
		('\xF947',MkDecomposition DCCanonical ['\x78CA']),
		('\xF948',MkDecomposition DCCanonical ['\x8CC2']),
		('\xF949',MkDecomposition DCCanonical ['\x96F7']),
		('\xF94A',MkDecomposition DCCanonical ['\x58D8']),
		('\xF94B',MkDecomposition DCCanonical ['\x5C62']),
		('\xF94C',MkDecomposition DCCanonical ['\x6A13']),
		('\xF94D',MkDecomposition DCCanonical ['\x6DDA']),
		('\xF94E',MkDecomposition DCCanonical ['\x6F0F']),
		('\xF94F',MkDecomposition DCCanonical ['\x7D2F']),
		('\xF950',MkDecomposition DCCanonical ['\x7E37']),
		('\xF951',MkDecomposition DCCanonical ['\x964B']),
		('\xF952',MkDecomposition DCCanonical ['\x52D2']),
		('\xF953',MkDecomposition DCCanonical ['\x808B']),
		('\xF954',MkDecomposition DCCanonical ['\x51DC']),
		('\xF955',MkDecomposition DCCanonical ['\x51CC']),
		('\xF956',MkDecomposition DCCanonical ['\x7A1C']),
		('\xF957',MkDecomposition DCCanonical ['\x7DBE']),
		('\xF958',MkDecomposition DCCanonical ['\x83F1']),
		('\xF959',MkDecomposition DCCanonical ['\x9675']),
		('\xF95A',MkDecomposition DCCanonical ['\x8B80']),
		('\xF95B',MkDecomposition DCCanonical ['\x62CF']),
		('\xF95C',MkDecomposition DCCanonical ['\x6A02']),
		('\xF95D',MkDecomposition DCCanonical ['\x8AFE']),
		('\xF95E',MkDecomposition DCCanonical ['\x4E39']),
		('\xF95F',MkDecomposition DCCanonical ['\x5BE7']),
		('\xF960',MkDecomposition DCCanonical ['\x6012']),
		('\xF961',MkDecomposition DCCanonical ['\x7387']),
		('\xF962',MkDecomposition DCCanonical ['\x7570']),
		('\xF963',MkDecomposition DCCanonical ['\x5317']),
		('\xF964',MkDecomposition DCCanonical ['\x78FB']),
		('\xF965',MkDecomposition DCCanonical ['\x4FBF']),
		('\xF966',MkDecomposition DCCanonical ['\x5FA9']),
		('\xF967',MkDecomposition DCCanonical ['\x4E0D']),
		('\xF968',MkDecomposition DCCanonical ['\x6CCC']),
		('\xF969',MkDecomposition DCCanonical ['\x6578']),
		('\xF96A',MkDecomposition DCCanonical ['\x7D22']),
		('\xF96B',MkDecomposition DCCanonical ['\x53C3']),
		('\xF96C',MkDecomposition DCCanonical ['\x585E']),
		('\xF96D',MkDecomposition DCCanonical ['\x7701']),
		('\xF96E',MkDecomposition DCCanonical ['\x8449']),
		('\xF96F',MkDecomposition DCCanonical ['\x8AAA']),
		('\xF970',MkDecomposition DCCanonical ['\x6BBA']),
		('\xF971',MkDecomposition DCCanonical ['\x8FB0']),
		('\xF972',MkDecomposition DCCanonical ['\x6C88']),
		('\xF973',MkDecomposition DCCanonical ['\x62FE']),
		('\xF974',MkDecomposition DCCanonical ['\x82E5']),
		('\xF975',MkDecomposition DCCanonical ['\x63A0']),
		('\xF976',MkDecomposition DCCanonical ['\x7565']),
		('\xF977',MkDecomposition DCCanonical ['\x4EAE']),
		('\xF978',MkDecomposition DCCanonical ['\x5169']),
		('\xF979',MkDecomposition DCCanonical ['\x51C9']),
		('\xF97A',MkDecomposition DCCanonical ['\x6881']),
		('\xF97B',MkDecomposition DCCanonical ['\x7CE7']),
		('\xF97C',MkDecomposition DCCanonical ['\x826F']),
		('\xF97D',MkDecomposition DCCanonical ['\x8AD2']),
		('\xF97E',MkDecomposition DCCanonical ['\x91CF']),
		('\xF97F',MkDecomposition DCCanonical ['\x52F5']),
		('\xF980',MkDecomposition DCCanonical ['\x5442']),
		('\xF981',MkDecomposition DCCanonical ['\x5973']),
		('\xF982',MkDecomposition DCCanonical ['\x5EEC']),
		('\xF983',MkDecomposition DCCanonical ['\x65C5']),
		('\xF984',MkDecomposition DCCanonical ['\x6FFE']),
		('\xF985',MkDecomposition DCCanonical ['\x792A']),
		('\xF986',MkDecomposition DCCanonical ['\x95AD']),
		('\xF987',MkDecomposition DCCanonical ['\x9A6A']),
		('\xF988',MkDecomposition DCCanonical ['\x9E97']),
		('\xF989',MkDecomposition DCCanonical ['\x9ECE']),
		('\xF98A',MkDecomposition DCCanonical ['\x529B']),
		('\xF98B',MkDecomposition DCCanonical ['\x66C6']),
		('\xF98C',MkDecomposition DCCanonical ['\x6B77']),
		('\xF98D',MkDecomposition DCCanonical ['\x8F62']),
		('\xF98E',MkDecomposition DCCanonical ['\x5E74']),
		('\xF98F',MkDecomposition DCCanonical ['\x6190']),
		('\xF990',MkDecomposition DCCanonical ['\x6200']),
		('\xF991',MkDecomposition DCCanonical ['\x649A']),
		('\xF992',MkDecomposition DCCanonical ['\x6F23']),
		('\xF993',MkDecomposition DCCanonical ['\x7149']),
		('\xF994',MkDecomposition DCCanonical ['\x7489']),
		('\xF995',MkDecomposition DCCanonical ['\x79CA']),
		('\xF996',MkDecomposition DCCanonical ['\x7DF4']),
		('\xF997',MkDecomposition DCCanonical ['\x806F']),
		('\xF998',MkDecomposition DCCanonical ['\x8F26']),
		('\xF999',MkDecomposition DCCanonical ['\x84EE']),
		('\xF99A',MkDecomposition DCCanonical ['\x9023']),
		('\xF99B',MkDecomposition DCCanonical ['\x934A']),
		('\xF99C',MkDecomposition DCCanonical ['\x5217']),
		('\xF99D',MkDecomposition DCCanonical ['\x52A3']),
		('\xF99E',MkDecomposition DCCanonical ['\x54BD']),
		('\xF99F',MkDecomposition DCCanonical ['\x70C8']),
		('\xF9A0',MkDecomposition DCCanonical ['\x88C2']),
		('\xF9A1',MkDecomposition DCCanonical ['\x8AAA']),
		('\xF9A2',MkDecomposition DCCanonical ['\x5EC9']),
		('\xF9A3',MkDecomposition DCCanonical ['\x5FF5']),
		('\xF9A4',MkDecomposition DCCanonical ['\x637B']),
		('\xF9A5',MkDecomposition DCCanonical ['\x6BAE']),
		('\xF9A6',MkDecomposition DCCanonical ['\x7C3E']),
		('\xF9A7',MkDecomposition DCCanonical ['\x7375']),
		('\xF9A8',MkDecomposition DCCanonical ['\x4EE4']),
		('\xF9A9',MkDecomposition DCCanonical ['\x56F9']),
		('\xF9AA',MkDecomposition DCCanonical ['\x5BE7']),
		('\xF9AB',MkDecomposition DCCanonical ['\x5DBA']),
		('\xF9AC',MkDecomposition DCCanonical ['\x601C']),
		('\xF9AD',MkDecomposition DCCanonical ['\x73B2']),
		('\xF9AE',MkDecomposition DCCanonical ['\x7469']),
		('\xF9AF',MkDecomposition DCCanonical ['\x7F9A']),
		('\xF9B0',MkDecomposition DCCanonical ['\x8046']),
		('\xF9B1',MkDecomposition DCCanonical ['\x9234']),
		('\xF9B2',MkDecomposition DCCanonical ['\x96F6']),
		('\xF9B3',MkDecomposition DCCanonical ['\x9748']),
		('\xF9B4',MkDecomposition DCCanonical ['\x9818']),
		('\xF9B5',MkDecomposition DCCanonical ['\x4F8B']),
		('\xF9B6',MkDecomposition DCCanonical ['\x79AE']),
		('\xF9B7',MkDecomposition DCCanonical ['\x91B4']),
		('\xF9B8',MkDecomposition DCCanonical ['\x96B8']),
		('\xF9B9',MkDecomposition DCCanonical ['\x60E1']),
		('\xF9BA',MkDecomposition DCCanonical ['\x4E86']),
		('\xF9BB',MkDecomposition DCCanonical ['\x50DA']),
		('\xF9BC',MkDecomposition DCCanonical ['\x5BEE']),
		('\xF9BD',MkDecomposition DCCanonical ['\x5C3F']),
		('\xF9BE',MkDecomposition DCCanonical ['\x6599']),
		('\xF9BF',MkDecomposition DCCanonical ['\x6A02']),
		('\xF9C0',MkDecomposition DCCanonical ['\x71CE']),
		('\xF9C1',MkDecomposition DCCanonical ['\x7642']),
		('\xF9C2',MkDecomposition DCCanonical ['\x84FC']),
		('\xF9C3',MkDecomposition DCCanonical ['\x907C']),
		('\xF9C4',MkDecomposition DCCanonical ['\x9F8D']),
		('\xF9C5',MkDecomposition DCCanonical ['\x6688']),
		('\xF9C6',MkDecomposition DCCanonical ['\x962E']),
		('\xF9C7',MkDecomposition DCCanonical ['\x5289']),
		('\xF9C8',MkDecomposition DCCanonical ['\x677B']),
		('\xF9C9',MkDecomposition DCCanonical ['\x67F3']),
		('\xF9CA',MkDecomposition DCCanonical ['\x6D41']),
		('\xF9CB',MkDecomposition DCCanonical ['\x6E9C']),
		('\xF9CC',MkDecomposition DCCanonical ['\x7409']),
		('\xF9CD',MkDecomposition DCCanonical ['\x7559']),
		('\xF9CE',MkDecomposition DCCanonical ['\x786B']),
		('\xF9CF',MkDecomposition DCCanonical ['\x7D10']),
		('\xF9D0',MkDecomposition DCCanonical ['\x985E']),
		('\xF9D1',MkDecomposition DCCanonical ['\x516D']),
		('\xF9D2',MkDecomposition DCCanonical ['\x622E']),
		('\xF9D3',MkDecomposition DCCanonical ['\x9678']),
		('\xF9D4',MkDecomposition DCCanonical ['\x502B']),
		('\xF9D5',MkDecomposition DCCanonical ['\x5D19']),
		('\xF9D6',MkDecomposition DCCanonical ['\x6DEA']),
		('\xF9D7',MkDecomposition DCCanonical ['\x8F2A']),
		('\xF9D8',MkDecomposition DCCanonical ['\x5F8B']),
		('\xF9D9',MkDecomposition DCCanonical ['\x6144']),
		('\xF9DA',MkDecomposition DCCanonical ['\x6817']),
		('\xF9DB',MkDecomposition DCCanonical ['\x7387']),
		('\xF9DC',MkDecomposition DCCanonical ['\x9686']),
		('\xF9DD',MkDecomposition DCCanonical ['\x5229']),
		('\xF9DE',MkDecomposition DCCanonical ['\x540F']),
		('\xF9DF',MkDecomposition DCCanonical ['\x5C65']),
		('\xF9E0',MkDecomposition DCCanonical ['\x6613']),
		('\xF9E1',MkDecomposition DCCanonical ['\x674E']),
		('\xF9E2',MkDecomposition DCCanonical ['\x68A8']),
		('\xF9E3',MkDecomposition DCCanonical ['\x6CE5']),
		('\xF9E4',MkDecomposition DCCanonical ['\x7406']),
		('\xF9E5',MkDecomposition DCCanonical ['\x75E2']),
		('\xF9E6',MkDecomposition DCCanonical ['\x7F79']),
		('\xF9E7',MkDecomposition DCCanonical ['\x88CF']),
		('\xF9E8',MkDecomposition DCCanonical ['\x88E1']),
		('\xF9E9',MkDecomposition DCCanonical ['\x91CC']),
		('\xF9EA',MkDecomposition DCCanonical ['\x96E2']),
		('\xF9EB',MkDecomposition DCCanonical ['\x533F']),
		('\xF9EC',MkDecomposition DCCanonical ['\x6EBA']),
		('\xF9ED',MkDecomposition DCCanonical ['\x541D']),
		('\xF9EE',MkDecomposition DCCanonical ['\x71D0']),
		('\xF9EF',MkDecomposition DCCanonical ['\x7498']),
		('\xF9F0',MkDecomposition DCCanonical ['\x85FA']),
		('\xF9F1',MkDecomposition DCCanonical ['\x96A3']),
		('\xF9F2',MkDecomposition DCCanonical ['\x9C57']),
		('\xF9F3',MkDecomposition DCCanonical ['\x9E9F']),
		('\xF9F4',MkDecomposition DCCanonical ['\x6797']),
		('\xF9F5',MkDecomposition DCCanonical ['\x6DCB']),
		('\xF9F6',MkDecomposition DCCanonical ['\x81E8']),
		('\xF9F7',MkDecomposition DCCanonical ['\x7ACB']),
		('\xF9F8',MkDecomposition DCCanonical ['\x7B20']),
		('\xF9F9',MkDecomposition DCCanonical ['\x7C92']),
		('\xF9FA',MkDecomposition DCCanonical ['\x72C0']),
		('\xF9FB',MkDecomposition DCCanonical ['\x7099']),
		('\xF9FC',MkDecomposition DCCanonical ['\x8B58']),
		('\xF9FD',MkDecomposition DCCanonical ['\x4EC0']),
		('\xF9FE',MkDecomposition DCCanonical ['\x8336']),
		('\xF9FF',MkDecomposition DCCanonical ['\x523A']),
		('\xFA00',MkDecomposition DCCanonical ['\x5207']),
		('\xFA01',MkDecomposition DCCanonical ['\x5EA6']),
		('\xFA02',MkDecomposition DCCanonical ['\x62D3']),
		('\xFA03',MkDecomposition DCCanonical ['\x7CD6']),
		('\xFA04',MkDecomposition DCCanonical ['\x5B85']),
		('\xFA05',MkDecomposition DCCanonical ['\x6D1E']),
		('\xFA06',MkDecomposition DCCanonical ['\x66B4']),
		('\xFA07',MkDecomposition DCCanonical ['\x8F3B']),
		('\xFA08',MkDecomposition DCCanonical ['\x884C']),
		('\xFA09',MkDecomposition DCCanonical ['\x964D']),
		('\xFA0A',MkDecomposition DCCanonical ['\x898B']),
		('\xFA0B',MkDecomposition DCCanonical ['\x5ED3']),
		('\xFA0C',MkDecomposition DCCanonical ['\x5140']),
		('\xFA0D',MkDecomposition DCCanonical ['\x55C0']),
		('\xFA10',MkDecomposition DCCanonical ['\x585A']),
		('\xFA12',MkDecomposition DCCanonical ['\x6674']),
		('\xFA15',MkDecomposition DCCanonical ['\x51DE']),
		('\xFA16',MkDecomposition DCCanonical ['\x732A']),
		('\xFA17',MkDecomposition DCCanonical ['\x76CA']),
		('\xFA18',MkDecomposition DCCanonical ['\x793C']),
		('\xFA19',MkDecomposition DCCanonical ['\x795E']),
		('\xFA1A',MkDecomposition DCCanonical ['\x7965']),
		('\xFA1B',MkDecomposition DCCanonical ['\x798F']),
		('\xFA1C',MkDecomposition DCCanonical ['\x9756']),
		('\xFA1D',MkDecomposition DCCanonical ['\x7CBE']),
		('\xFA1E',MkDecomposition DCCanonical ['\x7FBD']),
		('\xFA20',MkDecomposition DCCanonical ['\x8612']),
		('\xFA22',MkDecomposition DCCanonical ['\x8AF8']),
		('\xFA25',MkDecomposition DCCanonical ['\x9038']),
		('\xFA26',MkDecomposition DCCanonical ['\x90FD']),
		('\xFA2A',MkDecomposition DCCanonical ['\x98EF']),
		('\xFA2B',MkDecomposition DCCanonical ['\x98FC']),
		('\xFA2C',MkDecomposition DCCanonical ['\x9928']),
		('\xFA2D',MkDecomposition DCCanonical ['\x9DB4']),
		('\xFA30',MkDecomposition DCCanonical ['\x4FAE']),
		('\xFA31',MkDecomposition DCCanonical ['\x50E7']),
		('\xFA32',MkDecomposition DCCanonical ['\x514D']),
		('\xFA33',MkDecomposition DCCanonical ['\x52C9']),
		('\xFA34',MkDecomposition DCCanonical ['\x52E4']),
		('\xFA35',MkDecomposition DCCanonical ['\x5351']),
		('\xFA36',MkDecomposition DCCanonical ['\x559D']),
		('\xFA37',MkDecomposition DCCanonical ['\x5606']),
		('\xFA38',MkDecomposition DCCanonical ['\x5668']),
		('\xFA39',MkDecomposition DCCanonical ['\x5840']),
		('\xFA3A',MkDecomposition DCCanonical ['\x58A8']),
		('\xFA3B',MkDecomposition DCCanonical ['\x5C64']),
		('\xFA3C',MkDecomposition DCCanonical ['\x5C6E']),
		('\xFA3D',MkDecomposition DCCanonical ['\x6094']),
		('\xFA3E',MkDecomposition DCCanonical ['\x6168']),
		('\xFA3F',MkDecomposition DCCanonical ['\x618E']),
		('\xFA40',MkDecomposition DCCanonical ['\x61F2']),
		('\xFA41',MkDecomposition DCCanonical ['\x654F']),
		('\xFA42',MkDecomposition DCCanonical ['\x65E2']),
		('\xFA43',MkDecomposition DCCanonical ['\x6691']),
		('\xFA44',MkDecomposition DCCanonical ['\x6885']),
		('\xFA45',MkDecomposition DCCanonical ['\x6D77']),
		('\xFA46',MkDecomposition DCCanonical ['\x6E1A']),
		('\xFA47',MkDecomposition DCCanonical ['\x6F22']),
		('\xFA48',MkDecomposition DCCanonical ['\x716E']),
		('\xFA49',MkDecomposition DCCanonical ['\x722B']),
		('\xFA4A',MkDecomposition DCCanonical ['\x7422']),
		('\xFA4B',MkDecomposition DCCanonical ['\x7891']),
		('\xFA4C',MkDecomposition DCCanonical ['\x793E']),
		('\xFA4D',MkDecomposition DCCanonical ['\x7949']),
		('\xFA4E',MkDecomposition DCCanonical ['\x7948']),
		('\xFA4F',MkDecomposition DCCanonical ['\x7950']),
		('\xFA50',MkDecomposition DCCanonical ['\x7956']),
		('\xFA51',MkDecomposition DCCanonical ['\x795D']),
		('\xFA52',MkDecomposition DCCanonical ['\x798D']),
		('\xFA53',MkDecomposition DCCanonical ['\x798E']),
		('\xFA54',MkDecomposition DCCanonical ['\x7A40']),
		('\xFA55',MkDecomposition DCCanonical ['\x7A81']),
		('\xFA56',MkDecomposition DCCanonical ['\x7BC0']),
		('\xFA57',MkDecomposition DCCanonical ['\x7DF4']),
		('\xFA58',MkDecomposition DCCanonical ['\x7E09']),
		('\xFA59',MkDecomposition DCCanonical ['\x7E41']),
		('\xFA5A',MkDecomposition DCCanonical ['\x7F72']),
		('\xFA5B',MkDecomposition DCCanonical ['\x8005']),
		('\xFA5C',MkDecomposition DCCanonical ['\x81ED']),
		('\xFA5D',MkDecomposition DCCanonical ['\x8279']),
		('\xFA5E',MkDecomposition DCCanonical ['\x8279']),
		('\xFA5F',MkDecomposition DCCanonical ['\x8457']),
		('\xFA60',MkDecomposition DCCanonical ['\x8910']),
		('\xFA61',MkDecomposition DCCanonical ['\x8996']),
		('\xFA62',MkDecomposition DCCanonical ['\x8B01']),
		('\xFA63',MkDecomposition DCCanonical ['\x8B39']),
		('\xFA64',MkDecomposition DCCanonical ['\x8CD3']),
		('\xFA65',MkDecomposition DCCanonical ['\x8D08']),
		('\xFA66',MkDecomposition DCCanonical ['\x8FB6']),
		('\xFA67',MkDecomposition DCCanonical ['\x9038']),
		('\xFA68',MkDecomposition DCCanonical ['\x96E3']),
		('\xFA69',MkDecomposition DCCanonical ['\x97FF']),
		('\xFA6A',MkDecomposition DCCanonical ['\x983B']),
		('\xFB00',MkDecomposition DCCompat ['\x0066','\x0066']),
		('\xFB01',MkDecomposition DCCompat ['\x0066','\x0069']),
		('\xFB02',MkDecomposition DCCompat ['\x0066','\x006C']),
		('\xFB03',MkDecomposition DCCompat ['\x0066','\x0066','\x0069']),
		('\xFB04',MkDecomposition DCCompat ['\x0066','\x0066','\x006C']),
		('\xFB05',MkDecomposition DCCompat ['\x017F','\x0074']),
		('\xFB06',MkDecomposition DCCompat ['\x0073','\x0074']),
		('\xFB13',MkDecomposition DCCompat ['\x0574','\x0576']),
		('\xFB14',MkDecomposition DCCompat ['\x0574','\x0565']),
		('\xFB15',MkDecomposition DCCompat ['\x0574','\x056B']),
		('\xFB16',MkDecomposition DCCompat ['\x057E','\x0576']),
		('\xFB17',MkDecomposition DCCompat ['\x0574','\x056D']),
		('\xFB1D',MkDecomposition DCCanonical ['\x05D9','\x05B4']),
		('\xFB1F',MkDecomposition DCCanonical ['\x05F2','\x05B7']),
		('\xFB20',MkDecomposition DCFont ['\x05E2']),
		('\xFB21',MkDecomposition DCFont ['\x05D0']),
		('\xFB22',MkDecomposition DCFont ['\x05D3']),
		('\xFB23',MkDecomposition DCFont ['\x05D4']),
		('\xFB24',MkDecomposition DCFont ['\x05DB']),
		('\xFB25',MkDecomposition DCFont ['\x05DC']),
		('\xFB26',MkDecomposition DCFont ['\x05DD']),
		('\xFB27',MkDecomposition DCFont ['\x05E8']),
		('\xFB28',MkDecomposition DCFont ['\x05EA']),
		('\xFB29',MkDecomposition DCFont ['\x002B']),
		('\xFB2A',MkDecomposition DCCanonical ['\x05E9','\x05C1']),
		('\xFB2B',MkDecomposition DCCanonical ['\x05E9','\x05C2']),
		('\xFB2C',MkDecomposition DCCanonical ['\xFB49','\x05C1']),
		('\xFB2D',MkDecomposition DCCanonical ['\xFB49','\x05C2']),
		('\xFB2E',MkDecomposition DCCanonical ['\x05D0','\x05B7']),
		('\xFB2F',MkDecomposition DCCanonical ['\x05D0','\x05B8']),
		('\xFB30',MkDecomposition DCCanonical ['\x05D0','\x05BC']),
		('\xFB31',MkDecomposition DCCanonical ['\x05D1','\x05BC']),
		('\xFB32',MkDecomposition DCCanonical ['\x05D2','\x05BC']),
		('\xFB33',MkDecomposition DCCanonical ['\x05D3','\x05BC']),
		('\xFB34',MkDecomposition DCCanonical ['\x05D4','\x05BC']),
		('\xFB35',MkDecomposition DCCanonical ['\x05D5','\x05BC']),
		('\xFB36',MkDecomposition DCCanonical ['\x05D6','\x05BC']),
		('\xFB38',MkDecomposition DCCanonical ['\x05D8','\x05BC']),
		('\xFB39',MkDecomposition DCCanonical ['\x05D9','\x05BC']),
		('\xFB3A',MkDecomposition DCCanonical ['\x05DA','\x05BC']),
		('\xFB3B',MkDecomposition DCCanonical ['\x05DB','\x05BC']),
		('\xFB3C',MkDecomposition DCCanonical ['\x05DC','\x05BC']),
		('\xFB3E',MkDecomposition DCCanonical ['\x05DE','\x05BC']),
		('\xFB40',MkDecomposition DCCanonical ['\x05E0','\x05BC']),
		('\xFB41',MkDecomposition DCCanonical ['\x05E1','\x05BC']),
		('\xFB43',MkDecomposition DCCanonical ['\x05E3','\x05BC']),
		('\xFB44',MkDecomposition DCCanonical ['\x05E4','\x05BC']),
		('\xFB46',MkDecomposition DCCanonical ['\x05E6','\x05BC']),
		('\xFB47',MkDecomposition DCCanonical ['\x05E7','\x05BC']),
		('\xFB48',MkDecomposition DCCanonical ['\x05E8','\x05BC']),
		('\xFB49',MkDecomposition DCCanonical ['\x05E9','\x05BC']),
		('\xFB4A',MkDecomposition DCCanonical ['\x05EA','\x05BC']),
		('\xFB4B',MkDecomposition DCCanonical ['\x05D5','\x05B9']),
		('\xFB4C',MkDecomposition DCCanonical ['\x05D1','\x05BF']),
		('\xFB4D',MkDecomposition DCCanonical ['\x05DB','\x05BF']),
		('\xFB4E',MkDecomposition DCCanonical ['\x05E4','\x05BF']),
		('\xFB4F',MkDecomposition DCCompat ['\x05D0','\x05DC']),
		('\xFB50',MkDecomposition DCIsolated ['\x0671']),
		('\xFB51',MkDecomposition DCFinal ['\x0671']),
		('\xFB52',MkDecomposition DCIsolated ['\x067B']),
		('\xFB53',MkDecomposition DCFinal ['\x067B']),
		('\xFB54',MkDecomposition DCInitial ['\x067B']),
		('\xFB55',MkDecomposition DCMedial ['\x067B']),
		('\xFB56',MkDecomposition DCIsolated ['\x067E']),
		('\xFB57',MkDecomposition DCFinal ['\x067E']),
		('\xFB58',MkDecomposition DCInitial ['\x067E']),
		('\xFB59',MkDecomposition DCMedial ['\x067E']),
		('\xFB5A',MkDecomposition DCIsolated ['\x0680']),
		('\xFB5B',MkDecomposition DCFinal ['\x0680']),
		('\xFB5C',MkDecomposition DCInitial ['\x0680']),
		('\xFB5D',MkDecomposition DCMedial ['\x0680']),
		('\xFB5E',MkDecomposition DCIsolated ['\x067A']),
		('\xFB5F',MkDecomposition DCFinal ['\x067A']),
		('\xFB60',MkDecomposition DCInitial ['\x067A']),
		('\xFB61',MkDecomposition DCMedial ['\x067A']),
		('\xFB62',MkDecomposition DCIsolated ['\x067F']),
		('\xFB63',MkDecomposition DCFinal ['\x067F']),
		('\xFB64',MkDecomposition DCInitial ['\x067F']),
		('\xFB65',MkDecomposition DCMedial ['\x067F']),
		('\xFB66',MkDecomposition DCIsolated ['\x0679']),
		('\xFB67',MkDecomposition DCFinal ['\x0679']),
		('\xFB68',MkDecomposition DCInitial ['\x0679']),
		('\xFB69',MkDecomposition DCMedial ['\x0679']),
		('\xFB6A',MkDecomposition DCIsolated ['\x06A4']),
		('\xFB6B',MkDecomposition DCFinal ['\x06A4']),
		('\xFB6C',MkDecomposition DCInitial ['\x06A4']),
		('\xFB6D',MkDecomposition DCMedial ['\x06A4']),
		('\xFB6E',MkDecomposition DCIsolated ['\x06A6']),
		('\xFB6F',MkDecomposition DCFinal ['\x06A6']),
		('\xFB70',MkDecomposition DCInitial ['\x06A6']),
		('\xFB71',MkDecomposition DCMedial ['\x06A6']),
		('\xFB72',MkDecomposition DCIsolated ['\x0684']),
		('\xFB73',MkDecomposition DCFinal ['\x0684']),
		('\xFB74',MkDecomposition DCInitial ['\x0684']),
		('\xFB75',MkDecomposition DCMedial ['\x0684']),
		('\xFB76',MkDecomposition DCIsolated ['\x0683']),
		('\xFB77',MkDecomposition DCFinal ['\x0683']),
		('\xFB78',MkDecomposition DCInitial ['\x0683']),
		('\xFB79',MkDecomposition DCMedial ['\x0683']),
		('\xFB7A',MkDecomposition DCIsolated ['\x0686']),
		('\xFB7B',MkDecomposition DCFinal ['\x0686']),
		('\xFB7C',MkDecomposition DCInitial ['\x0686']),
		('\xFB7D',MkDecomposition DCMedial ['\x0686']),
		('\xFB7E',MkDecomposition DCIsolated ['\x0687']),
		('\xFB7F',MkDecomposition DCFinal ['\x0687']),
		('\xFB80',MkDecomposition DCInitial ['\x0687']),
		('\xFB81',MkDecomposition DCMedial ['\x0687']),
		('\xFB82',MkDecomposition DCIsolated ['\x068D']),
		('\xFB83',MkDecomposition DCFinal ['\x068D']),
		('\xFB84',MkDecomposition DCIsolated ['\x068C']),
		('\xFB85',MkDecomposition DCFinal ['\x068C']),
		('\xFB86',MkDecomposition DCIsolated ['\x068E']),
		('\xFB87',MkDecomposition DCFinal ['\x068E']),
		('\xFB88',MkDecomposition DCIsolated ['\x0688']),
		('\xFB89',MkDecomposition DCFinal ['\x0688']),
		('\xFB8A',MkDecomposition DCIsolated ['\x0698']),
		('\xFB8B',MkDecomposition DCFinal ['\x0698']),
		('\xFB8C',MkDecomposition DCIsolated ['\x0691']),
		('\xFB8D',MkDecomposition DCFinal ['\x0691']),
		('\xFB8E',MkDecomposition DCIsolated ['\x06A9']),
		('\xFB8F',MkDecomposition DCFinal ['\x06A9']),
		('\xFB90',MkDecomposition DCInitial ['\x06A9']),
		('\xFB91',MkDecomposition DCMedial ['\x06A9']),
		('\xFB92',MkDecomposition DCIsolated ['\x06AF']),
		('\xFB93',MkDecomposition DCFinal ['\x06AF']),
		('\xFB94',MkDecomposition DCInitial ['\x06AF']),
		('\xFB95',MkDecomposition DCMedial ['\x06AF']),
		('\xFB96',MkDecomposition DCIsolated ['\x06B3']),
		('\xFB97',MkDecomposition DCFinal ['\x06B3']),
		('\xFB98',MkDecomposition DCInitial ['\x06B3']),
		('\xFB99',MkDecomposition DCMedial ['\x06B3']),
		('\xFB9A',MkDecomposition DCIsolated ['\x06B1']),
		('\xFB9B',MkDecomposition DCFinal ['\x06B1']),
		('\xFB9C',MkDecomposition DCInitial ['\x06B1']),
		('\xFB9D',MkDecomposition DCMedial ['\x06B1']),
		('\xFB9E',MkDecomposition DCIsolated ['\x06BA']),
		('\xFB9F',MkDecomposition DCFinal ['\x06BA']),
		('\xFBA0',MkDecomposition DCIsolated ['\x06BB']),
		('\xFBA1',MkDecomposition DCFinal ['\x06BB']),
		('\xFBA2',MkDecomposition DCInitial ['\x06BB']),
		('\xFBA3',MkDecomposition DCMedial ['\x06BB']),
		('\xFBA4',MkDecomposition DCIsolated ['\x06C0']),
		('\xFBA5',MkDecomposition DCFinal ['\x06C0']),
		('\xFBA6',MkDecomposition DCIsolated ['\x06C1']),
		('\xFBA7',MkDecomposition DCFinal ['\x06C1']),
		('\xFBA8',MkDecomposition DCInitial ['\x06C1']),
		('\xFBA9',MkDecomposition DCMedial ['\x06C1']),
		('\xFBAA',MkDecomposition DCIsolated ['\x06BE']),
		('\xFBAB',MkDecomposition DCFinal ['\x06BE']),
		('\xFBAC',MkDecomposition DCInitial ['\x06BE']),
		('\xFBAD',MkDecomposition DCMedial ['\x06BE']),
		('\xFBAE',MkDecomposition DCIsolated ['\x06D2']),
		('\xFBAF',MkDecomposition DCFinal ['\x06D2']),
		('\xFBB0',MkDecomposition DCIsolated ['\x06D3']),
		('\xFBB1',MkDecomposition DCFinal ['\x06D3']),
		('\xFBD3',MkDecomposition DCIsolated ['\x06AD']),
		('\xFBD4',MkDecomposition DCFinal ['\x06AD']),
		('\xFBD5',MkDecomposition DCInitial ['\x06AD']),
		('\xFBD6',MkDecomposition DCMedial ['\x06AD']),
		('\xFBD7',MkDecomposition DCIsolated ['\x06C7']),
		('\xFBD8',MkDecomposition DCFinal ['\x06C7']),
		('\xFBD9',MkDecomposition DCIsolated ['\x06C6']),
		('\xFBDA',MkDecomposition DCFinal ['\x06C6']),
		('\xFBDB',MkDecomposition DCIsolated ['\x06C8']),
		('\xFBDC',MkDecomposition DCFinal ['\x06C8']),
		('\xFBDD',MkDecomposition DCIsolated ['\x0677']),
		('\xFBDE',MkDecomposition DCIsolated ['\x06CB']),
		('\xFBDF',MkDecomposition DCFinal ['\x06CB']),
		('\xFBE0',MkDecomposition DCIsolated ['\x06C5']),
		('\xFBE1',MkDecomposition DCFinal ['\x06C5']),
		('\xFBE2',MkDecomposition DCIsolated ['\x06C9']),
		('\xFBE3',MkDecomposition DCFinal ['\x06C9']),
		('\xFBE4',MkDecomposition DCIsolated ['\x06D0']),
		('\xFBE5',MkDecomposition DCFinal ['\x06D0']),
		('\xFBE6',MkDecomposition DCInitial ['\x06D0']),
		('\xFBE7',MkDecomposition DCMedial ['\x06D0']),
		('\xFBE8',MkDecomposition DCInitial ['\x0649']),
		('\xFBE9',MkDecomposition DCMedial ['\x0649']),
		('\xFBEA',MkDecomposition DCIsolated ['\x0626','\x0627']),
		('\xFBEB',MkDecomposition DCFinal ['\x0626','\x0627']),
		('\xFBEC',MkDecomposition DCIsolated ['\x0626','\x06D5']),
		('\xFBED',MkDecomposition DCFinal ['\x0626','\x06D5']),
		('\xFBEE',MkDecomposition DCIsolated ['\x0626','\x0648']),
		('\xFBEF',MkDecomposition DCFinal ['\x0626','\x0648']),
		('\xFBF0',MkDecomposition DCIsolated ['\x0626','\x06C7']),
		('\xFBF1',MkDecomposition DCFinal ['\x0626','\x06C7']),
		('\xFBF2',MkDecomposition DCIsolated ['\x0626','\x06C6']),
		('\xFBF3',MkDecomposition DCFinal ['\x0626','\x06C6']),
		('\xFBF4',MkDecomposition DCIsolated ['\x0626','\x06C8']),
		('\xFBF5',MkDecomposition DCFinal ['\x0626','\x06C8']),
		('\xFBF6',MkDecomposition DCIsolated ['\x0626','\x06D0']),
		('\xFBF7',MkDecomposition DCFinal ['\x0626','\x06D0']),
		('\xFBF8',MkDecomposition DCInitial ['\x0626','\x06D0']),
		('\xFBF9',MkDecomposition DCIsolated ['\x0626','\x0649']),
		('\xFBFA',MkDecomposition DCFinal ['\x0626','\x0649']),
		('\xFBFB',MkDecomposition DCInitial ['\x0626','\x0649']),
		('\xFBFC',MkDecomposition DCIsolated ['\x06CC']),
		('\xFBFD',MkDecomposition DCFinal ['\x06CC']),
		('\xFBFE',MkDecomposition DCInitial ['\x06CC']),
		('\xFBFF',MkDecomposition DCMedial ['\x06CC']),
		('\xFC00',MkDecomposition DCIsolated ['\x0626','\x062C']),
		('\xFC01',MkDecomposition DCIsolated ['\x0626','\x062D']),
		('\xFC02',MkDecomposition DCIsolated ['\x0626','\x0645']),
		('\xFC03',MkDecomposition DCIsolated ['\x0626','\x0649']),
		('\xFC04',MkDecomposition DCIsolated ['\x0626','\x064A']),
		('\xFC05',MkDecomposition DCIsolated ['\x0628','\x062C']),
		('\xFC06',MkDecomposition DCIsolated ['\x0628','\x062D']),
		('\xFC07',MkDecomposition DCIsolated ['\x0628','\x062E']),
		('\xFC08',MkDecomposition DCIsolated ['\x0628','\x0645']),
		('\xFC09',MkDecomposition DCIsolated ['\x0628','\x0649']),
		('\xFC0A',MkDecomposition DCIsolated ['\x0628','\x064A']),
		('\xFC0B',MkDecomposition DCIsolated ['\x062A','\x062C']),
		('\xFC0C',MkDecomposition DCIsolated ['\x062A','\x062D']),
		('\xFC0D',MkDecomposition DCIsolated ['\x062A','\x062E']),
		('\xFC0E',MkDecomposition DCIsolated ['\x062A','\x0645']),
		('\xFC0F',MkDecomposition DCIsolated ['\x062A','\x0649']),
		('\xFC10',MkDecomposition DCIsolated ['\x062A','\x064A']),
		('\xFC11',MkDecomposition DCIsolated ['\x062B','\x062C']),
		('\xFC12',MkDecomposition DCIsolated ['\x062B','\x0645']),
		('\xFC13',MkDecomposition DCIsolated ['\x062B','\x0649']),
		('\xFC14',MkDecomposition DCIsolated ['\x062B','\x064A']),
		('\xFC15',MkDecomposition DCIsolated ['\x062C','\x062D']),
		('\xFC16',MkDecomposition DCIsolated ['\x062C','\x0645']),
		('\xFC17',MkDecomposition DCIsolated ['\x062D','\x062C']),
		('\xFC18',MkDecomposition DCIsolated ['\x062D','\x0645']),
		('\xFC19',MkDecomposition DCIsolated ['\x062E','\x062C']),
		('\xFC1A',MkDecomposition DCIsolated ['\x062E','\x062D']),
		('\xFC1B',MkDecomposition DCIsolated ['\x062E','\x0645']),
		('\xFC1C',MkDecomposition DCIsolated ['\x0633','\x062C']),
		('\xFC1D',MkDecomposition DCIsolated ['\x0633','\x062D']),
		('\xFC1E',MkDecomposition DCIsolated ['\x0633','\x062E']),
		('\xFC1F',MkDecomposition DCIsolated ['\x0633','\x0645']),
		('\xFC20',MkDecomposition DCIsolated ['\x0635','\x062D']),
		('\xFC21',MkDecomposition DCIsolated ['\x0635','\x0645']),
		('\xFC22',MkDecomposition DCIsolated ['\x0636','\x062C']),
		('\xFC23',MkDecomposition DCIsolated ['\x0636','\x062D']),
		('\xFC24',MkDecomposition DCIsolated ['\x0636','\x062E']),
		('\xFC25',MkDecomposition DCIsolated ['\x0636','\x0645']),
		('\xFC26',MkDecomposition DCIsolated ['\x0637','\x062D']),
		('\xFC27',MkDecomposition DCIsolated ['\x0637','\x0645']),
		('\xFC28',MkDecomposition DCIsolated ['\x0638','\x0645']),
		('\xFC29',MkDecomposition DCIsolated ['\x0639','\x062C']),
		('\xFC2A',MkDecomposition DCIsolated ['\x0639','\x0645']),
		('\xFC2B',MkDecomposition DCIsolated ['\x063A','\x062C']),
		('\xFC2C',MkDecomposition DCIsolated ['\x063A','\x0645']),
		('\xFC2D',MkDecomposition DCIsolated ['\x0641','\x062C']),
		('\xFC2E',MkDecomposition DCIsolated ['\x0641','\x062D']),
		('\xFC2F',MkDecomposition DCIsolated ['\x0641','\x062E']),
		('\xFC30',MkDecomposition DCIsolated ['\x0641','\x0645']),
		('\xFC31',MkDecomposition DCIsolated ['\x0641','\x0649']),
		('\xFC32',MkDecomposition DCIsolated ['\x0641','\x064A']),
		('\xFC33',MkDecomposition DCIsolated ['\x0642','\x062D']),
		('\xFC34',MkDecomposition DCIsolated ['\x0642','\x0645']),
		('\xFC35',MkDecomposition DCIsolated ['\x0642','\x0649']),
		('\xFC36',MkDecomposition DCIsolated ['\x0642','\x064A']),
		('\xFC37',MkDecomposition DCIsolated ['\x0643','\x0627']),
		('\xFC38',MkDecomposition DCIsolated ['\x0643','\x062C']),
		('\xFC39',MkDecomposition DCIsolated ['\x0643','\x062D']),
		('\xFC3A',MkDecomposition DCIsolated ['\x0643','\x062E']),
		('\xFC3B',MkDecomposition DCIsolated ['\x0643','\x0644']),
		('\xFC3C',MkDecomposition DCIsolated ['\x0643','\x0645']),
		('\xFC3D',MkDecomposition DCIsolated ['\x0643','\x0649']),
		('\xFC3E',MkDecomposition DCIsolated ['\x0643','\x064A']),
		('\xFC3F',MkDecomposition DCIsolated ['\x0644','\x062C']),
		('\xFC40',MkDecomposition DCIsolated ['\x0644','\x062D']),
		('\xFC41',MkDecomposition DCIsolated ['\x0644','\x062E']),
		('\xFC42',MkDecomposition DCIsolated ['\x0644','\x0645']),
		('\xFC43',MkDecomposition DCIsolated ['\x0644','\x0649']),
		('\xFC44',MkDecomposition DCIsolated ['\x0644','\x064A']),
		('\xFC45',MkDecomposition DCIsolated ['\x0645','\x062C']),
		('\xFC46',MkDecomposition DCIsolated ['\x0645','\x062D']),
		('\xFC47',MkDecomposition DCIsolated ['\x0645','\x062E']),
		('\xFC48',MkDecomposition DCIsolated ['\x0645','\x0645']),
		('\xFC49',MkDecomposition DCIsolated ['\x0645','\x0649']),
		('\xFC4A',MkDecomposition DCIsolated ['\x0645','\x064A']),
		('\xFC4B',MkDecomposition DCIsolated ['\x0646','\x062C']),
		('\xFC4C',MkDecomposition DCIsolated ['\x0646','\x062D']),
		('\xFC4D',MkDecomposition DCIsolated ['\x0646','\x062E']),
		('\xFC4E',MkDecomposition DCIsolated ['\x0646','\x0645']),
		('\xFC4F',MkDecomposition DCIsolated ['\x0646','\x0649']),
		('\xFC50',MkDecomposition DCIsolated ['\x0646','\x064A']),
		('\xFC51',MkDecomposition DCIsolated ['\x0647','\x062C']),
		('\xFC52',MkDecomposition DCIsolated ['\x0647','\x0645']),
		('\xFC53',MkDecomposition DCIsolated ['\x0647','\x0649']),
		('\xFC54',MkDecomposition DCIsolated ['\x0647','\x064A']),
		('\xFC55',MkDecomposition DCIsolated ['\x064A','\x062C']),
		('\xFC56',MkDecomposition DCIsolated ['\x064A','\x062D']),
		('\xFC57',MkDecomposition DCIsolated ['\x064A','\x062E']),
		('\xFC58',MkDecomposition DCIsolated ['\x064A','\x0645']),
		('\xFC59',MkDecomposition DCIsolated ['\x064A','\x0649']),
		('\xFC5A',MkDecomposition DCIsolated ['\x064A','\x064A']),
		('\xFC5B',MkDecomposition DCIsolated ['\x0630','\x0670']),
		('\xFC5C',MkDecomposition DCIsolated ['\x0631','\x0670']),
		('\xFC5D',MkDecomposition DCIsolated ['\x0649','\x0670']),
		('\xFC5E',MkDecomposition DCIsolated ['\x0020','\x064C','\x0651']),
		('\xFC5F',MkDecomposition DCIsolated ['\x0020','\x064D','\x0651']),
		('\xFC60',MkDecomposition DCIsolated ['\x0020','\x064E','\x0651']),
		('\xFC61',MkDecomposition DCIsolated ['\x0020','\x064F','\x0651']),
		('\xFC62',MkDecomposition DCIsolated ['\x0020','\x0650','\x0651']),
		('\xFC63',MkDecomposition DCIsolated ['\x0020','\x0651','\x0670']),
		('\xFC64',MkDecomposition DCFinal ['\x0626','\x0631']),
		('\xFC65',MkDecomposition DCFinal ['\x0626','\x0632']),
		('\xFC66',MkDecomposition DCFinal ['\x0626','\x0645']),
		('\xFC67',MkDecomposition DCFinal ['\x0626','\x0646']),
		('\xFC68',MkDecomposition DCFinal ['\x0626','\x0649']),
		('\xFC69',MkDecomposition DCFinal ['\x0626','\x064A']),
		('\xFC6A',MkDecomposition DCFinal ['\x0628','\x0631']),
		('\xFC6B',MkDecomposition DCFinal ['\x0628','\x0632']),
		('\xFC6C',MkDecomposition DCFinal ['\x0628','\x0645']),
		('\xFC6D',MkDecomposition DCFinal ['\x0628','\x0646']),
		('\xFC6E',MkDecomposition DCFinal ['\x0628','\x0649']),
		('\xFC6F',MkDecomposition DCFinal ['\x0628','\x064A']),
		('\xFC70',MkDecomposition DCFinal ['\x062A','\x0631']),
		('\xFC71',MkDecomposition DCFinal ['\x062A','\x0632']),
		('\xFC72',MkDecomposition DCFinal ['\x062A','\x0645']),
		('\xFC73',MkDecomposition DCFinal ['\x062A','\x0646']),
		('\xFC74',MkDecomposition DCFinal ['\x062A','\x0649']),
		('\xFC75',MkDecomposition DCFinal ['\x062A','\x064A']),
		('\xFC76',MkDecomposition DCFinal ['\x062B','\x0631']),
		('\xFC77',MkDecomposition DCFinal ['\x062B','\x0632']),
		('\xFC78',MkDecomposition DCFinal ['\x062B','\x0645']),
		('\xFC79',MkDecomposition DCFinal ['\x062B','\x0646']),
		('\xFC7A',MkDecomposition DCFinal ['\x062B','\x0649']),
		('\xFC7B',MkDecomposition DCFinal ['\x062B','\x064A']),
		('\xFC7C',MkDecomposition DCFinal ['\x0641','\x0649']),
		('\xFC7D',MkDecomposition DCFinal ['\x0641','\x064A']),
		('\xFC7E',MkDecomposition DCFinal ['\x0642','\x0649']),
		('\xFC7F',MkDecomposition DCFinal ['\x0642','\x064A']),
		('\xFC80',MkDecomposition DCFinal ['\x0643','\x0627']),
		('\xFC81',MkDecomposition DCFinal ['\x0643','\x0644']),
		('\xFC82',MkDecomposition DCFinal ['\x0643','\x0645']),
		('\xFC83',MkDecomposition DCFinal ['\x0643','\x0649']),
		('\xFC84',MkDecomposition DCFinal ['\x0643','\x064A']),
		('\xFC85',MkDecomposition DCFinal ['\x0644','\x0645']),
		('\xFC86',MkDecomposition DCFinal ['\x0644','\x0649']),
		('\xFC87',MkDecomposition DCFinal ['\x0644','\x064A']),
		('\xFC88',MkDecomposition DCFinal ['\x0645','\x0627']),
		('\xFC89',MkDecomposition DCFinal ['\x0645','\x0645']),
		('\xFC8A',MkDecomposition DCFinal ['\x0646','\x0631']),
		('\xFC8B',MkDecomposition DCFinal ['\x0646','\x0632']),
		('\xFC8C',MkDecomposition DCFinal ['\x0646','\x0645']),
		('\xFC8D',MkDecomposition DCFinal ['\x0646','\x0646']),
		('\xFC8E',MkDecomposition DCFinal ['\x0646','\x0649']),
		('\xFC8F',MkDecomposition DCFinal ['\x0646','\x064A']),
		('\xFC90',MkDecomposition DCFinal ['\x0649','\x0670']),
		('\xFC91',MkDecomposition DCFinal ['\x064A','\x0631']),
		('\xFC92',MkDecomposition DCFinal ['\x064A','\x0632']),
		('\xFC93',MkDecomposition DCFinal ['\x064A','\x0645']),
		('\xFC94',MkDecomposition DCFinal ['\x064A','\x0646']),
		('\xFC95',MkDecomposition DCFinal ['\x064A','\x0649']),
		('\xFC96',MkDecomposition DCFinal ['\x064A','\x064A']),
		('\xFC97',MkDecomposition DCInitial ['\x0626','\x062C']),
		('\xFC98',MkDecomposition DCInitial ['\x0626','\x062D']),
		('\xFC99',MkDecomposition DCInitial ['\x0626','\x062E']),
		('\xFC9A',MkDecomposition DCInitial ['\x0626','\x0645']),
		('\xFC9B',MkDecomposition DCInitial ['\x0626','\x0647']),
		('\xFC9C',MkDecomposition DCInitial ['\x0628','\x062C']),
		('\xFC9D',MkDecomposition DCInitial ['\x0628','\x062D']),
		('\xFC9E',MkDecomposition DCInitial ['\x0628','\x062E']),
		('\xFC9F',MkDecomposition DCInitial ['\x0628','\x0645']),
		('\xFCA0',MkDecomposition DCInitial ['\x0628','\x0647']),
		('\xFCA1',MkDecomposition DCInitial ['\x062A','\x062C']),
		('\xFCA2',MkDecomposition DCInitial ['\x062A','\x062D']),
		('\xFCA3',MkDecomposition DCInitial ['\x062A','\x062E']),
		('\xFCA4',MkDecomposition DCInitial ['\x062A','\x0645']),
		('\xFCA5',MkDecomposition DCInitial ['\x062A','\x0647']),
		('\xFCA6',MkDecomposition DCInitial ['\x062B','\x0645']),
		('\xFCA7',MkDecomposition DCInitial ['\x062C','\x062D']),
		('\xFCA8',MkDecomposition DCInitial ['\x062C','\x0645']),
		('\xFCA9',MkDecomposition DCInitial ['\x062D','\x062C']),
		('\xFCAA',MkDecomposition DCInitial ['\x062D','\x0645']),
		('\xFCAB',MkDecomposition DCInitial ['\x062E','\x062C']),
		('\xFCAC',MkDecomposition DCInitial ['\x062E','\x0645']),
		('\xFCAD',MkDecomposition DCInitial ['\x0633','\x062C']),
		('\xFCAE',MkDecomposition DCInitial ['\x0633','\x062D']),
		('\xFCAF',MkDecomposition DCInitial ['\x0633','\x062E']),
		('\xFCB0',MkDecomposition DCInitial ['\x0633','\x0645']),
		('\xFCB1',MkDecomposition DCInitial ['\x0635','\x062D']),
		('\xFCB2',MkDecomposition DCInitial ['\x0635','\x062E']),
		('\xFCB3',MkDecomposition DCInitial ['\x0635','\x0645']),
		('\xFCB4',MkDecomposition DCInitial ['\x0636','\x062C']),
		('\xFCB5',MkDecomposition DCInitial ['\x0636','\x062D']),
		('\xFCB6',MkDecomposition DCInitial ['\x0636','\x062E']),
		('\xFCB7',MkDecomposition DCInitial ['\x0636','\x0645']),
		('\xFCB8',MkDecomposition DCInitial ['\x0637','\x062D']),
		('\xFCB9',MkDecomposition DCInitial ['\x0638','\x0645']),
		('\xFCBA',MkDecomposition DCInitial ['\x0639','\x062C']),
		('\xFCBB',MkDecomposition DCInitial ['\x0639','\x0645']),
		('\xFCBC',MkDecomposition DCInitial ['\x063A','\x062C']),
		('\xFCBD',MkDecomposition DCInitial ['\x063A','\x0645']),
		('\xFCBE',MkDecomposition DCInitial ['\x0641','\x062C']),
		('\xFCBF',MkDecomposition DCInitial ['\x0641','\x062D']),
		('\xFCC0',MkDecomposition DCInitial ['\x0641','\x062E']),
		('\xFCC1',MkDecomposition DCInitial ['\x0641','\x0645']),
		('\xFCC2',MkDecomposition DCInitial ['\x0642','\x062D']),
		('\xFCC3',MkDecomposition DCInitial ['\x0642','\x0645']),
		('\xFCC4',MkDecomposition DCInitial ['\x0643','\x062C']),
		('\xFCC5',MkDecomposition DCInitial ['\x0643','\x062D']),
		('\xFCC6',MkDecomposition DCInitial ['\x0643','\x062E']),
		('\xFCC7',MkDecomposition DCInitial ['\x0643','\x0644']),
		('\xFCC8',MkDecomposition DCInitial ['\x0643','\x0645']),
		('\xFCC9',MkDecomposition DCInitial ['\x0644','\x062C']),
		('\xFCCA',MkDecomposition DCInitial ['\x0644','\x062D']),
		('\xFCCB',MkDecomposition DCInitial ['\x0644','\x062E']),
		('\xFCCC',MkDecomposition DCInitial ['\x0644','\x0645']),
		('\xFCCD',MkDecomposition DCInitial ['\x0644','\x0647']),
		('\xFCCE',MkDecomposition DCInitial ['\x0645','\x062C']),
		('\xFCCF',MkDecomposition DCInitial ['\x0645','\x062D']),
		('\xFCD0',MkDecomposition DCInitial ['\x0645','\x062E']),
		('\xFCD1',MkDecomposition DCInitial ['\x0645','\x0645']),
		('\xFCD2',MkDecomposition DCInitial ['\x0646','\x062C']),
		('\xFCD3',MkDecomposition DCInitial ['\x0646','\x062D']),
		('\xFCD4',MkDecomposition DCInitial ['\x0646','\x062E']),
		('\xFCD5',MkDecomposition DCInitial ['\x0646','\x0645']),
		('\xFCD6',MkDecomposition DCInitial ['\x0646','\x0647']),
		('\xFCD7',MkDecomposition DCInitial ['\x0647','\x062C']),
		('\xFCD8',MkDecomposition DCInitial ['\x0647','\x0645']),
		('\xFCD9',MkDecomposition DCInitial ['\x0647','\x0670']),
		('\xFCDA',MkDecomposition DCInitial ['\x064A','\x062C']),
		('\xFCDB',MkDecomposition DCInitial ['\x064A','\x062D']),
		('\xFCDC',MkDecomposition DCInitial ['\x064A','\x062E']),
		('\xFCDD',MkDecomposition DCInitial ['\x064A','\x0645']),
		('\xFCDE',MkDecomposition DCInitial ['\x064A','\x0647']),
		('\xFCDF',MkDecomposition DCMedial ['\x0626','\x0645']),
		('\xFCE0',MkDecomposition DCMedial ['\x0626','\x0647']),
		('\xFCE1',MkDecomposition DCMedial ['\x0628','\x0645']),
		('\xFCE2',MkDecomposition DCMedial ['\x0628','\x0647']),
		('\xFCE3',MkDecomposition DCMedial ['\x062A','\x0645']),
		('\xFCE4',MkDecomposition DCMedial ['\x062A','\x0647']),
		('\xFCE5',MkDecomposition DCMedial ['\x062B','\x0645']),
		('\xFCE6',MkDecomposition DCMedial ['\x062B','\x0647']),
		('\xFCE7',MkDecomposition DCMedial ['\x0633','\x0645']),
		('\xFCE8',MkDecomposition DCMedial ['\x0633','\x0647']),
		('\xFCE9',MkDecomposition DCMedial ['\x0634','\x0645']),
		('\xFCEA',MkDecomposition DCMedial ['\x0634','\x0647']),
		('\xFCEB',MkDecomposition DCMedial ['\x0643','\x0644']),
		('\xFCEC',MkDecomposition DCMedial ['\x0643','\x0645']),
		('\xFCED',MkDecomposition DCMedial ['\x0644','\x0645']),
		('\xFCEE',MkDecomposition DCMedial ['\x0646','\x0645']),
		('\xFCEF',MkDecomposition DCMedial ['\x0646','\x0647']),
		('\xFCF0',MkDecomposition DCMedial ['\x064A','\x0645']),
		('\xFCF1',MkDecomposition DCMedial ['\x064A','\x0647']),
		('\xFCF2',MkDecomposition DCMedial ['\x0640','\x064E','\x0651']),
		('\xFCF3',MkDecomposition DCMedial ['\x0640','\x064F','\x0651']),
		('\xFCF4',MkDecomposition DCMedial ['\x0640','\x0650','\x0651']),
		('\xFCF5',MkDecomposition DCIsolated ['\x0637','\x0649']),
		('\xFCF6',MkDecomposition DCIsolated ['\x0637','\x064A']),
		('\xFCF7',MkDecomposition DCIsolated ['\x0639','\x0649']),
		('\xFCF8',MkDecomposition DCIsolated ['\x0639','\x064A']),
		('\xFCF9',MkDecomposition DCIsolated ['\x063A','\x0649']),
		('\xFCFA',MkDecomposition DCIsolated ['\x063A','\x064A']),
		('\xFCFB',MkDecomposition DCIsolated ['\x0633','\x0649']),
		('\xFCFC',MkDecomposition DCIsolated ['\x0633','\x064A']),
		('\xFCFD',MkDecomposition DCIsolated ['\x0634','\x0649']),
		('\xFCFE',MkDecomposition DCIsolated ['\x0634','\x064A']),
		('\xFCFF',MkDecomposition DCIsolated ['\x062D','\x0649']),
		('\xFD00',MkDecomposition DCIsolated ['\x062D','\x064A']),
		('\xFD01',MkDecomposition DCIsolated ['\x062C','\x0649']),
		('\xFD02',MkDecomposition DCIsolated ['\x062C','\x064A']),
		('\xFD03',MkDecomposition DCIsolated ['\x062E','\x0649']),
		('\xFD04',MkDecomposition DCIsolated ['\x062E','\x064A']),
		('\xFD05',MkDecomposition DCIsolated ['\x0635','\x0649']),
		('\xFD06',MkDecomposition DCIsolated ['\x0635','\x064A']),
		('\xFD07',MkDecomposition DCIsolated ['\x0636','\x0649']),
		('\xFD08',MkDecomposition DCIsolated ['\x0636','\x064A']),
		('\xFD09',MkDecomposition DCIsolated ['\x0634','\x062C']),
		('\xFD0A',MkDecomposition DCIsolated ['\x0634','\x062D']),
		('\xFD0B',MkDecomposition DCIsolated ['\x0634','\x062E']),
		('\xFD0C',MkDecomposition DCIsolated ['\x0634','\x0645']),
		('\xFD0D',MkDecomposition DCIsolated ['\x0634','\x0631']),
		('\xFD0E',MkDecomposition DCIsolated ['\x0633','\x0631']),
		('\xFD0F',MkDecomposition DCIsolated ['\x0635','\x0631']),
		('\xFD10',MkDecomposition DCIsolated ['\x0636','\x0631']),
		('\xFD11',MkDecomposition DCFinal ['\x0637','\x0649']),
		('\xFD12',MkDecomposition DCFinal ['\x0637','\x064A']),
		('\xFD13',MkDecomposition DCFinal ['\x0639','\x0649']),
		('\xFD14',MkDecomposition DCFinal ['\x0639','\x064A']),
		('\xFD15',MkDecomposition DCFinal ['\x063A','\x0649']),
		('\xFD16',MkDecomposition DCFinal ['\x063A','\x064A']),
		('\xFD17',MkDecomposition DCFinal ['\x0633','\x0649']),
		('\xFD18',MkDecomposition DCFinal ['\x0633','\x064A']),
		('\xFD19',MkDecomposition DCFinal ['\x0634','\x0649']),
		('\xFD1A',MkDecomposition DCFinal ['\x0634','\x064A']),
		('\xFD1B',MkDecomposition DCFinal ['\x062D','\x0649']),
		('\xFD1C',MkDecomposition DCFinal ['\x062D','\x064A']),
		('\xFD1D',MkDecomposition DCFinal ['\x062C','\x0649']),
		('\xFD1E',MkDecomposition DCFinal ['\x062C','\x064A']),
		('\xFD1F',MkDecomposition DCFinal ['\x062E','\x0649']),
		('\xFD20',MkDecomposition DCFinal ['\x062E','\x064A']),
		('\xFD21',MkDecomposition DCFinal ['\x0635','\x0649']),
		('\xFD22',MkDecomposition DCFinal ['\x0635','\x064A']),
		('\xFD23',MkDecomposition DCFinal ['\x0636','\x0649']),
		('\xFD24',MkDecomposition DCFinal ['\x0636','\x064A']),
		('\xFD25',MkDecomposition DCFinal ['\x0634','\x062C']),
		('\xFD26',MkDecomposition DCFinal ['\x0634','\x062D']),
		('\xFD27',MkDecomposition DCFinal ['\x0634','\x062E']),
		('\xFD28',MkDecomposition DCFinal ['\x0634','\x0645']),
		('\xFD29',MkDecomposition DCFinal ['\x0634','\x0631']),
		('\xFD2A',MkDecomposition DCFinal ['\x0633','\x0631']),
		('\xFD2B',MkDecomposition DCFinal ['\x0635','\x0631']),
		('\xFD2C',MkDecomposition DCFinal ['\x0636','\x0631']),
		('\xFD2D',MkDecomposition DCInitial ['\x0634','\x062C']),
		('\xFD2E',MkDecomposition DCInitial ['\x0634','\x062D']),
		('\xFD2F',MkDecomposition DCInitial ['\x0634','\x062E']),
		('\xFD30',MkDecomposition DCInitial ['\x0634','\x0645']),
		('\xFD31',MkDecomposition DCInitial ['\x0633','\x0647']),
		('\xFD32',MkDecomposition DCInitial ['\x0634','\x0647']),
		('\xFD33',MkDecomposition DCInitial ['\x0637','\x0645']),
		('\xFD34',MkDecomposition DCMedial ['\x0633','\x062C']),
		('\xFD35',MkDecomposition DCMedial ['\x0633','\x062D']),
		('\xFD36',MkDecomposition DCMedial ['\x0633','\x062E']),
		('\xFD37',MkDecomposition DCMedial ['\x0634','\x062C']),
		('\xFD38',MkDecomposition DCMedial ['\x0634','\x062D']),
		('\xFD39',MkDecomposition DCMedial ['\x0634','\x062E']),
		('\xFD3A',MkDecomposition DCMedial ['\x0637','\x0645']),
		('\xFD3B',MkDecomposition DCMedial ['\x0638','\x0645']),
		('\xFD3C',MkDecomposition DCFinal ['\x0627','\x064B']),
		('\xFD3D',MkDecomposition DCIsolated ['\x0627','\x064B']),
		('\xFD50',MkDecomposition DCInitial ['\x062A','\x062C','\x0645']),
		('\xFD51',MkDecomposition DCFinal ['\x062A','\x062D','\x062C']),
		('\xFD52',MkDecomposition DCInitial ['\x062A','\x062D','\x062C']),
		('\xFD53',MkDecomposition DCInitial ['\x062A','\x062D','\x0645']),
		('\xFD54',MkDecomposition DCInitial ['\x062A','\x062E','\x0645']),
		('\xFD55',MkDecomposition DCInitial ['\x062A','\x0645','\x062C']),
		('\xFD56',MkDecomposition DCInitial ['\x062A','\x0645','\x062D']),
		('\xFD57',MkDecomposition DCInitial ['\x062A','\x0645','\x062E']),
		('\xFD58',MkDecomposition DCFinal ['\x062C','\x0645','\x062D']),
		('\xFD59',MkDecomposition DCInitial ['\x062C','\x0645','\x062D']),
		('\xFD5A',MkDecomposition DCFinal ['\x062D','\x0645','\x064A']),
		('\xFD5B',MkDecomposition DCFinal ['\x062D','\x0645','\x0649']),
		('\xFD5C',MkDecomposition DCInitial ['\x0633','\x062D','\x062C']),
		('\xFD5D',MkDecomposition DCInitial ['\x0633','\x062C','\x062D']),
		('\xFD5E',MkDecomposition DCFinal ['\x0633','\x062C','\x0649']),
		('\xFD5F',MkDecomposition DCFinal ['\x0633','\x0645','\x062D']),
		('\xFD60',MkDecomposition DCInitial ['\x0633','\x0645','\x062D']),
		('\xFD61',MkDecomposition DCInitial ['\x0633','\x0645','\x062C']),
		('\xFD62',MkDecomposition DCFinal ['\x0633','\x0645','\x0645']),
		('\xFD63',MkDecomposition DCInitial ['\x0633','\x0645','\x0645']),
		('\xFD64',MkDecomposition DCFinal ['\x0635','\x062D','\x062D']),
		('\xFD65',MkDecomposition DCInitial ['\x0635','\x062D','\x062D']),
		('\xFD66',MkDecomposition DCFinal ['\x0635','\x0645','\x0645']),
		('\xFD67',MkDecomposition DCFinal ['\x0634','\x062D','\x0645']),
		('\xFD68',MkDecomposition DCInitial ['\x0634','\x062D','\x0645']),
		('\xFD69',MkDecomposition DCFinal ['\x0634','\x062C','\x064A']),
		('\xFD6A',MkDecomposition DCFinal ['\x0634','\x0645','\x062E']),
		('\xFD6B',MkDecomposition DCInitial ['\x0634','\x0645','\x062E']),
		('\xFD6C',MkDecomposition DCFinal ['\x0634','\x0645','\x0645']),
		('\xFD6D',MkDecomposition DCInitial ['\x0634','\x0645','\x0645']),
		('\xFD6E',MkDecomposition DCFinal ['\x0636','\x062D','\x0649']),
		('\xFD6F',MkDecomposition DCFinal ['\x0636','\x062E','\x0645']),
		('\xFD70',MkDecomposition DCInitial ['\x0636','\x062E','\x0645']),
		('\xFD71',MkDecomposition DCFinal ['\x0637','\x0645','\x062D']),
		('\xFD72',MkDecomposition DCInitial ['\x0637','\x0645','\x062D']),
		('\xFD73',MkDecomposition DCInitial ['\x0637','\x0645','\x0645']),
		('\xFD74',MkDecomposition DCFinal ['\x0637','\x0645','\x064A']),
		('\xFD75',MkDecomposition DCFinal ['\x0639','\x062C','\x0645']),
		('\xFD76',MkDecomposition DCFinal ['\x0639','\x0645','\x0645']),
		('\xFD77',MkDecomposition DCInitial ['\x0639','\x0645','\x0645']),
		('\xFD78',MkDecomposition DCFinal ['\x0639','\x0645','\x0649']),
		('\xFD79',MkDecomposition DCFinal ['\x063A','\x0645','\x0645']),
		('\xFD7A',MkDecomposition DCFinal ['\x063A','\x0645','\x064A']),
		('\xFD7B',MkDecomposition DCFinal ['\x063A','\x0645','\x0649']),
		('\xFD7C',MkDecomposition DCFinal ['\x0641','\x062E','\x0645']),
		('\xFD7D',MkDecomposition DCInitial ['\x0641','\x062E','\x0645']),
		('\xFD7E',MkDecomposition DCFinal ['\x0642','\x0645','\x062D']),
		('\xFD7F',MkDecomposition DCFinal ['\x0642','\x0645','\x0645']),
		('\xFD80',MkDecomposition DCFinal ['\x0644','\x062D','\x0645']),
		('\xFD81',MkDecomposition DCFinal ['\x0644','\x062D','\x064A']),
		('\xFD82',MkDecomposition DCFinal ['\x0644','\x062D','\x0649']),
		('\xFD83',MkDecomposition DCInitial ['\x0644','\x062C','\x062C']),
		('\xFD84',MkDecomposition DCFinal ['\x0644','\x062C','\x062C']),
		('\xFD85',MkDecomposition DCFinal ['\x0644','\x062E','\x0645']),
		('\xFD86',MkDecomposition DCInitial ['\x0644','\x062E','\x0645']),
		('\xFD87',MkDecomposition DCFinal ['\x0644','\x0645','\x062D']),
		('\xFD88',MkDecomposition DCInitial ['\x0644','\x0645','\x062D']),
		('\xFD89',MkDecomposition DCInitial ['\x0645','\x062D','\x062C']),
		('\xFD8A',MkDecomposition DCInitial ['\x0645','\x062D','\x0645']),
		('\xFD8B',MkDecomposition DCFinal ['\x0645','\x062D','\x064A']),
		('\xFD8C',MkDecomposition DCInitial ['\x0645','\x062C','\x062D']),
		('\xFD8D',MkDecomposition DCInitial ['\x0645','\x062C','\x0645']),
		('\xFD8E',MkDecomposition DCInitial ['\x0645','\x062E','\x062C']),
		('\xFD8F',MkDecomposition DCInitial ['\x0645','\x062E','\x0645']),
		('\xFD92',MkDecomposition DCInitial ['\x0645','\x062C','\x062E']),
		('\xFD93',MkDecomposition DCInitial ['\x0647','\x0645','\x062C']),
		('\xFD94',MkDecomposition DCInitial ['\x0647','\x0645','\x0645']),
		('\xFD95',MkDecomposition DCInitial ['\x0646','\x062D','\x0645']),
		('\xFD96',MkDecomposition DCFinal ['\x0646','\x062D','\x0649']),
		('\xFD97',MkDecomposition DCFinal ['\x0646','\x062C','\x0645']),
		('\xFD98',MkDecomposition DCInitial ['\x0646','\x062C','\x0645']),
		('\xFD99',MkDecomposition DCFinal ['\x0646','\x062C','\x0649']),
		('\xFD9A',MkDecomposition DCFinal ['\x0646','\x0645','\x064A']),
		('\xFD9B',MkDecomposition DCFinal ['\x0646','\x0645','\x0649']),
		('\xFD9C',MkDecomposition DCFinal ['\x064A','\x0645','\x0645']),
		('\xFD9D',MkDecomposition DCInitial ['\x064A','\x0645','\x0645']),
		('\xFD9E',MkDecomposition DCFinal ['\x0628','\x062E','\x064A']),
		('\xFD9F',MkDecomposition DCFinal ['\x062A','\x062C','\x064A']),
		('\xFDA0',MkDecomposition DCFinal ['\x062A','\x062C','\x0649']),
		('\xFDA1',MkDecomposition DCFinal ['\x062A','\x062E','\x064A']),
		('\xFDA2',MkDecomposition DCFinal ['\x062A','\x062E','\x0649']),
		('\xFDA3',MkDecomposition DCFinal ['\x062A','\x0645','\x064A']),
		('\xFDA4',MkDecomposition DCFinal ['\x062A','\x0645','\x0649']),
		('\xFDA5',MkDecomposition DCFinal ['\x062C','\x0645','\x064A']),
		('\xFDA6',MkDecomposition DCFinal ['\x062C','\x062D','\x0649']),
		('\xFDA7',MkDecomposition DCFinal ['\x062C','\x0645','\x0649']),
		('\xFDA8',MkDecomposition DCFinal ['\x0633','\x062E','\x0649']),
		('\xFDA9',MkDecomposition DCFinal ['\x0635','\x062D','\x064A']),
		('\xFDAA',MkDecomposition DCFinal ['\x0634','\x062D','\x064A']),
		('\xFDAB',MkDecomposition DCFinal ['\x0636','\x062D','\x064A']),
		('\xFDAC',MkDecomposition DCFinal ['\x0644','\x062C','\x064A']),
		('\xFDAD',MkDecomposition DCFinal ['\x0644','\x0645','\x064A']),
		('\xFDAE',MkDecomposition DCFinal ['\x064A','\x062D','\x064A']),
		('\xFDAF',MkDecomposition DCFinal ['\x064A','\x062C','\x064A']),
		('\xFDB0',MkDecomposition DCFinal ['\x064A','\x0645','\x064A']),
		('\xFDB1',MkDecomposition DCFinal ['\x0645','\x0645','\x064A']),
		('\xFDB2',MkDecomposition DCFinal ['\x0642','\x0645','\x064A']),
		('\xFDB3',MkDecomposition DCFinal ['\x0646','\x062D','\x064A']),
		('\xFDB4',MkDecomposition DCInitial ['\x0642','\x0645','\x062D']),
		('\xFDB5',MkDecomposition DCInitial ['\x0644','\x062D','\x0645']),
		('\xFDB6',MkDecomposition DCFinal ['\x0639','\x0645','\x064A']),
		('\xFDB7',MkDecomposition DCFinal ['\x0643','\x0645','\x064A']),
		('\xFDB8',MkDecomposition DCInitial ['\x0646','\x062C','\x062D']),
		('\xFDB9',MkDecomposition DCFinal ['\x0645','\x062E','\x064A']),
		('\xFDBA',MkDecomposition DCInitial ['\x0644','\x062C','\x0645']),
		('\xFDBB',MkDecomposition DCFinal ['\x0643','\x0645','\x0645']),
		('\xFDBC',MkDecomposition DCFinal ['\x0644','\x062C','\x0645']),
		('\xFDBD',MkDecomposition DCFinal ['\x0646','\x062C','\x062D']),
		('\xFDBE',MkDecomposition DCFinal ['\x062C','\x062D','\x064A']),
		('\xFDBF',MkDecomposition DCFinal ['\x062D','\x062C','\x064A']),
		('\xFDC0',MkDecomposition DCFinal ['\x0645','\x062C','\x064A']),
		('\xFDC1',MkDecomposition DCFinal ['\x0641','\x0645','\x064A']),
		('\xFDC2',MkDecomposition DCFinal ['\x0628','\x062D','\x064A']),
		('\xFDC3',MkDecomposition DCInitial ['\x0643','\x0645','\x0645']),
		('\xFDC4',MkDecomposition DCInitial ['\x0639','\x062C','\x0645']),
		('\xFDC5',MkDecomposition DCInitial ['\x0635','\x0645','\x0645']),
		('\xFDC6',MkDecomposition DCFinal ['\x0633','\x062E','\x064A']),
		('\xFDC7',MkDecomposition DCFinal ['\x0646','\x062C','\x064A']),
		('\xFDF0',MkDecomposition DCIsolated ['\x0635','\x0644','\x06D2']),
		('\xFDF1',MkDecomposition DCIsolated ['\x0642','\x0644','\x06D2']),
		('\xFDF2',MkDecomposition DCIsolated ['\x0627','\x0644','\x0644','\x0647']),
		('\xFDF3',MkDecomposition DCIsolated ['\x0627','\x0643','\x0628','\x0631']),
		('\xFDF4',MkDecomposition DCIsolated ['\x0645','\x062D','\x0645','\x062F']),
		('\xFDF5',MkDecomposition DCIsolated ['\x0635','\x0644','\x0639','\x0645']),
		('\xFDF6',MkDecomposition DCIsolated ['\x0631','\x0633','\x0648','\x0644']),
		('\xFDF7',MkDecomposition DCIsolated ['\x0639','\x0644','\x064A','\x0647']),
		('\xFDF8',MkDecomposition DCIsolated ['\x0648','\x0633','\x0644','\x0645']),
		('\xFDF9',MkDecomposition DCIsolated ['\x0635','\x0644','\x0649']),
		('\xFDFA',MkDecomposition DCIsolated ['\x0635','\x0644','\x0649','\x0020','\x0627','\x0644','\x0644','\x0647','\x0020','\x0639','\x0644','\x064A','\x0647','\x0020','\x0648','\x0633','\x0644','\x0645']),
		('\xFDFB',MkDecomposition DCIsolated ['\x062C','\x0644','\x0020','\x062C','\x0644','\x0627','\x0644','\x0647']),
		('\xFDFC',MkDecomposition DCIsolated ['\x0631','\x06CC','\x0627','\x0644']),
		('\xFE30',MkDecomposition DCVertical ['\x2025']),
		('\xFE31',MkDecomposition DCVertical ['\x2014']),
		('\xFE32',MkDecomposition DCVertical ['\x2013']),
		('\xFE33',MkDecomposition DCVertical ['\x005F']),
		('\xFE34',MkDecomposition DCVertical ['\x005F']),
		('\xFE35',MkDecomposition DCVertical ['\x0028']),
		('\xFE36',MkDecomposition DCVertical ['\x0029']),
		('\xFE37',MkDecomposition DCVertical ['\x007B']),
		('\xFE38',MkDecomposition DCVertical ['\x007D']),
		('\xFE39',MkDecomposition DCVertical ['\x3014']),
		('\xFE3A',MkDecomposition DCVertical ['\x3015']),
		('\xFE3B',MkDecomposition DCVertical ['\x3010']),
		('\xFE3C',MkDecomposition DCVertical ['\x3011']),
		('\xFE3D',MkDecomposition DCVertical ['\x300A']),
		('\xFE3E',MkDecomposition DCVertical ['\x300B']),
		('\xFE3F',MkDecomposition DCVertical ['\x3008']),
		('\xFE40',MkDecomposition DCVertical ['\x3009']),
		('\xFE41',MkDecomposition DCVertical ['\x300C']),
		('\xFE42',MkDecomposition DCVertical ['\x300D']),
		('\xFE43',MkDecomposition DCVertical ['\x300E']),
		('\xFE44',MkDecomposition DCVertical ['\x300F']),
		('\xFE49',MkDecomposition DCCompat ['\x203E']),
		('\xFE4A',MkDecomposition DCCompat ['\x203E']),
		('\xFE4B',MkDecomposition DCCompat ['\x203E']),
		('\xFE4C',MkDecomposition DCCompat ['\x203E']),
		('\xFE4D',MkDecomposition DCCompat ['\x005F']),
		('\xFE4E',MkDecomposition DCCompat ['\x005F']),
		('\xFE4F',MkDecomposition DCCompat ['\x005F']),
		('\xFE50',MkDecomposition DCSmall ['\x002C']),
		('\xFE51',MkDecomposition DCSmall ['\x3001']),
		('\xFE52',MkDecomposition DCSmall ['\x002E']),
		('\xFE54',MkDecomposition DCSmall ['\x003B']),
		('\xFE55',MkDecomposition DCSmall ['\x003A']),
		('\xFE56',MkDecomposition DCSmall ['\x003F']),
		('\xFE57',MkDecomposition DCSmall ['\x0021']),
		('\xFE58',MkDecomposition DCSmall ['\x2014']),
		('\xFE59',MkDecomposition DCSmall ['\x0028']),
		('\xFE5A',MkDecomposition DCSmall ['\x0029']),
		('\xFE5B',MkDecomposition DCSmall ['\x007B']),
		('\xFE5C',MkDecomposition DCSmall ['\x007D']),
		('\xFE5D',MkDecomposition DCSmall ['\x3014']),
		('\xFE5E',MkDecomposition DCSmall ['\x3015']),
		('\xFE5F',MkDecomposition DCSmall ['\x0023']),
		('\xFE60',MkDecomposition DCSmall ['\x0026']),
		('\xFE61',MkDecomposition DCSmall ['\x002A']),
		('\xFE62',MkDecomposition DCSmall ['\x002B']),
		('\xFE63',MkDecomposition DCSmall ['\x002D']),
		('\xFE64',MkDecomposition DCSmall ['\x003C']),
		('\xFE65',MkDecomposition DCSmall ['\x003E']),
		('\xFE66',MkDecomposition DCSmall ['\x003D']),
		('\xFE68',MkDecomposition DCSmall ['\x005C']),
		('\xFE69',MkDecomposition DCSmall ['\x0024']),
		('\xFE6A',MkDecomposition DCSmall ['\x0025']),
		('\xFE6B',MkDecomposition DCSmall ['\x0040']),
		('\xFE70',MkDecomposition DCIsolated ['\x0020','\x064B']),
		('\xFE71',MkDecomposition DCMedial ['\x0640','\x064B']),
		('\xFE72',MkDecomposition DCIsolated ['\x0020','\x064C']),
		('\xFE74',MkDecomposition DCIsolated ['\x0020','\x064D']),
		('\xFE76',MkDecomposition DCIsolated ['\x0020','\x064E']),
		('\xFE77',MkDecomposition DCMedial ['\x0640','\x064E']),
		('\xFE78',MkDecomposition DCIsolated ['\x0020','\x064F']),
		('\xFE79',MkDecomposition DCMedial ['\x0640','\x064F']),
		('\xFE7A',MkDecomposition DCIsolated ['\x0020','\x0650']),
		('\xFE7B',MkDecomposition DCMedial ['\x0640','\x0650']),
		('\xFE7C',MkDecomposition DCIsolated ['\x0020','\x0651']),
		('\xFE7D',MkDecomposition DCMedial ['\x0640','\x0651']),
		('\xFE7E',MkDecomposition DCIsolated ['\x0020','\x0652']),
		('\xFE7F',MkDecomposition DCMedial ['\x0640','\x0652']),
		('\xFE80',MkDecomposition DCIsolated ['\x0621']),
		('\xFE81',MkDecomposition DCIsolated ['\x0622']),
		('\xFE82',MkDecomposition DCFinal ['\x0622']),
		('\xFE83',MkDecomposition DCIsolated ['\x0623']),
		('\xFE84',MkDecomposition DCFinal ['\x0623']),
		('\xFE85',MkDecomposition DCIsolated ['\x0624']),
		('\xFE86',MkDecomposition DCFinal ['\x0624']),
		('\xFE87',MkDecomposition DCIsolated ['\x0625']),
		('\xFE88',MkDecomposition DCFinal ['\x0625']),
		('\xFE89',MkDecomposition DCIsolated ['\x0626']),
		('\xFE8A',MkDecomposition DCFinal ['\x0626']),
		('\xFE8B',MkDecomposition DCInitial ['\x0626']),
		('\xFE8C',MkDecomposition DCMedial ['\x0626']),
		('\xFE8D',MkDecomposition DCIsolated ['\x0627']),
		('\xFE8E',MkDecomposition DCFinal ['\x0627']),
		('\xFE8F',MkDecomposition DCIsolated ['\x0628']),
		('\xFE90',MkDecomposition DCFinal ['\x0628']),
		('\xFE91',MkDecomposition DCInitial ['\x0628']),
		('\xFE92',MkDecomposition DCMedial ['\x0628']),
		('\xFE93',MkDecomposition DCIsolated ['\x0629']),
		('\xFE94',MkDecomposition DCFinal ['\x0629']),
		('\xFE95',MkDecomposition DCIsolated ['\x062A']),
		('\xFE96',MkDecomposition DCFinal ['\x062A']),
		('\xFE97',MkDecomposition DCInitial ['\x062A']),
		('\xFE98',MkDecomposition DCMedial ['\x062A']),
		('\xFE99',MkDecomposition DCIsolated ['\x062B']),
		('\xFE9A',MkDecomposition DCFinal ['\x062B']),
		('\xFE9B',MkDecomposition DCInitial ['\x062B']),
		('\xFE9C',MkDecomposition DCMedial ['\x062B']),
		('\xFE9D',MkDecomposition DCIsolated ['\x062C']),
		('\xFE9E',MkDecomposition DCFinal ['\x062C']),
		('\xFE9F',MkDecomposition DCInitial ['\x062C']),
		('\xFEA0',MkDecomposition DCMedial ['\x062C']),
		('\xFEA1',MkDecomposition DCIsolated ['\x062D']),
		('\xFEA2',MkDecomposition DCFinal ['\x062D']),
		('\xFEA3',MkDecomposition DCInitial ['\x062D']),
		('\xFEA4',MkDecomposition DCMedial ['\x062D']),
		('\xFEA5',MkDecomposition DCIsolated ['\x062E']),
		('\xFEA6',MkDecomposition DCFinal ['\x062E']),
		('\xFEA7',MkDecomposition DCInitial ['\x062E']),
		('\xFEA8',MkDecomposition DCMedial ['\x062E']),
		('\xFEA9',MkDecomposition DCIsolated ['\x062F']),
		('\xFEAA',MkDecomposition DCFinal ['\x062F']),
		('\xFEAB',MkDecomposition DCIsolated ['\x0630']),
		('\xFEAC',MkDecomposition DCFinal ['\x0630']),
		('\xFEAD',MkDecomposition DCIsolated ['\x0631']),
		('\xFEAE',MkDecomposition DCFinal ['\x0631']),
		('\xFEAF',MkDecomposition DCIsolated ['\x0632']),
		('\xFEB0',MkDecomposition DCFinal ['\x0632']),
		('\xFEB1',MkDecomposition DCIsolated ['\x0633']),
		('\xFEB2',MkDecomposition DCFinal ['\x0633']),
		('\xFEB3',MkDecomposition DCInitial ['\x0633']),
		('\xFEB4',MkDecomposition DCMedial ['\x0633']),
		('\xFEB5',MkDecomposition DCIsolated ['\x0634']),
		('\xFEB6',MkDecomposition DCFinal ['\x0634']),
		('\xFEB7',MkDecomposition DCInitial ['\x0634']),
		('\xFEB8',MkDecomposition DCMedial ['\x0634']),
		('\xFEB9',MkDecomposition DCIsolated ['\x0635']),
		('\xFEBA',MkDecomposition DCFinal ['\x0635']),
		('\xFEBB',MkDecomposition DCInitial ['\x0635']),
		('\xFEBC',MkDecomposition DCMedial ['\x0635']),
		('\xFEBD',MkDecomposition DCIsolated ['\x0636']),
		('\xFEBE',MkDecomposition DCFinal ['\x0636']),
		('\xFEBF',MkDecomposition DCInitial ['\x0636']),
		('\xFEC0',MkDecomposition DCMedial ['\x0636']),
		('\xFEC1',MkDecomposition DCIsolated ['\x0637']),
		('\xFEC2',MkDecomposition DCFinal ['\x0637']),
		('\xFEC3',MkDecomposition DCInitial ['\x0637']),
		('\xFEC4',MkDecomposition DCMedial ['\x0637']),
		('\xFEC5',MkDecomposition DCIsolated ['\x0638']),
		('\xFEC6',MkDecomposition DCFinal ['\x0638']),
		('\xFEC7',MkDecomposition DCInitial ['\x0638']),
		('\xFEC8',MkDecomposition DCMedial ['\x0638']),
		('\xFEC9',MkDecomposition DCIsolated ['\x0639']),
		('\xFECA',MkDecomposition DCFinal ['\x0639']),
		('\xFECB',MkDecomposition DCInitial ['\x0639']),
		('\xFECC',MkDecomposition DCMedial ['\x0639']),
		('\xFECD',MkDecomposition DCIsolated ['\x063A']),
		('\xFECE',MkDecomposition DCFinal ['\x063A']),
		('\xFECF',MkDecomposition DCInitial ['\x063A']),
		('\xFED0',MkDecomposition DCMedial ['\x063A']),
		('\xFED1',MkDecomposition DCIsolated ['\x0641']),
		('\xFED2',MkDecomposition DCFinal ['\x0641']),
		('\xFED3',MkDecomposition DCInitial ['\x0641']),
		('\xFED4',MkDecomposition DCMedial ['\x0641']),
		('\xFED5',MkDecomposition DCIsolated ['\x0642']),
		('\xFED6',MkDecomposition DCFinal ['\x0642']),
		('\xFED7',MkDecomposition DCInitial ['\x0642']),
		('\xFED8',MkDecomposition DCMedial ['\x0642']),
		('\xFED9',MkDecomposition DCIsolated ['\x0643']),
		('\xFEDA',MkDecomposition DCFinal ['\x0643']),
		('\xFEDB',MkDecomposition DCInitial ['\x0643']),
		('\xFEDC',MkDecomposition DCMedial ['\x0643']),
		('\xFEDD',MkDecomposition DCIsolated ['\x0644']),
		('\xFEDE',MkDecomposition DCFinal ['\x0644']),
		('\xFEDF',MkDecomposition DCInitial ['\x0644']),
		('\xFEE0',MkDecomposition DCMedial ['\x0644']),
		('\xFEE1',MkDecomposition DCIsolated ['\x0645']),
		('\xFEE2',MkDecomposition DCFinal ['\x0645']),
		('\xFEE3',MkDecomposition DCInitial ['\x0645']),
		('\xFEE4',MkDecomposition DCMedial ['\x0645']),
		('\xFEE5',MkDecomposition DCIsolated ['\x0646']),
		('\xFEE6',MkDecomposition DCFinal ['\x0646']),
		('\xFEE7',MkDecomposition DCInitial ['\x0646']),
		('\xFEE8',MkDecomposition DCMedial ['\x0646']),
		('\xFEE9',MkDecomposition DCIsolated ['\x0647']),
		('\xFEEA',MkDecomposition DCFinal ['\x0647']),
		('\xFEEB',MkDecomposition DCInitial ['\x0647']),
		('\xFEEC',MkDecomposition DCMedial ['\x0647']),
		('\xFEED',MkDecomposition DCIsolated ['\x0648']),
		('\xFEEE',MkDecomposition DCFinal ['\x0648']),
		('\xFEEF',MkDecomposition DCIsolated ['\x0649']),
		('\xFEF0',MkDecomposition DCFinal ['\x0649']),
		('\xFEF1',MkDecomposition DCIsolated ['\x064A']),
		('\xFEF2',MkDecomposition DCFinal ['\x064A']),
		('\xFEF3',MkDecomposition DCInitial ['\x064A']),
		('\xFEF4',MkDecomposition DCMedial ['\x064A']),
		('\xFEF5',MkDecomposition DCIsolated ['\x0644','\x0622']),
		('\xFEF6',MkDecomposition DCFinal ['\x0644','\x0622']),
		('\xFEF7',MkDecomposition DCIsolated ['\x0644','\x0623']),
		('\xFEF8',MkDecomposition DCFinal ['\x0644','\x0623']),
		('\xFEF9',MkDecomposition DCIsolated ['\x0644','\x0625']),
		('\xFEFA',MkDecomposition DCFinal ['\x0644','\x0625']),
		('\xFEFB',MkDecomposition DCIsolated ['\x0644','\x0627']),
		('\xFEFC',MkDecomposition DCFinal ['\x0644','\x0627']),
		('\xFF01',MkDecomposition DCWide ['\x0021']),
		('\xFF02',MkDecomposition DCWide ['\x0022']),
		('\xFF03',MkDecomposition DCWide ['\x0023']),
		('\xFF04',MkDecomposition DCWide ['\x0024']),
		('\xFF05',MkDecomposition DCWide ['\x0025']),
		('\xFF06',MkDecomposition DCWide ['\x0026']),
		('\xFF07',MkDecomposition DCWide ['\x0027']),
		('\xFF08',MkDecomposition DCWide ['\x0028']),
		('\xFF09',MkDecomposition DCWide ['\x0029']),
		('\xFF0A',MkDecomposition DCWide ['\x002A']),
		('\xFF0B',MkDecomposition DCWide ['\x002B']),
		('\xFF0C',MkDecomposition DCWide ['\x002C']),
		('\xFF0D',MkDecomposition DCWide ['\x002D']),
		('\xFF0E',MkDecomposition DCWide ['\x002E']),
		('\xFF0F',MkDecomposition DCWide ['\x002F']),
		('\xFF10',MkDecomposition DCWide ['\x0030']),
		('\xFF11',MkDecomposition DCWide ['\x0031']),
		('\xFF12',MkDecomposition DCWide ['\x0032']),
		('\xFF13',MkDecomposition DCWide ['\x0033']),
		('\xFF14',MkDecomposition DCWide ['\x0034']),
		('\xFF15',MkDecomposition DCWide ['\x0035']),
		('\xFF16',MkDecomposition DCWide ['\x0036']),
		('\xFF17',MkDecomposition DCWide ['\x0037']),
		('\xFF18',MkDecomposition DCWide ['\x0038']),
		('\xFF19',MkDecomposition DCWide ['\x0039']),
		('\xFF1A',MkDecomposition DCWide ['\x003A']),
		('\xFF1B',MkDecomposition DCWide ['\x003B']),
		('\xFF1C',MkDecomposition DCWide ['\x003C']),
		('\xFF1D',MkDecomposition DCWide ['\x003D']),
		('\xFF1E',MkDecomposition DCWide ['\x003E']),
		('\xFF1F',MkDecomposition DCWide ['\x003F']),
		('\xFF20',MkDecomposition DCWide ['\x0040']),
		('\xFF21',MkDecomposition DCWide ['\x0041']),
		('\xFF22',MkDecomposition DCWide ['\x0042']),
		('\xFF23',MkDecomposition DCWide ['\x0043']),
		('\xFF24',MkDecomposition DCWide ['\x0044']),
		('\xFF25',MkDecomposition DCWide ['\x0045']),
		('\xFF26',MkDecomposition DCWide ['\x0046']),
		('\xFF27',MkDecomposition DCWide ['\x0047']),
		('\xFF28',MkDecomposition DCWide ['\x0048']),
		('\xFF29',MkDecomposition DCWide ['\x0049']),
		('\xFF2A',MkDecomposition DCWide ['\x004A']),
		('\xFF2B',MkDecomposition DCWide ['\x004B']),
		('\xFF2C',MkDecomposition DCWide ['\x004C']),
		('\xFF2D',MkDecomposition DCWide ['\x004D']),
		('\xFF2E',MkDecomposition DCWide ['\x004E']),
		('\xFF2F',MkDecomposition DCWide ['\x004F']),
		('\xFF30',MkDecomposition DCWide ['\x0050']),
		('\xFF31',MkDecomposition DCWide ['\x0051']),
		('\xFF32',MkDecomposition DCWide ['\x0052']),
		('\xFF33',MkDecomposition DCWide ['\x0053']),
		('\xFF34',MkDecomposition DCWide ['\x0054']),
		('\xFF35',MkDecomposition DCWide ['\x0055']),
		('\xFF36',MkDecomposition DCWide ['\x0056']),
		('\xFF37',MkDecomposition DCWide ['\x0057']),
		('\xFF38',MkDecomposition DCWide ['\x0058']),
		('\xFF39',MkDecomposition DCWide ['\x0059']),
		('\xFF3A',MkDecomposition DCWide ['\x005A']),
		('\xFF3B',MkDecomposition DCWide ['\x005B']),
		('\xFF3C',MkDecomposition DCWide ['\x005C']),
		('\xFF3D',MkDecomposition DCWide ['\x005D']),
		('\xFF3E',MkDecomposition DCWide ['\x005E']),
		('\xFF3F',MkDecomposition DCWide ['\x005F']),
		('\xFF40',MkDecomposition DCWide ['\x0060']),
		('\xFF41',MkDecomposition DCWide ['\x0061']),
		('\xFF42',MkDecomposition DCWide ['\x0062']),
		('\xFF43',MkDecomposition DCWide ['\x0063']),
		('\xFF44',MkDecomposition DCWide ['\x0064']),
		('\xFF45',MkDecomposition DCWide ['\x0065']),
		('\xFF46',MkDecomposition DCWide ['\x0066']),
		('\xFF47',MkDecomposition DCWide ['\x0067']),
		('\xFF48',MkDecomposition DCWide ['\x0068']),
		('\xFF49',MkDecomposition DCWide ['\x0069']),
		('\xFF4A',MkDecomposition DCWide ['\x006A']),
		('\xFF4B',MkDecomposition DCWide ['\x006B']),
		('\xFF4C',MkDecomposition DCWide ['\x006C']),
		('\xFF4D',MkDecomposition DCWide ['\x006D']),
		('\xFF4E',MkDecomposition DCWide ['\x006E']),
		('\xFF4F',MkDecomposition DCWide ['\x006F']),
		('\xFF50',MkDecomposition DCWide ['\x0070']),
		('\xFF51',MkDecomposition DCWide ['\x0071']),
		('\xFF52',MkDecomposition DCWide ['\x0072']),
		('\xFF53',MkDecomposition DCWide ['\x0073']),
		('\xFF54',MkDecomposition DCWide ['\x0074']),
		('\xFF55',MkDecomposition DCWide ['\x0075']),
		('\xFF56',MkDecomposition DCWide ['\x0076']),
		('\xFF57',MkDecomposition DCWide ['\x0077']),
		('\xFF58',MkDecomposition DCWide ['\x0078']),
		('\xFF59',MkDecomposition DCWide ['\x0079']),
		('\xFF5A',MkDecomposition DCWide ['\x007A']),
		('\xFF5B',MkDecomposition DCWide ['\x007B']),
		('\xFF5C',MkDecomposition DCWide ['\x007C']),
		('\xFF5D',MkDecomposition DCWide ['\x007D']),
		('\xFF5E',MkDecomposition DCWide ['\x007E']),
		('\xFF5F',MkDecomposition DCWide ['\x2985']),
		('\xFF60',MkDecomposition DCWide ['\x2986']),
		('\xFF61',MkDecomposition DCNarrow ['\x3002']),
		('\xFF62',MkDecomposition DCNarrow ['\x300C']),
		('\xFF63',MkDecomposition DCNarrow ['\x300D']),
		('\xFF64',MkDecomposition DCNarrow ['\x3001']),
		('\xFF65',MkDecomposition DCNarrow ['\x30FB']),
		('\xFF66',MkDecomposition DCNarrow ['\x30F2']),
		('\xFF67',MkDecomposition DCNarrow ['\x30A1']),
		('\xFF68',MkDecomposition DCNarrow ['\x30A3']),
		('\xFF69',MkDecomposition DCNarrow ['\x30A5']),
		('\xFF6A',MkDecomposition DCNarrow ['\x30A7']),
		('\xFF6B',MkDecomposition DCNarrow ['\x30A9']),
		('\xFF6C',MkDecomposition DCNarrow ['\x30E3']),
		('\xFF6D',MkDecomposition DCNarrow ['\x30E5']),
		('\xFF6E',MkDecomposition DCNarrow ['\x30E7']),
		('\xFF6F',MkDecomposition DCNarrow ['\x30C3']),
		('\xFF70',MkDecomposition DCNarrow ['\x30FC']),
		('\xFF71',MkDecomposition DCNarrow ['\x30A2']),
		('\xFF72',MkDecomposition DCNarrow ['\x30A4']),
		('\xFF73',MkDecomposition DCNarrow ['\x30A6']),
		('\xFF74',MkDecomposition DCNarrow ['\x30A8']),
		('\xFF75',MkDecomposition DCNarrow ['\x30AA']),
		('\xFF76',MkDecomposition DCNarrow ['\x30AB']),
		('\xFF77',MkDecomposition DCNarrow ['\x30AD']),
		('\xFF78',MkDecomposition DCNarrow ['\x30AF']),
		('\xFF79',MkDecomposition DCNarrow ['\x30B1']),
		('\xFF7A',MkDecomposition DCNarrow ['\x30B3']),
		('\xFF7B',MkDecomposition DCNarrow ['\x30B5']),
		('\xFF7C',MkDecomposition DCNarrow ['\x30B7']),
		('\xFF7D',MkDecomposition DCNarrow ['\x30B9']),
		('\xFF7E',MkDecomposition DCNarrow ['\x30BB']),
		('\xFF7F',MkDecomposition DCNarrow ['\x30BD']),
		('\xFF80',MkDecomposition DCNarrow ['\x30BF']),
		('\xFF81',MkDecomposition DCNarrow ['\x30C1']),
		('\xFF82',MkDecomposition DCNarrow ['\x30C4']),
		('\xFF83',MkDecomposition DCNarrow ['\x30C6']),
		('\xFF84',MkDecomposition DCNarrow ['\x30C8']),
		('\xFF85',MkDecomposition DCNarrow ['\x30CA']),
		('\xFF86',MkDecomposition DCNarrow ['\x30CB']),
		('\xFF87',MkDecomposition DCNarrow ['\x30CC']),
		('\xFF88',MkDecomposition DCNarrow ['\x30CD']),
		('\xFF89',MkDecomposition DCNarrow ['\x30CE']),
		('\xFF8A',MkDecomposition DCNarrow ['\x30CF']),
		('\xFF8B',MkDecomposition DCNarrow ['\x30D2']),
		('\xFF8C',MkDecomposition DCNarrow ['\x30D5']),
		('\xFF8D',MkDecomposition DCNarrow ['\x30D8']),
		('\xFF8E',MkDecomposition DCNarrow ['\x30DB']),
		('\xFF8F',MkDecomposition DCNarrow ['\x30DE']),
		('\xFF90',MkDecomposition DCNarrow ['\x30DF']),
		('\xFF91',MkDecomposition DCNarrow ['\x30E0']),
		('\xFF92',MkDecomposition DCNarrow ['\x30E1']),
		('\xFF93',MkDecomposition DCNarrow ['\x30E2']),
		('\xFF94',MkDecomposition DCNarrow ['\x30E4']),
		('\xFF95',MkDecomposition DCNarrow ['\x30E6']),
		('\xFF96',MkDecomposition DCNarrow ['\x30E8']),
		('\xFF97',MkDecomposition DCNarrow ['\x30E9']),
		('\xFF98',MkDecomposition DCNarrow ['\x30EA']),
		('\xFF99',MkDecomposition DCNarrow ['\x30EB']),
		('\xFF9A',MkDecomposition DCNarrow ['\x30EC']),
		('\xFF9B',MkDecomposition DCNarrow ['\x30ED']),
		('\xFF9C',MkDecomposition DCNarrow ['\x30EF']),
		('\xFF9D',MkDecomposition DCNarrow ['\x30F3']),
		('\xFF9E',MkDecomposition DCNarrow ['\x3099']),
		('\xFF9F',MkDecomposition DCNarrow ['\x309A']),
		('\xFFA0',MkDecomposition DCNarrow ['\x3164']),
		('\xFFA1',MkDecomposition DCNarrow ['\x3131']),
		('\xFFA2',MkDecomposition DCNarrow ['\x3132']),
		('\xFFA3',MkDecomposition DCNarrow ['\x3133']),
		('\xFFA4',MkDecomposition DCNarrow ['\x3134']),
		('\xFFA5',MkDecomposition DCNarrow ['\x3135']),
		('\xFFA6',MkDecomposition DCNarrow ['\x3136']),
		('\xFFA7',MkDecomposition DCNarrow ['\x3137']),
		('\xFFA8',MkDecomposition DCNarrow ['\x3138']),
		('\xFFA9',MkDecomposition DCNarrow ['\x3139']),
		('\xFFAA',MkDecomposition DCNarrow ['\x313A']),
		('\xFFAB',MkDecomposition DCNarrow ['\x313B']),
		('\xFFAC',MkDecomposition DCNarrow ['\x313C']),
		('\xFFAD',MkDecomposition DCNarrow ['\x313D']),
		('\xFFAE',MkDecomposition DCNarrow ['\x313E']),
		('\xFFAF',MkDecomposition DCNarrow ['\x313F']),
		('\xFFB0',MkDecomposition DCNarrow ['\x3140']),
		('\xFFB1',MkDecomposition DCNarrow ['\x3141']),
		('\xFFB2',MkDecomposition DCNarrow ['\x3142']),
		('\xFFB3',MkDecomposition DCNarrow ['\x3143']),
		('\xFFB4',MkDecomposition DCNarrow ['\x3144']),
		('\xFFB5',MkDecomposition DCNarrow ['\x3145']),
		('\xFFB6',MkDecomposition DCNarrow ['\x3146']),
		('\xFFB7',MkDecomposition DCNarrow ['\x3147']),
		('\xFFB8',MkDecomposition DCNarrow ['\x3148']),
		('\xFFB9',MkDecomposition DCNarrow ['\x3149']),
		('\xFFBA',MkDecomposition DCNarrow ['\x314A']),
		('\xFFBB',MkDecomposition DCNarrow ['\x314B']),
		('\xFFBC',MkDecomposition DCNarrow ['\x314C']),
		('\xFFBD',MkDecomposition DCNarrow ['\x314D']),
		('\xFFBE',MkDecomposition DCNarrow ['\x314E']),
		('\xFFC2',MkDecomposition DCNarrow ['\x314F']),
		('\xFFC3',MkDecomposition DCNarrow ['\x3150']),
		('\xFFC4',MkDecomposition DCNarrow ['\x3151']),
		('\xFFC5',MkDecomposition DCNarrow ['\x3152']),
		('\xFFC6',MkDecomposition DCNarrow ['\x3153']),
		('\xFFC7',MkDecomposition DCNarrow ['\x3154']),
		('\xFFCA',MkDecomposition DCNarrow ['\x3155']),
		('\xFFCB',MkDecomposition DCNarrow ['\x3156']),
		('\xFFCC',MkDecomposition DCNarrow ['\x3157']),
		('\xFFCD',MkDecomposition DCNarrow ['\x3158']),
		('\xFFCE',MkDecomposition DCNarrow ['\x3159']),
		('\xFFCF',MkDecomposition DCNarrow ['\x315A']),
		('\xFFD2',MkDecomposition DCNarrow ['\x315B']),
		('\xFFD3',MkDecomposition DCNarrow ['\x315C']),
		('\xFFD4',MkDecomposition DCNarrow ['\x315D']),
		('\xFFD5',MkDecomposition DCNarrow ['\x315E']),
		('\xFFD6',MkDecomposition DCNarrow ['\x315F']),
		('\xFFD7',MkDecomposition DCNarrow ['\x3160']),
		('\xFFDA',MkDecomposition DCNarrow ['\x3161']),
		('\xFFDB',MkDecomposition DCNarrow ['\x3162']),
		('\xFFDC',MkDecomposition DCNarrow ['\x3163']),
		('\xFFE0',MkDecomposition DCWide ['\x00A2']),
		('\xFFE1',MkDecomposition DCWide ['\x00A3']),
		('\xFFE2',MkDecomposition DCWide ['\x00AC']),
		('\xFFE3',MkDecomposition DCWide ['\x00AF']),
		('\xFFE4',MkDecomposition DCWide ['\x00A6']),
		('\xFFE5',MkDecomposition DCWide ['\x00A5']),
		('\xFFE6',MkDecomposition DCWide ['\x20A9']),
		('\xFFE8',MkDecomposition DCNarrow ['\x2502']),
		('\xFFE9',MkDecomposition DCNarrow ['\x2190']),
		('\xFFEA',MkDecomposition DCNarrow ['\x2191']),
		('\xFFEB',MkDecomposition DCNarrow ['\x2192']),
		('\xFFEC',MkDecomposition DCNarrow ['\x2193']),
		('\xFFED',MkDecomposition DCNarrow ['\x25A0']),
		('\xFFEE',MkDecomposition DCNarrow ['\x25CB']),
		('\x1D15E',MkDecomposition DCCanonical ['\x1D157','\x1D165']),
		('\x1D15F',MkDecomposition DCCanonical ['\x1D158','\x1D165']),
		('\x1D160',MkDecomposition DCCanonical ['\x1D15F','\x1D16E']),
		('\x1D161',MkDecomposition DCCanonical ['\x1D15F','\x1D16F']),
		('\x1D162',MkDecomposition DCCanonical ['\x1D15F','\x1D170']),
		('\x1D163',MkDecomposition DCCanonical ['\x1D15F','\x1D171']),
		('\x1D164',MkDecomposition DCCanonical ['\x1D15F','\x1D172']),
		('\x1D1BB',MkDecomposition DCCanonical ['\x1D1B9','\x1D165']),
		('\x1D1BC',MkDecomposition DCCanonical ['\x1D1BA','\x1D165']),
		('\x1D1BD',MkDecomposition DCCanonical ['\x1D1BB','\x1D16E']),
		('\x1D1BE',MkDecomposition DCCanonical ['\x1D1BC','\x1D16E']),
		('\x1D1BF',MkDecomposition DCCanonical ['\x1D1BB','\x1D16F']),
		('\x1D1C0',MkDecomposition DCCanonical ['\x1D1BC','\x1D16F']),
		('\x1D400',MkDecomposition DCFont ['\x0041']),
		('\x1D401',MkDecomposition DCFont ['\x0042']),
		('\x1D402',MkDecomposition DCFont ['\x0043']),
		('\x1D403',MkDecomposition DCFont ['\x0044']),
		('\x1D404',MkDecomposition DCFont ['\x0045']),
		('\x1D405',MkDecomposition DCFont ['\x0046']),
		('\x1D406',MkDecomposition DCFont ['\x0047']),
		('\x1D407',MkDecomposition DCFont ['\x0048']),
		('\x1D408',MkDecomposition DCFont ['\x0049']),
		('\x1D409',MkDecomposition DCFont ['\x004A']),
		('\x1D40A',MkDecomposition DCFont ['\x004B']),
		('\x1D40B',MkDecomposition DCFont ['\x004C']),
		('\x1D40C',MkDecomposition DCFont ['\x004D']),
		('\x1D40D',MkDecomposition DCFont ['\x004E']),
		('\x1D40E',MkDecomposition DCFont ['\x004F']),
		('\x1D40F',MkDecomposition DCFont ['\x0050']),
		('\x1D410',MkDecomposition DCFont ['\x0051']),
		('\x1D411',MkDecomposition DCFont ['\x0052']),
		('\x1D412',MkDecomposition DCFont ['\x0053']),
		('\x1D413',MkDecomposition DCFont ['\x0054']),
		('\x1D414',MkDecomposition DCFont ['\x0055']),
		('\x1D415',MkDecomposition DCFont ['\x0056']),
		('\x1D416',MkDecomposition DCFont ['\x0057']),
		('\x1D417',MkDecomposition DCFont ['\x0058']),
		('\x1D418',MkDecomposition DCFont ['\x0059']),
		('\x1D419',MkDecomposition DCFont ['\x005A']),
		('\x1D41A',MkDecomposition DCFont ['\x0061']),
		('\x1D41B',MkDecomposition DCFont ['\x0062']),
		('\x1D41C',MkDecomposition DCFont ['\x0063']),
		('\x1D41D',MkDecomposition DCFont ['\x0064']),
		('\x1D41E',MkDecomposition DCFont ['\x0065']),
		('\x1D41F',MkDecomposition DCFont ['\x0066']),
		('\x1D420',MkDecomposition DCFont ['\x0067']),
		('\x1D421',MkDecomposition DCFont ['\x0068']),
		('\x1D422',MkDecomposition DCFont ['\x0069']),
		('\x1D423',MkDecomposition DCFont ['\x006A']),
		('\x1D424',MkDecomposition DCFont ['\x006B']),
		('\x1D425',MkDecomposition DCFont ['\x006C']),
		('\x1D426',MkDecomposition DCFont ['\x006D']),
		('\x1D427',MkDecomposition DCFont ['\x006E']),
		('\x1D428',MkDecomposition DCFont ['\x006F']),
		('\x1D429',MkDecomposition DCFont ['\x0070']),
		('\x1D42A',MkDecomposition DCFont ['\x0071']),
		('\x1D42B',MkDecomposition DCFont ['\x0072']),
		('\x1D42C',MkDecomposition DCFont ['\x0073']),
		('\x1D42D',MkDecomposition DCFont ['\x0074']),
		('\x1D42E',MkDecomposition DCFont ['\x0075']),
		('\x1D42F',MkDecomposition DCFont ['\x0076']),
		('\x1D430',MkDecomposition DCFont ['\x0077']),
		('\x1D431',MkDecomposition DCFont ['\x0078']),
		('\x1D432',MkDecomposition DCFont ['\x0079']),
		('\x1D433',MkDecomposition DCFont ['\x007A']),
		('\x1D434',MkDecomposition DCFont ['\x0041']),
		('\x1D435',MkDecomposition DCFont ['\x0042']),
		('\x1D436',MkDecomposition DCFont ['\x0043']),
		('\x1D437',MkDecomposition DCFont ['\x0044']),
		('\x1D438',MkDecomposition DCFont ['\x0045']),
		('\x1D439',MkDecomposition DCFont ['\x0046']),
		('\x1D43A',MkDecomposition DCFont ['\x0047']),
		('\x1D43B',MkDecomposition DCFont ['\x0048']),
		('\x1D43C',MkDecomposition DCFont ['\x0049']),
		('\x1D43D',MkDecomposition DCFont ['\x004A']),
		('\x1D43E',MkDecomposition DCFont ['\x004B']),
		('\x1D43F',MkDecomposition DCFont ['\x004C']),
		('\x1D440',MkDecomposition DCFont ['\x004D']),
		('\x1D441',MkDecomposition DCFont ['\x004E']),
		('\x1D442',MkDecomposition DCFont ['\x004F']),
		('\x1D443',MkDecomposition DCFont ['\x0050']),
		('\x1D444',MkDecomposition DCFont ['\x0051']),
		('\x1D445',MkDecomposition DCFont ['\x0052']),
		('\x1D446',MkDecomposition DCFont ['\x0053']),
		('\x1D447',MkDecomposition DCFont ['\x0054']),
		('\x1D448',MkDecomposition DCFont ['\x0055']),
		('\x1D449',MkDecomposition DCFont ['\x0056']),
		('\x1D44A',MkDecomposition DCFont ['\x0057']),
		('\x1D44B',MkDecomposition DCFont ['\x0058']),
		('\x1D44C',MkDecomposition DCFont ['\x0059']),
		('\x1D44D',MkDecomposition DCFont ['\x005A']),
		('\x1D44E',MkDecomposition DCFont ['\x0061']),
		('\x1D44F',MkDecomposition DCFont ['\x0062']),
		('\x1D450',MkDecomposition DCFont ['\x0063']),
		('\x1D451',MkDecomposition DCFont ['\x0064']),
		('\x1D452',MkDecomposition DCFont ['\x0065']),
		('\x1D453',MkDecomposition DCFont ['\x0066']),
		('\x1D454',MkDecomposition DCFont ['\x0067']),
		('\x1D456',MkDecomposition DCFont ['\x0069']),
		('\x1D457',MkDecomposition DCFont ['\x006A']),
		('\x1D458',MkDecomposition DCFont ['\x006B']),
		('\x1D459',MkDecomposition DCFont ['\x006C']),
		('\x1D45A',MkDecomposition DCFont ['\x006D']),
		('\x1D45B',MkDecomposition DCFont ['\x006E']),
		('\x1D45C',MkDecomposition DCFont ['\x006F']),
		('\x1D45D',MkDecomposition DCFont ['\x0070']),
		('\x1D45E',MkDecomposition DCFont ['\x0071']),
		('\x1D45F',MkDecomposition DCFont ['\x0072']),
		('\x1D460',MkDecomposition DCFont ['\x0073']),
		('\x1D461',MkDecomposition DCFont ['\x0074']),
		('\x1D462',MkDecomposition DCFont ['\x0075']),
		('\x1D463',MkDecomposition DCFont ['\x0076']),
		('\x1D464',MkDecomposition DCFont ['\x0077']),
		('\x1D465',MkDecomposition DCFont ['\x0078']),
		('\x1D466',MkDecomposition DCFont ['\x0079']),
		('\x1D467',MkDecomposition DCFont ['\x007A']),
		('\x1D468',MkDecomposition DCFont ['\x0041']),
		('\x1D469',MkDecomposition DCFont ['\x0042']),
		('\x1D46A',MkDecomposition DCFont ['\x0043']),
		('\x1D46B',MkDecomposition DCFont ['\x0044']),
		('\x1D46C',MkDecomposition DCFont ['\x0045']),
		('\x1D46D',MkDecomposition DCFont ['\x0046']),
		('\x1D46E',MkDecomposition DCFont ['\x0047']),
		('\x1D46F',MkDecomposition DCFont ['\x0048']),
		('\x1D470',MkDecomposition DCFont ['\x0049']),
		('\x1D471',MkDecomposition DCFont ['\x004A']),
		('\x1D472',MkDecomposition DCFont ['\x004B']),
		('\x1D473',MkDecomposition DCFont ['\x004C']),
		('\x1D474',MkDecomposition DCFont ['\x004D']),
		('\x1D475',MkDecomposition DCFont ['\x004E']),
		('\x1D476',MkDecomposition DCFont ['\x004F']),
		('\x1D477',MkDecomposition DCFont ['\x0050']),
		('\x1D478',MkDecomposition DCFont ['\x0051']),
		('\x1D479',MkDecomposition DCFont ['\x0052']),
		('\x1D47A',MkDecomposition DCFont ['\x0053']),
		('\x1D47B',MkDecomposition DCFont ['\x0054']),
		('\x1D47C',MkDecomposition DCFont ['\x0055']),
		('\x1D47D',MkDecomposition DCFont ['\x0056']),
		('\x1D47E',MkDecomposition DCFont ['\x0057']),
		('\x1D47F',MkDecomposition DCFont ['\x0058']),
		('\x1D480',MkDecomposition DCFont ['\x0059']),
		('\x1D481',MkDecomposition DCFont ['\x005A']),
		('\x1D482',MkDecomposition DCFont ['\x0061']),
		('\x1D483',MkDecomposition DCFont ['\x0062']),
		('\x1D484',MkDecomposition DCFont ['\x0063']),
		('\x1D485',MkDecomposition DCFont ['\x0064']),
		('\x1D486',MkDecomposition DCFont ['\x0065']),
		('\x1D487',MkDecomposition DCFont ['\x0066']),
		('\x1D488',MkDecomposition DCFont ['\x0067']),
		('\x1D489',MkDecomposition DCFont ['\x0068']),
		('\x1D48A',MkDecomposition DCFont ['\x0069']),
		('\x1D48B',MkDecomposition DCFont ['\x006A']),
		('\x1D48C',MkDecomposition DCFont ['\x006B']),
		('\x1D48D',MkDecomposition DCFont ['\x006C']),
		('\x1D48E',MkDecomposition DCFont ['\x006D']),
		('\x1D48F',MkDecomposition DCFont ['\x006E']),
		('\x1D490',MkDecomposition DCFont ['\x006F']),
		('\x1D491',MkDecomposition DCFont ['\x0070']),
		('\x1D492',MkDecomposition DCFont ['\x0071']),
		('\x1D493',MkDecomposition DCFont ['\x0072']),
		('\x1D494',MkDecomposition DCFont ['\x0073']),
		('\x1D495',MkDecomposition DCFont ['\x0074']),
		('\x1D496',MkDecomposition DCFont ['\x0075']),
		('\x1D497',MkDecomposition DCFont ['\x0076']),
		('\x1D498',MkDecomposition DCFont ['\x0077']),
		('\x1D499',MkDecomposition DCFont ['\x0078']),
		('\x1D49A',MkDecomposition DCFont ['\x0079']),
		('\x1D49B',MkDecomposition DCFont ['\x007A']),
		('\x1D49C',MkDecomposition DCFont ['\x0041']),
		('\x1D49E',MkDecomposition DCFont ['\x0043']),
		('\x1D49F',MkDecomposition DCFont ['\x0044']),
		('\x1D4A2',MkDecomposition DCFont ['\x0047']),
		('\x1D4A5',MkDecomposition DCFont ['\x004A']),
		('\x1D4A6',MkDecomposition DCFont ['\x004B']),
		('\x1D4A9',MkDecomposition DCFont ['\x004E']),
		('\x1D4AA',MkDecomposition DCFont ['\x004F']),
		('\x1D4AB',MkDecomposition DCFont ['\x0050']),
		('\x1D4AC',MkDecomposition DCFont ['\x0051']),
		('\x1D4AE',MkDecomposition DCFont ['\x0053']),
		('\x1D4AF',MkDecomposition DCFont ['\x0054']),
		('\x1D4B0',MkDecomposition DCFont ['\x0055']),
		('\x1D4B1',MkDecomposition DCFont ['\x0056']),
		('\x1D4B2',MkDecomposition DCFont ['\x0057']),
		('\x1D4B3',MkDecomposition DCFont ['\x0058']),
		('\x1D4B4',MkDecomposition DCFont ['\x0059']),
		('\x1D4B5',MkDecomposition DCFont ['\x005A']),
		('\x1D4B6',MkDecomposition DCFont ['\x0061']),
		('\x1D4B7',MkDecomposition DCFont ['\x0062']),
		('\x1D4B8',MkDecomposition DCFont ['\x0063']),
		('\x1D4B9',MkDecomposition DCFont ['\x0064']),
		('\x1D4BB',MkDecomposition DCFont ['\x0066']),
		('\x1D4BD',MkDecomposition DCFont ['\x0068']),
		('\x1D4BE',MkDecomposition DCFont ['\x0069']),
		('\x1D4BF',MkDecomposition DCFont ['\x006A']),
		('\x1D4C0',MkDecomposition DCFont ['\x006B']),
		('\x1D4C2',MkDecomposition DCFont ['\x006D']),
		('\x1D4C3',MkDecomposition DCFont ['\x006E']),
		('\x1D4C5',MkDecomposition DCFont ['\x0070']),
		('\x1D4C6',MkDecomposition DCFont ['\x0071']),
		('\x1D4C7',MkDecomposition DCFont ['\x0072']),
		('\x1D4C8',MkDecomposition DCFont ['\x0073']),
		('\x1D4C9',MkDecomposition DCFont ['\x0074']),
		('\x1D4CA',MkDecomposition DCFont ['\x0075']),
		('\x1D4CB',MkDecomposition DCFont ['\x0076']),
		('\x1D4CC',MkDecomposition DCFont ['\x0077']),
		('\x1D4CD',MkDecomposition DCFont ['\x0078']),
		('\x1D4CE',MkDecomposition DCFont ['\x0079']),
		('\x1D4CF',MkDecomposition DCFont ['\x007A']),
		('\x1D4D0',MkDecomposition DCFont ['\x0041']),
		('\x1D4D1',MkDecomposition DCFont ['\x0042']),
		('\x1D4D2',MkDecomposition DCFont ['\x0043']),
		('\x1D4D3',MkDecomposition DCFont ['\x0044']),
		('\x1D4D4',MkDecomposition DCFont ['\x0045']),
		('\x1D4D5',MkDecomposition DCFont ['\x0046']),
		('\x1D4D6',MkDecomposition DCFont ['\x0047']),
		('\x1D4D7',MkDecomposition DCFont ['\x0048']),
		('\x1D4D8',MkDecomposition DCFont ['\x0049']),
		('\x1D4D9',MkDecomposition DCFont ['\x004A']),
		('\x1D4DA',MkDecomposition DCFont ['\x004B']),
		('\x1D4DB',MkDecomposition DCFont ['\x004C']),
		('\x1D4DC',MkDecomposition DCFont ['\x004D']),
		('\x1D4DD',MkDecomposition DCFont ['\x004E']),
		('\x1D4DE',MkDecomposition DCFont ['\x004F']),
		('\x1D4DF',MkDecomposition DCFont ['\x0050']),
		('\x1D4E0',MkDecomposition DCFont ['\x0051']),
		('\x1D4E1',MkDecomposition DCFont ['\x0052']),
		('\x1D4E2',MkDecomposition DCFont ['\x0053']),
		('\x1D4E3',MkDecomposition DCFont ['\x0054']),
		('\x1D4E4',MkDecomposition DCFont ['\x0055']),
		('\x1D4E5',MkDecomposition DCFont ['\x0056']),
		('\x1D4E6',MkDecomposition DCFont ['\x0057']),
		('\x1D4E7',MkDecomposition DCFont ['\x0058']),
		('\x1D4E8',MkDecomposition DCFont ['\x0059']),
		('\x1D4E9',MkDecomposition DCFont ['\x005A']),
		('\x1D4EA',MkDecomposition DCFont ['\x0061']),
		('\x1D4EB',MkDecomposition DCFont ['\x0062']),
		('\x1D4EC',MkDecomposition DCFont ['\x0063']),
		('\x1D4ED',MkDecomposition DCFont ['\x0064']),
		('\x1D4EE',MkDecomposition DCFont ['\x0065']),
		('\x1D4EF',MkDecomposition DCFont ['\x0066']),
		('\x1D4F0',MkDecomposition DCFont ['\x0067']),
		('\x1D4F1',MkDecomposition DCFont ['\x0068']),
		('\x1D4F2',MkDecomposition DCFont ['\x0069']),
		('\x1D4F3',MkDecomposition DCFont ['\x006A']),
		('\x1D4F4',MkDecomposition DCFont ['\x006B']),
		('\x1D4F5',MkDecomposition DCFont ['\x006C']),
		('\x1D4F6',MkDecomposition DCFont ['\x006D']),
		('\x1D4F7',MkDecomposition DCFont ['\x006E']),
		('\x1D4F8',MkDecomposition DCFont ['\x006F']),
		('\x1D4F9',MkDecomposition DCFont ['\x0070']),
		('\x1D4FA',MkDecomposition DCFont ['\x0071']),
		('\x1D4FB',MkDecomposition DCFont ['\x0072']),
		('\x1D4FC',MkDecomposition DCFont ['\x0073']),
		('\x1D4FD',MkDecomposition DCFont ['\x0074']),
		('\x1D4FE',MkDecomposition DCFont ['\x0075']),
		('\x1D4FF',MkDecomposition DCFont ['\x0076']),
		('\x1D500',MkDecomposition DCFont ['\x0077']),
		('\x1D501',MkDecomposition DCFont ['\x0078']),
		('\x1D502',MkDecomposition DCFont ['\x0079']),
		('\x1D503',MkDecomposition DCFont ['\x007A']),
		('\x1D504',MkDecomposition DCFont ['\x0041']),
		('\x1D505',MkDecomposition DCFont ['\x0042']),
		('\x1D507',MkDecomposition DCFont ['\x0044']),
		('\x1D508',MkDecomposition DCFont ['\x0045']),
		('\x1D509',MkDecomposition DCFont ['\x0046']),
		('\x1D50A',MkDecomposition DCFont ['\x0047']),
		('\x1D50D',MkDecomposition DCFont ['\x004A']),
		('\x1D50E',MkDecomposition DCFont ['\x004B']),
		('\x1D50F',MkDecomposition DCFont ['\x004C']),
		('\x1D510',MkDecomposition DCFont ['\x004D']),
		('\x1D511',MkDecomposition DCFont ['\x004E']),
		('\x1D512',MkDecomposition DCFont ['\x004F']),
		('\x1D513',MkDecomposition DCFont ['\x0050']),
		('\x1D514',MkDecomposition DCFont ['\x0051']),
		('\x1D516',MkDecomposition DCFont ['\x0053']),
		('\x1D517',MkDecomposition DCFont ['\x0054']),
		('\x1D518',MkDecomposition DCFont ['\x0055']),
		('\x1D519',MkDecomposition DCFont ['\x0056']),
		('\x1D51A',MkDecomposition DCFont ['\x0057']),
		('\x1D51B',MkDecomposition DCFont ['\x0058']),
		('\x1D51C',MkDecomposition DCFont ['\x0059']),
		('\x1D51E',MkDecomposition DCFont ['\x0061']),
		('\x1D51F',MkDecomposition DCFont ['\x0062']),
		('\x1D520',MkDecomposition DCFont ['\x0063']),
		('\x1D521',MkDecomposition DCFont ['\x0064']),
		('\x1D522',MkDecomposition DCFont ['\x0065']),
		('\x1D523',MkDecomposition DCFont ['\x0066']),
		('\x1D524',MkDecomposition DCFont ['\x0067']),
		('\x1D525',MkDecomposition DCFont ['\x0068']),
		('\x1D526',MkDecomposition DCFont ['\x0069']),
		('\x1D527',MkDecomposition DCFont ['\x006A']),
		('\x1D528',MkDecomposition DCFont ['\x006B']),
		('\x1D529',MkDecomposition DCFont ['\x006C']),
		('\x1D52A',MkDecomposition DCFont ['\x006D']),
		('\x1D52B',MkDecomposition DCFont ['\x006E']),
		('\x1D52C',MkDecomposition DCFont ['\x006F']),
		('\x1D52D',MkDecomposition DCFont ['\x0070']),
		('\x1D52E',MkDecomposition DCFont ['\x0071']),
		('\x1D52F',MkDecomposition DCFont ['\x0072']),
		('\x1D530',MkDecomposition DCFont ['\x0073']),
		('\x1D531',MkDecomposition DCFont ['\x0074']),
		('\x1D532',MkDecomposition DCFont ['\x0075']),
		('\x1D533',MkDecomposition DCFont ['\x0076']),
		('\x1D534',MkDecomposition DCFont ['\x0077']),
		('\x1D535',MkDecomposition DCFont ['\x0078']),
		('\x1D536',MkDecomposition DCFont ['\x0079']),
		('\x1D537',MkDecomposition DCFont ['\x007A']),
		('\x1D538',MkDecomposition DCFont ['\x0041']),
		('\x1D539',MkDecomposition DCFont ['\x0042']),
		('\x1D53B',MkDecomposition DCFont ['\x0044']),
		('\x1D53C',MkDecomposition DCFont ['\x0045']),
		('\x1D53D',MkDecomposition DCFont ['\x0046']),
		('\x1D53E',MkDecomposition DCFont ['\x0047']),
		('\x1D540',MkDecomposition DCFont ['\x0049']),
		('\x1D541',MkDecomposition DCFont ['\x004A']),
		('\x1D542',MkDecomposition DCFont ['\x004B']),
		('\x1D543',MkDecomposition DCFont ['\x004C']),
		('\x1D544',MkDecomposition DCFont ['\x004D']),
		('\x1D546',MkDecomposition DCFont ['\x004F']),
		('\x1D54A',MkDecomposition DCFont ['\x0053']),
		('\x1D54B',MkDecomposition DCFont ['\x0054']),
		('\x1D54C',MkDecomposition DCFont ['\x0055']),
		('\x1D54D',MkDecomposition DCFont ['\x0056']),
		('\x1D54E',MkDecomposition DCFont ['\x0057']),
		('\x1D54F',MkDecomposition DCFont ['\x0058']),
		('\x1D550',MkDecomposition DCFont ['\x0059']),
		('\x1D552',MkDecomposition DCFont ['\x0061']),
		('\x1D553',MkDecomposition DCFont ['\x0062']),
		('\x1D554',MkDecomposition DCFont ['\x0063']),
		('\x1D555',MkDecomposition DCFont ['\x0064']),
		('\x1D556',MkDecomposition DCFont ['\x0065']),
		('\x1D557',MkDecomposition DCFont ['\x0066']),
		('\x1D558',MkDecomposition DCFont ['\x0067']),
		('\x1D559',MkDecomposition DCFont ['\x0068']),
		('\x1D55A',MkDecomposition DCFont ['\x0069']),
		('\x1D55B',MkDecomposition DCFont ['\x006A']),
		('\x1D55C',MkDecomposition DCFont ['\x006B']),
		('\x1D55D',MkDecomposition DCFont ['\x006C']),
		('\x1D55E',MkDecomposition DCFont ['\x006D']),
		('\x1D55F',MkDecomposition DCFont ['\x006E']),
		('\x1D560',MkDecomposition DCFont ['\x006F']),
		('\x1D561',MkDecomposition DCFont ['\x0070']),
		('\x1D562',MkDecomposition DCFont ['\x0071']),
		('\x1D563',MkDecomposition DCFont ['\x0072']),
		('\x1D564',MkDecomposition DCFont ['\x0073']),
		('\x1D565',MkDecomposition DCFont ['\x0074']),
		('\x1D566',MkDecomposition DCFont ['\x0075']),
		('\x1D567',MkDecomposition DCFont ['\x0076']),
		('\x1D568',MkDecomposition DCFont ['\x0077']),
		('\x1D569',MkDecomposition DCFont ['\x0078']),
		('\x1D56A',MkDecomposition DCFont ['\x0079']),
		('\x1D56B',MkDecomposition DCFont ['\x007A']),
		('\x1D56C',MkDecomposition DCFont ['\x0041']),
		('\x1D56D',MkDecomposition DCFont ['\x0042']),
		('\x1D56E',MkDecomposition DCFont ['\x0043']),
		('\x1D56F',MkDecomposition DCFont ['\x0044']),
		('\x1D570',MkDecomposition DCFont ['\x0045']),
		('\x1D571',MkDecomposition DCFont ['\x0046']),
		('\x1D572',MkDecomposition DCFont ['\x0047']),
		('\x1D573',MkDecomposition DCFont ['\x0048']),
		('\x1D574',MkDecomposition DCFont ['\x0049']),
		('\x1D575',MkDecomposition DCFont ['\x004A']),
		('\x1D576',MkDecomposition DCFont ['\x004B']),
		('\x1D577',MkDecomposition DCFont ['\x004C']),
		('\x1D578',MkDecomposition DCFont ['\x004D']),
		('\x1D579',MkDecomposition DCFont ['\x004E']),
		('\x1D57A',MkDecomposition DCFont ['\x004F']),
		('\x1D57B',MkDecomposition DCFont ['\x0050']),
		('\x1D57C',MkDecomposition DCFont ['\x0051']),
		('\x1D57D',MkDecomposition DCFont ['\x0052']),
		('\x1D57E',MkDecomposition DCFont ['\x0053']),
		('\x1D57F',MkDecomposition DCFont ['\x0054']),
		('\x1D580',MkDecomposition DCFont ['\x0055']),
		('\x1D581',MkDecomposition DCFont ['\x0056']),
		('\x1D582',MkDecomposition DCFont ['\x0057']),
		('\x1D583',MkDecomposition DCFont ['\x0058']),
		('\x1D584',MkDecomposition DCFont ['\x0059']),
		('\x1D585',MkDecomposition DCFont ['\x005A']),
		('\x1D586',MkDecomposition DCFont ['\x0061']),
		('\x1D587',MkDecomposition DCFont ['\x0062']),
		('\x1D588',MkDecomposition DCFont ['\x0063']),
		('\x1D589',MkDecomposition DCFont ['\x0064']),
		('\x1D58A',MkDecomposition DCFont ['\x0065']),
		('\x1D58B',MkDecomposition DCFont ['\x0066']),
		('\x1D58C',MkDecomposition DCFont ['\x0067']),
		('\x1D58D',MkDecomposition DCFont ['\x0068']),
		('\x1D58E',MkDecomposition DCFont ['\x0069']),
		('\x1D58F',MkDecomposition DCFont ['\x006A']),
		('\x1D590',MkDecomposition DCFont ['\x006B']),
		('\x1D591',MkDecomposition DCFont ['\x006C']),
		('\x1D592',MkDecomposition DCFont ['\x006D']),
		('\x1D593',MkDecomposition DCFont ['\x006E']),
		('\x1D594',MkDecomposition DCFont ['\x006F']),
		('\x1D595',MkDecomposition DCFont ['\x0070']),
		('\x1D596',MkDecomposition DCFont ['\x0071']),
		('\x1D597',MkDecomposition DCFont ['\x0072']),
		('\x1D598',MkDecomposition DCFont ['\x0073']),
		('\x1D599',MkDecomposition DCFont ['\x0074']),
		('\x1D59A',MkDecomposition DCFont ['\x0075']),
		('\x1D59B',MkDecomposition DCFont ['\x0076']),
		('\x1D59C',MkDecomposition DCFont ['\x0077']),
		('\x1D59D',MkDecomposition DCFont ['\x0078']),
		('\x1D59E',MkDecomposition DCFont ['\x0079']),
		('\x1D59F',MkDecomposition DCFont ['\x007A']),
		('\x1D5A0',MkDecomposition DCFont ['\x0041']),
		('\x1D5A1',MkDecomposition DCFont ['\x0042']),
		('\x1D5A2',MkDecomposition DCFont ['\x0043']),
		('\x1D5A3',MkDecomposition DCFont ['\x0044']),
		('\x1D5A4',MkDecomposition DCFont ['\x0045']),
		('\x1D5A5',MkDecomposition DCFont ['\x0046']),
		('\x1D5A6',MkDecomposition DCFont ['\x0047']),
		('\x1D5A7',MkDecomposition DCFont ['\x0048']),
		('\x1D5A8',MkDecomposition DCFont ['\x0049']),
		('\x1D5A9',MkDecomposition DCFont ['\x004A']),
		('\x1D5AA',MkDecomposition DCFont ['\x004B']),
		('\x1D5AB',MkDecomposition DCFont ['\x004C']),
		('\x1D5AC',MkDecomposition DCFont ['\x004D']),
		('\x1D5AD',MkDecomposition DCFont ['\x004E']),
		('\x1D5AE',MkDecomposition DCFont ['\x004F']),
		('\x1D5AF',MkDecomposition DCFont ['\x0050']),
		('\x1D5B0',MkDecomposition DCFont ['\x0051']),
		('\x1D5B1',MkDecomposition DCFont ['\x0052']),
		('\x1D5B2',MkDecomposition DCFont ['\x0053']),
		('\x1D5B3',MkDecomposition DCFont ['\x0054']),
		('\x1D5B4',MkDecomposition DCFont ['\x0055']),
		('\x1D5B5',MkDecomposition DCFont ['\x0056']),
		('\x1D5B6',MkDecomposition DCFont ['\x0057']),
		('\x1D5B7',MkDecomposition DCFont ['\x0058']),
		('\x1D5B8',MkDecomposition DCFont ['\x0059']),
		('\x1D5B9',MkDecomposition DCFont ['\x005A']),
		('\x1D5BA',MkDecomposition DCFont ['\x0061']),
		('\x1D5BB',MkDecomposition DCFont ['\x0062']),
		('\x1D5BC',MkDecomposition DCFont ['\x0063']),
		('\x1D5BD',MkDecomposition DCFont ['\x0064']),
		('\x1D5BE',MkDecomposition DCFont ['\x0065']),
		('\x1D5BF',MkDecomposition DCFont ['\x0066']),
		('\x1D5C0',MkDecomposition DCFont ['\x0067']),
		('\x1D5C1',MkDecomposition DCFont ['\x0068']),
		('\x1D5C2',MkDecomposition DCFont ['\x0069']),
		('\x1D5C3',MkDecomposition DCFont ['\x006A']),
		('\x1D5C4',MkDecomposition DCFont ['\x006B']),
		('\x1D5C5',MkDecomposition DCFont ['\x006C']),
		('\x1D5C6',MkDecomposition DCFont ['\x006D']),
		('\x1D5C7',MkDecomposition DCFont ['\x006E']),
		('\x1D5C8',MkDecomposition DCFont ['\x006F']),
		('\x1D5C9',MkDecomposition DCFont ['\x0070']),
		('\x1D5CA',MkDecomposition DCFont ['\x0071']),
		('\x1D5CB',MkDecomposition DCFont ['\x0072']),
		('\x1D5CC',MkDecomposition DCFont ['\x0073']),
		('\x1D5CD',MkDecomposition DCFont ['\x0074']),
		('\x1D5CE',MkDecomposition DCFont ['\x0075']),
		('\x1D5CF',MkDecomposition DCFont ['\x0076']),
		('\x1D5D0',MkDecomposition DCFont ['\x0077']),
		('\x1D5D1',MkDecomposition DCFont ['\x0078']),
		('\x1D5D2',MkDecomposition DCFont ['\x0079']),
		('\x1D5D3',MkDecomposition DCFont ['\x007A']),
		('\x1D5D4',MkDecomposition DCFont ['\x0041']),
		('\x1D5D5',MkDecomposition DCFont ['\x0042']),
		('\x1D5D6',MkDecomposition DCFont ['\x0043']),
		('\x1D5D7',MkDecomposition DCFont ['\x0044']),
		('\x1D5D8',MkDecomposition DCFont ['\x0045']),
		('\x1D5D9',MkDecomposition DCFont ['\x0046']),
		('\x1D5DA',MkDecomposition DCFont ['\x0047']),
		('\x1D5DB',MkDecomposition DCFont ['\x0048']),
		('\x1D5DC',MkDecomposition DCFont ['\x0049']),
		('\x1D5DD',MkDecomposition DCFont ['\x004A']),
		('\x1D5DE',MkDecomposition DCFont ['\x004B']),
		('\x1D5DF',MkDecomposition DCFont ['\x004C']),
		('\x1D5E0',MkDecomposition DCFont ['\x004D']),
		('\x1D5E1',MkDecomposition DCFont ['\x004E']),
		('\x1D5E2',MkDecomposition DCFont ['\x004F']),
		('\x1D5E3',MkDecomposition DCFont ['\x0050']),
		('\x1D5E4',MkDecomposition DCFont ['\x0051']),
		('\x1D5E5',MkDecomposition DCFont ['\x0052']),
		('\x1D5E6',MkDecomposition DCFont ['\x0053']),
		('\x1D5E7',MkDecomposition DCFont ['\x0054']),
		('\x1D5E8',MkDecomposition DCFont ['\x0055']),
		('\x1D5E9',MkDecomposition DCFont ['\x0056']),
		('\x1D5EA',MkDecomposition DCFont ['\x0057']),
		('\x1D5EB',MkDecomposition DCFont ['\x0058']),
		('\x1D5EC',MkDecomposition DCFont ['\x0059']),
		('\x1D5ED',MkDecomposition DCFont ['\x005A']),
		('\x1D5EE',MkDecomposition DCFont ['\x0061']),
		('\x1D5EF',MkDecomposition DCFont ['\x0062']),
		('\x1D5F0',MkDecomposition DCFont ['\x0063']),
		('\x1D5F1',MkDecomposition DCFont ['\x0064']),
		('\x1D5F2',MkDecomposition DCFont ['\x0065']),
		('\x1D5F3',MkDecomposition DCFont ['\x0066']),
		('\x1D5F4',MkDecomposition DCFont ['\x0067']),
		('\x1D5F5',MkDecomposition DCFont ['\x0068']),
		('\x1D5F6',MkDecomposition DCFont ['\x0069']),
		('\x1D5F7',MkDecomposition DCFont ['\x006A']),
		('\x1D5F8',MkDecomposition DCFont ['\x006B']),
		('\x1D5F9',MkDecomposition DCFont ['\x006C']),
		('\x1D5FA',MkDecomposition DCFont ['\x006D']),
		('\x1D5FB',MkDecomposition DCFont ['\x006E']),
		('\x1D5FC',MkDecomposition DCFont ['\x006F']),
		('\x1D5FD',MkDecomposition DCFont ['\x0070']),
		('\x1D5FE',MkDecomposition DCFont ['\x0071']),
		('\x1D5FF',MkDecomposition DCFont ['\x0072']),
		('\x1D600',MkDecomposition DCFont ['\x0073']),
		('\x1D601',MkDecomposition DCFont ['\x0074']),
		('\x1D602',MkDecomposition DCFont ['\x0075']),
		('\x1D603',MkDecomposition DCFont ['\x0076']),
		('\x1D604',MkDecomposition DCFont ['\x0077']),
		('\x1D605',MkDecomposition DCFont ['\x0078']),
		('\x1D606',MkDecomposition DCFont ['\x0079']),
		('\x1D607',MkDecomposition DCFont ['\x007A']),
		('\x1D608',MkDecomposition DCFont ['\x0041']),
		('\x1D609',MkDecomposition DCFont ['\x0042']),
		('\x1D60A',MkDecomposition DCFont ['\x0043']),
		('\x1D60B',MkDecomposition DCFont ['\x0044']),
		('\x1D60C',MkDecomposition DCFont ['\x0045']),
		('\x1D60D',MkDecomposition DCFont ['\x0046']),
		('\x1D60E',MkDecomposition DCFont ['\x0047']),
		('\x1D60F',MkDecomposition DCFont ['\x0048']),
		('\x1D610',MkDecomposition DCFont ['\x0049']),
		('\x1D611',MkDecomposition DCFont ['\x004A']),
		('\x1D612',MkDecomposition DCFont ['\x004B']),
		('\x1D613',MkDecomposition DCFont ['\x004C']),
		('\x1D614',MkDecomposition DCFont ['\x004D']),
		('\x1D615',MkDecomposition DCFont ['\x004E']),
		('\x1D616',MkDecomposition DCFont ['\x004F']),
		('\x1D617',MkDecomposition DCFont ['\x0050']),
		('\x1D618',MkDecomposition DCFont ['\x0051']),
		('\x1D619',MkDecomposition DCFont ['\x0052']),
		('\x1D61A',MkDecomposition DCFont ['\x0053']),
		('\x1D61B',MkDecomposition DCFont ['\x0054']),
		('\x1D61C',MkDecomposition DCFont ['\x0055']),
		('\x1D61D',MkDecomposition DCFont ['\x0056']),
		('\x1D61E',MkDecomposition DCFont ['\x0057']),
		('\x1D61F',MkDecomposition DCFont ['\x0058']),
		('\x1D620',MkDecomposition DCFont ['\x0059']),
		('\x1D621',MkDecomposition DCFont ['\x005A']),
		('\x1D622',MkDecomposition DCFont ['\x0061']),
		('\x1D623',MkDecomposition DCFont ['\x0062']),
		('\x1D624',MkDecomposition DCFont ['\x0063']),
		('\x1D625',MkDecomposition DCFont ['\x0064']),
		('\x1D626',MkDecomposition DCFont ['\x0065']),
		('\x1D627',MkDecomposition DCFont ['\x0066']),
		('\x1D628',MkDecomposition DCFont ['\x0067']),
		('\x1D629',MkDecomposition DCFont ['\x0068']),
		('\x1D62A',MkDecomposition DCFont ['\x0069']),
		('\x1D62B',MkDecomposition DCFont ['\x006A']),
		('\x1D62C',MkDecomposition DCFont ['\x006B']),
		('\x1D62D',MkDecomposition DCFont ['\x006C']),
		('\x1D62E',MkDecomposition DCFont ['\x006D']),
		('\x1D62F',MkDecomposition DCFont ['\x006E']),
		('\x1D630',MkDecomposition DCFont ['\x006F']),
		('\x1D631',MkDecomposition DCFont ['\x0070']),
		('\x1D632',MkDecomposition DCFont ['\x0071']),
		('\x1D633',MkDecomposition DCFont ['\x0072']),
		('\x1D634',MkDecomposition DCFont ['\x0073']),
		('\x1D635',MkDecomposition DCFont ['\x0074']),
		('\x1D636',MkDecomposition DCFont ['\x0075']),
		('\x1D637',MkDecomposition DCFont ['\x0076']),
		('\x1D638',MkDecomposition DCFont ['\x0077']),
		('\x1D639',MkDecomposition DCFont ['\x0078']),
		('\x1D63A',MkDecomposition DCFont ['\x0079']),
		('\x1D63B',MkDecomposition DCFont ['\x007A']),
		('\x1D63C',MkDecomposition DCFont ['\x0041']),
		('\x1D63D',MkDecomposition DCFont ['\x0042']),
		('\x1D63E',MkDecomposition DCFont ['\x0043']),
		('\x1D63F',MkDecomposition DCFont ['\x0044']),
		('\x1D640',MkDecomposition DCFont ['\x0045']),
		('\x1D641',MkDecomposition DCFont ['\x0046']),
		('\x1D642',MkDecomposition DCFont ['\x0047']),
		('\x1D643',MkDecomposition DCFont ['\x0048']),
		('\x1D644',MkDecomposition DCFont ['\x0049']),
		('\x1D645',MkDecomposition DCFont ['\x004A']),
		('\x1D646',MkDecomposition DCFont ['\x004B']),
		('\x1D647',MkDecomposition DCFont ['\x004C']),
		('\x1D648',MkDecomposition DCFont ['\x004D']),
		('\x1D649',MkDecomposition DCFont ['\x004E']),
		('\x1D64A',MkDecomposition DCFont ['\x004F']),
		('\x1D64B',MkDecomposition DCFont ['\x0050']),
		('\x1D64C',MkDecomposition DCFont ['\x0051']),
		('\x1D64D',MkDecomposition DCFont ['\x0052']),
		('\x1D64E',MkDecomposition DCFont ['\x0053']),
		('\x1D64F',MkDecomposition DCFont ['\x0054']),
		('\x1D650',MkDecomposition DCFont ['\x0055']),
		('\x1D651',MkDecomposition DCFont ['\x0056']),
		('\x1D652',MkDecomposition DCFont ['\x0057']),
		('\x1D653',MkDecomposition DCFont ['\x0058']),
		('\x1D654',MkDecomposition DCFont ['\x0059']),
		('\x1D655',MkDecomposition DCFont ['\x005A']),
		('\x1D656',MkDecomposition DCFont ['\x0061']),
		('\x1D657',MkDecomposition DCFont ['\x0062']),
		('\x1D658',MkDecomposition DCFont ['\x0063']),
		('\x1D659',MkDecomposition DCFont ['\x0064']),
		('\x1D65A',MkDecomposition DCFont ['\x0065']),
		('\x1D65B',MkDecomposition DCFont ['\x0066']),
		('\x1D65C',MkDecomposition DCFont ['\x0067']),
		('\x1D65D',MkDecomposition DCFont ['\x0068']),
		('\x1D65E',MkDecomposition DCFont ['\x0069']),
		('\x1D65F',MkDecomposition DCFont ['\x006A']),
		('\x1D660',MkDecomposition DCFont ['\x006B']),
		('\x1D661',MkDecomposition DCFont ['\x006C']),
		('\x1D662',MkDecomposition DCFont ['\x006D']),
		('\x1D663',MkDecomposition DCFont ['\x006E']),
		('\x1D664',MkDecomposition DCFont ['\x006F']),
		('\x1D665',MkDecomposition DCFont ['\x0070']),
		('\x1D666',MkDecomposition DCFont ['\x0071']),
		('\x1D667',MkDecomposition DCFont ['\x0072']),
		('\x1D668',MkDecomposition DCFont ['\x0073']),
		('\x1D669',MkDecomposition DCFont ['\x0074']),
		('\x1D66A',MkDecomposition DCFont ['\x0075']),
		('\x1D66B',MkDecomposition DCFont ['\x0076']),
		('\x1D66C',MkDecomposition DCFont ['\x0077']),
		('\x1D66D',MkDecomposition DCFont ['\x0078']),
		('\x1D66E',MkDecomposition DCFont ['\x0079']),
		('\x1D66F',MkDecomposition DCFont ['\x007A']),
		('\x1D670',MkDecomposition DCFont ['\x0041']),
		('\x1D671',MkDecomposition DCFont ['\x0042']),
		('\x1D672',MkDecomposition DCFont ['\x0043']),
		('\x1D673',MkDecomposition DCFont ['\x0044']),
		('\x1D674',MkDecomposition DCFont ['\x0045']),
		('\x1D675',MkDecomposition DCFont ['\x0046']),
		('\x1D676',MkDecomposition DCFont ['\x0047']),
		('\x1D677',MkDecomposition DCFont ['\x0048']),
		('\x1D678',MkDecomposition DCFont ['\x0049']),
		('\x1D679',MkDecomposition DCFont ['\x004A']),
		('\x1D67A',MkDecomposition DCFont ['\x004B']),
		('\x1D67B',MkDecomposition DCFont ['\x004C']),
		('\x1D67C',MkDecomposition DCFont ['\x004D']),
		('\x1D67D',MkDecomposition DCFont ['\x004E']),
		('\x1D67E',MkDecomposition DCFont ['\x004F']),
		('\x1D67F',MkDecomposition DCFont ['\x0050']),
		('\x1D680',MkDecomposition DCFont ['\x0051']),
		('\x1D681',MkDecomposition DCFont ['\x0052']),
		('\x1D682',MkDecomposition DCFont ['\x0053']),
		('\x1D683',MkDecomposition DCFont ['\x0054']),
		('\x1D684',MkDecomposition DCFont ['\x0055']),
		('\x1D685',MkDecomposition DCFont ['\x0056']),
		('\x1D686',MkDecomposition DCFont ['\x0057']),
		('\x1D687',MkDecomposition DCFont ['\x0058']),
		('\x1D688',MkDecomposition DCFont ['\x0059']),
		('\x1D689',MkDecomposition DCFont ['\x005A']),
		('\x1D68A',MkDecomposition DCFont ['\x0061']),
		('\x1D68B',MkDecomposition DCFont ['\x0062']),
		('\x1D68C',MkDecomposition DCFont ['\x0063']),
		('\x1D68D',MkDecomposition DCFont ['\x0064']),
		('\x1D68E',MkDecomposition DCFont ['\x0065']),
		('\x1D68F',MkDecomposition DCFont ['\x0066']),
		('\x1D690',MkDecomposition DCFont ['\x0067']),
		('\x1D691',MkDecomposition DCFont ['\x0068']),
		('\x1D692',MkDecomposition DCFont ['\x0069']),
		('\x1D693',MkDecomposition DCFont ['\x006A']),
		('\x1D694',MkDecomposition DCFont ['\x006B']),
		('\x1D695',MkDecomposition DCFont ['\x006C']),
		('\x1D696',MkDecomposition DCFont ['\x006D']),
		('\x1D697',MkDecomposition DCFont ['\x006E']),
		('\x1D698',MkDecomposition DCFont ['\x006F']),
		('\x1D699',MkDecomposition DCFont ['\x0070']),
		('\x1D69A',MkDecomposition DCFont ['\x0071']),
		('\x1D69B',MkDecomposition DCFont ['\x0072']),
		('\x1D69C',MkDecomposition DCFont ['\x0073']),
		('\x1D69D',MkDecomposition DCFont ['\x0074']),
		('\x1D69E',MkDecomposition DCFont ['\x0075']),
		('\x1D69F',MkDecomposition DCFont ['\x0076']),
		('\x1D6A0',MkDecomposition DCFont ['\x0077']),
		('\x1D6A1',MkDecomposition DCFont ['\x0078']),
		('\x1D6A2',MkDecomposition DCFont ['\x0079']),
		('\x1D6A3',MkDecomposition DCFont ['\x007A']),
		('\x1D6A8',MkDecomposition DCFont ['\x0391']),
		('\x1D6A9',MkDecomposition DCFont ['\x0392']),
		('\x1D6AA',MkDecomposition DCFont ['\x0393']),
		('\x1D6AB',MkDecomposition DCFont ['\x0394']),
		('\x1D6AC',MkDecomposition DCFont ['\x0395']),
		('\x1D6AD',MkDecomposition DCFont ['\x0396']),
		('\x1D6AE',MkDecomposition DCFont ['\x0397']),
		('\x1D6AF',MkDecomposition DCFont ['\x0398']),
		('\x1D6B0',MkDecomposition DCFont ['\x0399']),
		('\x1D6B1',MkDecomposition DCFont ['\x039A']),
		('\x1D6B2',MkDecomposition DCFont ['\x039B']),
		('\x1D6B3',MkDecomposition DCFont ['\x039C']),
		('\x1D6B4',MkDecomposition DCFont ['\x039D']),
		('\x1D6B5',MkDecomposition DCFont ['\x039E']),
		('\x1D6B6',MkDecomposition DCFont ['\x039F']),
		('\x1D6B7',MkDecomposition DCFont ['\x03A0']),
		('\x1D6B8',MkDecomposition DCFont ['\x03A1']),
		('\x1D6B9',MkDecomposition DCFont ['\x03F4']),
		('\x1D6BA',MkDecomposition DCFont ['\x03A3']),
		('\x1D6BB',MkDecomposition DCFont ['\x03A4']),
		('\x1D6BC',MkDecomposition DCFont ['\x03A5']),
		('\x1D6BD',MkDecomposition DCFont ['\x03A6']),
		('\x1D6BE',MkDecomposition DCFont ['\x03A7']),
		('\x1D6BF',MkDecomposition DCFont ['\x03A8']),
		('\x1D6C0',MkDecomposition DCFont ['\x03A9']),
		('\x1D6C1',MkDecomposition DCFont ['\x2207']),
		('\x1D6C2',MkDecomposition DCFont ['\x03B1']),
		('\x1D6C3',MkDecomposition DCFont ['\x03B2']),
		('\x1D6C4',MkDecomposition DCFont ['\x03B3']),
		('\x1D6C5',MkDecomposition DCFont ['\x03B4']),
		('\x1D6C6',MkDecomposition DCFont ['\x03B5']),
		('\x1D6C7',MkDecomposition DCFont ['\x03B6']),
		('\x1D6C8',MkDecomposition DCFont ['\x03B7']),
		('\x1D6C9',MkDecomposition DCFont ['\x03B8']),
		('\x1D6CA',MkDecomposition DCFont ['\x03B9']),
		('\x1D6CB',MkDecomposition DCFont ['\x03BA']),
		('\x1D6CC',MkDecomposition DCFont ['\x03BB']),
		('\x1D6CD',MkDecomposition DCFont ['\x03BC']),
		('\x1D6CE',MkDecomposition DCFont ['\x03BD']),
		('\x1D6CF',MkDecomposition DCFont ['\x03BE']),
		('\x1D6D0',MkDecomposition DCFont ['\x03BF']),
		('\x1D6D1',MkDecomposition DCFont ['\x03C0']),
		('\x1D6D2',MkDecomposition DCFont ['\x03C1']),
		('\x1D6D3',MkDecomposition DCFont ['\x03C2']),
		('\x1D6D4',MkDecomposition DCFont ['\x03C3']),
		('\x1D6D5',MkDecomposition DCFont ['\x03C4']),
		('\x1D6D6',MkDecomposition DCFont ['\x03C5']),
		('\x1D6D7',MkDecomposition DCFont ['\x03C6']),
		('\x1D6D8',MkDecomposition DCFont ['\x03C7']),
		('\x1D6D9',MkDecomposition DCFont ['\x03C8']),
		('\x1D6DA',MkDecomposition DCFont ['\x03C9']),
		('\x1D6DB',MkDecomposition DCFont ['\x2202']),
		('\x1D6DC',MkDecomposition DCFont ['\x03F5']),
		('\x1D6DD',MkDecomposition DCFont ['\x03D1']),
		('\x1D6DE',MkDecomposition DCFont ['\x03F0']),
		('\x1D6DF',MkDecomposition DCFont ['\x03D5']),
		('\x1D6E0',MkDecomposition DCFont ['\x03F1']),
		('\x1D6E1',MkDecomposition DCFont ['\x03D6']),
		('\x1D6E2',MkDecomposition DCFont ['\x0391']),
		('\x1D6E3',MkDecomposition DCFont ['\x0392']),
		('\x1D6E4',MkDecomposition DCFont ['\x0393']),
		('\x1D6E5',MkDecomposition DCFont ['\x0394']),
		('\x1D6E6',MkDecomposition DCFont ['\x0395']),
		('\x1D6E7',MkDecomposition DCFont ['\x0396']),
		('\x1D6E8',MkDecomposition DCFont ['\x0397']),
		('\x1D6E9',MkDecomposition DCFont ['\x0398']),
		('\x1D6EA',MkDecomposition DCFont ['\x0399']),
		('\x1D6EB',MkDecomposition DCFont ['\x039A']),
		('\x1D6EC',MkDecomposition DCFont ['\x039B']),
		('\x1D6ED',MkDecomposition DCFont ['\x039C']),
		('\x1D6EE',MkDecomposition DCFont ['\x039D']),
		('\x1D6EF',MkDecomposition DCFont ['\x039E']),
		('\x1D6F0',MkDecomposition DCFont ['\x039F']),
		('\x1D6F1',MkDecomposition DCFont ['\x03A0']),
		('\x1D6F2',MkDecomposition DCFont ['\x03A1']),
		('\x1D6F3',MkDecomposition DCFont ['\x03F4']),
		('\x1D6F4',MkDecomposition DCFont ['\x03A3']),
		('\x1D6F5',MkDecomposition DCFont ['\x03A4']),
		('\x1D6F6',MkDecomposition DCFont ['\x03A5']),
		('\x1D6F7',MkDecomposition DCFont ['\x03A6']),
		('\x1D6F8',MkDecomposition DCFont ['\x03A7']),
		('\x1D6F9',MkDecomposition DCFont ['\x03A8']),
		('\x1D6FA',MkDecomposition DCFont ['\x03A9']),
		('\x1D6FB',MkDecomposition DCFont ['\x2207']),
		('\x1D6FC',MkDecomposition DCFont ['\x03B1']),
		('\x1D6FD',MkDecomposition DCFont ['\x03B2']),
		('\x1D6FE',MkDecomposition DCFont ['\x03B3']),
		('\x1D6FF',MkDecomposition DCFont ['\x03B4']),
		('\x1D700',MkDecomposition DCFont ['\x03B5']),
		('\x1D701',MkDecomposition DCFont ['\x03B6']),
		('\x1D702',MkDecomposition DCFont ['\x03B7']),
		('\x1D703',MkDecomposition DCFont ['\x03B8']),
		('\x1D704',MkDecomposition DCFont ['\x03B9']),
		('\x1D705',MkDecomposition DCFont ['\x03BA']),
		('\x1D706',MkDecomposition DCFont ['\x03BB']),
		('\x1D707',MkDecomposition DCFont ['\x03BC']),
		('\x1D708',MkDecomposition DCFont ['\x03BD']),
		('\x1D709',MkDecomposition DCFont ['\x03BE']),
		('\x1D70A',MkDecomposition DCFont ['\x03BF']),
		('\x1D70B',MkDecomposition DCFont ['\x03C0']),
		('\x1D70C',MkDecomposition DCFont ['\x03C1']),
		('\x1D70D',MkDecomposition DCFont ['\x03C2']),
		('\x1D70E',MkDecomposition DCFont ['\x03C3']),
		('\x1D70F',MkDecomposition DCFont ['\x03C4']),
		('\x1D710',MkDecomposition DCFont ['\x03C5']),
		('\x1D711',MkDecomposition DCFont ['\x03C6']),
		('\x1D712',MkDecomposition DCFont ['\x03C7']),
		('\x1D713',MkDecomposition DCFont ['\x03C8']),
		('\x1D714',MkDecomposition DCFont ['\x03C9']),
		('\x1D715',MkDecomposition DCFont ['\x2202']),
		('\x1D716',MkDecomposition DCFont ['\x03F5']),
		('\x1D717',MkDecomposition DCFont ['\x03D1']),
		('\x1D718',MkDecomposition DCFont ['\x03F0']),
		('\x1D719',MkDecomposition DCFont ['\x03D5']),
		('\x1D71A',MkDecomposition DCFont ['\x03F1']),
		('\x1D71B',MkDecomposition DCFont ['\x03D6']),
		('\x1D71C',MkDecomposition DCFont ['\x0391']),
		('\x1D71D',MkDecomposition DCFont ['\x0392']),
		('\x1D71E',MkDecomposition DCFont ['\x0393']),
		('\x1D71F',MkDecomposition DCFont ['\x0394']),
		('\x1D720',MkDecomposition DCFont ['\x0395']),
		('\x1D721',MkDecomposition DCFont ['\x0396']),
		('\x1D722',MkDecomposition DCFont ['\x0397']),
		('\x1D723',MkDecomposition DCFont ['\x0398']),
		('\x1D724',MkDecomposition DCFont ['\x0399']),
		('\x1D725',MkDecomposition DCFont ['\x039A']),
		('\x1D726',MkDecomposition DCFont ['\x039B']),
		('\x1D727',MkDecomposition DCFont ['\x039C']),
		('\x1D728',MkDecomposition DCFont ['\x039D']),
		('\x1D729',MkDecomposition DCFont ['\x039E']),
		('\x1D72A',MkDecomposition DCFont ['\x039F']),
		('\x1D72B',MkDecomposition DCFont ['\x03A0']),
		('\x1D72C',MkDecomposition DCFont ['\x03A1']),
		('\x1D72D',MkDecomposition DCFont ['\x03F4']),
		('\x1D72E',MkDecomposition DCFont ['\x03A3']),
		('\x1D72F',MkDecomposition DCFont ['\x03A4']),
		('\x1D730',MkDecomposition DCFont ['\x03A5']),
		('\x1D731',MkDecomposition DCFont ['\x03A6']),
		('\x1D732',MkDecomposition DCFont ['\x03A7']),
		('\x1D733',MkDecomposition DCFont ['\x03A8']),
		('\x1D734',MkDecomposition DCFont ['\x03A9']),
		('\x1D735',MkDecomposition DCFont ['\x2207']),
		('\x1D736',MkDecomposition DCFont ['\x03B1']),
		('\x1D737',MkDecomposition DCFont ['\x03B2']),
		('\x1D738',MkDecomposition DCFont ['\x03B3']),
		('\x1D739',MkDecomposition DCFont ['\x03B4']),
		('\x1D73A',MkDecomposition DCFont ['\x03B5']),
		('\x1D73B',MkDecomposition DCFont ['\x03B6']),
		('\x1D73C',MkDecomposition DCFont ['\x03B7']),
		('\x1D73D',MkDecomposition DCFont ['\x03B8']),
		('\x1D73E',MkDecomposition DCFont ['\x03B9']),
		('\x1D73F',MkDecomposition DCFont ['\x03BA']),
		('\x1D740',MkDecomposition DCFont ['\x03BB']),
		('\x1D741',MkDecomposition DCFont ['\x03BC']),
		('\x1D742',MkDecomposition DCFont ['\x03BD']),
		('\x1D743',MkDecomposition DCFont ['\x03BE']),
		('\x1D744',MkDecomposition DCFont ['\x03BF']),
		('\x1D745',MkDecomposition DCFont ['\x03C0']),
		('\x1D746',MkDecomposition DCFont ['\x03C1']),
		('\x1D747',MkDecomposition DCFont ['\x03C2']),
		('\x1D748',MkDecomposition DCFont ['\x03C3']),
		('\x1D749',MkDecomposition DCFont ['\x03C4']),
		('\x1D74A',MkDecomposition DCFont ['\x03C5']),
		('\x1D74B',MkDecomposition DCFont ['\x03C6']),
		('\x1D74C',MkDecomposition DCFont ['\x03C7']),
		('\x1D74D',MkDecomposition DCFont ['\x03C8']),
		('\x1D74E',MkDecomposition DCFont ['\x03C9']),
		('\x1D74F',MkDecomposition DCFont ['\x2202']),
		('\x1D750',MkDecomposition DCFont ['\x03F5']),
		('\x1D751',MkDecomposition DCFont ['\x03D1']),
		('\x1D752',MkDecomposition DCFont ['\x03F0']),
		('\x1D753',MkDecomposition DCFont ['\x03D5']),
		('\x1D754',MkDecomposition DCFont ['\x03F1']),
		('\x1D755',MkDecomposition DCFont ['\x03D6']),
		('\x1D756',MkDecomposition DCFont ['\x0391']),
		('\x1D757',MkDecomposition DCFont ['\x0392']),
		('\x1D758',MkDecomposition DCFont ['\x0393']),
		('\x1D759',MkDecomposition DCFont ['\x0394']),
		('\x1D75A',MkDecomposition DCFont ['\x0395']),
		('\x1D75B',MkDecomposition DCFont ['\x0396']),
		('\x1D75C',MkDecomposition DCFont ['\x0397']),
		('\x1D75D',MkDecomposition DCFont ['\x0398']),
		('\x1D75E',MkDecomposition DCFont ['\x0399']),
		('\x1D75F',MkDecomposition DCFont ['\x039A']),
		('\x1D760',MkDecomposition DCFont ['\x039B']),
		('\x1D761',MkDecomposition DCFont ['\x039C']),
		('\x1D762',MkDecomposition DCFont ['\x039D']),
		('\x1D763',MkDecomposition DCFont ['\x039E']),
		('\x1D764',MkDecomposition DCFont ['\x039F']),
		('\x1D765',MkDecomposition DCFont ['\x03A0']),
		('\x1D766',MkDecomposition DCFont ['\x03A1']),
		('\x1D767',MkDecomposition DCFont ['\x03F4']),
		('\x1D768',MkDecomposition DCFont ['\x03A3']),
		('\x1D769',MkDecomposition DCFont ['\x03A4']),
		('\x1D76A',MkDecomposition DCFont ['\x03A5']),
		('\x1D76B',MkDecomposition DCFont ['\x03A6']),
		('\x1D76C',MkDecomposition DCFont ['\x03A7']),
		('\x1D76D',MkDecomposition DCFont ['\x03A8']),
		('\x1D76E',MkDecomposition DCFont ['\x03A9']),
		('\x1D76F',MkDecomposition DCFont ['\x2207']),
		('\x1D770',MkDecomposition DCFont ['\x03B1']),
		('\x1D771',MkDecomposition DCFont ['\x03B2']),
		('\x1D772',MkDecomposition DCFont ['\x03B3']),
		('\x1D773',MkDecomposition DCFont ['\x03B4']),
		('\x1D774',MkDecomposition DCFont ['\x03B5']),
		('\x1D775',MkDecomposition DCFont ['\x03B6']),
		('\x1D776',MkDecomposition DCFont ['\x03B7']),
		('\x1D777',MkDecomposition DCFont ['\x03B8']),
		('\x1D778',MkDecomposition DCFont ['\x03B9']),
		('\x1D779',MkDecomposition DCFont ['\x03BA']),
		('\x1D77A',MkDecomposition DCFont ['\x03BB']),
		('\x1D77B',MkDecomposition DCFont ['\x03BC']),
		('\x1D77C',MkDecomposition DCFont ['\x03BD']),
		('\x1D77D',MkDecomposition DCFont ['\x03BE']),
		('\x1D77E',MkDecomposition DCFont ['\x03BF']),
		('\x1D77F',MkDecomposition DCFont ['\x03C0']),
		('\x1D780',MkDecomposition DCFont ['\x03C1']),
		('\x1D781',MkDecomposition DCFont ['\x03C2']),
		('\x1D782',MkDecomposition DCFont ['\x03C3']),
		('\x1D783',MkDecomposition DCFont ['\x03C4']),
		('\x1D784',MkDecomposition DCFont ['\x03C5']),
		('\x1D785',MkDecomposition DCFont ['\x03C6']),
		('\x1D786',MkDecomposition DCFont ['\x03C7']),
		('\x1D787',MkDecomposition DCFont ['\x03C8']),
		('\x1D788',MkDecomposition DCFont ['\x03C9']),
		('\x1D789',MkDecomposition DCFont ['\x2202']),
		('\x1D78A',MkDecomposition DCFont ['\x03F5']),
		('\x1D78B',MkDecomposition DCFont ['\x03D1']),
		('\x1D78C',MkDecomposition DCFont ['\x03F0']),
		('\x1D78D',MkDecomposition DCFont ['\x03D5']),
		('\x1D78E',MkDecomposition DCFont ['\x03F1']),
		('\x1D78F',MkDecomposition DCFont ['\x03D6']),
		('\x1D790',MkDecomposition DCFont ['\x0391']),
		('\x1D791',MkDecomposition DCFont ['\x0392']),
		('\x1D792',MkDecomposition DCFont ['\x0393']),
		('\x1D793',MkDecomposition DCFont ['\x0394']),
		('\x1D794',MkDecomposition DCFont ['\x0395']),
		('\x1D795',MkDecomposition DCFont ['\x0396']),
		('\x1D796',MkDecomposition DCFont ['\x0397']),
		('\x1D797',MkDecomposition DCFont ['\x0398']),
		('\x1D798',MkDecomposition DCFont ['\x0399']),
		('\x1D799',MkDecomposition DCFont ['\x039A']),
		('\x1D79A',MkDecomposition DCFont ['\x039B']),
		('\x1D79B',MkDecomposition DCFont ['\x039C']),
		('\x1D79C',MkDecomposition DCFont ['\x039D']),
		('\x1D79D',MkDecomposition DCFont ['\x039E']),
		('\x1D79E',MkDecomposition DCFont ['\x039F']),
		('\x1D79F',MkDecomposition DCFont ['\x03A0']),
		('\x1D7A0',MkDecomposition DCFont ['\x03A1']),
		('\x1D7A1',MkDecomposition DCFont ['\x03F4']),
		('\x1D7A2',MkDecomposition DCFont ['\x03A3']),
		('\x1D7A3',MkDecomposition DCFont ['\x03A4']),
		('\x1D7A4',MkDecomposition DCFont ['\x03A5']),
		('\x1D7A5',MkDecomposition DCFont ['\x03A6']),
		('\x1D7A6',MkDecomposition DCFont ['\x03A7']),
		('\x1D7A7',MkDecomposition DCFont ['\x03A8']),
		('\x1D7A8',MkDecomposition DCFont ['\x03A9']),
		('\x1D7A9',MkDecomposition DCFont ['\x2207']),
		('\x1D7AA',MkDecomposition DCFont ['\x03B1']),
		('\x1D7AB',MkDecomposition DCFont ['\x03B2']),
		('\x1D7AC',MkDecomposition DCFont ['\x03B3']),
		('\x1D7AD',MkDecomposition DCFont ['\x03B4']),
		('\x1D7AE',MkDecomposition DCFont ['\x03B5']),
		('\x1D7AF',MkDecomposition DCFont ['\x03B6']),
		('\x1D7B0',MkDecomposition DCFont ['\x03B7']),
		('\x1D7B1',MkDecomposition DCFont ['\x03B8']),
		('\x1D7B2',MkDecomposition DCFont ['\x03B9']),
		('\x1D7B3',MkDecomposition DCFont ['\x03BA']),
		('\x1D7B4',MkDecomposition DCFont ['\x03BB']),
		('\x1D7B5',MkDecomposition DCFont ['\x03BC']),
		('\x1D7B6',MkDecomposition DCFont ['\x03BD']),
		('\x1D7B7',MkDecomposition DCFont ['\x03BE']),
		('\x1D7B8',MkDecomposition DCFont ['\x03BF']),
		('\x1D7B9',MkDecomposition DCFont ['\x03C0']),
		('\x1D7BA',MkDecomposition DCFont ['\x03C1']),
		('\x1D7BB',MkDecomposition DCFont ['\x03C2']),
		('\x1D7BC',MkDecomposition DCFont ['\x03C3']),
		('\x1D7BD',MkDecomposition DCFont ['\x03C4']),
		('\x1D7BE',MkDecomposition DCFont ['\x03C5']),
		('\x1D7BF',MkDecomposition DCFont ['\x03C6']),
		('\x1D7C0',MkDecomposition DCFont ['\x03C7']),
		('\x1D7C1',MkDecomposition DCFont ['\x03C8']),
		('\x1D7C2',MkDecomposition DCFont ['\x03C9']),
		('\x1D7C3',MkDecomposition DCFont ['\x2202']),
		('\x1D7C4',MkDecomposition DCFont ['\x03F5']),
		('\x1D7C5',MkDecomposition DCFont ['\x03D1']),
		('\x1D7C6',MkDecomposition DCFont ['\x03F0']),
		('\x1D7C7',MkDecomposition DCFont ['\x03D5']),
		('\x1D7C8',MkDecomposition DCFont ['\x03F1']),
		('\x1D7C9',MkDecomposition DCFont ['\x03D6']),
		('\x1D7CE',MkDecomposition DCFont ['\x0030']),
		('\x1D7CF',MkDecomposition DCFont ['\x0031']),
		('\x1D7D0',MkDecomposition DCFont ['\x0032']),
		('\x1D7D1',MkDecomposition DCFont ['\x0033']),
		('\x1D7D2',MkDecomposition DCFont ['\x0034']),
		('\x1D7D3',MkDecomposition DCFont ['\x0035']),
		('\x1D7D4',MkDecomposition DCFont ['\x0036']),
		('\x1D7D5',MkDecomposition DCFont ['\x0037']),
		('\x1D7D6',MkDecomposition DCFont ['\x0038']),
		('\x1D7D7',MkDecomposition DCFont ['\x0039']),
		('\x1D7D8',MkDecomposition DCFont ['\x0030']),
		('\x1D7D9',MkDecomposition DCFont ['\x0031']),
		('\x1D7DA',MkDecomposition DCFont ['\x0032']),
		('\x1D7DB',MkDecomposition DCFont ['\x0033']),
		('\x1D7DC',MkDecomposition DCFont ['\x0034']),
		('\x1D7DD',MkDecomposition DCFont ['\x0035']),
		('\x1D7DE',MkDecomposition DCFont ['\x0036']),
		('\x1D7DF',MkDecomposition DCFont ['\x0037']),
		('\x1D7E0',MkDecomposition DCFont ['\x0038']),
		('\x1D7E1',MkDecomposition DCFont ['\x0039']),
		('\x1D7E2',MkDecomposition DCFont ['\x0030']),
		('\x1D7E3',MkDecomposition DCFont ['\x0031']),
		('\x1D7E4',MkDecomposition DCFont ['\x0032']),
		('\x1D7E5',MkDecomposition DCFont ['\x0033']),
		('\x1D7E6',MkDecomposition DCFont ['\x0034']),
		('\x1D7E7',MkDecomposition DCFont ['\x0035']),
		('\x1D7E8',MkDecomposition DCFont ['\x0036']),
		('\x1D7E9',MkDecomposition DCFont ['\x0037']),
		('\x1D7EA',MkDecomposition DCFont ['\x0038']),
		('\x1D7EB',MkDecomposition DCFont ['\x0039']),
		('\x1D7EC',MkDecomposition DCFont ['\x0030']),
		('\x1D7ED',MkDecomposition DCFont ['\x0031']),
		('\x1D7EE',MkDecomposition DCFont ['\x0032']),
		('\x1D7EF',MkDecomposition DCFont ['\x0033']),
		('\x1D7F0',MkDecomposition DCFont ['\x0034']),
		('\x1D7F1',MkDecomposition DCFont ['\x0035']),
		('\x1D7F2',MkDecomposition DCFont ['\x0036']),
		('\x1D7F3',MkDecomposition DCFont ['\x0037']),
		('\x1D7F4',MkDecomposition DCFont ['\x0038']),
		('\x1D7F5',MkDecomposition DCFont ['\x0039']),
		('\x1D7F6',MkDecomposition DCFont ['\x0030']),
		('\x1D7F7',MkDecomposition DCFont ['\x0031']),
		('\x1D7F8',MkDecomposition DCFont ['\x0032']),
		('\x1D7F9',MkDecomposition DCFont ['\x0033']),
		('\x1D7FA',MkDecomposition DCFont ['\x0034']),
		('\x1D7FB',MkDecomposition DCFont ['\x0035']),
		('\x1D7FC',MkDecomposition DCFont ['\x0036']),
		('\x1D7FD',MkDecomposition DCFont ['\x0037']),
		('\x1D7FE',MkDecomposition DCFont ['\x0038']),
		('\x1D7FF',MkDecomposition DCFont ['\x0039']),
		('\x2F800',MkDecomposition DCCanonical ['\x4E3D']),
		('\x2F801',MkDecomposition DCCanonical ['\x4E38']),
		('\x2F802',MkDecomposition DCCanonical ['\x4E41']),
		('\x2F803',MkDecomposition DCCanonical ['\x20122']),
		('\x2F804',MkDecomposition DCCanonical ['\x4F60']),
		('\x2F805',MkDecomposition DCCanonical ['\x4FAE']),
		('\x2F806',MkDecomposition DCCanonical ['\x4FBB']),
		('\x2F807',MkDecomposition DCCanonical ['\x5002']),
		('\x2F808',MkDecomposition DCCanonical ['\x507A']),
		('\x2F809',MkDecomposition DCCanonical ['\x5099']),
		('\x2F80A',MkDecomposition DCCanonical ['\x50E7']),
		('\x2F80B',MkDecomposition DCCanonical ['\x50CF']),
		('\x2F80C',MkDecomposition DCCanonical ['\x349E']),
		('\x2F80D',MkDecomposition DCCanonical ['\x2063A']),
		('\x2F80E',MkDecomposition DCCanonical ['\x514D']),
		('\x2F80F',MkDecomposition DCCanonical ['\x5154']),
		('\x2F810',MkDecomposition DCCanonical ['\x5164']),
		('\x2F811',MkDecomposition DCCanonical ['\x5177']),
		('\x2F812',MkDecomposition DCCanonical ['\x2051C']),
		('\x2F813',MkDecomposition DCCanonical ['\x34B9']),
		('\x2F814',MkDecomposition DCCanonical ['\x5167']),
		('\x2F815',MkDecomposition DCCanonical ['\x518D']),
		('\x2F816',MkDecomposition DCCanonical ['\x2054B']),
		('\x2F817',MkDecomposition DCCanonical ['\x5197']),
		('\x2F818',MkDecomposition DCCanonical ['\x51A4']),
		('\x2F819',MkDecomposition DCCanonical ['\x4ECC']),
		('\x2F81A',MkDecomposition DCCanonical ['\x51AC']),
		('\x2F81B',MkDecomposition DCCanonical ['\x51B5']),
		('\x2F81C',MkDecomposition DCCanonical ['\x291DF']),
		('\x2F81D',MkDecomposition DCCanonical ['\x51F5']),
		('\x2F81E',MkDecomposition DCCanonical ['\x5203']),
		('\x2F81F',MkDecomposition DCCanonical ['\x34DF']),
		('\x2F820',MkDecomposition DCCanonical ['\x523B']),
		('\x2F821',MkDecomposition DCCanonical ['\x5246']),
		('\x2F822',MkDecomposition DCCanonical ['\x5272']),
		('\x2F823',MkDecomposition DCCanonical ['\x5277']),
		('\x2F824',MkDecomposition DCCanonical ['\x3515']),
		('\x2F825',MkDecomposition DCCanonical ['\x52C7']),
		('\x2F826',MkDecomposition DCCanonical ['\x52C9']),
		('\x2F827',MkDecomposition DCCanonical ['\x52E4']),
		('\x2F828',MkDecomposition DCCanonical ['\x52FA']),
		('\x2F829',MkDecomposition DCCanonical ['\x5305']),
		('\x2F82A',MkDecomposition DCCanonical ['\x5306']),
		('\x2F82B',MkDecomposition DCCanonical ['\x5317']),
		('\x2F82C',MkDecomposition DCCanonical ['\x5349']),
		('\x2F82D',MkDecomposition DCCanonical ['\x5351']),
		('\x2F82E',MkDecomposition DCCanonical ['\x535A']),
		('\x2F82F',MkDecomposition DCCanonical ['\x5373']),
		('\x2F830',MkDecomposition DCCanonical ['\x537D']),
		('\x2F831',MkDecomposition DCCanonical ['\x537F']),
		('\x2F832',MkDecomposition DCCanonical ['\x537F']),
		('\x2F833',MkDecomposition DCCanonical ['\x537F']),
		('\x2F834',MkDecomposition DCCanonical ['\x20A2C']),
		('\x2F835',MkDecomposition DCCanonical ['\x7070']),
		('\x2F836',MkDecomposition DCCanonical ['\x53CA']),
		('\x2F837',MkDecomposition DCCanonical ['\x53DF']),
		('\x2F838',MkDecomposition DCCanonical ['\x20B63']),
		('\x2F839',MkDecomposition DCCanonical ['\x53EB']),
		('\x2F83A',MkDecomposition DCCanonical ['\x53F1']),
		('\x2F83B',MkDecomposition DCCanonical ['\x5406']),
		('\x2F83C',MkDecomposition DCCanonical ['\x549E']),
		('\x2F83D',MkDecomposition DCCanonical ['\x5438']),
		('\x2F83E',MkDecomposition DCCanonical ['\x5448']),
		('\x2F83F',MkDecomposition DCCanonical ['\x5468']),
		('\x2F840',MkDecomposition DCCanonical ['\x54A2']),
		('\x2F841',MkDecomposition DCCanonical ['\x54F6']),
		('\x2F842',MkDecomposition DCCanonical ['\x5510']),
		('\x2F843',MkDecomposition DCCanonical ['\x5553']),
		('\x2F844',MkDecomposition DCCanonical ['\x5563']),
		('\x2F845',MkDecomposition DCCanonical ['\x5584']),
		('\x2F846',MkDecomposition DCCanonical ['\x5584']),
		('\x2F847',MkDecomposition DCCanonical ['\x5599']),
		('\x2F848',MkDecomposition DCCanonical ['\x55AB']),
		('\x2F849',MkDecomposition DCCanonical ['\x55B3']),
		('\x2F84A',MkDecomposition DCCanonical ['\x55C2']),
		('\x2F84B',MkDecomposition DCCanonical ['\x5716']),
		('\x2F84C',MkDecomposition DCCanonical ['\x5606']),
		('\x2F84D',MkDecomposition DCCanonical ['\x5717']),
		('\x2F84E',MkDecomposition DCCanonical ['\x5651']),
		('\x2F84F',MkDecomposition DCCanonical ['\x5674']),
		('\x2F850',MkDecomposition DCCanonical ['\x5207']),
		('\x2F851',MkDecomposition DCCanonical ['\x58EE']),
		('\x2F852',MkDecomposition DCCanonical ['\x57CE']),
		('\x2F853',MkDecomposition DCCanonical ['\x57F4']),
		('\x2F854',MkDecomposition DCCanonical ['\x580D']),
		('\x2F855',MkDecomposition DCCanonical ['\x578B']),
		('\x2F856',MkDecomposition DCCanonical ['\x5832']),
		('\x2F857',MkDecomposition DCCanonical ['\x5831']),
		('\x2F858',MkDecomposition DCCanonical ['\x58AC']),
		('\x2F859',MkDecomposition DCCanonical ['\x214E4']),
		('\x2F85A',MkDecomposition DCCanonical ['\x58F2']),
		('\x2F85B',MkDecomposition DCCanonical ['\x58F7']),
		('\x2F85C',MkDecomposition DCCanonical ['\x5906']),
		('\x2F85D',MkDecomposition DCCanonical ['\x591A']),
		('\x2F85E',MkDecomposition DCCanonical ['\x5922']),
		('\x2F85F',MkDecomposition DCCanonical ['\x5962']),
		('\x2F860',MkDecomposition DCCanonical ['\x216A8']),
		('\x2F861',MkDecomposition DCCanonical ['\x216EA']),
		('\x2F862',MkDecomposition DCCanonical ['\x59EC']),
		('\x2F863',MkDecomposition DCCanonical ['\x5A1B']),
		('\x2F864',MkDecomposition DCCanonical ['\x5A27']),
		('\x2F865',MkDecomposition DCCanonical ['\x59D8']),
		('\x2F866',MkDecomposition DCCanonical ['\x5A66']),
		('\x2F867',MkDecomposition DCCanonical ['\x36EE']),
		('\x2F868',MkDecomposition DCCanonical ['\x2136A']),
		('\x2F869',MkDecomposition DCCanonical ['\x5B08']),
		('\x2F86A',MkDecomposition DCCanonical ['\x5B3E']),
		('\x2F86B',MkDecomposition DCCanonical ['\x5B3E']),
		('\x2F86C',MkDecomposition DCCanonical ['\x219C8']),
		('\x2F86D',MkDecomposition DCCanonical ['\x5BC3']),
		('\x2F86E',MkDecomposition DCCanonical ['\x5BD8']),
		('\x2F86F',MkDecomposition DCCanonical ['\x5BE7']),
		('\x2F870',MkDecomposition DCCanonical ['\x5BF3']),
		('\x2F871',MkDecomposition DCCanonical ['\x21B18']),
		('\x2F872',MkDecomposition DCCanonical ['\x5BFF']),
		('\x2F873',MkDecomposition DCCanonical ['\x5C06']),
		('\x2F874',MkDecomposition DCCanonical ['\x5F33']),
		('\x2F875',MkDecomposition DCCanonical ['\x5C22']),
		('\x2F876',MkDecomposition DCCanonical ['\x3781']),
		('\x2F877',MkDecomposition DCCanonical ['\x5C60']),
		('\x2F878',MkDecomposition DCCanonical ['\x5C6E']),
		('\x2F879',MkDecomposition DCCanonical ['\x5CC0']),
		('\x2F87A',MkDecomposition DCCanonical ['\x5C8D']),
		('\x2F87B',MkDecomposition DCCanonical ['\x21DE4']),
		('\x2F87C',MkDecomposition DCCanonical ['\x5D43']),
		('\x2F87D',MkDecomposition DCCanonical ['\x21DE6']),
		('\x2F87E',MkDecomposition DCCanonical ['\x5D6E']),
		('\x2F87F',MkDecomposition DCCanonical ['\x5D6B']),
		('\x2F880',MkDecomposition DCCanonical ['\x5D7C']),
		('\x2F881',MkDecomposition DCCanonical ['\x5DE1']),
		('\x2F882',MkDecomposition DCCanonical ['\x5DE2']),
		('\x2F883',MkDecomposition DCCanonical ['\x382F']),
		('\x2F884',MkDecomposition DCCanonical ['\x5DFD']),
		('\x2F885',MkDecomposition DCCanonical ['\x5E28']),
		('\x2F886',MkDecomposition DCCanonical ['\x5E3D']),
		('\x2F887',MkDecomposition DCCanonical ['\x5E69']),
		('\x2F888',MkDecomposition DCCanonical ['\x3862']),
		('\x2F889',MkDecomposition DCCanonical ['\x22183']),
		('\x2F88A',MkDecomposition DCCanonical ['\x387C']),
		('\x2F88B',MkDecomposition DCCanonical ['\x5EB0']),
		('\x2F88C',MkDecomposition DCCanonical ['\x5EB3']),
		('\x2F88D',MkDecomposition DCCanonical ['\x5EB6']),
		('\x2F88E',MkDecomposition DCCanonical ['\x5ECA']),
		('\x2F88F',MkDecomposition DCCanonical ['\x2A392']),
		('\x2F890',MkDecomposition DCCanonical ['\x5EFE']),
		('\x2F891',MkDecomposition DCCanonical ['\x22331']),
		('\x2F892',MkDecomposition DCCanonical ['\x22331']),
		('\x2F893',MkDecomposition DCCanonical ['\x8201']),
		('\x2F894',MkDecomposition DCCanonical ['\x5F22']),
		('\x2F895',MkDecomposition DCCanonical ['\x5F22']),
		('\x2F896',MkDecomposition DCCanonical ['\x38C7']),
		('\x2F897',MkDecomposition DCCanonical ['\x232B8']),
		('\x2F898',MkDecomposition DCCanonical ['\x261DA']),
		('\x2F899',MkDecomposition DCCanonical ['\x5F62']),
		('\x2F89A',MkDecomposition DCCanonical ['\x5F6B']),
		('\x2F89B',MkDecomposition DCCanonical ['\x38E3']),
		('\x2F89C',MkDecomposition DCCanonical ['\x5F9A']),
		('\x2F89D',MkDecomposition DCCanonical ['\x5FCD']),
		('\x2F89E',MkDecomposition DCCanonical ['\x5FD7']),
		('\x2F89F',MkDecomposition DCCanonical ['\x5FF9']),
		('\x2F8A0',MkDecomposition DCCanonical ['\x6081']),
		('\x2F8A1',MkDecomposition DCCanonical ['\x393A']),
		('\x2F8A2',MkDecomposition DCCanonical ['\x391C']),
		('\x2F8A3',MkDecomposition DCCanonical ['\x6094']),
		('\x2F8A4',MkDecomposition DCCanonical ['\x226D4']),
		('\x2F8A5',MkDecomposition DCCanonical ['\x60C7']),
		('\x2F8A6',MkDecomposition DCCanonical ['\x6148']),
		('\x2F8A7',MkDecomposition DCCanonical ['\x614C']),
		('\x2F8A8',MkDecomposition DCCanonical ['\x614E']),
		('\x2F8A9',MkDecomposition DCCanonical ['\x614C']),
		('\x2F8AA',MkDecomposition DCCanonical ['\x617A']),
		('\x2F8AB',MkDecomposition DCCanonical ['\x618E']),
		('\x2F8AC',MkDecomposition DCCanonical ['\x61B2']),
		('\x2F8AD',MkDecomposition DCCanonical ['\x61A4']),
		('\x2F8AE',MkDecomposition DCCanonical ['\x61AF']),
		('\x2F8AF',MkDecomposition DCCanonical ['\x61DE']),
		('\x2F8B0',MkDecomposition DCCanonical ['\x61F2']),
		('\x2F8B1',MkDecomposition DCCanonical ['\x61F6']),
		('\x2F8B2',MkDecomposition DCCanonical ['\x6210']),
		('\x2F8B3',MkDecomposition DCCanonical ['\x621B']),
		('\x2F8B4',MkDecomposition DCCanonical ['\x625D']),
		('\x2F8B5',MkDecomposition DCCanonical ['\x62B1']),
		('\x2F8B6',MkDecomposition DCCanonical ['\x62D4']),
		('\x2F8B7',MkDecomposition DCCanonical ['\x6350']),
		('\x2F8B8',MkDecomposition DCCanonical ['\x22B0C']),
		('\x2F8B9',MkDecomposition DCCanonical ['\x633D']),
		('\x2F8BA',MkDecomposition DCCanonical ['\x62FC']),
		('\x2F8BB',MkDecomposition DCCanonical ['\x6368']),
		('\x2F8BC',MkDecomposition DCCanonical ['\x6383']),
		('\x2F8BD',MkDecomposition DCCanonical ['\x63E4']),
		('\x2F8BE',MkDecomposition DCCanonical ['\x22BF1']),
		('\x2F8BF',MkDecomposition DCCanonical ['\x6422']),
		('\x2F8C0',MkDecomposition DCCanonical ['\x63C5']),
		('\x2F8C1',MkDecomposition DCCanonical ['\x63A9']),
		('\x2F8C2',MkDecomposition DCCanonical ['\x3A2E']),
		('\x2F8C3',MkDecomposition DCCanonical ['\x6469']),
		('\x2F8C4',MkDecomposition DCCanonical ['\x647E']),
		('\x2F8C5',MkDecomposition DCCanonical ['\x649D']),
		('\x2F8C6',MkDecomposition DCCanonical ['\x6477']),
		('\x2F8C7',MkDecomposition DCCanonical ['\x3A6C']),
		('\x2F8C8',MkDecomposition DCCanonical ['\x654F']),
		('\x2F8C9',MkDecomposition DCCanonical ['\x656C']),
		('\x2F8CA',MkDecomposition DCCanonical ['\x2300A']),
		('\x2F8CB',MkDecomposition DCCanonical ['\x65E3']),
		('\x2F8CC',MkDecomposition DCCanonical ['\x66F8']),
		('\x2F8CD',MkDecomposition DCCanonical ['\x6649']),
		('\x2F8CE',MkDecomposition DCCanonical ['\x3B19']),
		('\x2F8CF',MkDecomposition DCCanonical ['\x6691']),
		('\x2F8D0',MkDecomposition DCCanonical ['\x3B08']),
		('\x2F8D1',MkDecomposition DCCanonical ['\x3AE4']),
		('\x2F8D2',MkDecomposition DCCanonical ['\x5192']),
		('\x2F8D3',MkDecomposition DCCanonical ['\x5195']),
		('\x2F8D4',MkDecomposition DCCanonical ['\x6700']),
		('\x2F8D5',MkDecomposition DCCanonical ['\x669C']),
		('\x2F8D6',MkDecomposition DCCanonical ['\x80AD']),
		('\x2F8D7',MkDecomposition DCCanonical ['\x43D9']),
		('\x2F8D8',MkDecomposition DCCanonical ['\x6717']),
		('\x2F8D9',MkDecomposition DCCanonical ['\x671B']),
		('\x2F8DA',MkDecomposition DCCanonical ['\x6721']),
		('\x2F8DB',MkDecomposition DCCanonical ['\x675E']),
		('\x2F8DC',MkDecomposition DCCanonical ['\x6753']),
		('\x2F8DD',MkDecomposition DCCanonical ['\x233C3']),
		('\x2F8DE',MkDecomposition DCCanonical ['\x3B49']),
		('\x2F8DF',MkDecomposition DCCanonical ['\x67FA']),
		('\x2F8E0',MkDecomposition DCCanonical ['\x6785']),
		('\x2F8E1',MkDecomposition DCCanonical ['\x6852']),
		('\x2F8E2',MkDecomposition DCCanonical ['\x6885']),
		('\x2F8E3',MkDecomposition DCCanonical ['\x2346D']),
		('\x2F8E4',MkDecomposition DCCanonical ['\x688E']),
		('\x2F8E5',MkDecomposition DCCanonical ['\x681F']),
		('\x2F8E6',MkDecomposition DCCanonical ['\x6914']),
		('\x2F8E7',MkDecomposition DCCanonical ['\x3B9D']),
		('\x2F8E8',MkDecomposition DCCanonical ['\x6942']),
		('\x2F8E9',MkDecomposition DCCanonical ['\x69A3']),
		('\x2F8EA',MkDecomposition DCCanonical ['\x69EA']),
		('\x2F8EB',MkDecomposition DCCanonical ['\x6AA8']),
		('\x2F8EC',MkDecomposition DCCanonical ['\x236A3']),
		('\x2F8ED',MkDecomposition DCCanonical ['\x6ADB']),
		('\x2F8EE',MkDecomposition DCCanonical ['\x3C18']),
		('\x2F8EF',MkDecomposition DCCanonical ['\x6B21']),
		('\x2F8F0',MkDecomposition DCCanonical ['\x238A7']),
		('\x2F8F1',MkDecomposition DCCanonical ['\x6B54']),
		('\x2F8F2',MkDecomposition DCCanonical ['\x3C4E']),
		('\x2F8F3',MkDecomposition DCCanonical ['\x6B72']),
		('\x2F8F4',MkDecomposition DCCanonical ['\x6B9F']),
		('\x2F8F5',MkDecomposition DCCanonical ['\x6BBA']),
		('\x2F8F6',MkDecomposition DCCanonical ['\x6BBB']),
		('\x2F8F7',MkDecomposition DCCanonical ['\x23A8D']),
		('\x2F8F8',MkDecomposition DCCanonical ['\x21D0B']),
		('\x2F8F9',MkDecomposition DCCanonical ['\x23AFA']),
		('\x2F8FA',MkDecomposition DCCanonical ['\x6C4E']),
		('\x2F8FB',MkDecomposition DCCanonical ['\x23CBC']),
		('\x2F8FC',MkDecomposition DCCanonical ['\x6CBF']),
		('\x2F8FD',MkDecomposition DCCanonical ['\x6CCD']),
		('\x2F8FE',MkDecomposition DCCanonical ['\x6C67']),
		('\x2F8FF',MkDecomposition DCCanonical ['\x6D16']),
		('\x2F900',MkDecomposition DCCanonical ['\x6D3E']),
		('\x2F901',MkDecomposition DCCanonical ['\x6D77']),
		('\x2F902',MkDecomposition DCCanonical ['\x6D41']),
		('\x2F903',MkDecomposition DCCanonical ['\x6D69']),
		('\x2F904',MkDecomposition DCCanonical ['\x6D78']),
		('\x2F905',MkDecomposition DCCanonical ['\x6D85']),
		('\x2F906',MkDecomposition DCCanonical ['\x23D1E']),
		('\x2F907',MkDecomposition DCCanonical ['\x6D34']),
		('\x2F908',MkDecomposition DCCanonical ['\x6E2F']),
		('\x2F909',MkDecomposition DCCanonical ['\x6E6E']),
		('\x2F90A',MkDecomposition DCCanonical ['\x3D33']),
		('\x2F90B',MkDecomposition DCCanonical ['\x6ECB']),
		('\x2F90C',MkDecomposition DCCanonical ['\x6EC7']),
		('\x2F90D',MkDecomposition DCCanonical ['\x23ED1']),
		('\x2F90E',MkDecomposition DCCanonical ['\x6DF9']),
		('\x2F90F',MkDecomposition DCCanonical ['\x6F6E']),
		('\x2F910',MkDecomposition DCCanonical ['\x23F5E']),
		('\x2F911',MkDecomposition DCCanonical ['\x23F8E']),
		('\x2F912',MkDecomposition DCCanonical ['\x6FC6']),
		('\x2F913',MkDecomposition DCCanonical ['\x7039']),
		('\x2F914',MkDecomposition DCCanonical ['\x701E']),
		('\x2F915',MkDecomposition DCCanonical ['\x701B']),
		('\x2F916',MkDecomposition DCCanonical ['\x3D96']),
		('\x2F917',MkDecomposition DCCanonical ['\x704A']),
		('\x2F918',MkDecomposition DCCanonical ['\x707D']),
		('\x2F919',MkDecomposition DCCanonical ['\x7077']),
		('\x2F91A',MkDecomposition DCCanonical ['\x70AD']),
		('\x2F91B',MkDecomposition DCCanonical ['\x20525']),
		('\x2F91C',MkDecomposition DCCanonical ['\x7145']),
		('\x2F91D',MkDecomposition DCCanonical ['\x24263']),
		('\x2F91E',MkDecomposition DCCanonical ['\x719C']),
		('\x2F91F',MkDecomposition DCCanonical ['\x43AB']),
		('\x2F920',MkDecomposition DCCanonical ['\x7228']),
		('\x2F921',MkDecomposition DCCanonical ['\x7235']),
		('\x2F922',MkDecomposition DCCanonical ['\x7250']),
		('\x2F923',MkDecomposition DCCanonical ['\x24608']),
		('\x2F924',MkDecomposition DCCanonical ['\x7280']),
		('\x2F925',MkDecomposition DCCanonical ['\x7295']),
		('\x2F926',MkDecomposition DCCanonical ['\x24735']),
		('\x2F927',MkDecomposition DCCanonical ['\x24814']),
		('\x2F928',MkDecomposition DCCanonical ['\x737A']),
		('\x2F929',MkDecomposition DCCanonical ['\x738B']),
		('\x2F92A',MkDecomposition DCCanonical ['\x3EAC']),
		('\x2F92B',MkDecomposition DCCanonical ['\x73A5']),
		('\x2F92C',MkDecomposition DCCanonical ['\x3EB8']),
		('\x2F92D',MkDecomposition DCCanonical ['\x3EB8']),
		('\x2F92E',MkDecomposition DCCanonical ['\x7447']),
		('\x2F92F',MkDecomposition DCCanonical ['\x745C']),
		('\x2F930',MkDecomposition DCCanonical ['\x7471']),
		('\x2F931',MkDecomposition DCCanonical ['\x7485']),
		('\x2F932',MkDecomposition DCCanonical ['\x74CA']),
		('\x2F933',MkDecomposition DCCanonical ['\x3F1B']),
		('\x2F934',MkDecomposition DCCanonical ['\x7524']),
		('\x2F935',MkDecomposition DCCanonical ['\x24C36']),
		('\x2F936',MkDecomposition DCCanonical ['\x753E']),
		('\x2F937',MkDecomposition DCCanonical ['\x24C92']),
		('\x2F938',MkDecomposition DCCanonical ['\x7570']),
		('\x2F939',MkDecomposition DCCanonical ['\x2219F']),
		('\x2F93A',MkDecomposition DCCanonical ['\x7610']),
		('\x2F93B',MkDecomposition DCCanonical ['\x24FA1']),
		('\x2F93C',MkDecomposition DCCanonical ['\x24FB8']),
		('\x2F93D',MkDecomposition DCCanonical ['\x25044']),
		('\x2F93E',MkDecomposition DCCanonical ['\x3FFC']),
		('\x2F93F',MkDecomposition DCCanonical ['\x4008']),
		('\x2F940',MkDecomposition DCCanonical ['\x76F4']),
		('\x2F941',MkDecomposition DCCanonical ['\x250F3']),
		('\x2F942',MkDecomposition DCCanonical ['\x250F2']),
		('\x2F943',MkDecomposition DCCanonical ['\x25119']),
		('\x2F944',MkDecomposition DCCanonical ['\x25133']),
		('\x2F945',MkDecomposition DCCanonical ['\x771E']),
		('\x2F946',MkDecomposition DCCanonical ['\x771F']),
		('\x2F947',MkDecomposition DCCanonical ['\x771F']),
		('\x2F948',MkDecomposition DCCanonical ['\x774A']),
		('\x2F949',MkDecomposition DCCanonical ['\x4039']),
		('\x2F94A',MkDecomposition DCCanonical ['\x778B']),
		('\x2F94B',MkDecomposition DCCanonical ['\x4046']),
		('\x2F94C',MkDecomposition DCCanonical ['\x4096']),
		('\x2F94D',MkDecomposition DCCanonical ['\x2541D']),
		('\x2F94E',MkDecomposition DCCanonical ['\x784E']),
		('\x2F94F',MkDecomposition DCCanonical ['\x788C']),
		('\x2F950',MkDecomposition DCCanonical ['\x78CC']),
		('\x2F951',MkDecomposition DCCanonical ['\x40E3']),
		('\x2F952',MkDecomposition DCCanonical ['\x25626']),
		('\x2F953',MkDecomposition DCCanonical ['\x7956']),
		('\x2F954',MkDecomposition DCCanonical ['\x2569A']),
		('\x2F955',MkDecomposition DCCanonical ['\x256C5']),
		('\x2F956',MkDecomposition DCCanonical ['\x798F']),
		('\x2F957',MkDecomposition DCCanonical ['\x79EB']),
		('\x2F958',MkDecomposition DCCanonical ['\x412F']),
		('\x2F959',MkDecomposition DCCanonical ['\x7A40']),
		('\x2F95A',MkDecomposition DCCanonical ['\x7A4A']),
		('\x2F95B',MkDecomposition DCCanonical ['\x7A4F']),
		('\x2F95C',MkDecomposition DCCanonical ['\x2597C']),
		('\x2F95D',MkDecomposition DCCanonical ['\x25AA7']),
		('\x2F95E',MkDecomposition DCCanonical ['\x25AA7']),
		('\x2F95F',MkDecomposition DCCanonical ['\x7AAE']),
		('\x2F960',MkDecomposition DCCanonical ['\x4202']),
		('\x2F961',MkDecomposition DCCanonical ['\x25BAB']),
		('\x2F962',MkDecomposition DCCanonical ['\x7BC6']),
		('\x2F963',MkDecomposition DCCanonical ['\x7BC9']),
		('\x2F964',MkDecomposition DCCanonical ['\x4227']),
		('\x2F965',MkDecomposition DCCanonical ['\x25C80']),
		('\x2F966',MkDecomposition DCCanonical ['\x7CD2']),
		('\x2F967',MkDecomposition DCCanonical ['\x42A0']),
		('\x2F968',MkDecomposition DCCanonical ['\x7CE8']),
		('\x2F969',MkDecomposition DCCanonical ['\x7CE3']),
		('\x2F96A',MkDecomposition DCCanonical ['\x7D00']),
		('\x2F96B',MkDecomposition DCCanonical ['\x25F86']),
		('\x2F96C',MkDecomposition DCCanonical ['\x7D63']),
		('\x2F96D',MkDecomposition DCCanonical ['\x4301']),
		('\x2F96E',MkDecomposition DCCanonical ['\x7DC7']),
		('\x2F96F',MkDecomposition DCCanonical ['\x7E02']),
		('\x2F970',MkDecomposition DCCanonical ['\x7E45']),
		('\x2F971',MkDecomposition DCCanonical ['\x4334']),
		('\x2F972',MkDecomposition DCCanonical ['\x26228']),
		('\x2F973',MkDecomposition DCCanonical ['\x26247']),
		('\x2F974',MkDecomposition DCCanonical ['\x4359']),
		('\x2F975',MkDecomposition DCCanonical ['\x262D9']),
		('\x2F976',MkDecomposition DCCanonical ['\x7F7A']),
		('\x2F977',MkDecomposition DCCanonical ['\x2633E']),
		('\x2F978',MkDecomposition DCCanonical ['\x7F95']),
		('\x2F979',MkDecomposition DCCanonical ['\x7FFA']),
		('\x2F97A',MkDecomposition DCCanonical ['\x8005']),
		('\x2F97B',MkDecomposition DCCanonical ['\x264DA']),
		('\x2F97C',MkDecomposition DCCanonical ['\x26523']),
		('\x2F97D',MkDecomposition DCCanonical ['\x8060']),
		('\x2F97E',MkDecomposition DCCanonical ['\x265A8']),
		('\x2F97F',MkDecomposition DCCanonical ['\x8070']),
		('\x2F980',MkDecomposition DCCanonical ['\x2335F']),
		('\x2F981',MkDecomposition DCCanonical ['\x43D5']),
		('\x2F982',MkDecomposition DCCanonical ['\x80B2']),
		('\x2F983',MkDecomposition DCCanonical ['\x8103']),
		('\x2F984',MkDecomposition DCCanonical ['\x440B']),
		('\x2F985',MkDecomposition DCCanonical ['\x813E']),
		('\x2F986',MkDecomposition DCCanonical ['\x5AB5']),
		('\x2F987',MkDecomposition DCCanonical ['\x267A7']),
		('\x2F988',MkDecomposition DCCanonical ['\x267B5']),
		('\x2F989',MkDecomposition DCCanonical ['\x23393']),
		('\x2F98A',MkDecomposition DCCanonical ['\x2339C']),
		('\x2F98B',MkDecomposition DCCanonical ['\x8201']),
		('\x2F98C',MkDecomposition DCCanonical ['\x8204']),
		('\x2F98D',MkDecomposition DCCanonical ['\x8F9E']),
		('\x2F98E',MkDecomposition DCCanonical ['\x446B']),
		('\x2F98F',MkDecomposition DCCanonical ['\x8291']),
		('\x2F990',MkDecomposition DCCanonical ['\x828B']),
		('\x2F991',MkDecomposition DCCanonical ['\x829D']),
		('\x2F992',MkDecomposition DCCanonical ['\x52B3']),
		('\x2F993',MkDecomposition DCCanonical ['\x82B1']),
		('\x2F994',MkDecomposition DCCanonical ['\x82B3']),
		('\x2F995',MkDecomposition DCCanonical ['\x82BD']),
		('\x2F996',MkDecomposition DCCanonical ['\x82E6']),
		('\x2F997',MkDecomposition DCCanonical ['\x26B3C']),
		('\x2F998',MkDecomposition DCCanonical ['\x82E5']),
		('\x2F999',MkDecomposition DCCanonical ['\x831D']),
		('\x2F99A',MkDecomposition DCCanonical ['\x8363']),
		('\x2F99B',MkDecomposition DCCanonical ['\x83AD']),
		('\x2F99C',MkDecomposition DCCanonical ['\x8323']),
		('\x2F99D',MkDecomposition DCCanonical ['\x83BD']),
		('\x2F99E',MkDecomposition DCCanonical ['\x83E7']),
		('\x2F99F',MkDecomposition DCCanonical ['\x8457']),
		('\x2F9A0',MkDecomposition DCCanonical ['\x8353']),
		('\x2F9A1',MkDecomposition DCCanonical ['\x83CA']),
		('\x2F9A2',MkDecomposition DCCanonical ['\x83CC']),
		('\x2F9A3',MkDecomposition DCCanonical ['\x83DC']),
		('\x2F9A4',MkDecomposition DCCanonical ['\x26C36']),
		('\x2F9A5',MkDecomposition DCCanonical ['\x26D6B']),
		('\x2F9A6',MkDecomposition DCCanonical ['\x26CD5']),
		('\x2F9A7',MkDecomposition DCCanonical ['\x452B']),
		('\x2F9A8',MkDecomposition DCCanonical ['\x84F1']),
		('\x2F9A9',MkDecomposition DCCanonical ['\x84F3']),
		('\x2F9AA',MkDecomposition DCCanonical ['\x8516']),
		('\x2F9AB',MkDecomposition DCCanonical ['\x273CA']),
		('\x2F9AC',MkDecomposition DCCanonical ['\x8564']),
		('\x2F9AD',MkDecomposition DCCanonical ['\x26F2C']),
		('\x2F9AE',MkDecomposition DCCanonical ['\x455D']),
		('\x2F9AF',MkDecomposition DCCanonical ['\x4561']),
		('\x2F9B0',MkDecomposition DCCanonical ['\x26FB1']),
		('\x2F9B1',MkDecomposition DCCanonical ['\x270D2']),
		('\x2F9B2',MkDecomposition DCCanonical ['\x456B']),
		('\x2F9B3',MkDecomposition DCCanonical ['\x8650']),
		('\x2F9B4',MkDecomposition DCCanonical ['\x865C']),
		('\x2F9B5',MkDecomposition DCCanonical ['\x8667']),
		('\x2F9B6',MkDecomposition DCCanonical ['\x8669']),
		('\x2F9B7',MkDecomposition DCCanonical ['\x86A9']),
		('\x2F9B8',MkDecomposition DCCanonical ['\x8688']),
		('\x2F9B9',MkDecomposition DCCanonical ['\x870E']),
		('\x2F9BA',MkDecomposition DCCanonical ['\x86E2']),
		('\x2F9BB',MkDecomposition DCCanonical ['\x8779']),
		('\x2F9BC',MkDecomposition DCCanonical ['\x8728']),
		('\x2F9BD',MkDecomposition DCCanonical ['\x876B']),
		('\x2F9BE',MkDecomposition DCCanonical ['\x8786']),
		('\x2F9BF',MkDecomposition DCCanonical ['\x4D57']),
		('\x2F9C0',MkDecomposition DCCanonical ['\x87E1']),
		('\x2F9C1',MkDecomposition DCCanonical ['\x8801']),
		('\x2F9C2',MkDecomposition DCCanonical ['\x45F9']),
		('\x2F9C3',MkDecomposition DCCanonical ['\x8860']),
		('\x2F9C4',MkDecomposition DCCanonical ['\x8863']),
		('\x2F9C5',MkDecomposition DCCanonical ['\x27667']),
		('\x2F9C6',MkDecomposition DCCanonical ['\x88D7']),
		('\x2F9C7',MkDecomposition DCCanonical ['\x88DE']),
		('\x2F9C8',MkDecomposition DCCanonical ['\x4635']),
		('\x2F9C9',MkDecomposition DCCanonical ['\x88FA']),
		('\x2F9CA',MkDecomposition DCCanonical ['\x34BB']),
		('\x2F9CB',MkDecomposition DCCanonical ['\x278AE']),
		('\x2F9CC',MkDecomposition DCCanonical ['\x27966']),
		('\x2F9CD',MkDecomposition DCCanonical ['\x46BE']),
		('\x2F9CE',MkDecomposition DCCanonical ['\x46C7']),
		('\x2F9CF',MkDecomposition DCCanonical ['\x8AA0']),
		('\x2F9D0',MkDecomposition DCCanonical ['\x8AED']),
		('\x2F9D1',MkDecomposition DCCanonical ['\x8B8A']),
		('\x2F9D2',MkDecomposition DCCanonical ['\x8C55']),
		('\x2F9D3',MkDecomposition DCCanonical ['\x27CA8']),
		('\x2F9D4',MkDecomposition DCCanonical ['\x8CAB']),
		('\x2F9D5',MkDecomposition DCCanonical ['\x8CC1']),
		('\x2F9D6',MkDecomposition DCCanonical ['\x8D1B']),
		('\x2F9D7',MkDecomposition DCCanonical ['\x8D77']),
		('\x2F9D8',MkDecomposition DCCanonical ['\x27F2F']),
		('\x2F9D9',MkDecomposition DCCanonical ['\x20804']),
		('\x2F9DA',MkDecomposition DCCanonical ['\x8DCB']),
		('\x2F9DB',MkDecomposition DCCanonical ['\x8DBC']),
		('\x2F9DC',MkDecomposition DCCanonical ['\x8DF0']),
		('\x2F9DD',MkDecomposition DCCanonical ['\x208DE']),
		('\x2F9DE',MkDecomposition DCCanonical ['\x8ED4']),
		('\x2F9DF',MkDecomposition DCCanonical ['\x8F38']),
		('\x2F9E0',MkDecomposition DCCanonical ['\x285D2']),
		('\x2F9E1',MkDecomposition DCCanonical ['\x285ED']),
		('\x2F9E2',MkDecomposition DCCanonical ['\x9094']),
		('\x2F9E3',MkDecomposition DCCanonical ['\x90F1']),
		('\x2F9E4',MkDecomposition DCCanonical ['\x9111']),
		('\x2F9E5',MkDecomposition DCCanonical ['\x2872E']),
		('\x2F9E6',MkDecomposition DCCanonical ['\x911B']),
		('\x2F9E7',MkDecomposition DCCanonical ['\x9238']),
		('\x2F9E8',MkDecomposition DCCanonical ['\x92D7']),
		('\x2F9E9',MkDecomposition DCCanonical ['\x92D8']),
		('\x2F9EA',MkDecomposition DCCanonical ['\x927C']),
		('\x2F9EB',MkDecomposition DCCanonical ['\x93F9']),
		('\x2F9EC',MkDecomposition DCCanonical ['\x9415']),
		('\x2F9ED',MkDecomposition DCCanonical ['\x28BFA']),
		('\x2F9EE',MkDecomposition DCCanonical ['\x958B']),
		('\x2F9EF',MkDecomposition DCCanonical ['\x4995']),
		('\x2F9F0',MkDecomposition DCCanonical ['\x95B7']),
		('\x2F9F1',MkDecomposition DCCanonical ['\x28D77']),
		('\x2F9F2',MkDecomposition DCCanonical ['\x49E6']),
		('\x2F9F3',MkDecomposition DCCanonical ['\x96C3']),
		('\x2F9F4',MkDecomposition DCCanonical ['\x5DB2']),
		('\x2F9F5',MkDecomposition DCCanonical ['\x9723']),
		('\x2F9F6',MkDecomposition DCCanonical ['\x29145']),
		('\x2F9F7',MkDecomposition DCCanonical ['\x2921A']),
		('\x2F9F8',MkDecomposition DCCanonical ['\x4A6E']),
		('\x2F9F9',MkDecomposition DCCanonical ['\x4A76']),
		('\x2F9FA',MkDecomposition DCCanonical ['\x97E0']),
		('\x2F9FB',MkDecomposition DCCanonical ['\x2940A']),
		('\x2F9FC',MkDecomposition DCCanonical ['\x4AB2']),
		('\x2F9FD',MkDecomposition DCCanonical ['\x29496']),
		('\x2F9FE',MkDecomposition DCCanonical ['\x980B']),
		('\x2F9FF',MkDecomposition DCCanonical ['\x980B']),
		('\x2FA00',MkDecomposition DCCanonical ['\x9829']),
		('\x2FA01',MkDecomposition DCCanonical ['\x295B6']),
		('\x2FA02',MkDecomposition DCCanonical ['\x98E2']),
		('\x2FA03',MkDecomposition DCCanonical ['\x4B33']),
		('\x2FA04',MkDecomposition DCCanonical ['\x9929']),
		('\x2FA05',MkDecomposition DCCanonical ['\x99A7']),
		('\x2FA06',MkDecomposition DCCanonical ['\x99C2']),
		('\x2FA07',MkDecomposition DCCanonical ['\x99FE']),
		('\x2FA08',MkDecomposition DCCanonical ['\x4BCE']),
		('\x2FA09',MkDecomposition DCCanonical ['\x29B30']),
		('\x2FA0A',MkDecomposition DCCanonical ['\x9B12']),
		('\x2FA0B',MkDecomposition DCCanonical ['\x9C40']),
		('\x2FA0C',MkDecomposition DCCanonical ['\x9CFD']),
		('\x2FA0D',MkDecomposition DCCanonical ['\x4CCE']),
		('\x2FA0E',MkDecomposition DCCanonical ['\x4CED']),
		('\x2FA0F',MkDecomposition DCCanonical ['\x9D67']),
		('\x2FA10',MkDecomposition DCCanonical ['\x2A0CE']),
		('\x2FA11',MkDecomposition DCCanonical ['\x4CF8']),
		('\x2FA12',MkDecomposition DCCanonical ['\x2A105']),
		('\x2FA13',MkDecomposition DCCanonical ['\x2A20E']),
		('\x2FA14',MkDecomposition DCCanonical ['\x2A291']),
		('\x2FA15',MkDecomposition DCCanonical ['\x9EBB']),
		('\x2FA16',MkDecomposition DCCanonical ['\x4D56']),
		('\x2FA17',MkDecomposition DCCanonical ['\x9EF9']),
		('\x2FA18',MkDecomposition DCCanonical ['\x9EFE']),
		('\x2FA19',MkDecomposition DCCanonical ['\x9F05']),
		('\x2FA1A',MkDecomposition DCCanonical ['\x9F0F']),
		('\x2FA1B',MkDecomposition DCCanonical ['\x9F16']),
		('\x2FA1C',MkDecomposition DCCanonical ['\x9F3B']),
		('\x2FA1D',MkDecomposition DCCanonical ['\x2A600']),
		('\x10FFFF',NoDecomposition)
		];

	theArray :: Array Char Decomposition;
	theArray = accumArray (\_ a -> a) NoDecomposition ('\0','\x10FFFF') theList;

	getFromArray :: Char -> Decomposition;
	getFromArray c = if (inRange ('\0','\x10FFFF') c)
	 then theArray ! c
	 else NoDecomposition;

	getDecomposition :: Char -> Decomposition;
	getDecomposition c = handleOmittedRange (getFromArray c) getFromArray c;
}
